#ifndef EFL_GENERATED_ELM_CTXPOPUP_HH
#define EFL_GENERATED_ELM_CTXPOPUP_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_ctxpopup.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <string>

struct elm_ctxpopup
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_ctxpopup>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_ctxpopup(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_ctxpopup(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_ctxpopup(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_ctxpopup(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_ctxpopup(elm_ctxpopup const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_ctxpopup() {}

   /// @brief @brief Dismiss a ctxpopup object
   ///
   /// Use this function to simulate clicking outside of the ctxpopup to dismiss it.
   /// In this way, the ctxpopup will be hidden and the "clicked" signal will be
   /// emitted.
   ///
   void dismiss() const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_dismiss());
   }

   /// @brief @brief Clear all items in the given ctxpopup object.
   ///
   /// @ingroup Ctxpopup
   ///
   void clear() const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_clear());
   }

   /// @brief @brief Add a new item to a ctxpopup object.
   ///
   /// @return A handle to the item added or @c NULL, on errors
   ///
   /// @warning Ctxpopup can't hold both an item list and a content at the same
   /// time. When an item is added, any previous content will be removed.
   ///
   /// @see elm_object_content_set()
   ///
   /// @ingroup Ctxpopup
   ///
   /// @param label The Label of the new item
   /// @param icon Icon to be set on new item
   /// @param func Convenience function called when item selected
   /// @param data Data passed to @p func
   ///
   Elm_Object_Item * item_append(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_append(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
      return _tmp_ret;
   }

   /// @brief @brief Prepend a new item to a ctxpopup object.
   /// @since 1.11
   ///
   /// @return A handle to the item added or @c NULL, on errors
   ///
   /// @warning Ctxpopup can't hold both an item list and a content at the same
   /// time. When an item is added, any previous content will be removed.
   ///
   /// @see elm_object_content_set()
   ///
   /// @ingroup Ctxpopup
   ///
   /// @param label The Label of the new item
   /// @param icon Icon to be set on new item
   /// @param func Convenience function called when item selected
   /// @param data Data passed to @p func
   ///
   Elm_Object_Item * item_prepend(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prepend(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
      return _tmp_ret;
   }

   /// @param horizontal @c EINA_TRUE for horizontal mode, @c EINA_FALSE for vertical
   ///
   bool horizontal_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param horizontal @c EINA_TRUE for horizontal mode, @c EINA_FALSE for vertical
   ///
   void horizontal_set(bool horizontal_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_horizontal_set(efl::eolian::to_c(horizontal_)));
   }

   /// @param disabled auto hide enable/disable.
   ///
   bool auto_hide_disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled auto hide enable/disable.
   ///
   void auto_hide_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_auto_hide_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param parent The parent to use
   ///
   evas::object hover_parent_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param parent The parent to use
   ///
   void hover_parent_set(evas::object parent_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_hover_parent_set(efl::eolian::to_c(parent_)));
   }

   /// @param first 1st priority of direction
   /// @param second 2nd priority of direction
   /// @param third 3th priority of direction
   /// @param fourth 4th priority of direction
   ///
   void direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
   }

   /// @param first 1st priority of direction
   /// @param second 2nd priority of direction
   /// @param third 3th priority of direction
   /// @param fourth 4th priority of direction
   ///
   void direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
   }

   Elm_Ctxpopup_Direction direction_get() const
   {
      Elm_Ctxpopup_Direction _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_direction_get());
      return _tmp_ret;
   }

   const Eina_List * items_get() const
   {
      const Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_items_get());
      return _tmp_ret;
   }

   Elm_Object_Item * first_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
      return _tmp_ret;
   }

   Elm_Object_Item * last_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_CTXPOPUP_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_CTXPOPUP_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_ctxpopup_dismiss_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->dismiss();
}

template <typename T>
void _elm_ctxpopup_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->clear();
}

template <typename T>
Elm_Object_Item * _elm_ctxpopup_item_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Smart_Cb func_, const void * data_)
{
   return static_cast<T*>(self->this_)->item_append(efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(icon_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
Elm_Object_Item * _elm_ctxpopup_item_prepend_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Object * icon_, Evas_Smart_Cb func_, const void * data_)
{
   return static_cast<T*>(self->this_)->item_prepend(efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(icon_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
bool _elm_ctxpopup_horizontal_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->horizontal_get();
}

template <typename T>
void _elm_ctxpopup_horizontal_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   static_cast<T*>(self->this_)->horizontal_set(efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_ctxpopup_auto_hide_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->auto_hide_disabled_get();
}

template <typename T>
void _elm_ctxpopup_auto_hide_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->auto_hide_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
evas::object _elm_ctxpopup_hover_parent_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->hover_parent_get();
}

template <typename T>
void _elm_ctxpopup_hover_parent_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * parent_)
{
   static_cast<T*>(self->this_)->hover_parent_set(efl::eolian::to_cxx<evas::object>(parent_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_ctxpopup_direction_priority_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_)
{
   static_cast<T*>(self->this_)->direction_priority_get(first_, second_, third_, fourth_);
}

template <typename T>
void _elm_ctxpopup_direction_priority_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_)
{
   static_cast<T*>(self->this_)->direction_priority_set(first_, second_, third_, fourth_);
}

template <typename T>
Elm_Ctxpopup_Direction _elm_ctxpopup_direction_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->direction_get();
}

template <typename T>
const Eina_List * _elm_ctxpopup_items_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->items_get();
}

template <typename T>
Elm_Object_Item * _elm_ctxpopup_first_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->first_item_get();
}

template <typename T>
Elm_Object_Item * _elm_ctxpopup_last_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->last_item_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_ctxpopup >
{
   template <typename T>
   struct type
   {
      virtual void dismiss()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_dismiss());
      }

      virtual void clear()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_clear());
      }

      virtual Elm_Object_Item * item_append(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_append(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
            return _tmp_ret;
      }

      virtual Elm_Object_Item * item_prepend(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_item_prepend(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
            return _tmp_ret;
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      virtual bool auto_hide_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void auto_hide_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_auto_hide_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual evas::object hover_parent_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hover_parent_set(evas::object parent_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_hover_parent_set(efl::eolian::to_c(parent_)));
      }

      virtual void direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
      }

      virtual void direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
      }

      virtual Elm_Ctxpopup_Direction direction_get()
      {
         Elm_Ctxpopup_Direction _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_direction_get());
            return _tmp_ret;
      }

      virtual const Eina_List * items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_items_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * first_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * last_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_ctxpopup >
{
   static const int value = 16;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_ctxpopup>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_dismiss_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_dismiss);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_clear_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_clear);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_item_append_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_append);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_item_prepend_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_item_prepend);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_horizontal_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_horizontal_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_horizontal_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_horizontal_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_auto_hide_disabled_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_auto_hide_disabled_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_auto_hide_disabled_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_auto_hide_disabled_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_hover_parent_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_hover_parent_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_hover_parent_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_hover_parent_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_direction_priority_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_priority_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_direction_priority_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_priority_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_direction_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_direction_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_items_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_items_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_first_item_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_first_item_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_ctxpopup_last_item_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_ctxpopup_last_item_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_ctxpopup >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_ctxpopup, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_ctxpopup >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_ctxpopup, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_ctxpopup>
{
   template <typename U>
   struct type
   {
      operator ::elm_ctxpopup() const
      {
         return ::elm_ctxpopup(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void dismiss()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_dismiss());
      }

      void clear()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_clear());
      }

      Elm_Object_Item * item_append(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_append(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
            return _tmp_ret;
      }

      Elm_Object_Item * item_prepend(std::string label_, evas::object icon_, Evas_Smart_Cb func_, const void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_item_prepend(efl::eolian::to_c(label_), efl::eolian::to_c(icon_), func_, data_));
            return _tmp_ret;
      }

      bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void horizontal_set(bool horizontal_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      bool auto_hide_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_auto_hide_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void auto_hide_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_auto_hide_disabled_set(efl::eolian::to_c(disabled_)));
      }

      evas::object hover_parent_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_hover_parent_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void hover_parent_set(evas::object parent_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_hover_parent_set(efl::eolian::to_c(parent_)));
      }

      void direction_priority_get(Elm_Ctxpopup_Direction* first_, Elm_Ctxpopup_Direction* second_, Elm_Ctxpopup_Direction* third_, Elm_Ctxpopup_Direction* fourth_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_get(first_, second_, third_, fourth_));
      }

      void direction_priority_set(Elm_Ctxpopup_Direction first_, Elm_Ctxpopup_Direction second_, Elm_Ctxpopup_Direction third_, Elm_Ctxpopup_Direction fourth_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_ctxpopup_direction_priority_set(first_, second_, third_, fourth_));
      }

      Elm_Ctxpopup_Direction direction_get()
      {
         Elm_Ctxpopup_Direction _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_direction_get());
            return _tmp_ret;
      }

      const Eina_List * items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_items_get());
            return _tmp_ret;
      }

      Elm_Object_Item * first_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_first_item_get());
            return _tmp_ret;
      }

      Elm_Object_Item * last_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_ctxpopup_last_item_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CTXPOPUP_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_ctxpopup, function_type>,
         ELM_CTXPOPUP_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CTXPOPUP_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_ctxpopup>)
{
   return (ELM_CTXPOPUP_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_CTXPOPUP_HH

