#ifndef EFL_GENERATED_ELM_FILESELECTOR_HH
#define EFL_GENERATED_ELM_FILESELECTOR_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_fileselector.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_fileselector.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"

struct elm_fileselector
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_fileselector>::template type< ::elm_fileselector>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_fileselector>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_fileselector(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_fileselector(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_fileselector(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_fileselector(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_fileselector(elm_fileselector const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_fileselector() {}

   /// @param visible @c EINA_TRUE to show buttons, @c EINA_FALSE to hide.
   ///
   bool buttons_ok_cancel_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_buttons_ok_cancel_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param visible @c EINA_TRUE to show buttons, @c EINA_FALSE to hide.
   ///
   void buttons_ok_cancel_set(bool visible_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_fileselector_buttons_ok_cancel_set(efl::eolian::to_c(visible_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector, function_type>,
         ELM_FILESELECTOR_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector, function_type>,
         ELM_FILESELECTOR_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_FILESELECTOR_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_FILESELECTOR_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _elm_fileselector_buttons_ok_cancel_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->buttons_ok_cancel_get();
}

template <typename T>
void _elm_fileselector_buttons_ok_cancel_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool visible_)
{
   static_cast<T*>(self->this_)->buttons_ok_cancel_set(efl::eolian::to_cxx<bool>(visible_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_fileselector >
{
   template <typename T>
   struct type
   {
      virtual bool buttons_ok_cancel_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_fileselector_buttons_ok_cancel_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void buttons_ok_cancel_set(bool visible_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_buttons_ok_cancel_set(efl::eolian::to_c(visible_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_fileselector >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_fileselector>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_fileselector_buttons_ok_cancel_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_buttons_ok_cancel_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_fileselector_buttons_ok_cancel_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_buttons_ok_cancel_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_fileselector >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_fileselector, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_fileselector >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_fileselector, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_fileselector>
{
   template <typename U>
   struct type
   {
      operator ::elm_fileselector() const
      {
         return ::elm_fileselector(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool buttons_ok_cancel_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_buttons_ok_cancel_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void buttons_ok_cancel_set(bool visible_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_fileselector_buttons_ok_cancel_set(efl::eolian::to_c(visible_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector, function_type>,
         ELM_FILESELECTOR_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector, function_type>,
         ELM_FILESELECTOR_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_fileselector>)
{
   return (ELM_FILESELECTOR_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_FILESELECTOR_HH

