#ifndef EFL_GENERATED_ELM_FILESELECTOR_ENTRY_HH
#define EFL_GENERATED_ELM_FILESELECTOR_ENTRY_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_fileselector_entry.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_fileselector.eo.hh"
#include <string>

struct elm_fileselector_entry
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_fileselector>::template type< ::elm_fileselector_entry>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_fileselector_entry(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_fileselector_entry(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_fileselector_entry(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_fileselector_entry(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_fileselector_entry(elm_fileselector_entry const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_fileselector_entry() {}

   /// @param value @c EINA_TRUE to make it use an inner window, @c
   /// EINA_FALSE to make it use a dedicated window
   ///
   bool inwin_mode_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_entry_inwin_mode_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param value @c EINA_TRUE to make it use an inner window, @c
   /// EINA_FALSE to make it use a dedicated window
   ///
   void inwin_mode_set(bool value_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_fileselector_entry_inwin_mode_set(efl::eolian::to_c(value_)));
   }

   /// @param width The window's width
   /// @param height The window's height
   ///
   void window_size_get(Evas_Coord* width_, Evas_Coord* height_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_fileselector_entry_window_size_get(width_, height_));
   }

   /// @param width The window's width
   /// @param height The window's height
   ///
   void window_size_set(Evas_Coord width_, Evas_Coord height_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_fileselector_entry_window_size_set(width_, height_));
   }

   /// @param title The title string
   ///
   std::string window_title_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_entry_window_title_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param title The title string
   ///
   void window_title_set(std::string title_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_fileselector_entry_window_title_set(efl::eolian::to_c(title_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_FILESELECTOR_ENTRY_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_FILESELECTOR_ENTRY_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _elm_fileselector_entry_inwin_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->inwin_mode_get();
}

template <typename T>
void _elm_fileselector_entry_inwin_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool value_)
{
   static_cast<T*>(self->this_)->inwin_mode_set(efl::eolian::to_cxx<bool>(value_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_fileselector_entry_window_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* width_, Evas_Coord* height_)
{
   static_cast<T*>(self->this_)->window_size_get(width_, height_);
}

template <typename T>
void _elm_fileselector_entry_window_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord width_, Evas_Coord height_)
{
   static_cast<T*>(self->this_)->window_size_set(width_, height_);
}

template <typename T>
std::string _elm_fileselector_entry_window_title_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->window_title_get();
}

template <typename T>
void _elm_fileselector_entry_window_title_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   static_cast<T*>(self->this_)->window_title_set(efl::eolian::to_cxx<std::string>(title_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_fileselector_entry >
{
   template <typename T>
   struct type
   {
      virtual bool inwin_mode_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_fileselector_entry_inwin_mode_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void inwin_mode_set(bool value_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_entry_inwin_mode_set(efl::eolian::to_c(value_)));
      }

      virtual void window_size_get(Evas_Coord* width_, Evas_Coord* height_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_entry_window_size_get(width_, height_));
      }

      virtual void window_size_set(Evas_Coord width_, Evas_Coord height_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_entry_window_size_set(width_, height_));
      }

      virtual std::string window_title_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_fileselector_entry_window_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void window_title_set(std::string title_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_fileselector_entry_window_title_set(efl::eolian::to_c(title_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_fileselector_entry >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_fileselector_entry>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_inwin_mode_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_inwin_mode_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_inwin_mode_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_inwin_mode_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_window_size_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_window_size_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_window_size_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_window_size_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_window_title_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_window_title_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_fileselector_entry_window_title_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_fileselector_entry_window_title_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_fileselector_entry >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_fileselector_entry, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_fileselector_entry >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_fileselector_entry, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_fileselector_entry>
{
   template <typename U>
   struct type
   {
      operator ::elm_fileselector_entry() const
      {
         return ::elm_fileselector_entry(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool inwin_mode_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_entry_inwin_mode_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void inwin_mode_set(bool value_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_fileselector_entry_inwin_mode_set(efl::eolian::to_c(value_)));
      }

      void window_size_get(Evas_Coord* width_, Evas_Coord* height_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_fileselector_entry_window_size_get(width_, height_));
      }

      void window_size_set(Evas_Coord width_, Evas_Coord height_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_fileselector_entry_window_size_set(width_, height_));
      }

      std::string window_title_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_fileselector_entry_window_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void window_title_set(std::string title_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_fileselector_entry_window_title_set(efl::eolian::to_c(title_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FILESELECTOR_ENTRY_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_fileselector_entry, function_type>,
         ELM_FILESELECTOR_ENTRY_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FILESELECTOR_ENTRY_EVENT_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_fileselector_entry>)
{
   return (ELM_FILESELECTOR_ENTRY_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_FILESELECTOR_ENTRY_HH

