#ifndef EFL_GENERATED_ELM_MULTIBUTTONENTRY_HH
#define EFL_GENERATED_ELM_MULTIBUTTONENTRY_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_multibuttonentry.eo.h"
}

#include "elm_layout.eo.hh"
#include <string>

struct elm_multibuttonentry
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_multibuttonentry(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_multibuttonentry(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_multibuttonentry(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_multibuttonentry(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_multibuttonentry(elm_multibuttonentry const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_multibuttonentry() {}

   /// @brief Prepend a new item to the multibuttonentry
   ///
   /// @return A handle to the item added or NULL if not possible
   ///
   /// @see Use elm_object_item_del() to delete the item.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param label The label of new item
   /// @param func The callback function to be invoked when this item is pressed.
   /// @param data The pointer to the data to be attached
   ///
   Elm_Object_Item * item_prepend(std::string label_, Evas_Smart_Cb func_, void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(efl::eolian::to_c(label_), func_, data_));
      return _tmp_ret;
   }

   /// @brief Remove all items in the multibuttonentry.
   ///
   /// @ingroup Multibuttonentry
   ///
   void clear() const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_clear());
   }

   /// @brief Remove a filter from the list
   ///
   /// Removes the given callback from the filter list. See elm_multibuttonentry_item_filter_append()
   /// for more information.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param func The filter function to remove
   /// @param data The user data passed when adding the function
   ///
   void item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
   }

   /// @brief Add a new item to the multibuttonentry before the indicated object
   ///
   /// reference.
   /// @return A handle to the item added or NULL if not possible
   ///
   /// @see Use elm_object_item_del() to delete the item.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param before The item before which to add it
   /// @param label The label of new item
   /// @param func The callback function to be invoked when this item is pressed.
   /// @param data The pointer to the data to be attached
   ///
   Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string label_, Evas_Smart_Cb func_, void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(before_, efl::eolian::to_c(label_), func_, data_));
      return _tmp_ret;
   }

   /// @brief Append a new item to the multibuttonentry
   ///
   /// @return A handle to the item added or NULL if not possible
   ///
   /// @see Use elm_object_item_del() to delete the item.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param label The label of new item
   /// @param func The callback function to be invoked when this item is pressed.
   /// @param data The pointer to the data to be attached
   ///
   Elm_Object_Item * item_append(std::string label_, Evas_Smart_Cb func_, void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_append(efl::eolian::to_c(label_), func_, data_));
      return _tmp_ret;
   }

   /// @brief Prepend a filter function for text inserted in the Multibuttonentry
   ///
   /// Prepend the given callback to the list. See elm_multibuttonentry_item_filter_append()
   /// for more information
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param func The function to use as text filter
   /// @param data User data to pass to @p func
   ///
   void item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
   }

   /// @brief Append an item filter function for text inserted in the Multibuttonentry
   ///
   /// Append the given callback to the list. This functions will be called
   /// whenever any text is inserted into the Multibuttonentry, with the text to be inserted
   /// as a parameter. The callback function is free to alter the text in any way
   /// it wants, but it must remember to free the given pointer and update it.
   /// If the new text is to be discarded, the function can free it and set it text
   /// parameter to NULL. This will also prevent any following filters from being
   /// called.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param func The function to use as item filter
   /// @param data User data to pass to @p func
   ///
   void item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
   }

   /// @brief Add a new item to the multibuttonentry after the indicated object
   ///
   /// @return A handle to the item added or NULL if not possible
   ///
   /// @see Use elm_object_item_del() to delete the item.
   ///
   /// @ingroup Multibuttonentry
   ///
   /// @param after The item after which to add it
   /// @param label The label of new item
   /// @param func The callback function to be invoked when this item is pressed.
   /// @param data The pointer to the data to be attached
   ///
   Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string label_, Evas_Smart_Cb func_, void * data_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(after_, efl::eolian::to_c(label_), func_, data_));
      return _tmp_ret;
   }

   /// @param editable If @c EINA_TRUE, user can add/delete item in multibuttonentry, if not, the multibuttonentry is non-editable.
   ///
   bool editable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param editable If @c EINA_TRUE, user can add/delete item in multibuttonentry, if not, the multibuttonentry is non-editable.
   ///
   void editable_set(bool editable_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_editable_set(efl::eolian::to_c(editable_)));
   }

   /// @param expanded the value of expanded state.
   /// Set this to @c EINA_TRUE for expanded state.
   /// Set this to EINA_FALSE for single line state.
   ///
   bool expanded_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param expanded the value of expanded state.
   /// Set this to @c EINA_TRUE for expanded state.
   /// Set this to EINA_FALSE for single line state.
   ///
   void expanded_set(bool expanded_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_expanded_set(efl::eolian::to_c(expanded_)));
   }

   /// @param format_function format_function The actual format function
   /// @param data data User data to passed to @a format_function
   ///
   void format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
   }

   const Eina_List * items_get() const
   {
      const Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_items_get());
      return _tmp_ret;
   }

   Elm_Object_Item * first_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
      return _tmp_ret;
   }

   Elm_Object_Item * last_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
      return _tmp_ret;
   }

   evas::object entry_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   Elm_Object_Item * selected_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_item_selected_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED );
   }

   template <typename T>
   void
   callback_item_selected_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_added_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED );
   }

   template <typename T>
   void
   callback_item_added_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_deleted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED );
   }

   template <typename T>
   void
   callback_item_deleted_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED );
   }

   template <typename T>
   void
   callback_item_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_expanded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_EXPANDED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_EXPANDED );
   }

   template <typename T>
   void
   callback_expanded_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_EXPANDED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_contracted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED );
   }

   template <typename T>
   void
   callback_contracted_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_expand_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_expand_state_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_MULTIBUTTONENTRY_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_MULTIBUTTONENTRY_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Object_Item * _elm_multibuttonentry_item_prepend_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   return static_cast<T*>(self->this_)->item_prepend(efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
void _elm_multibuttonentry_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->clear();
}

template <typename T>
void _elm_multibuttonentry_item_filter_remove_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   static_cast<T*>(self->this_)->item_filter_remove(func_, data_);
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_item_insert_before_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Item * before_, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   return static_cast<T*>(self->this_)->item_insert_before(before_, efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_item_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   return static_cast<T*>(self->this_)->item_append(efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
void _elm_multibuttonentry_item_filter_prepend_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   static_cast<T*>(self->this_)->item_filter_prepend(func_, data_);
}

template <typename T>
void _elm_multibuttonentry_item_filter_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
{
   static_cast<T*>(self->this_)->item_filter_append(func_, data_);
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_item_insert_after_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Item * after_, const char * label_, Evas_Smart_Cb func_, void * data_)
{
   return static_cast<T*>(self->this_)->item_insert_after(after_, efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
bool _elm_multibuttonentry_editable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->editable_get();
}

template <typename T>
void _elm_multibuttonentry_editable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool editable_)
{
   static_cast<T*>(self->this_)->editable_set(efl::eolian::to_cxx<bool>(editable_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_multibuttonentry_expanded_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->expanded_get();
}

template <typename T>
void _elm_multibuttonentry_expanded_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool expanded_)
{
   static_cast<T*>(self->this_)->expanded_set(efl::eolian::to_cxx<bool>(expanded_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_multibuttonentry_format_function_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Multibuttonentry_Format_Cb format_function_, const void * data_)
{
   static_cast<T*>(self->this_)->format_function_set(format_function_, data_);
}

template <typename T>
const Eina_List * _elm_multibuttonentry_items_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->items_get();
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_first_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->first_item_get();
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_last_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->last_item_get();
}

template <typename T>
evas::object _elm_multibuttonentry_entry_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->entry_get();
}

template <typename T>
Elm_Object_Item * _elm_multibuttonentry_selected_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_item_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_multibuttonentry >
{
   template <typename T>
   struct type
   {
      virtual Elm_Object_Item * item_prepend(std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      virtual void clear()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_clear());
      }

      virtual void item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
      }

      virtual Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(before_, efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      virtual Elm_Object_Item * item_append(std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_append(efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      virtual void item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
      }

      virtual void item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
      }

      virtual Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(after_, efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void editable_set(bool editable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_editable_set(efl::eolian::to_c(editable_)));
      }

      virtual bool expanded_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void expanded_set(bool expanded_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_expanded_set(efl::eolian::to_c(expanded_)));
      }

      virtual void format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
      }

      virtual const Eina_List * items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_items_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * first_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * last_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
            return _tmp_ret;
      }

      virtual evas::object entry_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Object_Item * selected_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_multibuttonentry >
{
   static const int value = 18;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_multibuttonentry>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_prepend_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_prepend);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_clear_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_clear);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_filter_remove_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_remove);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_insert_before_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_insert_before);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_append_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_append);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_filter_prepend_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_prepend);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_filter_append_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_filter_append);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_item_insert_after_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_item_insert_after);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_editable_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_editable_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_editable_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_editable_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_expanded_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_expanded_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_expanded_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_expanded_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_format_function_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_format_function_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_items_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_items_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_first_item_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_first_item_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_last_item_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_last_item_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_entry_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_entry_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_multibuttonentry_selected_item_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_obj_multibuttonentry_selected_item_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_multibuttonentry >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_multibuttonentry, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_multibuttonentry >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_multibuttonentry, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_multibuttonentry>
{
   template <typename U>
   struct type
   {
      operator ::elm_multibuttonentry() const
      {
         return ::elm_multibuttonentry(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Object_Item * item_prepend(std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_prepend(efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      void clear()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_clear());
      }

      void item_filter_remove(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_remove(func_, data_));
      }

      Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_before(before_, efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      Elm_Object_Item * item_append(std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_append(efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      void item_filter_prepend(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_prepend(func_, data_));
      }

      void item_filter_append(Elm_Multibuttonentry_Item_Filter_Cb func_, void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_item_filter_append(func_, data_));
      }

      Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string label_, Evas_Smart_Cb func_, void * data_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_item_insert_after(after_, efl::eolian::to_c(label_), func_, data_));
            return _tmp_ret;
      }

      bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void editable_set(bool editable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_editable_set(efl::eolian::to_c(editable_)));
      }

      bool expanded_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_expanded_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void expanded_set(bool expanded_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_expanded_set(efl::eolian::to_c(expanded_)));
      }

      void format_function_set(Elm_Multibuttonentry_Format_Cb format_function_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_multibuttonentry_format_function_set(format_function_, data_));
      }

      const Eina_List * items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_items_get());
            return _tmp_ret;
      }

      Elm_Object_Item * first_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_first_item_get());
            return _tmp_ret;
      }

      Elm_Object_Item * last_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_last_item_get());
            return _tmp_ret;
      }

      evas::object entry_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_entry_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      Elm_Object_Item * selected_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_multibuttonentry_selected_item_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_item_selected_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED );
   }

   template <typename T>
   void
   callback_item_selected_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_SELECTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_added_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED );
   }

   template <typename T>
   void
   callback_item_added_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_ADDED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_deleted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED );
   }

   template <typename T>
   void
   callback_item_deleted_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_DELETED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_item_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED );
   }

   template <typename T>
   void
   callback_item_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_ITEM_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_UNFOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_expanded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_EXPANDED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_EXPANDED );
   }

   template <typename T>
   void
   callback_expanded_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_EXPANDED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_contracted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED );
   }

   template <typename T>
   void
   callback_contracted_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_CONTRACTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_expand_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_multibuttonentry, function_type>,
         ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_expand_state_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_MULTIBUTTONENTRY_EVENT_EXPAND_STATE_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_multibuttonentry>)
{
   return (ELM_MULTIBUTTONENTRY_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_MULTIBUTTONENTRY_HH

