#ifndef EFL_GENERATED_ELM_NAVIFRAME_HH
#define EFL_GENERATED_ELM_NAVIFRAME_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_naviframe.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <string>

struct elm_naviframe
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_naviframe>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_naviframe(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_naviframe(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_naviframe(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_naviframe(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_naviframe(elm_naviframe const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_naviframe() {}

   /// @brief @brief Pop an item that is on top of the stack
   ///
   /// @return @c NULL or the content object(if the
   /// elm_naviframe_content_preserve_on_pop_get is true).
   ///
   /// This pops an item that is on the top(visible) of the naviframe, makes it
   /// disappear, then deletes the item. The item that was underneath it on the
   /// stack will become visible.
   ///
   /// @see also elm_naviframe_content_preserve_on_pop_get()
   /// @see also elm_naviframe_item_pop_cb_set()
   ///
   /// @ingroup Naviframe
   ///
   evas::object item_pop() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_pop());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief @brief Insert a new item into the naviframe before item @p before.
   ///
   /// @return The created item or @c NULL upon failure.
   ///
   /// The item is inserted into the naviframe straight away without any
   /// transition operations. This item will be deleted when it is popped.
   ///
   /// @see also elm_naviframe_item_style_set()
   /// @see also elm_naviframe_item_push()
   /// @see also elm_naviframe_item_insert_after()
   ///
   /// The following styles are available for this item:
   /// @li @c "default"
   ///
   /// @ingroup Naviframe
   ///
   /// @param before The naviframe item to insert before.
   /// @param title_label The label in the title area. The name of the title
   /// label part is "elm.text.title"
   /// @param prev_btn The button to go to the previous item. If it is NULL,
   /// then naviframe will create a back button automatically. The name of
   /// the prev_btn part is "elm.swallow.prev_btn"
   /// @param next_btn The button to go to the next item. Or It could be just an
   /// extra function button. The name of the next_btn part is
   /// "elm.swallow.next_btn"
   /// @param content The main content object. The name of content part is
   /// "elm.swallow.content"
   /// @param item_style The current item style name. @c NULL would be default.
   ///
   Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_before(before_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
      return _tmp_ret;
   }

   /// @brief @brief Push a new item to the top of the naviframe stack (and show it).
   ///
   /// @return The created item or @c NULL upon failure.
   ///
   /// The item pushed becomes one page of the naviframe, this item will be
   /// deleted when it is popped.
   ///
   /// @see also elm_naviframe_item_style_set()
   /// @see also elm_naviframe_item_insert_before()
   /// @see also elm_naviframe_item_insert_after()
   ///
   /// The following styles are available for this item:
   /// @li @c "default"
   ///
   /// @ingroup Naviframe
   ///
   /// @param title_label The label in the title area. The name of the title
   /// label part is "elm.text.title"
   /// @param prev_btn The button to go to the previous item. If it is NULL,
   /// then naviframe will create a back button automatically. The name of
   /// the prev_btn part is "elm.swallow.prev_btn"
   /// @param next_btn The button to go to the next item. Or It could be just an
   /// extra function button. The name of the next_btn part is
   /// "elm.swallow.next_btn"
   /// @param content The main content object. The name of content part is
   /// "elm.swallow.content"
   /// @param item_style The current item style name. @c NULL would be default.
   ///
   Elm_Object_Item * item_push(std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_push(efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
      return _tmp_ret;
   }

   /// @brief @brief Simple version of item_promote.
   ///
   /// @see elm_naviframe_item_promote
   ///
   /// @param content 
   ///
   void item_simple_promote(evas::object content_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_naviframe_item_simple_promote(efl::eolian::to_c(content_)));
   }

   /// @brief @brief Insert a new item into the naviframe after item @p after.
   ///
   /// @return The created item or @c NULL upon failure.
   ///
   /// The item is inserted into the naviframe straight away without any
   /// transition operations. This item will be deleted when it is popped.
   ///
   /// @see also elm_naviframe_item_style_set()
   /// @see also elm_naviframe_item_push()
   /// @see also elm_naviframe_item_insert_before()
   ///
   /// The following styles are available for this item:
   /// @li @c "default"
   ///
   /// @ingroup Naviframe
   ///
   /// @param after The naviframe item to insert after.
   /// @param title_label The label in the title area. The name of the title
   /// label part is "elm.text.title"
   /// @param prev_btn The button to go to the previous item. If it is NULL,
   /// then naviframe will create a back button automatically. The name of
   /// the prev_btn part is "elm.swallow.prev_btn"
   /// @param next_btn The button to go to the next item. Or It could be just an
   /// extra function button. The name of the next_btn part is
   /// "elm.swallow.next_btn"
   /// @param content The main content object. The name of content part is
   /// "elm.swallow.content"
   /// @param item_style The current item style name. @c NULL would be default.
   ///
   Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_after(after_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
      return _tmp_ret;
   }

   /// @param enabled Events are received when enabled is @c EINA_TRUE, and
   /// ignored otherwise.
   ///
   bool event_enabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param enabled Events are received when enabled is @c EINA_TRUE, and
   /// ignored otherwise.
   ///
   void event_enabled_set(bool enabled_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_naviframe_event_enabled_set(efl::eolian::to_c(enabled_)));
   }

   /// @param preserve Enable the preserve mode if @c EINA_TRUE, disable otherwise
   ///
   bool content_preserve_on_pop_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param preserve Enable the preserve mode if @c EINA_TRUE, disable otherwise
   ///
   void content_preserve_on_pop_set(bool preserve_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_naviframe_content_preserve_on_pop_set(efl::eolian::to_c(preserve_)));
   }

   /// @param auto_pushed If @c EINA_TRUE, the previous button(back button) will
   /// be created internally when you pass the @c NULL to the prev_btn
   /// parameter in elm_naviframe_item_push
   ///
   bool prev_btn_auto_pushed_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param auto_pushed If @c EINA_TRUE, the previous button(back button) will
   /// be created internally when you pass the @c NULL to the prev_btn
   /// parameter in elm_naviframe_item_push
   ///
   void prev_btn_auto_pushed_set(bool auto_pushed_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_naviframe_prev_btn_auto_pushed_set(efl::eolian::to_c(auto_pushed_)));
   }

   Eina_List * items_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_items_get());
      return _tmp_ret;
   }

   Elm_Object_Item * top_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_top_item_get());
      return _tmp_ret;
   }

   Elm_Object_Item * bottom_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_transition_finished_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED );
   }

   template <typename T>
   void
   callback_transition_finished_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_transition_finished_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED );
   }

   template <typename T>
   void
   callback_title_transition_finished_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TITLE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TITLE_CLICKED );
   }

   template <typename T>
   void
   callback_title_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TITLE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_NAVIFRAME_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_NAVIFRAME_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
evas::object _elm_naviframe_item_pop_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->item_pop();
}

template <typename T>
Elm_Object_Item * _elm_naviframe_item_insert_before_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Item * before_, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   return static_cast<T*>(self->this_)->item_insert_before(before_, efl::eolian::to_cxx<std::string>(title_label_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(prev_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(next_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(item_style_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Object_Item * _elm_naviframe_item_push_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   return static_cast<T*>(self->this_)->item_push(efl::eolian::to_cxx<std::string>(title_label_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(prev_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(next_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(item_style_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_naviframe_item_simple_promote_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * content_)
{
   static_cast<T*>(self->this_)->item_simple_promote(efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Object_Item * _elm_naviframe_item_insert_after_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Object_Item * after_, const char * title_label_, Evas_Object * prev_btn_, Evas_Object * next_btn_, Evas_Object * content_, const char * item_style_)
{
   return static_cast<T*>(self->this_)->item_insert_after(after_, efl::eolian::to_cxx<std::string>(title_label_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(prev_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(next_btn_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(item_style_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_naviframe_event_enabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->event_enabled_get();
}

template <typename T>
void _elm_naviframe_event_enabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enabled_)
{
   static_cast<T*>(self->this_)->event_enabled_set(efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_naviframe_content_preserve_on_pop_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_preserve_on_pop_get();
}

template <typename T>
void _elm_naviframe_content_preserve_on_pop_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool preserve_)
{
   static_cast<T*>(self->this_)->content_preserve_on_pop_set(efl::eolian::to_cxx<bool>(preserve_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_naviframe_prev_btn_auto_pushed_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->prev_btn_auto_pushed_get();
}

template <typename T>
void _elm_naviframe_prev_btn_auto_pushed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool auto_pushed_)
{
   static_cast<T*>(self->this_)->prev_btn_auto_pushed_set(efl::eolian::to_cxx<bool>(auto_pushed_, std::tuple<std::false_type>()));
}

template <typename T>
Eina_List * _elm_naviframe_items_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->items_get();
}

template <typename T>
Elm_Object_Item * _elm_naviframe_top_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->top_item_get();
}

template <typename T>
Elm_Object_Item * _elm_naviframe_bottom_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->bottom_item_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_naviframe >
{
   template <typename T>
   struct type
   {
      virtual evas::object item_pop()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_pop());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_insert_before(before_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      virtual Elm_Object_Item * item_push(std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_push(efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      virtual void item_simple_promote(evas::object content_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_item_simple_promote(efl::eolian::to_c(content_)));
      }

      virtual Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_item_insert_after(after_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      virtual bool event_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void event_enabled_set(bool enabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_event_enabled_set(efl::eolian::to_c(enabled_)));
      }

      virtual bool content_preserve_on_pop_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void content_preserve_on_pop_set(bool preserve_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_content_preserve_on_pop_set(efl::eolian::to_c(preserve_)));
      }

      virtual bool prev_btn_auto_pushed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void prev_btn_auto_pushed_set(bool auto_pushed_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_naviframe_prev_btn_auto_pushed_set(efl::eolian::to_c(auto_pushed_)));
      }

      virtual Eina_List * items_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_items_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * top_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_top_item_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * bottom_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_naviframe >
{
   static const int value = 14;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_naviframe>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_naviframe_item_pop_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_pop);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_naviframe_item_insert_before_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_insert_before);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_naviframe_item_push_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_push);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_naviframe_item_simple_promote_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_simple_promote);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_naviframe_item_insert_after_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_item_insert_after);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_naviframe_event_enabled_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_event_enabled_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_naviframe_event_enabled_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_event_enabled_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_naviframe_content_preserve_on_pop_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_content_preserve_on_pop_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_naviframe_content_preserve_on_pop_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_content_preserve_on_pop_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_naviframe_prev_btn_auto_pushed_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_prev_btn_auto_pushed_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_naviframe_prev_btn_auto_pushed_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_prev_btn_auto_pushed_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_naviframe_items_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_items_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_naviframe_top_item_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_top_item_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_naviframe_bottom_item_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_naviframe_bottom_item_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_naviframe >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_naviframe, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_naviframe >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_naviframe, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_naviframe>
{
   template <typename U>
   struct type
   {
      operator ::elm_naviframe() const
      {
         return ::elm_naviframe(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      evas::object item_pop()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_pop());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      Elm_Object_Item * item_insert_before(Elm_Object_Item * before_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_before(before_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      Elm_Object_Item * item_push(std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_push(efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      void item_simple_promote(evas::object content_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_naviframe_item_simple_promote(efl::eolian::to_c(content_)));
      }

      Elm_Object_Item * item_insert_after(Elm_Object_Item * after_, std::string title_label_, evas::object prev_btn_, evas::object next_btn_, evas::object content_, std::string item_style_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_item_insert_after(after_, efl::eolian::to_c(title_label_), efl::eolian::to_c(prev_btn_), efl::eolian::to_c(next_btn_), efl::eolian::to_c(content_), efl::eolian::to_c(item_style_)));
            return _tmp_ret;
      }

      bool event_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_event_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void event_enabled_set(bool enabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_naviframe_event_enabled_set(efl::eolian::to_c(enabled_)));
      }

      bool content_preserve_on_pop_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_content_preserve_on_pop_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void content_preserve_on_pop_set(bool preserve_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_naviframe_content_preserve_on_pop_set(efl::eolian::to_c(preserve_)));
      }

      bool prev_btn_auto_pushed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_prev_btn_auto_pushed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void prev_btn_auto_pushed_set(bool auto_pushed_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_naviframe_prev_btn_auto_pushed_set(efl::eolian::to_c(auto_pushed_)));
      }

      Eina_List * items_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_items_get());
            return _tmp_ret;
      }

      Elm_Object_Item * top_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_top_item_get());
            return _tmp_ret;
      }

      Elm_Object_Item * bottom_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_naviframe_bottom_item_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_transition_finished_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED );
   }

   template <typename T>
   void
   callback_transition_finished_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TRANSITION_FINISHED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_transition_finished_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED );
   }

   template <typename T>
   void
   callback_title_transition_finished_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TITLE_TRANSITION_FINISHED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_TITLE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_TITLE_CLICKED );
   }

   template <typename T>
   void
   callback_title_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_TITLE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NAVIFRAME_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_naviframe, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_naviframe, function_type>,
         ELM_NAVIFRAME_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NAVIFRAME_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_naviframe>)
{
   return (ELM_NAVIFRAME_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_NAVIFRAME_HH

