#ifndef EFL_GENERATED_ELM_PLAYER_HH
#define EFL_GENERATED_ELM_PLAYER_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elc_player.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"

struct elm_player
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_player>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_player(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_player(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_player(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_player(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_player(elm_player const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_player() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_forward_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_FORWARD_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_FORWARD_CLICKED );
   }

   template <typename T>
   void
   callback_forward_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_FORWARD_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_info_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_INFO_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_INFO_CLICKED );
   }

   template <typename T>
   void
   callback_info_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_INFO_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_next_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_NEXT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_NEXT_CLICKED );
   }

   template <typename T>
   void
   callback_next_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_NEXT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_pause_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PAUSE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PAUSE_CLICKED );
   }

   template <typename T>
   void
   callback_pause_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PAUSE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_play_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PLAY_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PLAY_CLICKED );
   }

   template <typename T>
   void
   callback_play_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PLAY_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_prev_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PREV_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PREV_CLICKED );
   }

   template <typename T>
   void
   callback_prev_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PREV_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_rewind_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_REWIND_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_REWIND_CLICKED );
   }

   template <typename T>
   void
   callback_rewind_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_REWIND_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_quality_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_QUALITY_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_QUALITY_CLICKED );
   }

   template <typename T>
   void
   callback_quality_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_QUALITY_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_eject_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_EJECT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_EJECT_CLICKED );
   }

   template <typename T>
   void
   callback_eject_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_EJECT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_volume_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_VOLUME_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_VOLUME_CLICKED );
   }

   template <typename T>
   void
   callback_volume_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_VOLUME_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_mute_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_MUTE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_MUTE_CLICKED );
   }

   template <typename T>
   void
   callback_mute_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_MUTE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PLAYER_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_PLAYER_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_player >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_player >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_player>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_player >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_player, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_player >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_player, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_player>
{
   template <typename U>
   struct type
   {
      operator ::elm_player() const
      {
         return ::elm_player(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_forward_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_FORWARD_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_FORWARD_CLICKED );
   }

   template <typename T>
   void
   callback_forward_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_FORWARD_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_info_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_INFO_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_INFO_CLICKED );
   }

   template <typename T>
   void
   callback_info_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_INFO_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_next_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_NEXT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_NEXT_CLICKED );
   }

   template <typename T>
   void
   callback_next_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_NEXT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_pause_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PAUSE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PAUSE_CLICKED );
   }

   template <typename T>
   void
   callback_pause_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PAUSE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_play_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PLAY_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PLAY_CLICKED );
   }

   template <typename T>
   void
   callback_play_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PLAY_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_prev_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_PREV_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_PREV_CLICKED );
   }

   template <typename T>
   void
   callback_prev_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_PREV_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_rewind_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_REWIND_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_REWIND_CLICKED );
   }

   template <typename T>
   void
   callback_rewind_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_REWIND_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_quality_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_QUALITY_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_QUALITY_CLICKED );
   }

   template <typename T>
   void
   callback_quality_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_QUALITY_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_eject_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_EJECT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_EJECT_CLICKED );
   }

   template <typename T>
   void
   callback_eject_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_EJECT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_volume_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_VOLUME_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_VOLUME_CLICKED );
   }

   template <typename T>
   void
   callback_volume_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_VOLUME_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_mute_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_MUTE_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_MUTE_CLICKED );
   }

   template <typename T>
   void
   callback_mute_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_MUTE_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PLAYER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_player, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_player, function_type>,
         ELM_PLAYER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PLAYER_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_player>)
{
   return (ELM_PLAYER_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PLAYER_HH

