#ifndef EFL_GENERATED_ELM_ACTIONSLIDER_HH
#define EFL_GENERATED_ELM_ACTIONSLIDER_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_actionslider.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_actionslider
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_actionslider(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_actionslider(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_actionslider(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_actionslider(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_actionslider(elm_actionslider const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_actionslider() {}

   /// @param pos The position of the indicator.
   ///
   Elm_Actionslider_Pos indicator_pos_get() const
   {
      Elm_Actionslider_Pos _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
      return _tmp_ret;
   }

   /// @param pos The position of the indicator.
   ///
   void indicator_pos_set(Elm_Actionslider_Pos pos_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_actionslider_indicator_pos_set(pos_));
   }

   /// @param pos Bit mask indicating the magnet positions.
   ///
   Elm_Actionslider_Pos magnet_pos_get() const
   {
      Elm_Actionslider_Pos _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
      return _tmp_ret;
   }

   /// @param pos Bit mask indicating the magnet positions.
   ///
   void magnet_pos_set(Elm_Actionslider_Pos pos_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_actionslider_magnet_pos_set(pos_));
   }

   /// @param pos Bit mask indicating the enabled positions.
   ///
   Elm_Actionslider_Pos enabled_pos_get() const
   {
      Elm_Actionslider_Pos _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
      return _tmp_ret;
   }

   /// @param pos Bit mask indicating the enabled positions.
   ///
   void enabled_pos_set(Elm_Actionslider_Pos pos_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_actionslider_enabled_pos_set(pos_));
   }

   std::string selected_label_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_selected_label_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_actionslider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_actionslider, function_type>,
         ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_actionslider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_actionslider, function_type>,
         ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_ACTIONSLIDER_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_ACTIONSLIDER_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Actionslider_Pos _elm_actionslider_indicator_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->indicator_pos_get();
}

template <typename T>
void _elm_actionslider_indicator_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   static_cast<T*>(self->this_)->indicator_pos_set(pos_);
}

template <typename T>
Elm_Actionslider_Pos _elm_actionslider_magnet_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->magnet_pos_get();
}

template <typename T>
void _elm_actionslider_magnet_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   static_cast<T*>(self->this_)->magnet_pos_set(pos_);
}

template <typename T>
Elm_Actionslider_Pos _elm_actionslider_enabled_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->enabled_pos_get();
}

template <typename T>
void _elm_actionslider_enabled_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Actionslider_Pos pos_)
{
   static_cast<T*>(self->this_)->enabled_pos_set(pos_);
}

template <typename T>
std::string _elm_actionslider_selected_label_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_label_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_actionslider >
{
   template <typename T>
   struct type
   {
      virtual Elm_Actionslider_Pos indicator_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
            return _tmp_ret;
      }

      virtual void indicator_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_indicator_pos_set(pos_));
      }

      virtual Elm_Actionslider_Pos magnet_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
            return _tmp_ret;
      }

      virtual void magnet_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_magnet_pos_set(pos_));
      }

      virtual Elm_Actionslider_Pos enabled_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
            return _tmp_ret;
      }

      virtual void enabled_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_actionslider_enabled_pos_set(pos_));
      }

      virtual std::string selected_label_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_actionslider_selected_label_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_actionslider >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_actionslider>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_actionslider_indicator_pos_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_indicator_pos_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_actionslider_indicator_pos_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_indicator_pos_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_actionslider_magnet_pos_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_magnet_pos_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_actionslider_magnet_pos_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_magnet_pos_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_actionslider_enabled_pos_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_enabled_pos_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_actionslider_enabled_pos_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_enabled_pos_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_actionslider_selected_label_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_actionslider_selected_label_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_actionslider >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_actionslider, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_actionslider >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_actionslider, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_actionslider>
{
   template <typename U>
   struct type
   {
      operator ::elm_actionslider() const
      {
         return ::elm_actionslider(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Actionslider_Pos indicator_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_indicator_pos_get());
            return _tmp_ret;
      }

      void indicator_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_actionslider_indicator_pos_set(pos_));
      }

      Elm_Actionslider_Pos magnet_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_magnet_pos_get());
            return _tmp_ret;
      }

      void magnet_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_actionslider_magnet_pos_set(pos_));
      }

      Elm_Actionslider_Pos enabled_pos_get()
      {
         Elm_Actionslider_Pos _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_enabled_pos_get());
            return _tmp_ret;
      }

      void enabled_pos_set(Elm_Actionslider_Pos pos_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_actionslider_enabled_pos_set(pos_));
      }

      std::string selected_label_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_actionslider_selected_label_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_actionslider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_actionslider, function_type>,
         ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_ACTIONSLIDER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_actionslider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_actionslider, function_type>,
         ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_ACTIONSLIDER_EVENT_ACCESS_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_actionslider>)
{
   return (ELM_ACTIONSLIDER_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_ACTIONSLIDER_HH

