#ifndef EFL_GENERATED_ELM_APP_CLIENT_HH
#define EFL_GENERATED_ELM_APP_CLIENT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_app_client.eo.h"
}

#include <string>

struct elm_app_client
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_app_client(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_app_client(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   elm_app_client(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_client(_c0(_p))
   {}

   /// @param package Package of application
   ///
   elm_app_client(std::string package_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_client(_c1(package_, _p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_app_client(elm_app_client const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_app_client() {}

   /// @brief Close all views of application.
   ///
   void view_all_close() const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_all_close());
   }

   /// @brief Terminate application.
   ///
   void terminate() const
   {
      eo_do(_eo_ptr(), ::elm_app_client_terminate());
   }

   /// @brief Open a application view.
   ///
   /// @param args an array of
   /// @param view_open_cb callback to be called when view open
   /// @param data calback user data
   ///
   Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_) const
   {
      Elm_App_Client_Pending * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
      return _tmp_ret;
   }

   /// @brief Cancel a pending elm_app_client_view_open().
   ///
   /// @param pending the view open handler
   ///
   void view_open_cancel(Elm_App_Client_Pending * pending_) const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_open_cancel(pending_));
   }

   /// @param ret the iterator with all views, must be freed after use
   ///
   Eina_Iterator * views_get() const
   {
      Eina_Iterator * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_views_get());
      return _tmp_ret;
   }

   /// @param ret application package
   ///
   std::string package_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_package_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_created_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_CREATED );
   }

   template <typename T>
   void
   callback_view_created_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_view_deleted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_DELETED );
   }

   template <typename T>
   void
   callback_view_deleted_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_view_list_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED );
   }

   template <typename T>
   void
   callback_view_list_loaded_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_application_terminated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED );
   }

   template <typename T>
   void
   callback_application_terminated_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_CLIENT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_CLIENT_CLASS, _p._eo_raw, eo_constructor());
   }

   static Eo* _c1(std::string package_, efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_CLIENT_CLASS, _p._eo_raw, elm_app_client_constructor(efl::eolian::to_c(package_)));
   }

};
template <typename T>
void _elm_app_client_view_all_close_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->view_all_close();
}

template <typename T>
void _elm_app_client_terminate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->terminate();
}

template <typename T>
Elm_App_Client_Pending * _elm_app_client_view_open_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_)
{
   return static_cast<T*>(self->this_)->view_open(args_, view_open_cb_, data_);
}

template <typename T>
void _elm_app_client_view_open_cancel_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_App_Client_Pending * pending_)
{
   static_cast<T*>(self->this_)->view_open_cancel(pending_);
}

template <typename T>
Eina_Iterator * _elm_app_client_views_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->views_get();
}

template <typename T>
std::string _elm_app_client_package_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->package_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_app_client >
{
   template <typename T>
   struct type
   {
      virtual void view_all_close()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_all_close());
      }

      virtual void terminate()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_terminate());
      }

      virtual Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_)
      {
         Elm_App_Client_Pending * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
            return _tmp_ret;
      }

      virtual void view_open_cancel(Elm_App_Client_Pending * pending_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_open_cancel(pending_));
      }

      virtual Eina_Iterator * views_get()
      {
         Eina_Iterator * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_views_get());
            return _tmp_ret;
      }

      virtual std::string package_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_package_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_app_client >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_app_client>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_app_client_view_all_close_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_all_close);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_app_client_terminate_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_app_client_terminate);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_app_client_view_open_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_open);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_app_client_view_open_cancel_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_open_cancel);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_app_client_views_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_app_client_views_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_app_client_package_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_app_client_package_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_app_client >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_app_client >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client, ::std::tuple<std::string> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::elm_app_client_constructor(::efl::eolian::to_c(args.get<0>())));
}

inline void
call_constructor(tag< ::elm_app_client >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_app_client>
{
   template <typename U>
   struct type
   {
      operator ::elm_app_client() const
      {
         return ::elm_app_client(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void view_all_close()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_all_close());
      }

      void terminate()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_terminate());
      }

      Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_)
      {
         Elm_App_Client_Pending * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_open(args_, view_open_cb_, data_));
            return _tmp_ret;
      }

      void view_open_cancel(Elm_App_Client_Pending * pending_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_open_cancel(pending_));
      }

      Eina_Iterator * views_get()
      {
         Eina_Iterator * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_views_get());
            return _tmp_ret;
      }

      std::string package_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_package_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_created_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_CREATED );
   }

   template <typename T>
   void
   callback_view_created_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_view_deleted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_DELETED );
   }

   template <typename T>
   void
   callback_view_deleted_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_view_list_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED );
   }

   template <typename T>
   void
   callback_view_list_loaded_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_application_terminated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED );
   }

   template <typename T>
   void
   callback_application_terminated_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_app_client>)
{
   return (ELM_APP_CLIENT_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_APP_CLIENT_HH

