#ifndef EFL_GENERATED_ELM_APP_CLIENT_VIEW_HH
#define EFL_GENERATED_ELM_APP_CLIENT_VIEW_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_app_client_view.eo.h"
}

#include <string>

struct elm_app_client_view
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_app_client_view(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_app_client_view(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   elm_app_client_view(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_client_view(_c0(_p))
   {}

   /// @param path DBus path of view
   ///
   elm_app_client_view(std::string path_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_client_view(_c1(path_, _p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_app_client_view(elm_app_client_view const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_app_client_view() {}

   /// @brief Pause view
   ///
   /// @param cb callback to be called when view was paused
   /// @param data callback user data
   ///
   void pause(Elm_App_Client_View_Cb cb_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_pause(cb_, data_));
   }

   /// @brief Resume view
   ///
   /// @param cb callback to be called when view was resumed
   /// @param data callback user data
   ///
   void resume(Elm_App_Client_View_Cb cb_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_resume(cb_, data_));
   }

   /// @brief Close view
   ///
   /// @param cb callback to be called when view was closed
   /// @param data callback user data
   ///
   void close(Elm_App_Client_View_Cb cb_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_close(cb_, data_));
   }

   /// @param state state of view
   ///
   Elm_App_View_State state_get() const
   {
      Elm_App_View_State _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_state_get());
      return _tmp_ret;
   }

   /// @param events number of events of view
   ///
   int new_events_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_new_events_get());
      return _tmp_ret;
   }

   /// @param window window of view
   ///
   int window_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_window_get());
      return _tmp_ret;
   }

   /// @param w icon width
   /// @param h icon height
   /// @param has_alpha if icon have alpha channel
   /// @param pixels uchar array, with all bytes of icon
   ///
   void icon_pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const
   {
      eo_do(_eo_ptr(), ::elm_app_client_view_icon_pixels_get(w_, h_, has_alpha_, pixels_));
   }

   /// @param ret DBus path of view
   ///
   std::string path_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_path_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param ret Package of application
   ///
   std::string package_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_package_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param ret icon path of view
   ///
   std::string icon_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_icon_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param progress progress of view
   ///
   unsigned short progress_get() const
   {
      unsigned short _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_progress_get());
      return _tmp_ret;
   }

   /// @param ret title of view
   ///
   std::string title_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_client_view_title_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED );
   }

   template <typename T>
   void
   callback_title_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_icon_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED );
   }

   template <typename T>
   void
   callback_icon_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_icon_pixels_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED );
   }

   template <typename T>
   void
   callback_icon_pixels_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_new_events_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED );
   }

   template <typename T>
   void
   callback_new_events_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_progress_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED );
   }

   template <typename T>
   void
   callback_progress_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED );
   }

   template <typename T>
   void
   callback_window_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_CLIENT_VIEW_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_CLIENT_VIEW_CLASS, _p._eo_raw, eo_constructor());
   }

   static Eo* _c1(std::string path_, efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_CLIENT_VIEW_CLASS, _p._eo_raw, elm_app_client_view_constructor(efl::eolian::to_c(path_)));
   }

};
template <typename T>
void _elm_app_client_view_pause_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_App_Client_View_Cb cb_, const void * data_)
{
   static_cast<T*>(self->this_)->pause(cb_, data_);
}

template <typename T>
void _elm_app_client_view_resume_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_App_Client_View_Cb cb_, const void * data_)
{
   static_cast<T*>(self->this_)->resume(cb_, data_);
}

template <typename T>
void _elm_app_client_view_close_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_App_Client_View_Cb cb_, const void * data_)
{
   static_cast<T*>(self->this_)->close(cb_, data_);
}

template <typename T>
Elm_App_View_State _elm_app_client_view_state_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->state_get();
}

template <typename T>
int _elm_app_client_view_new_events_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->new_events_get();
}

template <typename T>
int _elm_app_client_view_window_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->window_get();
}

template <typename T>
void _elm_app_client_view_icon_pixels_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
{
   static_cast<T*>(self->this_)->icon_pixels_get(w_, h_, has_alpha_, pixels_);
}

template <typename T>
std::string _elm_app_client_view_path_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->path_get();
}

template <typename T>
std::string _elm_app_client_view_package_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->package_get();
}

template <typename T>
std::string _elm_app_client_view_icon_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->icon_get();
}

template <typename T>
unsigned short _elm_app_client_view_progress_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->progress_get();
}

template <typename T>
std::string _elm_app_client_view_title_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->title_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_app_client_view >
{
   template <typename T>
   struct type
   {
      virtual void pause(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_pause(cb_, data_));
      }

      virtual void resume(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_resume(cb_, data_));
      }

      virtual void close(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_close(cb_, data_));
      }

      virtual Elm_App_View_State state_get()
      {
         Elm_App_View_State _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_state_get());
            return _tmp_ret;
      }

      virtual int new_events_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_new_events_get());
            return _tmp_ret;
      }

      virtual int window_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_window_get());
            return _tmp_ret;
      }

      virtual void icon_pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_client_view_icon_pixels_get(w_, h_, has_alpha_, pixels_));
      }

      virtual std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string package_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_package_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string icon_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_icon_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual unsigned short progress_get()
      {
         unsigned short _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_progress_get());
            return _tmp_ret;
      }

      virtual std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_client_view_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_app_client_view >
{
   static const int value = 12;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_app_client_view>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_app_client_view_pause_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_pause);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_app_client_view_resume_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_resume);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_app_client_view_close_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_close);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_app_client_view_state_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_state_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_app_client_view_new_events_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_new_events_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_app_client_view_window_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_window_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_app_client_view_icon_pixels_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_icon_pixels_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_app_client_view_path_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_path_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_app_client_view_package_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_package_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_app_client_view_icon_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_icon_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_app_client_view_progress_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_progress_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_app_client_view_title_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_app_client_view_title_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_app_client_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client_view, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_app_client_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client_view, ::std::tuple<std::string> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::elm_app_client_view_constructor(::efl::eolian::to_c(args.get<0>())));
}

inline void
call_constructor(tag< ::elm_app_client_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_client_view, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_app_client_view>
{
   template <typename U>
   struct type
   {
      operator ::elm_app_client_view() const
      {
         return ::elm_app_client_view(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void pause(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_pause(cb_, data_));
      }

      void resume(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_resume(cb_, data_));
      }

      void close(Elm_App_Client_View_Cb cb_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_close(cb_, data_));
      }

      Elm_App_View_State state_get()
      {
         Elm_App_View_State _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_state_get());
            return _tmp_ret;
      }

      int new_events_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_new_events_get());
            return _tmp_ret;
      }

      int window_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_window_get());
            return _tmp_ret;
      }

      void icon_pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_client_view_icon_pixels_get(w_, h_, has_alpha_, pixels_));
      }

      std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string package_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_package_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string icon_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_icon_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      unsigned short progress_get()
      {
         unsigned short _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_progress_get());
            return _tmp_ret;
      }

      std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_client_view_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_STATE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_title_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED );
   }

   template <typename T>
   void
   callback_title_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_TITLE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_icon_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED );
   }

   template <typename T>
   void
   callback_icon_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_icon_pixels_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED );
   }

   template <typename T>
   void
   callback_icon_pixels_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_ICON_PIXELS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_new_events_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED );
   }

   template <typename T>
   void
   callback_new_events_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_NEW_EVENTS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_progress_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED );
   }

   template <typename T>
   void
   callback_progress_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_PROGRESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED );
   }

   template <typename T>
   void
   callback_window_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_WINDOW_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_client_view, function_type>,
         ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_VIEW_EVENT_PROPERTY_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_app_client_view>)
{
   return (ELM_APP_CLIENT_VIEW_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_APP_CLIENT_VIEW_HH

