#ifndef EFL_GENERATED_ELM_APP_SERVER_VIEW_HH
#define EFL_GENERATED_ELM_APP_SERVER_VIEW_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_app_server_view.eo.h"
}

#include <canvas/evas_object.eo.hh>
#include <string>

struct elm_app_server_view
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_app_server_view(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_app_server_view(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   elm_app_server_view(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_server_view(_c0(_p))
   {}

   /// @param id identifier of view
   ///
   elm_app_server_view(std::string id_, efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_app_server_view(_c1(id_, _p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_app_server_view(elm_app_server_view const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_app_server_view() {}

   void pause() const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_pause());
   }

   void resume() const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_resume());
   }

   void shallow() const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_shallow());
   }

   void close() const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_close());
   }

   /// @param progress 
   ///
   short progress_get() const
   {
      short _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_progress_get());
      return _tmp_ret;
   }

   /// @param progress 
   ///
   void progress_set(short progress_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_progress_set(progress_));
   }

   /// @param events 
   ///
   int new_events_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_new_events_get());
      return _tmp_ret;
   }

   /// @param events 
   ///
   void new_events_set(int events_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_new_events_set(events_));
   }

   /// @param icon 
   ///
   std::string icon_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_icon_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param icon 
   ///
   void icon_set(std::string icon_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_icon_set(efl::eolian::to_c(icon_)));
   }

   /// @param title 
   ///
   std::string title_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_title_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param title 
   ///
   void title_set(std::string title_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_title_set(efl::eolian::to_c(title_)));
   }

   /// @param win 
   ///
   void window_set(evas::object win_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_window_set(efl::eolian::to_c(win_)));
   }

   /// @param ret 
   ///
   Eina_Stringshare * id_get() const
   {
      Eina_Stringshare * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_id_get());
      return _tmp_ret;
   }

   /// @param ret 
   ///
   Elm_App_View_State state_get() const
   {
      Elm_App_View_State _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_state_get());
      return _tmp_ret;
   }

   /// @param ret 
   ///
   std::string path_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_app_server_view_path_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w 
   /// @param h 
   /// @param has_alpha 
   /// @param pixels 
   ///
   void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_pixels_get(w_, h_, has_alpha_, pixels_));
   }

   /// @param w 
   /// @param h 
   /// @param has_alpha 
   /// @param pixels 
   ///
   void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_) const
   {
      eo_do(_eo_ptr(), ::elm_app_server_view_pixels_set(w_, h_, efl::eolian::to_c(has_alpha_), pixels_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_resumed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_RESUMED );
   }

   template <typename T>
   void
   callback_resumed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_paused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_PAUSED );
   }

   template <typename T>
   void
   callback_paused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_closed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_CLOSED );
   }

   template <typename T>
   void
   callback_closed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_shallow_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SHALLOW );
   }

   template <typename T>
   void
   callback_shallow_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_save_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SAVE );
   }

   template <typename T>
   void
   callback_save_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_SERVER_VIEW_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_SERVER_VIEW_CLASS, _p._eo_raw, eo_constructor());
   }

   static Eo* _c1(std::string id_, efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_APP_SERVER_VIEW_CLASS, _p._eo_raw, elm_app_server_view_constructor(efl::eolian::to_c(id_)));
   }

};
template <typename T>
void _elm_app_server_view_pause_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->pause();
}

template <typename T>
void _elm_app_server_view_resume_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->resume();
}

template <typename T>
void _elm_app_server_view_shallow_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->shallow();
}

template <typename T>
void _elm_app_server_view_close_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->close();
}

template <typename T>
short _elm_app_server_view_progress_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->progress_get();
}

template <typename T>
void _elm_app_server_view_progress_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, short progress_)
{
   static_cast<T*>(self->this_)->progress_set(progress_);
}

template <typename T>
int _elm_app_server_view_new_events_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->new_events_get();
}

template <typename T>
void _elm_app_server_view_new_events_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int events_)
{
   static_cast<T*>(self->this_)->new_events_set(events_);
}

template <typename T>
std::string _elm_app_server_view_icon_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->icon_get();
}

template <typename T>
void _elm_app_server_view_icon_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * icon_)
{
   static_cast<T*>(self->this_)->icon_set(efl::eolian::to_cxx<std::string>(icon_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_app_server_view_title_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->title_get();
}

template <typename T>
void _elm_app_server_view_title_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   static_cast<T*>(self->this_)->title_set(efl::eolian::to_cxx<std::string>(title_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_app_server_view_window_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * win_)
{
   static_cast<T*>(self->this_)->window_set(efl::eolian::to_cxx<evas::object>(win_, std::tuple<std::false_type>()));
}

template <typename T>
Eina_Stringshare * _elm_app_server_view_id_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->id_get();
}

template <typename T>
Elm_App_View_State _elm_app_server_view_state_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->state_get();
}

template <typename T>
std::string _elm_app_server_view_path_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->path_get();
}

template <typename T>
void _elm_app_server_view_pixels_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
{
   static_cast<T*>(self->this_)->pixels_get(w_, h_, has_alpha_, pixels_);
}

template <typename T>
void _elm_app_server_view_pixels_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, unsigned int w_, unsigned int h_, Eina_Bool has_alpha_, const unsigned char * pixels_)
{
   static_cast<T*>(self->this_)->pixels_set(w_, h_, efl::eolian::to_cxx<bool>(has_alpha_, std::tuple<std::false_type>()), pixels_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_app_server_view >
{
   template <typename T>
   struct type
   {
      virtual void pause()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_pause());
      }

      virtual void resume()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_resume());
      }

      virtual void shallow()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_shallow());
      }

      virtual void close()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_close());
      }

      virtual short progress_get()
      {
         short _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_progress_get());
            return _tmp_ret;
      }

      virtual void progress_set(short progress_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_progress_set(progress_));
      }

      virtual int new_events_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_new_events_get());
            return _tmp_ret;
      }

      virtual void new_events_set(int events_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_new_events_set(events_));
      }

      virtual std::string icon_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_icon_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_set(std::string icon_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_icon_set(efl::eolian::to_c(icon_)));
      }

      virtual std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void title_set(std::string title_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_title_set(efl::eolian::to_c(title_)));
      }

      virtual void window_set(evas::object win_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_window_set(efl::eolian::to_c(win_)));
      }

      virtual Eina_Stringshare * id_get()
      {
         Eina_Stringshare * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_id_get());
            return _tmp_ret;
      }

      virtual Elm_App_View_State state_get()
      {
         Elm_App_View_State _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_state_get());
            return _tmp_ret;
      }

      virtual std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_app_server_view_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_pixels_get(w_, h_, has_alpha_, pixels_));
      }

      virtual void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_app_server_view_pixels_set(w_, h_, efl::eolian::to_c(has_alpha_), pixels_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_app_server_view >
{
   static const int value = 18;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_app_server_view>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_app_server_view_pause_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_pause);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_app_server_view_resume_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_resume);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_app_server_view_shallow_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_shallow);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_app_server_view_close_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_close);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_app_server_view_progress_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_progress_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_app_server_view_progress_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_progress_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_app_server_view_new_events_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_new_events_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_app_server_view_new_events_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_new_events_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_app_server_view_icon_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_icon_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_app_server_view_icon_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_icon_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_app_server_view_title_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_title_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_app_server_view_title_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_title_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_app_server_view_window_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_window_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_app_server_view_id_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_id_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_app_server_view_state_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_state_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_app_server_view_path_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_path_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_app_server_view_pixels_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_pixels_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_app_server_view_pixels_set_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_app_server_view_pixels_set);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_app_server_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_server_view, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_app_server_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_server_view, ::std::tuple<std::string> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::elm_app_server_view_constructor(::efl::eolian::to_c(args.get<0>())));
}

inline void
call_constructor(tag< ::elm_app_server_view >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_app_server_view, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_app_server_view>
{
   template <typename U>
   struct type
   {
      operator ::elm_app_server_view() const
      {
         return ::elm_app_server_view(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void pause()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_pause());
      }

      void resume()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_resume());
      }

      void shallow()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_shallow());
      }

      void close()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_close());
      }

      short progress_get()
      {
         short _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_progress_get());
            return _tmp_ret;
      }

      void progress_set(short progress_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_progress_set(progress_));
      }

      int new_events_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_new_events_get());
            return _tmp_ret;
      }

      void new_events_set(int events_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_new_events_set(events_));
      }

      std::string icon_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_icon_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void icon_set(std::string icon_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_icon_set(efl::eolian::to_c(icon_)));
      }

      std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void title_set(std::string title_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_title_set(efl::eolian::to_c(title_)));
      }

      void window_set(evas::object win_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_window_set(efl::eolian::to_c(win_)));
      }

      Eina_Stringshare * id_get()
      {
         Eina_Stringshare * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_id_get());
            return _tmp_ret;
      }

      Elm_App_View_State state_get()
      {
         Elm_App_View_State _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_state_get());
            return _tmp_ret;
      }

      std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_app_server_view_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_pixels_get(w_, h_, has_alpha_, pixels_));
      }

      void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_app_server_view_pixels_set(w_, h_, efl::eolian::to_c(has_alpha_), pixels_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_resumed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_RESUMED );
   }

   template <typename T>
   void
   callback_resumed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_paused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_PAUSED );
   }

   template <typename T>
   void
   callback_paused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_closed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_CLOSED );
   }

   template <typename T>
   void
   callback_closed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_shallow_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SHALLOW );
   }

   template <typename T>
   void
   callback_shallow_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_save_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, priority_,
            &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SAVE );
   }

   template <typename T>
   void
   callback_save_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_app_server_view>)
{
   return (ELM_APP_SERVER_VIEW_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_APP_SERVER_VIEW_HH

