#ifndef EFL_GENERATED_ELM_BG_HH
#define EFL_GENERATED_ELM_BG_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_bg.eo.h"
}

#include "elm_layout.eo.hh"
#include <string>

struct elm_bg
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_bg(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_bg(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_bg(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_bg(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_bg(elm_bg const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_bg() {}

   /// @param option The desired background option (see #Elm_Bg_Option)
   ///
   Elm_Bg_Option option_get() const
   {
      Elm_Bg_Option _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_bg_option_get());
      return _tmp_ret;
   }

   /// @param option The desired background option (see #Elm_Bg_Option)
   ///
   void option_set(Elm_Bg_Option option_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bg_option_set(option_));
   }

   /// @param r The red color component's value
   /// @param g The green color component's value
   /// @param b The blue color component's value
   /// @param a The blue color component's value
   ///
   void color_get(int* r_, int* g_, int* b_, int* a_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bg_color_get(r_, g_, b_, a_));
   }

   /// @param r The red color component's value
   /// @param g The green color component's value
   /// @param b The blue color component's value
   /// @param a The blue color component's value
   ///
   void color_set(int r_, int g_, int b_, int a_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bg_color_set(r_, g_, b_, a_));
   }

   /// @param file The file path
   /// @param group Optional key (group in Edje) within the file
   ///
   void file_get(const char ** file_, const char ** group_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bg_file_get(file_, group_));
   }

   /// @param file The file path
   /// @param group Optional key (group in Edje) within the file
   ///
   bool file_set(std::string file_, std::string group_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_bg_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w The new width of the image pixmap representation.
   /// @param h The new height of the image pixmap representation.
   ///
   void load_size_set(Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bg_load_size_set(w_, h_));
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_BG_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_BG_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Bg_Option _elm_bg_option_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->option_get();
}

template <typename T>
void _elm_bg_option_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Bg_Option option_)
{
   static_cast<T*>(self->this_)->option_set(option_);
}

template <typename T>
void _elm_bg_color_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* r_, int* g_, int* b_, int* a_)
{
   static_cast<T*>(self->this_)->color_get(r_, g_, b_, a_);
}

template <typename T>
void _elm_bg_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   static_cast<T*>(self->this_)->color_set(r_, g_, b_, a_);
}

template <typename T>
void _elm_bg_file_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char ** file_, const char ** group_)
{
   static_cast<T*>(self->this_)->file_get(file_, group_);
}

template <typename T>
bool _elm_bg_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * group_)
{
   return static_cast<T*>(self->this_)->file_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(group_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_bg_load_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->load_size_set(w_, h_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_bg >
{
   template <typename T>
   struct type
   {
      virtual Elm_Bg_Option option_get()
      {
         Elm_Bg_Option _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_bg_option_get());
            return _tmp_ret;
      }

      virtual void option_set(Elm_Bg_Option option_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_option_set(option_));
      }

      virtual void color_get(int* r_, int* g_, int* b_, int* a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_color_get(r_, g_, b_, a_));
      }

      virtual void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_color_set(r_, g_, b_, a_));
      }

      virtual void file_get(const char ** file_, const char ** group_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_file_get(file_, group_));
      }

      virtual bool file_set(std::string file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_bg_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void load_size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bg_load_size_set(w_, h_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_bg >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_bg>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_bg_option_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_option_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_bg_option_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_option_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_bg_color_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_color_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_bg_color_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_color_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_bg_file_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_file_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_bg_file_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_file_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_bg_load_size_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_bg_load_size_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_bg >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_bg, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_bg >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_bg, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_bg>
{
   template <typename U>
   struct type
   {
      operator ::elm_bg() const
      {
         return ::elm_bg(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Bg_Option option_get()
      {
         Elm_Bg_Option _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_bg_option_get());
            return _tmp_ret;
      }

      void option_set(Elm_Bg_Option option_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bg_option_set(option_));
      }

      void color_get(int* r_, int* g_, int* b_, int* a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bg_color_get(r_, g_, b_, a_));
      }

      void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bg_color_set(r_, g_, b_, a_));
      }

      void file_get(const char ** file_, const char ** group_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bg_file_get(file_, group_));
      }

      bool file_set(std::string file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_bg_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void load_size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bg_load_size_set(w_, h_));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_bg>)
{
   return (ELM_BG_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_BG_HH

