#ifndef EFL_GENERATED_ELM_BUBBLE_HH
#define EFL_GENERATED_ELM_BUBBLE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_bubble.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_bubble
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_bubble(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_bubble(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_bubble(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_bubble(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_bubble(elm_bubble const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_bubble() {}

   /// @param pos The given corner for the bubble.
   ///
   Elm_Bubble_Pos pos_get() const
   {
      Elm_Bubble_Pos _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_bubble_pos_get());
      return _tmp_ret;
   }

   /// @param pos The given corner for the bubble.
   ///
   void pos_set(Elm_Bubble_Pos pos_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_bubble_pos_set(pos_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_BUBBLE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_BUBBLE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Bubble_Pos _elm_bubble_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->pos_get();
}

template <typename T>
void _elm_bubble_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Bubble_Pos pos_)
{
   static_cast<T*>(self->this_)->pos_set(pos_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_bubble >
{
   template <typename T>
   struct type
   {
      virtual Elm_Bubble_Pos pos_get()
      {
         Elm_Bubble_Pos _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_bubble_pos_get());
            return _tmp_ret;
      }

      virtual void pos_set(Elm_Bubble_Pos pos_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_bubble_pos_set(pos_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_bubble >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_bubble>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_bubble_pos_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_bubble_pos_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_bubble_pos_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_bubble_pos_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_bubble >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_bubble, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_bubble >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_bubble, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_bubble>
{
   template <typename U>
   struct type
   {
      operator ::elm_bubble() const
      {
         return ::elm_bubble(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Bubble_Pos pos_get()
      {
         Elm_Bubble_Pos _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_bubble_pos_get());
            return _tmp_ret;
      }

      void pos_set(Elm_Bubble_Pos pos_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_bubble_pos_set(pos_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_BUBBLE_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_bubble, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_bubble, function_type>,
         ELM_BUBBLE_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_BUBBLE_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_bubble>)
{
   return (ELM_BUBBLE_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_BUBBLE_HH

