#ifndef EFL_GENERATED_ELM_BUTTON_HH
#define EFL_GENERATED_ELM_BUTTON_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_button.eo.h"
}

#include "elm_layout.eo.hh"
#include "evas_clickable_interface.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"

struct elm_button
      : elm_layout,
      efl::eo::detail::extension_inheritance<evas::clickable_interface>::template type< ::elm_button>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_button>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_button(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_button(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_button(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_button(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_button(elm_button const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_button() {}

   /// @param t Timeout in seconds
   ///
   double autorepeat_initial_timeout_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
      return _tmp_ret;
   }

   /// @param t Timeout in seconds
   ///
   void autorepeat_initial_timeout_set(double t_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_button_autorepeat_initial_timeout_set(t_));
   }

   /// @param t Interval in seconds
   ///
   double autorepeat_gap_timeout_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
      return _tmp_ret;
   }

   /// @param t Interval in seconds
   ///
   void autorepeat_gap_timeout_set(double t_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_button_autorepeat_gap_timeout_set(t_));
   }

   /// @param on A bool to turn on/off the event
   ///
   bool autorepeat_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param on A bool to turn on/off the event
   ///
   void autorepeat_set(bool on_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_button_autorepeat_set(efl::eolian::to_c(on_)));
   }

   /// @param ret 
   ///
   bool admits_autorepeat_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_BUTTON_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_BUTTON_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
double _elm_button_autorepeat_initial_timeout_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->autorepeat_initial_timeout_get();
}

template <typename T>
void _elm_button_autorepeat_initial_timeout_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double t_)
{
   static_cast<T*>(self->this_)->autorepeat_initial_timeout_set(t_);
}

template <typename T>
double _elm_button_autorepeat_gap_timeout_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->autorepeat_gap_timeout_get();
}

template <typename T>
void _elm_button_autorepeat_gap_timeout_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double t_)
{
   static_cast<T*>(self->this_)->autorepeat_gap_timeout_set(t_);
}

template <typename T>
bool _elm_button_autorepeat_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->autorepeat_get();
}

template <typename T>
void _elm_button_autorepeat_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool on_)
{
   static_cast<T*>(self->this_)->autorepeat_set(efl::eolian::to_cxx<bool>(on_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_button_admits_autorepeat_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->admits_autorepeat_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_button >
{
   template <typename T>
   struct type
   {
      virtual double autorepeat_initial_timeout_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
            return _tmp_ret;
      }

      virtual void autorepeat_initial_timeout_set(double t_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_initial_timeout_set(t_));
      }

      virtual double autorepeat_gap_timeout_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
            return _tmp_ret;
      }

      virtual void autorepeat_gap_timeout_set(double t_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_gap_timeout_set(t_));
      }

      virtual bool autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_autorepeat_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autorepeat_set(bool on_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_button_autorepeat_set(efl::eolian::to_c(on_)));
      }

      virtual bool admits_autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_button >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_button>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_initial_timeout_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_initial_timeout_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_initial_timeout_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_initial_timeout_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_gap_timeout_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_gap_timeout_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_gap_timeout_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_gap_timeout_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_button_autorepeat_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_button_autorepeat_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_button_admits_autorepeat_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_button_admits_autorepeat_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_button >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_button, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_button >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_button, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_button>
{
   template <typename U>
   struct type
   {
      operator ::elm_button() const
      {
         return ::elm_button(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      double autorepeat_initial_timeout_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_initial_timeout_get());
            return _tmp_ret;
      }

      void autorepeat_initial_timeout_set(double t_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_button_autorepeat_initial_timeout_set(t_));
      }

      double autorepeat_gap_timeout_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_gap_timeout_get());
            return _tmp_ret;
      }

      void autorepeat_gap_timeout_set(double t_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_button_autorepeat_gap_timeout_set(t_));
      }

      bool autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_button_autorepeat_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void autorepeat_set(bool on_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_button_autorepeat_set(efl::eolian::to_c(on_)));
      }

      bool admits_autorepeat_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_button_admits_autorepeat_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_button>)
{
   return (ELM_BUTTON_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_BUTTON_HH

