#ifndef EFL_GENERATED_ELM_CLOCK_HH
#define EFL_GENERATED_ELM_CLOCK_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_clock.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_clock
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_clock(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_clock(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_clock(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_clock(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_clock(elm_clock const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_clock() {}

   /// @param am_pm @c EINA_TRUE to put it in am/pm mode, @c EINA_FALSE
   /// to military mode
   ///
   bool show_am_pm_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_am_pm_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param am_pm @c EINA_TRUE to put it in am/pm mode, @c EINA_FALSE
   /// to military mode
   ///
   void show_am_pm_set(bool am_pm_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_show_am_pm_set(efl::eolian::to_c(am_pm_)));
   }

   /// @param interval The first interval value in seconds
   ///
   double first_interval_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_first_interval_get());
      return _tmp_ret;
   }

   /// @param interval The first interval value in seconds
   ///
   void first_interval_set(double interval_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_first_interval_set(interval_));
   }

   /// @param seconds @c EINA_TRUE to show seconds, @c EINA_FALSE otherwise
   ///
   bool show_seconds_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_seconds_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param seconds @c EINA_TRUE to show seconds, @c EINA_FALSE otherwise
   ///
   void show_seconds_set(bool seconds_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_show_seconds_set(efl::eolian::to_c(seconds_)));
   }

   /// @param edit @c EINA_TRUE to put it in edition, @c EINA_FALSE to
   /// put it back to "displaying only" mode
   ///
   bool edit_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param edit @c EINA_TRUE to put it in edition, @c EINA_FALSE to
   /// put it back to "displaying only" mode
   ///
   void edit_set(bool edit_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_edit_set(efl::eolian::to_c(edit_)));
   }

   /// @param paused @c EINA_TRUE to pause clock, @c EINA_FALSE otherwise
   ///
   bool pause_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_pause_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param paused @c EINA_TRUE to pause clock, @c EINA_FALSE otherwise
   ///
   void pause_set(bool paused_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_pause_set(efl::eolian::to_c(paused_)));
   }

   /// @param hrs The hours to set
   /// @param min The minutes to set
   /// @param sec The seconds to set
   ///
   void time_get(int* hrs_, int* min_, int* sec_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_time_get(hrs_, min_, sec_));
   }

   /// @param hrs The hours to set
   /// @param min The minutes to set
   /// @param sec The seconds to set
   ///
   void time_set(int hrs_, int min_, int sec_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_time_set(hrs_, min_, sec_));
   }

   /// @param digedit Bit mask indicating the digits to be editable
   /// (values in #Elm_Clock_Edit_Mode).
   ///
   Elm_Clock_Edit_Mode edit_mode_get() const
   {
      Elm_Clock_Edit_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_mode_get());
      return _tmp_ret;
   }

   /// @param digedit Bit mask indicating the digits to be editable
   /// (values in #Elm_Clock_Edit_Mode).
   ///
   void edit_mode_set(Elm_Clock_Edit_Mode digedit_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_clock_edit_mode_set(digedit_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_CLOCK_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_CLOCK_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _elm_clock_show_am_pm_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->show_am_pm_get();
}

template <typename T>
void _elm_clock_show_am_pm_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool am_pm_)
{
   static_cast<T*>(self->this_)->show_am_pm_set(efl::eolian::to_cxx<bool>(am_pm_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_clock_first_interval_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->first_interval_get();
}

template <typename T>
void _elm_clock_first_interval_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double interval_)
{
   static_cast<T*>(self->this_)->first_interval_set(interval_);
}

template <typename T>
bool _elm_clock_show_seconds_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->show_seconds_get();
}

template <typename T>
void _elm_clock_show_seconds_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool seconds_)
{
   static_cast<T*>(self->this_)->show_seconds_set(efl::eolian::to_cxx<bool>(seconds_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_clock_edit_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->edit_get();
}

template <typename T>
void _elm_clock_edit_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool edit_)
{
   static_cast<T*>(self->this_)->edit_set(efl::eolian::to_cxx<bool>(edit_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_clock_pause_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->pause_get();
}

template <typename T>
void _elm_clock_pause_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool paused_)
{
   static_cast<T*>(self->this_)->pause_set(efl::eolian::to_cxx<bool>(paused_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_clock_time_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* hrs_, int* min_, int* sec_)
{
   static_cast<T*>(self->this_)->time_get(hrs_, min_, sec_);
}

template <typename T>
void _elm_clock_time_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int hrs_, int min_, int sec_)
{
   static_cast<T*>(self->this_)->time_set(hrs_, min_, sec_);
}

template <typename T>
Elm_Clock_Edit_Mode _elm_clock_edit_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->edit_mode_get();
}

template <typename T>
void _elm_clock_edit_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Clock_Edit_Mode digedit_)
{
   static_cast<T*>(self->this_)->edit_mode_set(digedit_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_clock >
{
   template <typename T>
   struct type
   {
      virtual bool show_am_pm_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_show_am_pm_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void show_am_pm_set(bool am_pm_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_show_am_pm_set(efl::eolian::to_c(am_pm_)));
      }

      virtual double first_interval_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_first_interval_get());
            return _tmp_ret;
      }

      virtual void first_interval_set(double interval_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_first_interval_set(interval_));
      }

      virtual bool show_seconds_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_show_seconds_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void show_seconds_set(bool seconds_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_show_seconds_set(efl::eolian::to_c(seconds_)));
      }

      virtual bool edit_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_edit_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void edit_set(bool edit_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_edit_set(efl::eolian::to_c(edit_)));
      }

      virtual bool pause_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_pause_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void pause_set(bool paused_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_pause_set(efl::eolian::to_c(paused_)));
      }

      virtual void time_get(int* hrs_, int* min_, int* sec_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_time_get(hrs_, min_, sec_));
      }

      virtual void time_set(int hrs_, int min_, int sec_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_time_set(hrs_, min_, sec_));
      }

      virtual Elm_Clock_Edit_Mode edit_mode_get()
      {
         Elm_Clock_Edit_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_clock_edit_mode_get());
            return _tmp_ret;
      }

      virtual void edit_mode_set(Elm_Clock_Edit_Mode digedit_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_clock_edit_mode_set(digedit_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_clock >
{
   static const int value = 14;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_clock>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_clock_show_am_pm_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_am_pm_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_clock_show_am_pm_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_am_pm_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_clock_first_interval_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_first_interval_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_clock_first_interval_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_first_interval_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_clock_show_seconds_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_seconds_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_clock_show_seconds_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_show_seconds_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_clock_edit_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_clock_edit_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_clock_pause_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_pause_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_clock_pause_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_pause_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_clock_time_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_time_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_clock_time_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_time_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_clock_edit_mode_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_mode_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_clock_edit_mode_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_clock_edit_mode_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_clock >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_clock, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_clock >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_clock, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_clock>
{
   template <typename U>
   struct type
   {
      operator ::elm_clock() const
      {
         return ::elm_clock(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool show_am_pm_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_am_pm_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void show_am_pm_set(bool am_pm_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_show_am_pm_set(efl::eolian::to_c(am_pm_)));
      }

      double first_interval_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_first_interval_get());
            return _tmp_ret;
      }

      void first_interval_set(double interval_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_first_interval_set(interval_));
      }

      bool show_seconds_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_show_seconds_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void show_seconds_set(bool seconds_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_show_seconds_set(efl::eolian::to_c(seconds_)));
      }

      bool edit_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void edit_set(bool edit_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_edit_set(efl::eolian::to_c(edit_)));
      }

      bool pause_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_pause_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void pause_set(bool paused_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_pause_set(efl::eolian::to_c(paused_)));
      }

      void time_get(int* hrs_, int* min_, int* sec_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_time_get(hrs_, min_, sec_));
      }

      void time_set(int hrs_, int min_, int sec_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_time_set(hrs_, min_, sec_));
      }

      Elm_Clock_Edit_Mode edit_mode_get()
      {
         Elm_Clock_Edit_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_clock_edit_mode_get());
            return _tmp_ret;
      }

      void edit_mode_set(Elm_Clock_Edit_Mode digedit_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_clock_edit_mode_set(digedit_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CLOCK_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_clock, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_clock, function_type>,
         ELM_CLOCK_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CLOCK_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_clock>)
{
   return (ELM_CLOCK_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_CLOCK_HH

