#ifndef EFL_GENERATED_ELM_COLORSELECTOR_HH
#define EFL_GENERATED_ELM_COLORSELECTOR_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_colorselector.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <string>

struct elm_colorselector
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_colorselector>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_colorselector(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_colorselector(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_colorselector(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_colorselector(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_colorselector(elm_colorselector const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_colorselector() {}

   /// @brief Add a new color item to palette.
   ///
   /// @return A new color palette Item.
   ///
   /// @ingroup Colorselector
   ///
   /// @param r r-value of color
   /// @param g g-value of color
   /// @param b b-value of color
   /// @param a a-value of color
   ///
   Elm_Object_Item * palette_color_add(int r_, int g_, int b_, int a_) const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
      return _tmp_ret;
   }

   /// @brief Clear the palette items.
   ///
   /// @ingroup Colorselector
   ///
   void palette_clear() const
   {
      eo_do(_eo_ptr(), ::elm_obj_colorselector_palette_clear());
   }

   /// @param r r-value of color
   /// @param g g-value of color
   /// @param b b-value of color
   /// @param a a-value of color
   ///
   void color_get(int* r_, int* g_, int* b_, int* a_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
   }

   /// @param r r-value of color
   /// @param g g-value of color
   /// @param b b-value of color
   /// @param a a-value of color
   ///
   void color_set(int r_, int g_, int b_, int a_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
   }

   /// @param palette_name Name of palette
   ///
   std::string palette_name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param palette_name Name of palette
   ///
   void palette_name_set(std::string palette_name_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_colorselector_palette_name_set(efl::eolian::to_c(palette_name_)));
   }

   /// @param mode Elm_Colorselector_Mode
   ///
   Elm_Colorselector_Mode mode_get() const
   {
      Elm_Colorselector_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_mode_get());
      return _tmp_ret;
   }

   /// @param mode Elm_Colorselector_Mode
   ///
   void mode_set(Elm_Colorselector_Mode mode_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_colorselector_mode_set(mode_));
   }

   const Eina_List * palette_items_get() const
   {
      const Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_items_get());
      return _tmp_ret;
   }

   Elm_Object_Item * palette_selected_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_color_item_selected_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED );
   }

   template <typename T>
   void
   callback_color_item_selected_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_color_item_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED );
   }

   template <typename T>
   void
   callback_color_item_longpressed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_COLORSELECTOR_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_COLORSELECTOR_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Object_Item * _elm_colorselector_palette_color_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   return static_cast<T*>(self->this_)->palette_color_add(r_, g_, b_, a_);
}

template <typename T>
void _elm_colorselector_palette_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->palette_clear();
}

template <typename T>
void _elm_colorselector_color_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* r_, int* g_, int* b_, int* a_)
{
   static_cast<T*>(self->this_)->color_get(r_, g_, b_, a_);
}

template <typename T>
void _elm_colorselector_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   static_cast<T*>(self->this_)->color_set(r_, g_, b_, a_);
}

template <typename T>
std::string _elm_colorselector_palette_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->palette_name_get();
}

template <typename T>
void _elm_colorselector_palette_name_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * palette_name_)
{
   static_cast<T*>(self->this_)->palette_name_set(efl::eolian::to_cxx<std::string>(palette_name_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Colorselector_Mode _elm_colorselector_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->mode_get();
}

template <typename T>
void _elm_colorselector_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Colorselector_Mode mode_)
{
   static_cast<T*>(self->this_)->mode_set(mode_);
}

template <typename T>
const Eina_List * _elm_colorselector_palette_items_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->palette_items_get();
}

template <typename T>
Elm_Object_Item * _elm_colorselector_palette_selected_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->palette_selected_item_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_colorselector >
{
   template <typename T>
   struct type
   {
      virtual Elm_Object_Item * palette_color_add(int r_, int g_, int b_, int a_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
            return _tmp_ret;
      }

      virtual void palette_clear()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_palette_clear());
      }

      virtual void color_get(int* r_, int* g_, int* b_, int* a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
      }

      virtual void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
      }

      virtual std::string palette_name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void palette_name_set(std::string palette_name_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_palette_name_set(efl::eolian::to_c(palette_name_)));
      }

      virtual Elm_Colorselector_Mode mode_get()
      {
         Elm_Colorselector_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_Colorselector_Mode mode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_colorselector_mode_set(mode_));
      }

      virtual const Eina_List * palette_items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_items_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * palette_selected_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_colorselector >
{
   static const int value = 10;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_colorselector>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_color_add_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_color_add);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_clear_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_clear);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_colorselector_color_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_color_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_colorselector_color_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_color_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_name_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_name_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_name_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_name_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_colorselector_mode_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_mode_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_colorselector_mode_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_mode_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_items_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_items_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_colorselector_palette_selected_item_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_colorselector_palette_selected_item_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_colorselector >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_colorselector, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_colorselector >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_colorselector, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_colorselector>
{
   template <typename U>
   struct type
   {
      operator ::elm_colorselector() const
      {
         return ::elm_colorselector(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Object_Item * palette_color_add(int r_, int g_, int b_, int a_)
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_color_add(r_, g_, b_, a_));
            return _tmp_ret;
      }

      void palette_clear()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_colorselector_palette_clear());
      }

      void color_get(int* r_, int* g_, int* b_, int* a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_colorselector_color_get(r_, g_, b_, a_));
      }

      void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_colorselector_color_set(r_, g_, b_, a_));
      }

      std::string palette_name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void palette_name_set(std::string palette_name_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_colorselector_palette_name_set(efl::eolian::to_c(palette_name_)));
      }

      Elm_Colorselector_Mode mode_get()
      {
         Elm_Colorselector_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_mode_get());
            return _tmp_ret;
      }

      void mode_set(Elm_Colorselector_Mode mode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_colorselector_mode_set(mode_));
      }

      const Eina_List * palette_items_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_items_get());
            return _tmp_ret;
      }

      Elm_Object_Item * palette_selected_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_colorselector_palette_selected_item_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_color_item_selected_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED );
   }

   template <typename T>
   void
   callback_color_item_selected_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_SELECTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_color_item_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED );
   }

   template <typename T>
   void
   callback_color_item_longpressed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_COLOR_ITEM_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_COLORSELECTOR_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_colorselector, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_colorselector, function_type>,
         ELM_COLORSELECTOR_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_COLORSELECTOR_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_colorselector>)
{
   return (ELM_COLORSELECTOR_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_COLORSELECTOR_HH

