#ifndef EFL_GENERATED_ELM_CONFORMANT_HH
#define EFL_GENERATED_ELM_CONFORMANT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_conformant.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_conformant
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_conformant(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_conformant(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_conformant(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_conformant(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_conformant(elm_conformant const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_conformant() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_virtualkeypad_state_on_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON );
   }

   template <typename T>
   void
   callback_virtualkeypad_state_on_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_virtualkeypad_state_off_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF );
   }

   template <typename T>
   void
   callback_virtualkeypad_state_off_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clipboard_state_on_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON );
   }

   template <typename T>
   void
   callback_clipboard_state_on_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clipboard_state_off_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF );
   }

   template <typename T>
   void
   callback_clipboard_state_off_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_CONFORMANT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_CONFORMANT_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_conformant >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_conformant >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_conformant>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_conformant >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_conformant, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_conformant >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_conformant, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_conformant>
{
   template <typename U>
   struct type
   {
      operator ::elm_conformant() const
      {
         return ::elm_conformant(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_virtualkeypad_state_on_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON );
   }

   template <typename T>
   void
   callback_virtualkeypad_state_on_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_ON, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_virtualkeypad_state_off_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF );
   }

   template <typename T>
   void
   callback_virtualkeypad_state_off_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_VIRTUALKEYPAD_STATE_OFF, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clipboard_state_on_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON );
   }

   template <typename T>
   void
   callback_clipboard_state_on_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_ON, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clipboard_state_off_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF, priority_,
            &efl::eo::_detail::event_callback<::elm_conformant, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_conformant, function_type>,
         ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF );
   }

   template <typename T>
   void
   callback_clipboard_state_off_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_CONFORMANT_EVENT_CLIPBOARD_STATE_OFF, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_conformant>)
{
   return (ELM_CONFORMANT_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_CONFORMANT_HH

