#ifndef EFL_GENERATED_ELM_CONTAINER_HH
#define EFL_GENERATED_ELM_CONTAINER_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_container.eo.h"
}

#include "elm_widget.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <string>

struct elm_container
      : elm_widget
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_container(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_container(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_container(elm_container const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_container() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param name 
   /// @param content 
   ///
   bool content_set(std::string name_, evas::object content_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_container_content_set(efl::eolian::to_c(name_), efl::eolian::to_c(content_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param name 
   ///
   evas::object content_get(std::string name_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_container_content_get(efl::eolian::to_c(name_)));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param name 
   ///
   evas::object content_unset(std::string name_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_container_content_unset(efl::eolian::to_c(name_)));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param ret Eina_List
   ///
   Eina_List * content_swallow_list_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_container_content_swallow_list_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_CONTAINER_CLASS);
   }

private:
};
template <typename T>
bool _elm_container_content_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_, Evas_Object * content_)
{
   return static_cast<T*>(self->this_)->content_set(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()));
}

template <typename T>
evas::object _elm_container_content_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   return static_cast<T*>(self->this_)->content_get(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()));
}

template <typename T>
evas::object _elm_container_content_unset_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   return static_cast<T*>(self->this_)->content_unset(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()));
}

template <typename T>
Eina_List * _elm_container_content_swallow_list_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_swallow_list_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_container >
{
   template <typename T>
   struct type
   {
      virtual bool content_set(std::string name_, evas::object content_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_set(efl::eolian::to_c(name_), efl::eolian::to_c(content_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object content_get(std::string name_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_get(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object content_unset(std::string name_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_unset(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_List * content_swallow_list_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_container_content_swallow_list_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_container >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_container>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_container_content_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_container_content_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_container_content_unset_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_unset);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_container_content_swallow_list_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_container_content_swallow_list_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_container >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_container, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_container>
{
   template <typename U>
   struct type
   {
      operator ::elm_container() const
      {
         return ::elm_container(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool content_set(std::string name_, evas::object content_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_container_content_set(efl::eolian::to_c(name_), efl::eolian::to_c(content_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object content_get(std::string name_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_container_content_get(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object content_unset(std::string name_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_container_content_unset(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      Eina_List * content_swallow_list_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_container_content_swallow_list_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_container>)
{
   return (ELM_CONTAINER_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_CONTAINER_HH

