#ifndef EFL_GENERATED_ELM_FRAME_HH
#define EFL_GENERATED_ELM_FRAME_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_frame.eo.h"
}

#include "elm_layout.eo.hh"
#include "evas_clickable_interface.eo.hh"

struct elm_frame
      : elm_layout,
      efl::eo::detail::extension_inheritance<evas::clickable_interface>::template type< ::elm_frame>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_frame(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_frame(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_frame(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_frame(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_frame(elm_frame const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_frame() {}

   /// @brief @brief Manually collapse a frame with animations
   /// Use this to toggle the collapsed state of a frame, triggering animations.
   ///
   /// @ingroup Frame
   ///
   /// @param collapse true to collapse, false to expand
   ///
   void collapse_go(bool collapse_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_frame_collapse_go(efl::eolian::to_c(collapse_)));
   }

   /// @param collapse true to collapse, false to expand
   ///
   bool collapse_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_frame_collapse_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param collapse true to collapse, false to expand
   ///
   void collapse_set(bool collapse_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_frame_collapse_set(efl::eolian::to_c(collapse_)));
   }

   /// @param autocollapse Whether to enable autocollapse
   ///
   bool autocollapse_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_frame_autocollapse_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param autocollapse Whether to enable autocollapse
   ///
   void autocollapse_set(bool autocollapse_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_frame_autocollapse_set(efl::eolian::to_c(autocollapse_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_ACCESS_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_FRAME_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_FRAME_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_frame_collapse_go_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool collapse_)
{
   static_cast<T*>(self->this_)->collapse_go(efl::eolian::to_cxx<bool>(collapse_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_frame_collapse_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->collapse_get();
}

template <typename T>
void _elm_frame_collapse_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool collapse_)
{
   static_cast<T*>(self->this_)->collapse_set(efl::eolian::to_cxx<bool>(collapse_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_frame_autocollapse_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->autocollapse_get();
}

template <typename T>
void _elm_frame_autocollapse_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool autocollapse_)
{
   static_cast<T*>(self->this_)->autocollapse_set(efl::eolian::to_cxx<bool>(autocollapse_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_frame >
{
   template <typename T>
   struct type
   {
      virtual void collapse_go(bool collapse_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_collapse_go(efl::eolian::to_c(collapse_)));
      }

      virtual bool collapse_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_frame_collapse_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void collapse_set(bool collapse_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_collapse_set(efl::eolian::to_c(collapse_)));
      }

      virtual bool autocollapse_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_frame_autocollapse_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void autocollapse_set(bool autocollapse_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_frame_autocollapse_set(efl::eolian::to_c(autocollapse_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_frame >
{
   static const int value = 5;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_frame>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_frame_collapse_go_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_go);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_frame_collapse_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_frame_collapse_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_collapse_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_frame_autocollapse_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_autocollapse_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_frame_autocollapse_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_frame_autocollapse_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_frame >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_frame, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_frame >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_frame, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_frame>
{
   template <typename U>
   struct type
   {
      operator ::elm_frame() const
      {
         return ::elm_frame(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void collapse_go(bool collapse_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_frame_collapse_go(efl::eolian::to_c(collapse_)));
      }

      bool collapse_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_frame_collapse_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void collapse_set(bool collapse_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_frame_collapse_set(efl::eolian::to_c(collapse_)));
      }

      bool autocollapse_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_frame_autocollapse_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void autocollapse_set(bool autocollapse_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_frame_autocollapse_set(efl::eolian::to_c(autocollapse_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_FRAME_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_frame, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_frame, function_type>,
         ELM_FRAME_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_FRAME_EVENT_ACCESS_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_frame>)
{
   return (ELM_FRAME_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_FRAME_HH

