#ifndef EFL_GENERATED_ELM_GLVIEW_HH
#define EFL_GENERATED_ELM_GLVIEW_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_glview.eo.h"
}

#include "elm_widget.eo.hh"

struct elm_glview
      : elm_widget
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_glview(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_glview(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   elm_glview(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_glview(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_glview(elm_glview const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_glview() {}

   /// @param w width of the glview object
   /// @param h height of the glview object
   ///
   void size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_size_get(w_, h_));
   }

   /// @param w width of the glview object
   /// @param h height of the glview object
   ///
   void size_set(int w_, int h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_size_set(w_, h_));
   }

   /// @param policy The scaling policy.
   ///
   bool resize_policy_set(Elm_GLView_Resize_Policy policy_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   void changed_set() const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_changed_set());
   }

   /// @param func The resize function to be registered.
   ///
   void resize_func_set(Elm_GLView_Func_Cb func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_resize_func_set(func_));
   }

   /// @param func The delete function to be registered.
   ///
   void del_func_set(Elm_GLView_Func_Cb func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_del_func_set(func_));
   }

   /// @param func The init function to be registered.
   ///
   void init_func_set(Elm_GLView_Func_Cb func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_init_func_set(func_));
   }

   /// @param policy The render policy.
   ///
   bool render_policy_set(Elm_GLView_Render_Policy policy_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param mode The mode Options OR'ed enabling Alpha, Depth, Stencil, Direct.
   ///
   bool mode_set(Elm_GLView_Mode mode_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_glview_mode_set(mode_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param func The render function to be registered.
   ///
   void render_func_set(Elm_GLView_Func_Cb func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_glview_render_func_set(func_));
   }

   Evas_GL_API * gl_api_get() const
   {
      Evas_GL_API * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_glview_gl_api_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_UNFOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_ACCESS_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_GLVIEW_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_GLVIEW_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_glview_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->size_get(w_, h_);
}

template <typename T>
void _elm_glview_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int w_, int h_)
{
   static_cast<T*>(self->this_)->size_set(w_, h_);
}

template <typename T>
bool _elm_glview_resize_policy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Resize_Policy policy_)
{
   return static_cast<T*>(self->this_)->resize_policy_set(policy_);
}

template <typename T>
void _elm_glview_changed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->changed_set();
}

template <typename T>
void _elm_glview_resize_func_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   static_cast<T*>(self->this_)->resize_func_set(func_);
}

template <typename T>
void _elm_glview_del_func_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   static_cast<T*>(self->this_)->del_func_set(func_);
}

template <typename T>
void _elm_glview_init_func_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   static_cast<T*>(self->this_)->init_func_set(func_);
}

template <typename T>
bool _elm_glview_render_policy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Render_Policy policy_)
{
   return static_cast<T*>(self->this_)->render_policy_set(policy_);
}

template <typename T>
bool _elm_glview_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Mode mode_)
{
   return static_cast<T*>(self->this_)->mode_set(mode_);
}

template <typename T>
void _elm_glview_render_func_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_GLView_Func_Cb func_)
{
   static_cast<T*>(self->this_)->render_func_set(func_);
}

template <typename T>
Evas_GL_API * _elm_glview_gl_api_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->gl_api_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_glview >
{
   template <typename T>
   struct type
   {
      virtual void size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_size_get(w_, h_));
      }

      virtual void size_set(int w_, int h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_size_set(w_, h_));
      }

      virtual bool resize_policy_set(Elm_GLView_Resize_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void changed_set()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_changed_set());
      }

      virtual void resize_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_resize_func_set(func_));
      }

      virtual void del_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_del_func_set(func_));
      }

      virtual void init_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_init_func_set(func_));
      }

      virtual bool render_policy_set(Elm_GLView_Render_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool mode_set(Elm_GLView_Mode mode_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_mode_set(mode_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void render_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_glview_render_func_set(func_));
      }

      virtual Evas_GL_API * gl_api_get()
      {
         Evas_GL_API * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_glview_gl_api_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_glview >
{
   static const int value = 11;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_glview>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_glview_size_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_size_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_glview_size_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_size_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_glview_resize_policy_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_resize_policy_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_glview_changed_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_changed_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_glview_resize_func_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_resize_func_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_glview_del_func_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_del_func_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_glview_init_func_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_init_func_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_glview_render_policy_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_render_policy_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_glview_mode_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_mode_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_glview_render_func_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_render_func_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_glview_gl_api_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_glview_gl_api_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_glview >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_glview, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_glview >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_glview, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_glview>
{
   template <typename U>
   struct type
   {
      operator ::elm_glview() const
      {
         return ::elm_glview(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_size_get(w_, h_));
      }

      void size_set(int w_, int h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_size_set(w_, h_));
      }

      bool resize_policy_set(Elm_GLView_Resize_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_glview_resize_policy_set(policy_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void changed_set()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_changed_set());
      }

      void resize_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_resize_func_set(func_));
      }

      void del_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_del_func_set(func_));
      }

      void init_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_init_func_set(func_));
      }

      bool render_policy_set(Elm_GLView_Render_Policy policy_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_glview_render_policy_set(policy_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool mode_set(Elm_GLView_Mode mode_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_glview_mode_set(mode_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void render_func_set(Elm_GLView_Func_Cb func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_glview_render_func_set(func_));
      }

      Evas_GL_API * gl_api_get()
      {
         Evas_GL_API * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_glview_gl_api_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_UNFOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_GLVIEW_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_glview, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_glview, function_type>,
         ELM_GLVIEW_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_GLVIEW_EVENT_ACCESS_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_glview>)
{
   return (ELM_GLVIEW_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_GLVIEW_HH

