#ifndef EFL_GENERATED_ELM_GRID_HH
#define EFL_GENERATED_ELM_GRID_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_grid.eo.h"
}

#include "elm_widget.eo.hh"
#include <canvas/evas_object.eo.hh>

struct elm_grid
      : elm_widget
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_grid(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_grid(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   elm_grid(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_grid(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_grid(elm_grid const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_grid() {}

   /// @brief Faster way to remove all child objects from a grid object.
   ///
   /// @ingroup Grid
   ///
   /// @param clear If true, it will delete just removed children
   ///
   void clear(bool clear_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_grid_clear(efl::eolian::to_c(clear_)));
   }

   /// @brief Unpack a child from a grid object
   ///
   /// @ingroup Grid
   ///
   /// @param subobj The child to unpack
   ///
   void unpack(evas::object subobj_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_grid_unpack(efl::eolian::to_c(subobj_)));
   }

   /// @brief Pack child at given position and size
   ///
   /// @ingroup Grid
   ///
   /// @param subobj The child to pack
   /// @param x The virtual x coord at which to pack it
   /// @param y The virtual y coord at which to pack it
   /// @param w The virtual width at which to pack it
   /// @param h The virtual height at which to pack it
   ///
   void pack(evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_grid_pack(efl::eolian::to_c(subobj_), x_, y_, w_, h_));
   }

   /// @param w The virtual width of the grid
   /// @param h The virtual height of the grid
   ///
   void size_get(Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_grid_size_get(w_, h_));
   }

   /// @param w The virtual width of the grid
   /// @param h The virtual height of the grid
   ///
   void size_set(Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_grid_size_set(w_, h_));
   }

   Eina_List * children_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_grid_children_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_GRID_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_GRID_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_grid_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool clear_)
{
   static_cast<T*>(self->this_)->clear(efl::eolian::to_cxx<bool>(clear_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_grid_unpack_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_)
{
   static_cast<T*>(self->this_)->unpack(efl::eolian::to_cxx<evas::object>(subobj_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_grid_pack_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->pack(efl::eolian::to_cxx<evas::object>(subobj_, std::tuple<std::false_type>()), x_, y_, w_, h_);
}

template <typename T>
void _elm_grid_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->size_get(w_, h_);
}

template <typename T>
void _elm_grid_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->size_set(w_, h_);
}

template <typename T>
Eina_List * _elm_grid_children_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->children_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_grid >
{
   template <typename T>
   struct type
   {
      virtual void clear(bool clear_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_clear(efl::eolian::to_c(clear_)));
      }

      virtual void unpack(evas::object subobj_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_unpack(efl::eolian::to_c(subobj_)));
      }

      virtual void pack(evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_pack(efl::eolian::to_c(subobj_), x_, y_, w_, h_));
      }

      virtual void size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_size_get(w_, h_));
      }

      virtual void size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_size_set(w_, h_));
      }

      virtual Eina_List * children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_grid_children_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_grid >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_grid>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_grid_clear_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_clear);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_grid_unpack_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_unpack);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_grid_pack_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_pack);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_grid_size_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_size_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_grid_size_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_size_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_grid_children_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_children_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_grid >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_grid, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_grid >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_grid, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_grid>
{
   template <typename U>
   struct type
   {
      operator ::elm_grid() const
      {
         return ::elm_grid(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void clear(bool clear_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_grid_clear(efl::eolian::to_c(clear_)));
      }

      void unpack(evas::object subobj_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_grid_unpack(efl::eolian::to_c(subobj_)));
      }

      void pack(evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_grid_pack(efl::eolian::to_c(subobj_), x_, y_, w_, h_));
      }

      void size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_grid_size_get(w_, h_));
      }

      void size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_grid_size_set(w_, h_));
      }

      Eina_List * children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_grid_children_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_grid>)
{
   return (ELM_GRID_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_GRID_HH

