#ifndef EFL_GENERATED_ELM_ICON_HH
#define EFL_GENERATED_ELM_ICON_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_icon.eo.h"
}

#include "elm_image.eo.hh"
#include <string>

struct elm_icon
      : elm_image
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_icon(Eo* eo)
      : elm_image(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_icon(std::nullptr_t)
      : elm_image(nullptr)
   {}

   elm_icon(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_icon(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_icon(elm_icon const& other)
      : elm_image(eo_ref(other._eo_ptr()))
   {}

   ~elm_icon() {}

   /// @param order The icon lookup order (can be one of
   /// ELM_ICON_LOOKUP_FDO_THEME, ELM_ICON_LOOKUP_THEME_FDO, ELM_ICON_LOOKUP_FDO
   /// or ELM_ICON_LOOKUP_THEME)
   ///
   Elm_Icon_Lookup_Order order_lookup_get() const
   {
      Elm_Icon_Lookup_Order _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_icon_order_lookup_get());
      return _tmp_ret;
   }

   /// @param order The icon lookup order (can be one of
   /// ELM_ICON_LOOKUP_FDO_THEME, ELM_ICON_LOOKUP_THEME_FDO, ELM_ICON_LOOKUP_FDO
   /// or ELM_ICON_LOOKUP_THEME)
   ///
   void order_lookup_set(Elm_Icon_Lookup_Order order_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_icon_order_lookup_set(order_));
   }

   /// @param name The icon name
   ///
   std::string standard_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param name The icon name
   ///
   bool standard_set(std::string name_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_set(efl::eolian::to_c(name_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param file The path to file that will be used as icon image
   /// @param group The group that the icon belongs to an edje file
   ///
   void thumb_set(std::string file_, std::string group_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_icon_thumb_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_thumb_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ICON_EVENT_THUMB_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_icon, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_icon, function_type>,
         ELM_ICON_EVENT_THUMB_DONE );
   }

   template <typename T>
   void
   callback_thumb_done_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_ICON_EVENT_THUMB_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_thumb_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ICON_EVENT_THUMB_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_icon, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_icon, function_type>,
         ELM_ICON_EVENT_THUMB_ERROR );
   }

   template <typename T>
   void
   callback_thumb_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_ICON_EVENT_THUMB_ERROR, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_ICON_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_ICON_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
Elm_Icon_Lookup_Order _elm_icon_order_lookup_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->order_lookup_get();
}

template <typename T>
void _elm_icon_order_lookup_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Icon_Lookup_Order order_)
{
   static_cast<T*>(self->this_)->order_lookup_set(order_);
}

template <typename T>
std::string _elm_icon_standard_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->standard_get();
}

template <typename T>
bool _elm_icon_standard_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   return static_cast<T*>(self->this_)->standard_set(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_icon_thumb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * group_)
{
   static_cast<T*>(self->this_)->thumb_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(group_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_icon >
{
   template <typename T>
   struct type
   {
      virtual Elm_Icon_Lookup_Order order_lookup_get()
      {
         Elm_Icon_Lookup_Order _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_order_lookup_get());
            return _tmp_ret;
      }

      virtual void order_lookup_set(Elm_Icon_Lookup_Order order_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_icon_order_lookup_set(order_));
      }

      virtual std::string standard_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_standard_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool standard_set(std::string name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_icon_standard_set(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void thumb_set(std::string file_, std::string group_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_icon_thumb_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_icon >
{
   static const int value = 5;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_icon>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_icon_order_lookup_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_order_lookup_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_icon_order_lookup_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_order_lookup_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_icon_standard_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_standard_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_icon_standard_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_standard_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_icon_thumb_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_icon_thumb_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_icon >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_icon, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_icon >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_icon, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_icon>
{
   template <typename U>
   struct type
   {
      operator ::elm_icon() const
      {
         return ::elm_icon(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Elm_Icon_Lookup_Order order_lookup_get()
      {
         Elm_Icon_Lookup_Order _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_icon_order_lookup_get());
            return _tmp_ret;
      }

      void order_lookup_set(Elm_Icon_Lookup_Order order_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_icon_order_lookup_set(order_));
      }

      std::string standard_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool standard_set(std::string name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_icon_standard_set(efl::eolian::to_c(name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void thumb_set(std::string file_, std::string group_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_icon_thumb_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_thumb_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ICON_EVENT_THUMB_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_icon, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_icon, function_type>,
         ELM_ICON_EVENT_THUMB_DONE );
   }

   template <typename T>
   void
   callback_thumb_done_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_ICON_EVENT_THUMB_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_thumb_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_ICON_EVENT_THUMB_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_icon, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_icon, function_type>,
         ELM_ICON_EVENT_THUMB_ERROR );
   }

   template <typename T>
   void
   callback_thumb_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_ICON_EVENT_THUMB_ERROR, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_icon>)
{
   return (ELM_ICON_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_ICON_HH

