#ifndef EFL_GENERATED_ELM_IMAGE_HH
#define EFL_GENERATED_ELM_IMAGE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_image.eo.h"
}

#include "elm_widget.eo.hh"
#include "evas_clickable_interface.eo.hh"
#include "elm_interface_atspi_image.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <string>

struct elm_image
      : elm_widget,
      efl::eo::detail::extension_inheritance<evas::clickable_interface>::template type< ::elm_image>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_image>::template type< ::elm_image>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_image>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_image(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_image(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   elm_image(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_image(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_image(elm_image const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_image() {}

   /// @brief No description supplied by the EAPI.
   ///
   void sizing_eval() const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_sizing_eval());
   }

   /// @param set Turn on or off editability. Default is @c EINA_FALSE.
   ///
   bool editable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_editable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param set Turn on or off editability. Default is @c EINA_FALSE.
   ///
   void editable_set(bool set_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_editable_set(efl::eolian::to_c(set_)));
   }

   /// @param smooth 
   ///
   bool smooth_scale_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_smooth_scale_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param smooth 
   ///
   void smooth_scale_set(bool smooth_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_smooth_scale_set(efl::eolian::to_c(smooth_)));
   }

   /// @param resize_down 
   ///
   bool resize_down_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_resize_down_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param resize_down 
   ///
   void resize_down_set(bool resize_down_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_resize_down_set(efl::eolian::to_c(resize_down_)));
   }

   /// @param size 
   ///
   int load_size_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_load_size_get());
      return _tmp_ret;
   }

   /// @param size 
   ///
   void load_size_set(int size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_load_size_set(size_));
   }

   /// @param play @c EINA_TRUE to start the animation, @c EINA_FALSE
   /// otherwise. Default is @c EINA_FALSE.
   ///
   bool animated_play_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_play_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param play @c EINA_TRUE to start the animation, @c EINA_FALSE
   /// otherwise. Default is @c EINA_FALSE.
   ///
   void animated_play_set(bool play_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_animated_play_set(efl::eolian::to_c(play_)));
   }

   /// @param resize_up 
   ///
   bool resize_up_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_resize_up_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param resize_up 
   ///
   void resize_up_set(bool resize_up_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_resize_up_set(efl::eolian::to_c(resize_up_)));
   }

   /// @param smooth @c EINA_TRUE if smooth scaling should be used, @c EINA_FALSE
   /// otherwise. Default is @c EINA_TRUE.
   ///
   bool smooth_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_smooth_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param smooth @c EINA_TRUE if smooth scaling should be used, @c EINA_FALSE
   /// otherwise. Default is @c EINA_TRUE.
   ///
   void smooth_set(bool smooth_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_smooth_set(efl::eolian::to_c(smooth_)));
   }

   /// @param no_scale @c EINA_TRUE if the object is not scalable, @c EINA_FALSE
   /// otherwise. Default is @c EINA_FALSE.
   ///
   bool no_scale_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_no_scale_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param no_scale @c EINA_TRUE if the object is not scalable, @c EINA_FALSE
   /// otherwise. Default is @c EINA_FALSE.
   ///
   void no_scale_set(bool no_scale_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_no_scale_set(efl::eolian::to_c(no_scale_)));
   }

   /// @param anim @c EINA_TRUE if the object is to animate itself,
   /// @c EINA_FALSE otherwise. Default is @c EINA_FALSE.
   ///
   bool animated_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param anim @c EINA_TRUE if the object is to animate itself,
   /// @c EINA_FALSE otherwise. Default is @c EINA_FALSE.
   ///
   void animated_set(bool anim_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_animated_set(efl::eolian::to_c(anim_)));
   }

   /// @param scale 
   ///
   double scale_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_scale_get());
      return _tmp_ret;
   }

   /// @param scale 
   ///
   void scale_set(double scale_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_scale_set(scale_));
   }

   /// @param file The path to file that will be used as image source
   /// @param group The group that the image belongs to, in case it's an
   /// EET (including Edje case) file. This can be used as a key inside
   /// evas image cache if this is a normal image file not eet file.
   ///
   void file_get(const char ** file_, const char ** group_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_file_get(file_, group_));
   }

   /// @param file The path to file that will be used as image source
   /// @param group The group that the image belongs to, in case it's an
   /// EET (including Edje case) file. This can be used as a key inside
   /// evas image cache if this is a normal image file not eet file.
   ///
   bool file_set(std::string file_, std::string group_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param fill_inside 
   ///
   bool fill_inside_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_fill_inside_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param fill_inside 
   ///
   void fill_inside_set(bool fill_inside_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_fill_inside_set(efl::eolian::to_c(fill_inside_)));
   }

   /// @param fixed @c EINA_TRUE if the image should retain the aspect,
   /// @c EINA_FALSE otherwise.
   ///
   bool aspect_fixed_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_aspect_fixed_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param fixed @c EINA_TRUE if the image should retain the aspect,
   /// @c EINA_FALSE otherwise.
   ///
   void aspect_fixed_set(bool fixed_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_aspect_fixed_set(efl::eolian::to_c(fixed_)));
   }

   /// @param orient The image orientation @ref Elm_Image_Orient
   /// Default is #ELM_IMAGE_ORIENT_NONE.
   ///
   Elm_Image_Orient orient_get() const
   {
      Elm_Image_Orient _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_orient_get());
      return _tmp_ret;
   }

   /// @param orient The image orientation @ref Elm_Image_Orient
   /// Default is #ELM_IMAGE_ORIENT_NONE.
   ///
   void orient_set(Elm_Image_Orient orient_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_orient_set(orient_));
   }

   /// @param fill_outside @c EINA_TRUE if the object is filled outside,
   /// @c EINA_FALSE otherwise. Default is @c EINA_FALSE.
   ///
   bool fill_outside_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_fill_outside_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param fill_outside @c EINA_TRUE if the object is filled outside,
   /// @c EINA_FALSE otherwise. Default is @c EINA_FALSE.
   ///
   void fill_outside_set(bool fill_outside_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_fill_outside_set(efl::eolian::to_c(fill_outside_)));
   }

   /// @param up A bool to set if the object is resizable up. Default is
   /// @c EINA_TRUE.
   /// @param down A bool to set if the object is resizable down. Default
   /// is @c EINA_TRUE.
   ///
   void resizable_get(Eina_Bool* up_, Eina_Bool* down_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_resizable_get(up_, down_));
   }

   /// @param up A bool to set if the object is resizable up. Default is
   /// @c EINA_TRUE.
   /// @param down A bool to set if the object is resizable down. Default
   /// is @c EINA_TRUE.
   ///
   void resizable_set(bool up_, bool down_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_resizable_set(efl::eolian::to_c(up_), efl::eolian::to_c(down_)));
   }

   /// @param disabled If EINA_TRUE, preloading will be disabled
   ///
   void preload_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_preload_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param file The handler to an Eina_File that will be used as image source
   /// @param group The group that the image belongs to, in case it's an
   /// EET (including Edje case) file. This can be used as a key inside
   /// evas image cache if this is a normal image file not eet file.
   ///
   bool mmap_set(const Eina_File * file_, std::string group_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_mmap_set(file_, efl::eolian::to_c(group_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param img The binary data that will be used as image source
   /// @param size The size of binary data blob @p img
   /// @param format (Optional) expected format of @p img bytes
   /// @param key Optional indexing key of @p img to be passed to the
   /// image loader (eg. if @p img is a memory-mapped EET file)
   ///
   bool memfile_set(const void * img_, size_t size_, std::string format_, std::string key_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_memfile_set(img_, size_, efl::eolian::to_c(format_), efl::eolian::to_c(key_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   bool animated_available_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_available_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   evas::object object_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_image_object_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w Pointer to store width, or NULL.
   /// @param h Pointer to store height, or NULL.
   ///
   void object_size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_image_object_size_get(w_, h_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_drop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DROP, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DROP );
   }

   template <typename T>
   void
   callback_drop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DROP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_ERROR, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_IMAGE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_IMAGE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_image_sizing_eval_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->sizing_eval();
}

template <typename T>
bool _elm_image_editable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->editable_get();
}

template <typename T>
void _elm_image_editable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool set_)
{
   static_cast<T*>(self->this_)->editable_set(efl::eolian::to_cxx<bool>(set_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_smooth_scale_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->smooth_scale_get();
}

template <typename T>
void _elm_image_smooth_scale_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool smooth_)
{
   static_cast<T*>(self->this_)->smooth_scale_set(efl::eolian::to_cxx<bool>(smooth_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_resize_down_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->resize_down_get();
}

template <typename T>
void _elm_image_resize_down_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool resize_down_)
{
   static_cast<T*>(self->this_)->resize_down_set(efl::eolian::to_cxx<bool>(resize_down_, std::tuple<std::false_type>()));
}

template <typename T>
int _elm_image_load_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->load_size_get();
}

template <typename T>
void _elm_image_load_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int size_)
{
   static_cast<T*>(self->this_)->load_size_set(size_);
}

template <typename T>
bool _elm_image_animated_play_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->animated_play_get();
}

template <typename T>
void _elm_image_animated_play_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool play_)
{
   static_cast<T*>(self->this_)->animated_play_set(efl::eolian::to_cxx<bool>(play_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_resize_up_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->resize_up_get();
}

template <typename T>
void _elm_image_resize_up_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool resize_up_)
{
   static_cast<T*>(self->this_)->resize_up_set(efl::eolian::to_cxx<bool>(resize_up_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_smooth_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->smooth_get();
}

template <typename T>
void _elm_image_smooth_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool smooth_)
{
   static_cast<T*>(self->this_)->smooth_set(efl::eolian::to_cxx<bool>(smooth_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_no_scale_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->no_scale_get();
}

template <typename T>
void _elm_image_no_scale_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool no_scale_)
{
   static_cast<T*>(self->this_)->no_scale_set(efl::eolian::to_cxx<bool>(no_scale_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_animated_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->animated_get();
}

template <typename T>
void _elm_image_animated_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool anim_)
{
   static_cast<T*>(self->this_)->animated_set(efl::eolian::to_cxx<bool>(anim_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_image_scale_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->scale_get();
}

template <typename T>
void _elm_image_scale_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double scale_)
{
   static_cast<T*>(self->this_)->scale_set(scale_);
}

template <typename T>
void _elm_image_file_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char ** file_, const char ** group_)
{
   static_cast<T*>(self->this_)->file_get(file_, group_);
}

template <typename T>
bool _elm_image_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * group_)
{
   return static_cast<T*>(self->this_)->file_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(group_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_fill_inside_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->fill_inside_get();
}

template <typename T>
void _elm_image_fill_inside_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fill_inside_)
{
   static_cast<T*>(self->this_)->fill_inside_set(efl::eolian::to_cxx<bool>(fill_inside_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_aspect_fixed_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->aspect_fixed_get();
}

template <typename T>
void _elm_image_aspect_fixed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fixed_)
{
   static_cast<T*>(self->this_)->aspect_fixed_set(efl::eolian::to_cxx<bool>(fixed_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Image_Orient _elm_image_orient_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->orient_get();
}

template <typename T>
void _elm_image_orient_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Image_Orient orient_)
{
   static_cast<T*>(self->this_)->orient_set(orient_);
}

template <typename T>
bool _elm_image_fill_outside_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->fill_outside_get();
}

template <typename T>
void _elm_image_fill_outside_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fill_outside_)
{
   static_cast<T*>(self->this_)->fill_outside_set(efl::eolian::to_cxx<bool>(fill_outside_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_image_resizable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool* up_, Eina_Bool* down_)
{
   static_cast<T*>(self->this_)->resizable_get(up_, down_);
}

template <typename T>
void _elm_image_resizable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool up_, Eina_Bool down_)
{
   static_cast<T*>(self->this_)->resizable_set(efl::eolian::to_cxx<bool>(up_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(down_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_image_preload_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->preload_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_mmap_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Eina_File * file_, const char * group_)
{
   return static_cast<T*>(self->this_)->mmap_set(file_, efl::eolian::to_cxx<std::string>(group_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_memfile_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const void * img_, size_t size_, const char * format_, const char * key_)
{
   return static_cast<T*>(self->this_)->memfile_set(img_, size_, efl::eolian::to_cxx<std::string>(format_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_image_animated_available_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->animated_available_get();
}

template <typename T>
evas::object _elm_image_object_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->object_get();
}

template <typename T>
void _elm_image_object_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->object_size_get(w_, h_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_image >
{
   template <typename T>
   struct type
   {
      virtual void sizing_eval()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_sizing_eval());
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void editable_set(bool set_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_editable_set(efl::eolian::to_c(set_)));
      }

      virtual bool smooth_scale_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_smooth_scale_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void smooth_scale_set(bool smooth_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_smooth_scale_set(efl::eolian::to_c(smooth_)));
      }

      virtual bool resize_down_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_resize_down_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void resize_down_set(bool resize_down_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_resize_down_set(efl::eolian::to_c(resize_down_)));
      }

      virtual int load_size_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_load_size_get());
            return _tmp_ret;
      }

      virtual void load_size_set(int size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_load_size_set(size_));
      }

      virtual bool animated_play_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_animated_play_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void animated_play_set(bool play_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_animated_play_set(efl::eolian::to_c(play_)));
      }

      virtual bool resize_up_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_resize_up_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void resize_up_set(bool resize_up_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_resize_up_set(efl::eolian::to_c(resize_up_)));
      }

      virtual bool smooth_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_smooth_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void smooth_set(bool smooth_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_smooth_set(efl::eolian::to_c(smooth_)));
      }

      virtual bool no_scale_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_no_scale_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void no_scale_set(bool no_scale_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_no_scale_set(efl::eolian::to_c(no_scale_)));
      }

      virtual bool animated_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_animated_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void animated_set(bool anim_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_animated_set(efl::eolian::to_c(anim_)));
      }

      virtual double scale_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_scale_get());
            return _tmp_ret;
      }

      virtual void scale_set(double scale_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_scale_set(scale_));
      }

      virtual void file_get(const char ** file_, const char ** group_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_file_get(file_, group_));
      }

      virtual bool file_set(std::string file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool fill_inside_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_fill_inside_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void fill_inside_set(bool fill_inside_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_fill_inside_set(efl::eolian::to_c(fill_inside_)));
      }

      virtual bool aspect_fixed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_aspect_fixed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void aspect_fixed_set(bool fixed_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_aspect_fixed_set(efl::eolian::to_c(fixed_)));
      }

      virtual Elm_Image_Orient orient_get()
      {
         Elm_Image_Orient _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_orient_get());
            return _tmp_ret;
      }

      virtual void orient_set(Elm_Image_Orient orient_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_orient_set(orient_));
      }

      virtual bool fill_outside_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_fill_outside_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void fill_outside_set(bool fill_outside_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_fill_outside_set(efl::eolian::to_c(fill_outside_)));
      }

      virtual void resizable_get(Eina_Bool* up_, Eina_Bool* down_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_resizable_get(up_, down_));
      }

      virtual void resizable_set(bool up_, bool down_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_resizable_set(efl::eolian::to_c(up_), efl::eolian::to_c(down_)));
      }

      virtual void preload_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_preload_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual bool mmap_set(const Eina_File * file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_mmap_set(file_, efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool memfile_set(const void * img_, size_t size_, std::string format_, std::string key_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_memfile_set(img_, size_, efl::eolian::to_c(format_), efl::eolian::to_c(key_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool animated_available_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_animated_available_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_image_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void object_size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_image_object_size_get(w_, h_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_image >
{
   static const int value = 39;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_image>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_image_sizing_eval_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_image_sizing_eval);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_image_editable_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_image_editable_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_image_editable_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_image_editable_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_image_smooth_scale_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_image_smooth_scale_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_image_smooth_scale_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_image_smooth_scale_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_image_resize_down_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resize_down_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_image_resize_down_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resize_down_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_image_load_size_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_image_load_size_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_image_load_size_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_image_load_size_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_image_animated_play_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_image_animated_play_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_image_animated_play_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_image_animated_play_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_image_resize_up_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resize_up_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_image_resize_up_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resize_up_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_image_smooth_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_image_smooth_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_image_smooth_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_image_smooth_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_image_no_scale_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_image_no_scale_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_image_no_scale_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_image_no_scale_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_image_animated_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_obj_image_animated_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_image_animated_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_obj_image_animated_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_image_scale_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_obj_image_scale_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_image_scale_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_obj_image_scale_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_image_file_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_obj_image_file_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_elm_image_file_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::elm_obj_image_file_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_elm_image_fill_inside_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::elm_obj_image_fill_inside_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_elm_image_fill_inside_set_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::elm_obj_image_fill_inside_set);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_elm_image_aspect_fixed_get_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::elm_obj_image_aspect_fixed_get);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_elm_image_aspect_fixed_set_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::elm_obj_image_aspect_fixed_set);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_elm_image_orient_get_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::elm_obj_image_orient_get);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_elm_image_orient_set_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::elm_obj_image_orient_set);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::_elm_image_fill_outside_get_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::elm_obj_image_fill_outside_get);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::_elm_image_fill_outside_set_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::elm_obj_image_fill_outside_set);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::_elm_image_resizable_get_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resizable_get);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   ops[32].func = reinterpret_cast<void*>(& ::_elm_image_resizable_set_wrapper<T>);
   ops[32].api_func = reinterpret_cast<void*>(& ::elm_obj_image_resizable_set);
   ops[32].op = EO_OP_OVERRIDE;
   ops[32].op_type = EO_OP_TYPE_REGULAR;
   ops[32].doc = NULL;

   ops[33].func = reinterpret_cast<void*>(& ::_elm_image_preload_disabled_set_wrapper<T>);
   ops[33].api_func = reinterpret_cast<void*>(& ::elm_obj_image_preload_disabled_set);
   ops[33].op = EO_OP_OVERRIDE;
   ops[33].op_type = EO_OP_TYPE_REGULAR;
   ops[33].doc = NULL;

   ops[34].func = reinterpret_cast<void*>(& ::_elm_image_mmap_set_wrapper<T>);
   ops[34].api_func = reinterpret_cast<void*>(& ::elm_obj_image_mmap_set);
   ops[34].op = EO_OP_OVERRIDE;
   ops[34].op_type = EO_OP_TYPE_REGULAR;
   ops[34].doc = NULL;

   ops[35].func = reinterpret_cast<void*>(& ::_elm_image_memfile_set_wrapper<T>);
   ops[35].api_func = reinterpret_cast<void*>(& ::elm_obj_image_memfile_set);
   ops[35].op = EO_OP_OVERRIDE;
   ops[35].op_type = EO_OP_TYPE_REGULAR;
   ops[35].doc = NULL;

   ops[36].func = reinterpret_cast<void*>(& ::_elm_image_animated_available_get_wrapper<T>);
   ops[36].api_func = reinterpret_cast<void*>(& ::elm_obj_image_animated_available_get);
   ops[36].op = EO_OP_OVERRIDE;
   ops[36].op_type = EO_OP_TYPE_REGULAR;
   ops[36].doc = NULL;

   ops[37].func = reinterpret_cast<void*>(& ::_elm_image_object_get_wrapper<T>);
   ops[37].api_func = reinterpret_cast<void*>(& ::elm_obj_image_object_get);
   ops[37].op = EO_OP_OVERRIDE;
   ops[37].op_type = EO_OP_TYPE_REGULAR;
   ops[37].doc = NULL;

   ops[38].func = reinterpret_cast<void*>(& ::_elm_image_object_size_get_wrapper<T>);
   ops[38].api_func = reinterpret_cast<void*>(& ::elm_obj_image_object_size_get);
   ops[38].op = EO_OP_OVERRIDE;
   ops[38].op_type = EO_OP_TYPE_REGULAR;
   ops[38].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_image >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_image, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_image >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_image, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_image>
{
   template <typename U>
   struct type
   {
      operator ::elm_image() const
      {
         return ::elm_image(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void sizing_eval()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_sizing_eval());
      }

      bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void editable_set(bool set_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_editable_set(efl::eolian::to_c(set_)));
      }

      bool smooth_scale_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_smooth_scale_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void smooth_scale_set(bool smooth_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_smooth_scale_set(efl::eolian::to_c(smooth_)));
      }

      bool resize_down_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_resize_down_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void resize_down_set(bool resize_down_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_resize_down_set(efl::eolian::to_c(resize_down_)));
      }

      int load_size_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_load_size_get());
            return _tmp_ret;
      }

      void load_size_set(int size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_load_size_set(size_));
      }

      bool animated_play_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_play_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void animated_play_set(bool play_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_animated_play_set(efl::eolian::to_c(play_)));
      }

      bool resize_up_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_resize_up_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void resize_up_set(bool resize_up_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_resize_up_set(efl::eolian::to_c(resize_up_)));
      }

      bool smooth_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_smooth_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void smooth_set(bool smooth_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_smooth_set(efl::eolian::to_c(smooth_)));
      }

      bool no_scale_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_no_scale_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void no_scale_set(bool no_scale_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_no_scale_set(efl::eolian::to_c(no_scale_)));
      }

      bool animated_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void animated_set(bool anim_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_animated_set(efl::eolian::to_c(anim_)));
      }

      double scale_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_scale_get());
            return _tmp_ret;
      }

      void scale_set(double scale_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_scale_set(scale_));
      }

      void file_get(const char ** file_, const char ** group_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_file_get(file_, group_));
      }

      bool file_set(std::string file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool fill_inside_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_fill_inside_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void fill_inside_set(bool fill_inside_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_fill_inside_set(efl::eolian::to_c(fill_inside_)));
      }

      bool aspect_fixed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_aspect_fixed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void aspect_fixed_set(bool fixed_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_aspect_fixed_set(efl::eolian::to_c(fixed_)));
      }

      Elm_Image_Orient orient_get()
      {
         Elm_Image_Orient _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_orient_get());
            return _tmp_ret;
      }

      void orient_set(Elm_Image_Orient orient_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_orient_set(orient_));
      }

      bool fill_outside_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_fill_outside_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void fill_outside_set(bool fill_outside_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_fill_outside_set(efl::eolian::to_c(fill_outside_)));
      }

      void resizable_get(Eina_Bool* up_, Eina_Bool* down_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_resizable_get(up_, down_));
      }

      void resizable_set(bool up_, bool down_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_resizable_set(efl::eolian::to_c(up_), efl::eolian::to_c(down_)));
      }

      void preload_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_preload_disabled_set(efl::eolian::to_c(disabled_)));
      }

      bool mmap_set(const Eina_File * file_, std::string group_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_mmap_set(file_, efl::eolian::to_c(group_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool memfile_set(const void * img_, size_t size_, std::string format_, std::string key_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_memfile_set(img_, size_, efl::eolian::to_c(format_), efl::eolian::to_c(key_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool animated_available_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_animated_available_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_image_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void object_size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_image_object_size_get(w_, h_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_drop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DROP, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DROP );
   }

   template <typename T>
   void
   callback_drop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DROP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_IMAGE_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_image, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_image, function_type>,
         ELM_IMAGE_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_IMAGE_EVENT_DOWNLOAD_ERROR, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_image>)
{
   return (ELM_IMAGE_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_IMAGE_HH

