#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_accessible.eo.h"
}

#include <string>

struct elm_interface_atspi_accessible
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_accessible(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_accessible(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_accessible(elm_interface_atspi_accessible const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_accessible() {}

   /// @param localized_name 
   ///
   std::string localized_role_name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_localized_role_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param name obj name
   ///
   std::string name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param name obj name
   ///
   void name_set(std::string name_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_accessible_name_set(efl::eolian::to_c(name_)));
   }

   /// @param relations 
   ///
   Eina_List * relation_set_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_relation_set_get());
      return _tmp_ret;
   }

   /// @param role 
   ///
   Elm_Atspi_Role role_get() const
   {
      Elm_Atspi_Role _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_role_get());
      return _tmp_ret;
   }

   /// @param role 
   ///
   void role_set(Elm_Atspi_Role role_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_accessible_role_set(role_));
   }

   /// @param children 
   ///
   Eina_List * children_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_children_get());
      return _tmp_ret;
   }

   /// @param role_name 
   ///
   std::string role_name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_role_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param attributes 
   ///
   Eina_List * attributes_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_attributes_get());
      return _tmp_ret;
   }

   /// @param idx 
   ///
   int index_in_parent_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_index_in_parent_get());
      return _tmp_ret;
   }

   /// @param description 
   ///
   std::string description_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_description_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param description 
   ///
   void description_set(std::string description_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_accessible_description_set(efl::eolian::to_c(description_)));
   }

   /// @param parent 
   ///
   Eo * parent_get() const
   {
      Eo * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_parent_get());
      return _tmp_ret;
   }

   /// @param parent 
   ///
   void parent_set(Eo * parent_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_accessible_parent_set(parent_));
   }

   /// @param states 
   ///
   Elm_Atspi_State_Set state_set_get() const
   {
      Elm_Atspi_State_Set _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_state_set_get());
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_children_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED );
   }

   template <typename T>
   void
   callback_children_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_visible_data_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED );
   }

   template <typename T>
   void
   callback_visible_data_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_active_descendants_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED );
   }

   template <typename T>
   void
   callback_active_descendants_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_ACCESSIBLE_MIXIN);
   }

private:
};
template <typename T>
std::string _elm_interface_atspi_accessible_localized_role_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->localized_role_name_get();
}

template <typename T>
std::string _elm_interface_atspi_accessible_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->name_get();
}

template <typename T>
void _elm_interface_atspi_accessible_name_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_)
{
   static_cast<T*>(self->this_)->name_set(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()));
}

template <typename T>
Eina_List * _elm_interface_atspi_accessible_relation_set_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->relation_set_get();
}

template <typename T>
Elm_Atspi_Role _elm_interface_atspi_accessible_role_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->role_get();
}

template <typename T>
void _elm_interface_atspi_accessible_role_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Atspi_Role role_)
{
   static_cast<T*>(self->this_)->role_set(role_);
}

template <typename T>
Eina_List * _elm_interface_atspi_accessible_children_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->children_get();
}

template <typename T>
std::string _elm_interface_atspi_accessible_role_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->role_name_get();
}

template <typename T>
Eina_List * _elm_interface_atspi_accessible_attributes_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->attributes_get();
}

template <typename T>
int _elm_interface_atspi_accessible_index_in_parent_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->index_in_parent_get();
}

template <typename T>
std::string _elm_interface_atspi_accessible_description_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->description_get();
}

template <typename T>
void _elm_interface_atspi_accessible_description_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * description_)
{
   static_cast<T*>(self->this_)->description_set(efl::eolian::to_cxx<std::string>(description_, std::tuple<std::false_type>()));
}

template <typename T>
Eo * _elm_interface_atspi_accessible_parent_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->parent_get();
}

template <typename T>
void _elm_interface_atspi_accessible_parent_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eo * parent_)
{
   static_cast<T*>(self->this_)->parent_set(parent_);
}

template <typename T>
Elm_Atspi_State_Set _elm_interface_atspi_accessible_state_set_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->state_set_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_accessible >
{
   template <typename T>
   struct type
   {
      virtual std::string localized_role_name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_localized_role_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void name_set(std::string name_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_accessible_name_set(efl::eolian::to_c(name_)));
      }

      virtual Eina_List * relation_set_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_relation_set_get());
            return _tmp_ret;
      }

      virtual Elm_Atspi_Role role_get()
      {
         Elm_Atspi_Role _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_role_get());
            return _tmp_ret;
      }

      virtual void role_set(Elm_Atspi_Role role_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_accessible_role_set(role_));
      }

      virtual Eina_List * children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_children_get());
            return _tmp_ret;
      }

      virtual std::string role_name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_role_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_List * attributes_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_attributes_get());
            return _tmp_ret;
      }

      virtual int index_in_parent_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_index_in_parent_get());
            return _tmp_ret;
      }

      virtual std::string description_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_description_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void description_set(std::string description_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_accessible_description_set(efl::eolian::to_c(description_)));
      }

      virtual Eo * parent_get()
      {
         Eo * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_parent_get());
            return _tmp_ret;
      }

      virtual void parent_set(Eo * parent_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_accessible_parent_set(parent_));
      }

      virtual Elm_Atspi_State_Set state_set_get()
      {
         Elm_Atspi_State_Set _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_accessible_state_set_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_accessible >
{
   static const int value = 15;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_accessible>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_localized_role_name_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_localized_role_name_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_name_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_name_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_name_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_name_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_relation_set_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_relation_set_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_role_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_role_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_role_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_role_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_children_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_children_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_role_name_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_role_name_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_attributes_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_attributes_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_index_in_parent_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_index_in_parent_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_description_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_description_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_description_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_description_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_parent_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_parent_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_parent_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_parent_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_accessible_state_set_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_accessible_state_set_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_accessible >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_accessible, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_accessible>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_accessible() const
      {
         return ::elm_interface_atspi_accessible(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      std::string localized_role_name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_localized_role_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void name_set(std::string name_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_accessible_name_set(efl::eolian::to_c(name_)));
      }

      Eina_List * relation_set_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_relation_set_get());
            return _tmp_ret;
      }

      Elm_Atspi_Role role_get()
      {
         Elm_Atspi_Role _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_role_get());
            return _tmp_ret;
      }

      void role_set(Elm_Atspi_Role role_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_accessible_role_set(role_));
      }

      Eina_List * children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_children_get());
            return _tmp_ret;
      }

      std::string role_name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_role_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      Eina_List * attributes_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_attributes_get());
            return _tmp_ret;
      }

      int index_in_parent_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_index_in_parent_get());
            return _tmp_ret;
      }

      std::string description_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_description_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void description_set(std::string description_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_accessible_description_set(efl::eolian::to_c(description_)));
      }

      Eo * parent_get()
      {
         Eo * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_parent_get());
            return _tmp_ret;
      }

      void parent_set(Eo * parent_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_accessible_parent_set(parent_));
      }

      Elm_Atspi_State_Set state_set_get()
      {
         Elm_Atspi_State_Set _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_accessible_state_set_get());
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_property_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED );
   }

   template <typename T>
   void
   callback_property_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_PROPERTY_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_children_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED );
   }

   template <typename T>
   void
   callback_children_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_CHILDREN_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_state_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED );
   }

   template <typename T>
   void
   callback_state_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_STATE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_visible_data_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED );
   }

   template <typename T>
   void
   callback_visible_data_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_VISIBLE_DATA_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_active_descendants_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_accessible, function_type>,
         ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED );
   }

   template <typename T>
   void
   callback_active_descendants_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_ACCESSIBLE_EVENT_ACTIVE_DESCENDANTS_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_accessible>)
{
   return (ELM_INTERFACE_ATSPI_ACCESSIBLE_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_ACCESSIBLE_HH

