#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_COMPONENT_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_COMPONENT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_component.eo.h"
}


struct elm_interface_atspi_component
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_component(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_component(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_component(elm_interface_atspi_component const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_component() {}

   /// @param screen_coords If true x and y values will be relative
   /// to screen origin, otherwise relative to
   /// canvas
   /// @param x 
   /// @param y 
   ///
   bool contains(bool screen_coords_, int x_, int y_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_contains(efl::eolian::to_c(screen_coords_), x_, y_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Focuses accessible widget.
   ///
   /// @return true if focus grab focus has successed, false otherwise.
   ///
   bool focus_grab() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_focus_grab());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Gets top component object occupying space at given coordinates.
   ///
   /// @param screen_coords If true x and y values will be relative
   /// to screen origin, otherwise relative to
   /// canvas
   /// @param x 
   /// @param y 
   ///
   evas::object accessible_at_point_get(bool screen_coords_, int x_, int y_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_accessible_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w 
   /// @param h 
   ///
   void size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_component_size_get(w_, h_));
   }

   /// @param w 
   /// @param h 
   ///
   bool size_set(int w_, int h_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_size_set(w_, h_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param layer 
   ///
   int layer_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_layer_get());
      return _tmp_ret;
   }

   /// @param alpha alpha value in [0, 1] range.
   ///
   double alpha_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_alpha_get());
      return _tmp_ret;
   }

   /// @param z_order 
   ///
   int z_order_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_z_order_get());
      return _tmp_ret;
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void extents_get(bool screen_coords_, int* x_, int* y_, int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_component_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   bool extents_set(bool screen_coords_, int x_, int y_, int w_, int h_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_extents_set(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param x 
   /// @param y 
   ///
   void position_get(bool screen_coords_, int* x_, int* y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_component_position_get(efl::eolian::to_c(screen_coords_), x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   bool position_set(bool screen_coords_, int x_, int y_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_position_set(efl::eolian::to_c(screen_coords_), x_, y_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_COMPONENT_MIXIN);
   }

private:
};
template <typename T>
bool _elm_interface_atspi_component_contains_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int x_, int y_)
{
   return static_cast<T*>(self->this_)->contains(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_);
}

template <typename T>
bool _elm_interface_atspi_component_focus_grab_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_grab();
}

template <typename T>
evas::object _elm_interface_atspi_component_accessible_at_point_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int x_, int y_)
{
   return static_cast<T*>(self->this_)->accessible_at_point_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_);
}

template <typename T>
void _elm_interface_atspi_component_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->size_get(w_, h_);
}

template <typename T>
bool _elm_interface_atspi_component_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int w_, int h_)
{
   return static_cast<T*>(self->this_)->size_set(w_, h_);
}

template <typename T>
int _elm_interface_atspi_component_layer_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->layer_get();
}

template <typename T>
double _elm_interface_atspi_component_alpha_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->alpha_get();
}

template <typename T>
int _elm_interface_atspi_component_z_order_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->z_order_get();
}

template <typename T>
void _elm_interface_atspi_component_extents_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int* x_, int* y_, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->extents_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_, w_, h_);
}

template <typename T>
bool _elm_interface_atspi_component_extents_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int x_, int y_, int w_, int h_)
{
   return static_cast<T*>(self->this_)->extents_set(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_, w_, h_);
}

template <typename T>
void _elm_interface_atspi_component_position_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int* x_, int* y_)
{
   static_cast<T*>(self->this_)->position_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_);
}

template <typename T>
bool _elm_interface_atspi_component_position_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int x_, int y_)
{
   return static_cast<T*>(self->this_)->position_set(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_component >
{
   template <typename T>
   struct type
   {
      virtual bool contains(bool screen_coords_, int x_, int y_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_contains(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_grab()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_focus_grab());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object accessible_at_point_get(bool screen_coords_, int x_, int y_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_accessible_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_component_size_get(w_, h_));
      }

      virtual bool size_set(int w_, int h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_size_set(w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int layer_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_layer_get());
            return _tmp_ret;
      }

      virtual double alpha_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_alpha_get());
            return _tmp_ret;
      }

      virtual int z_order_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_z_order_get());
            return _tmp_ret;
      }

      virtual void extents_get(bool screen_coords_, int* x_, int* y_, int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_component_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
      }

      virtual bool extents_set(bool screen_coords_, int x_, int y_, int w_, int h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_extents_set(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void position_get(bool screen_coords_, int* x_, int* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_component_position_get(efl::eolian::to_c(screen_coords_), x_, y_));
      }

      virtual bool position_set(bool screen_coords_, int x_, int y_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_component_position_set(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_component >
{
   static const int value = 12;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_component>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_contains_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_contains);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_focus_grab_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_focus_grab);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_accessible_at_point_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_accessible_at_point_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_size_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_size_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_size_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_size_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_layer_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_layer_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_alpha_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_alpha_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_z_order_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_z_order_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_extents_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_extents_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_extents_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_extents_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_position_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_position_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_component_position_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_component_position_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_component >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_component, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_component>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_component() const
      {
         return ::elm_interface_atspi_component(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool contains(bool screen_coords_, int x_, int y_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_contains(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_grab()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_focus_grab());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object accessible_at_point_get(bool screen_coords_, int x_, int y_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_accessible_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_component_size_get(w_, h_));
      }

      bool size_set(int w_, int h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_size_set(w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      int layer_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_layer_get());
            return _tmp_ret;
      }

      double alpha_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_alpha_get());
            return _tmp_ret;
      }

      int z_order_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_z_order_get());
            return _tmp_ret;
      }

      void extents_get(bool screen_coords_, int* x_, int* y_, int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_component_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
      }

      bool extents_set(bool screen_coords_, int x_, int y_, int w_, int h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_extents_set(efl::eolian::to_c(screen_coords_), x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void position_get(bool screen_coords_, int* x_, int* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_component_position_get(efl::eolian::to_c(screen_coords_), x_, y_));
      }

      bool position_set(bool screen_coords_, int x_, int y_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_component_position_set(efl::eolian::to_c(screen_coords_), x_, y_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_component>)
{
   return (ELM_INTERFACE_ATSPI_COMPONENT_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_COMPONENT_HH

