#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_EDITABLE_TEXT_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_EDITABLE_TEXT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_editable_text.eo.h"
}

#include <string>

struct elm_interface_atspi_editable_text
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_editable_text(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_editable_text(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_editable_text(elm_interface_atspi_editable_text const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_editable_text() {}

   /// @param string 
   /// @param position 
   ///
   bool insert(std::string string_, int position_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_insert(efl::eolian::to_c(string_), position_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param start 
   /// @param end 
   ///
   bool copy(int start_, int end_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param start 
   /// @param end 
   ///
   bool cut(int start_, int end_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param start 
   /// @param end 
   ///
   bool delete_(int start_, int end_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param position 
   ///
   bool paste(int position_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param string 
   ///
   bool content_set(std::string string_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_content_set(efl::eolian::to_c(string_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_EDITABLE_TEXT_INTERFACE);
   }

private:
};
template <typename T>
bool _elm_interface_atspi_editable_text_insert_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * string_, int position_)
{
   return static_cast<T*>(self->this_)->insert(efl::eolian::to_cxx<std::string>(string_, std::tuple<std::false_type>()), position_);
}

template <typename T>
bool _elm_interface_atspi_editable_text_copy_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   return static_cast<T*>(self->this_)->copy(start_, end_);
}

template <typename T>
bool _elm_interface_atspi_editable_text_cut_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   return static_cast<T*>(self->this_)->cut(start_, end_);
}

template <typename T>
bool _elm_interface_atspi_editable_text_delete__wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int start_, int end_)
{
   return static_cast<T*>(self->this_)->delete_(start_, end_);
}

template <typename T>
bool _elm_interface_atspi_editable_text_paste_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int position_)
{
   return static_cast<T*>(self->this_)->paste(position_);
}

template <typename T>
bool _elm_interface_atspi_editable_text_content_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * string_)
{
   return static_cast<T*>(self->this_)->content_set(efl::eolian::to_cxx<std::string>(string_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_editable_text >
{
   template <typename T>
   struct type
   {
      virtual bool insert(std::string string_, int position_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_insert(efl::eolian::to_c(string_), position_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool copy(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool cut(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool delete_(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool paste(int position_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool content_set(std::string string_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_editable_text_content_set(efl::eolian::to_c(string_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_editable_text >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_editable_text>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_insert_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_insert);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_copy_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_copy);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_cut_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_cut);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_delete__wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_delete);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_paste_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_paste);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_editable_text_content_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_editable_text_content_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_editable_text >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_editable_text, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_editable_text>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_editable_text() const
      {
         return ::elm_interface_atspi_editable_text(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool insert(std::string string_, int position_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_insert(efl::eolian::to_c(string_), position_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool copy(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_copy(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool cut(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_cut(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool delete_(int start_, int end_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_delete(start_, end_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool paste(int position_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_paste(position_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool content_set(std::string string_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_editable_text_content_set(efl::eolian::to_c(string_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_editable_text>)
{
   return (ELM_INTERFACE_ATSPI_EDITABLE_TEXT_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_EDITABLE_TEXT_HH

