#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_IMAGE_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_IMAGE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_image.eo.h"
}

#include <string>

struct elm_interface_atspi_image
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_image(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_image(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_image(elm_interface_atspi_image const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_image() {}

   /// @param x 
   /// @param y 
   /// @param width 
   /// @param height 
   ///
   void extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_image_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
   }

   /// @param description 
   ///
   std::string description_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_description_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param description 
   ///
   void description_set(std::string description_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_image_description_set(efl::eolian::to_c(description_)));
   }

   /// @param locale 
   ///
   std::string locale_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_locale_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_IMAGE_MIXIN);
   }

private:
};
template <typename T>
void _elm_interface_atspi_image_extents_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int* x_, int* y_, int* width_, int* height_)
{
   static_cast<T*>(self->this_)->extents_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_, width_, height_);
}

template <typename T>
std::string _elm_interface_atspi_image_description_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->description_get();
}

template <typename T>
void _elm_interface_atspi_image_description_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * description_)
{
   static_cast<T*>(self->this_)->description_set(efl::eolian::to_cxx<std::string>(description_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_interface_atspi_image_locale_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->locale_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_image >
{
   template <typename T>
   struct type
   {
      virtual void extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_image_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
      }

      virtual std::string description_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_image_description_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void description_set(std::string description_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_image_description_set(efl::eolian::to_c(description_)));
      }

      virtual std::string locale_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_image_locale_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_image >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_image>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_extents_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_extents_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_description_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_description_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_description_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_description_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_image_locale_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_image_locale_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_image >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_image, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_image>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_image() const
      {
         return ::elm_interface_atspi_image(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void extents_get(bool screen_coords_, int* x_, int* y_, int* width_, int* height_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_image_extents_get(efl::eolian::to_c(screen_coords_), x_, y_, width_, height_));
      }

      std::string description_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_description_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void description_set(std::string description_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_image_description_set(efl::eolian::to_c(description_)));
      }

      std::string locale_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_image_locale_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_image>)
{
   return (ELM_INTERFACE_ATSPI_IMAGE_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_IMAGE_HH

