#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_selection.eo.h"
}


struct elm_interface_atspi_selection
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_selection(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_selection(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_selection(elm_interface_atspi_selection const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_selection() {}

   /// @param child_index 
   ///
   bool child_select(int child_index_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param child_index 
   ///
   bool selected_child_deselect(int child_index_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param child_index 
   ///
   bool is_child_selected(int child_index_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   bool all_children_select() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   bool clear() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_clear());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param child_index 
   ///
   bool child_deselect(int child_index_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   int selected_children_count_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
      return _tmp_ret;
   }

   Eo * selected_child_get(int selected_child_index_) const
   {
      Eo * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_selection_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>,
         ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_selection_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_SELECTION_INTERFACE);
   }

private:
};
template <typename T>
bool _elm_interface_atspi_selection_child_select_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   return static_cast<T*>(self->this_)->child_select(child_index_);
}

template <typename T>
bool _elm_interface_atspi_selection_selected_child_deselect_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   return static_cast<T*>(self->this_)->selected_child_deselect(child_index_);
}

template <typename T>
bool _elm_interface_atspi_selection_is_child_selected_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   return static_cast<T*>(self->this_)->is_child_selected(child_index_);
}

template <typename T>
bool _elm_interface_atspi_selection_all_children_select_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->all_children_select();
}

template <typename T>
bool _elm_interface_atspi_selection_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->clear();
}

template <typename T>
bool _elm_interface_atspi_selection_child_deselect_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int child_index_)
{
   return static_cast<T*>(self->this_)->child_deselect(child_index_);
}

template <typename T>
int _elm_interface_atspi_selection_selected_children_count_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_children_count_get();
}

template <typename T>
Eo * _elm_interface_atspi_selection_selected_child_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int selected_child_index_)
{
   return static_cast<T*>(self->this_)->selected_child_get(selected_child_index_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_selection >
{
   template <typename T>
   struct type
   {
      virtual bool child_select(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool selected_child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool is_child_selected(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool all_children_select()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool clear()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_clear());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int selected_children_count_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
            return _tmp_ret;
      }

      virtual Eo * selected_child_get(int selected_child_index_)
      {
         Eo * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_selection >
{
   static const int value = 8;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_selection>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_child_select_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_child_select);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_child_deselect_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_child_deselect);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_is_child_selected_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_is_child_selected);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_all_children_select_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_all_children_select);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_clear_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_clear);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_child_deselect_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_child_deselect);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_children_count_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_children_count_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_selection_selected_child_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_selection_selected_child_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_selection >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_selection, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_selection>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_selection() const
      {
         return ::elm_interface_atspi_selection(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool child_select(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_select(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool selected_child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_deselect(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool is_child_selected(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_is_child_selected(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool all_children_select()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_all_children_select());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool clear()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_clear());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool child_deselect(int child_index_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_child_deselect(child_index_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      int selected_children_count_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_children_count_get());
            return _tmp_ret;
      }

      Eo * selected_child_get(int selected_child_index_)
      {
         Eo * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_selection_selected_child_get(selected_child_index_));
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_selection_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_selection, function_type>,
         ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_selection_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_SELECTION_EVENT_SELECTION_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_selection>)
{
   return (ELM_INTERFACE_ATSPI_SELECTION_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_SELECTION_HH

