#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_text.eo.h"
}

#include <string>

struct elm_interface_atspi_text
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_text(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_text(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_text(elm_interface_atspi_text const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_text() {}

   /// @param start_offset 
   /// @param end_offset 
   ///
   bool selection_add(int start_offset_, int end_offset_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_add(start_offset_, end_offset_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param selection_number 
   ///
   bool selection_remove(int selection_number_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_remove(selection_number_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param character Character at offset. 0 when out-of
   /// bounds offset has been given.
   /// Codepoints between DC80 and DCFF indicates
   /// that string includes invalid UTF8 chars.
   ///
   Eina_Unicode character_get(int offset_) const
   {
      Eina_Unicode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_get(offset_));
      return _tmp_ret;
   }

   /// @param string Newly allocated UTF-8 encoded string.
   /// Must be free by a user.
   ///
   char * string_get(Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_) const
   {
      char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_string_get(granularity_, start_offset_, end_offset_));
      return _tmp_ret;
   }

   /// @param text UTF-8 encoded text.
   ///
   char * text_get(int start_offset_, int end_offset_) const
   {
      char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_get(start_offset_, end_offset_));
      return _tmp_ret;
   }

   /// @param offset 
   ///
   int caret_offset_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_caret_offset_get());
      return _tmp_ret;
   }

   /// @param offset 
   ///
   /// @return EINA_TRUE if caret was successfully moved,
   /// EINA_FASLE otherwise.
   bool caret_offset_set(int offset_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_caret_offset_set(offset_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param value 
   ///
   bool attribute_get(std::string name_, int * start_offset_, int * end_offset_, char ** value_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_attribute_get(efl::eolian::to_c(name_), start_offset_, end_offset_, value_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param attributes 
   ///
   Eina_List * attributes_get(int * start_offset_, int * end_offset_) const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_attributes_get(start_offset_, end_offset_));
      return _tmp_ret;
   }

   /// @param attributes 
   ///
   Eina_List * default_attributes_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_default_attributes_get());
      return _tmp_ret;
   }

   /// @param rect 
   ///
   bool character_extents_get(int offset_, bool screen_coords_, Eina_Rectangle* rect_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_extents_get(offset_, efl::eolian::to_c(screen_coords_), rect_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param count 
   ///
   int character_count_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_count_get());
      return _tmp_ret;
   }

   /// @param offset 
   ///
   int offset_at_point_get(bool screen_coords_, int x_, int y_) const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_offset_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
      return _tmp_ret;
   }

   /// @param ranges 
   ///
   Eina_List * bounded_ranges_get(bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_) const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_bounded_ranges_get(efl::eolian::to_c(screen_coords_), rect_, xclip_, yclip_));
      return _tmp_ret;
   }

   /// @param rect 
   ///
   bool range_extents_get(bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_range_extents_get(efl::eolian::to_c(screen_coords_), start_offset_, end_offset_, rect_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param count 
   ///
   int selections_count_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selections_count_get());
      return _tmp_ret;
   }

   /// @param start_offset 
   /// @param end_offset 
   ///
   void selection_get(int selection_number_, int* start_offset_, int* end_offset_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_text_selection_get(selection_number_, start_offset_, end_offset_));
   }

   /// @param start_offset 
   /// @param end_offset 
   ///
   bool selection_set(int selection_number_, int start_offset_, int end_offset_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_set(selection_number_, start_offset_, end_offset_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_bounds_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_bounds_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_attributes_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_attributes_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_caret_moved_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED );
   }

   template <typename T>
   void
   callback_access_text_caret_moved_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_inserted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED );
   }

   template <typename T>
   void
   callback_access_text_inserted_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_removed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED );
   }

   template <typename T>
   void
   callback_access_text_removed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_selection_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_selection_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_TEXT_INTERFACE);
   }

private:
};
template <typename T>
bool _elm_interface_atspi_text_selection_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int start_offset_, int end_offset_)
{
   return static_cast<T*>(self->this_)->selection_add(start_offset_, end_offset_);
}

template <typename T>
bool _elm_interface_atspi_text_selection_remove_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int selection_number_)
{
   return static_cast<T*>(self->this_)->selection_remove(selection_number_);
}

template <typename T>
Eina_Unicode _elm_interface_atspi_text_character_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int offset_)
{
   return static_cast<T*>(self->this_)->character_get(offset_);
}

template <typename T>
char * _elm_interface_atspi_text_string_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_)
{
   return static_cast<T*>(self->this_)->string_get(granularity_, start_offset_, end_offset_);
}

template <typename T>
char * _elm_interface_atspi_text_text_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int start_offset_, int end_offset_)
{
   return static_cast<T*>(self->this_)->text_get(start_offset_, end_offset_);
}

template <typename T>
int _elm_interface_atspi_text_caret_offset_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->caret_offset_get();
}

template <typename T>
bool _elm_interface_atspi_text_caret_offset_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int offset_)
{
   return static_cast<T*>(self->this_)->caret_offset_set(offset_);
}

template <typename T>
bool _elm_interface_atspi_text_attribute_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_, int * start_offset_, int * end_offset_, char ** value_)
{
   return static_cast<T*>(self->this_)->attribute_get(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()), start_offset_, end_offset_, value_);
}

template <typename T>
Eina_List * _elm_interface_atspi_text_attributes_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int * start_offset_, int * end_offset_)
{
   return static_cast<T*>(self->this_)->attributes_get(start_offset_, end_offset_);
}

template <typename T>
Eina_List * _elm_interface_atspi_text_default_attributes_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->default_attributes_get();
}

template <typename T>
bool _elm_interface_atspi_text_character_extents_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int offset_, Eina_Bool screen_coords_, Eina_Rectangle* rect_)
{
   return static_cast<T*>(self->this_)->character_extents_get(offset_, efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), rect_);
}

template <typename T>
int _elm_interface_atspi_text_character_count_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->character_count_get();
}

template <typename T>
int _elm_interface_atspi_text_offset_at_point_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int x_, int y_)
{
   return static_cast<T*>(self->this_)->offset_at_point_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), x_, y_);
}

template <typename T>
Eina_List * _elm_interface_atspi_text_bounded_ranges_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_)
{
   return static_cast<T*>(self->this_)->bounded_ranges_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), rect_, xclip_, yclip_);
}

template <typename T>
bool _elm_interface_atspi_text_range_extents_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_)
{
   return static_cast<T*>(self->this_)->range_extents_get(efl::eolian::to_cxx<bool>(screen_coords_, std::tuple<std::false_type>()), start_offset_, end_offset_, rect_);
}

template <typename T>
int _elm_interface_atspi_text_selections_count_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selections_count_get();
}

template <typename T>
void _elm_interface_atspi_text_selection_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int selection_number_, int* start_offset_, int* end_offset_)
{
   static_cast<T*>(self->this_)->selection_get(selection_number_, start_offset_, end_offset_);
}

template <typename T>
bool _elm_interface_atspi_text_selection_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int selection_number_, int start_offset_, int end_offset_)
{
   return static_cast<T*>(self->this_)->selection_set(selection_number_, start_offset_, end_offset_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_text >
{
   template <typename T>
   struct type
   {
      virtual bool selection_add(int start_offset_, int end_offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_selection_add(start_offset_, end_offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool selection_remove(int selection_number_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_selection_remove(selection_number_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_Unicode character_get(int offset_)
      {
         Eina_Unicode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_character_get(offset_));
            return _tmp_ret;
      }

      virtual char * string_get(Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_)
      {
         char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_string_get(granularity_, start_offset_, end_offset_));
            return _tmp_ret;
      }

      virtual char * text_get(int start_offset_, int end_offset_)
      {
         char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_get(start_offset_, end_offset_));
            return _tmp_ret;
      }

      virtual int caret_offset_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_caret_offset_get());
            return _tmp_ret;
      }

      virtual bool caret_offset_set(int offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_caret_offset_set(offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool attribute_get(std::string name_, int * start_offset_, int * end_offset_, char ** value_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_attribute_get(efl::eolian::to_c(name_), start_offset_, end_offset_, value_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Eina_List * attributes_get(int * start_offset_, int * end_offset_)
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_attributes_get(start_offset_, end_offset_));
            return _tmp_ret;
      }

      virtual Eina_List * default_attributes_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_default_attributes_get());
            return _tmp_ret;
      }

      virtual bool character_extents_get(int offset_, bool screen_coords_, Eina_Rectangle* rect_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_character_extents_get(offset_, efl::eolian::to_c(screen_coords_), rect_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int character_count_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_character_count_get());
            return _tmp_ret;
      }

      virtual int offset_at_point_get(bool screen_coords_, int x_, int y_)
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_offset_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
            return _tmp_ret;
      }

      virtual Eina_List * bounded_ranges_get(bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_)
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_bounded_ranges_get(efl::eolian::to_c(screen_coords_), rect_, xclip_, yclip_));
            return _tmp_ret;
      }

      virtual bool range_extents_get(bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_range_extents_get(efl::eolian::to_c(screen_coords_), start_offset_, end_offset_, rect_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int selections_count_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_selections_count_get());
            return _tmp_ret;
      }

      virtual void selection_get(int selection_number_, int* start_offset_, int* end_offset_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_text_selection_get(selection_number_, start_offset_, end_offset_));
      }

      virtual bool selection_set(int selection_number_, int start_offset_, int end_offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_text_selection_set(selection_number_, start_offset_, end_offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_text >
{
   static const int value = 18;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_text>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_selection_add_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_selection_add);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_selection_remove_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_selection_remove);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_character_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_character_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_string_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_string_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_text_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_caret_offset_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_caret_offset_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_caret_offset_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_caret_offset_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_attribute_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_attribute_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_attributes_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_attributes_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_default_attributes_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_default_attributes_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_character_extents_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_character_extents_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_character_count_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_character_count_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_offset_at_point_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_offset_at_point_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_bounded_ranges_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_bounded_ranges_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_range_extents_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_range_extents_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_selections_count_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_selections_count_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_selection_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_selection_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_text_selection_set_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_text_selection_set);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_text >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_text, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_text>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_text() const
      {
         return ::elm_interface_atspi_text(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool selection_add(int start_offset_, int end_offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_add(start_offset_, end_offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool selection_remove(int selection_number_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_remove(selection_number_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      Eina_Unicode character_get(int offset_)
      {
         Eina_Unicode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_get(offset_));
            return _tmp_ret;
      }

      char * string_get(Elm_Atspi_Text_Granularity granularity_, int * start_offset_, int * end_offset_)
      {
         char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_string_get(granularity_, start_offset_, end_offset_));
            return _tmp_ret;
      }

      char * text_get(int start_offset_, int end_offset_)
      {
         char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_get(start_offset_, end_offset_));
            return _tmp_ret;
      }

      int caret_offset_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_caret_offset_get());
            return _tmp_ret;
      }

      bool caret_offset_set(int offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_caret_offset_set(offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool attribute_get(std::string name_, int * start_offset_, int * end_offset_, char ** value_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_attribute_get(efl::eolian::to_c(name_), start_offset_, end_offset_, value_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      Eina_List * attributes_get(int * start_offset_, int * end_offset_)
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_attributes_get(start_offset_, end_offset_));
            return _tmp_ret;
      }

      Eina_List * default_attributes_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_default_attributes_get());
            return _tmp_ret;
      }

      bool character_extents_get(int offset_, bool screen_coords_, Eina_Rectangle* rect_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_extents_get(offset_, efl::eolian::to_c(screen_coords_), rect_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      int character_count_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_character_count_get());
            return _tmp_ret;
      }

      int offset_at_point_get(bool screen_coords_, int x_, int y_)
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_offset_at_point_get(efl::eolian::to_c(screen_coords_), x_, y_));
            return _tmp_ret;
      }

      Eina_List * bounded_ranges_get(bool screen_coords_, Eina_Rectangle rect_, Elm_Atspi_Text_Clip_Type xclip_, Elm_Atspi_Text_Clip_Type yclip_)
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_bounded_ranges_get(efl::eolian::to_c(screen_coords_), rect_, xclip_, yclip_));
            return _tmp_ret;
      }

      bool range_extents_get(bool screen_coords_, int start_offset_, int end_offset_, Eina_Rectangle* rect_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_range_extents_get(efl::eolian::to_c(screen_coords_), start_offset_, end_offset_, rect_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      int selections_count_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selections_count_get());
            return _tmp_ret;
      }

      void selection_get(int selection_number_, int* start_offset_, int* end_offset_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_text_selection_get(selection_number_, start_offset_, end_offset_));
      }

      bool selection_set(int selection_number_, int start_offset_, int end_offset_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_text_selection_set(selection_number_, start_offset_, end_offset_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_bounds_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_bounds_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_BOUNDS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_attributes_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_attributes_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_ATTRIBUTES_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_caret_moved_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED );
   }

   template <typename T>
   void
   callback_access_text_caret_moved_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_CARET_MOVED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_inserted_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED );
   }

   template <typename T>
   void
   callback_access_text_inserted_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_INSERTED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_removed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED );
   }

   template <typename T>
   void
   callback_access_text_removed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_REMOVED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_text_selection_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_text, function_type>,
         ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED );
   }

   template <typename T>
   void
   callback_access_text_selection_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_TEXT_EVENT_ACCESS_TEXT_SELECTION_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_text>)
{
   return (ELM_INTERFACE_ATSPI_TEXT_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_TEXT_HH

