#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_VALUE_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_VALUE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_value.eo.h"
}

#include <string>

struct elm_interface_atspi_value
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_value(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_value(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_value(elm_interface_atspi_value const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_value() {}

   /// @param value Value of widget casted to floating point number.
   /// @param text string describing value in given context
   /// eg. small, enough
   ///
   void value_and_text_get(double* value_, const char ** text_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_value_and_text_get(value_, text_));
   }

   /// @param value Value of widget casted to floating point number.
   /// @param text string describing value in given context
   /// eg. small, enough
   ///
   /// @return EINA_TRUE if setting widgets value has
   /// successed, EINA_FALSE otherwise.
   bool value_and_text_set(double value_, std::string text_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, efl::eolian::to_c(text_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param lower_limit 
   /// @param upper_limit 
   /// @param description 
   ///
   void range_get(double* lower_limit_, double* upper_limit_, const char ** description_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
   }

   /// @param increment 
   ///
   double increment_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_increment_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_VALUE_INTERFACE);
   }

private:
};
template <typename T>
void _elm_interface_atspi_value_value_and_text_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* value_, const char ** text_)
{
   static_cast<T*>(self->this_)->value_and_text_get(value_, text_);
}

template <typename T>
bool _elm_interface_atspi_value_value_and_text_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double value_, const char * text_)
{
   return static_cast<T*>(self->this_)->value_and_text_set(value_, efl::eolian::to_cxx<std::string>(text_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_atspi_value_range_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* lower_limit_, double* upper_limit_, const char ** description_)
{
   static_cast<T*>(self->this_)->range_get(lower_limit_, upper_limit_, description_);
}

template <typename T>
double _elm_interface_atspi_value_increment_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->increment_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_value >
{
   template <typename T>
   struct type
   {
      virtual void value_and_text_get(double* value_, const char ** text_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_value_and_text_get(value_, text_));
      }

      virtual bool value_and_text_set(double value_, std::string text_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, efl::eolian::to_c(text_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void range_get(double* lower_limit_, double* upper_limit_, const char ** description_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
      }

      virtual double increment_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_value_increment_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_value >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_value>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_value_and_text_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_and_text_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_value_and_text_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_and_text_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_range_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_range_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_increment_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_increment_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_value >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_value, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_value>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_value() const
      {
         return ::elm_interface_atspi_value(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void value_and_text_get(double* value_, const char ** text_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_value_and_text_get(value_, text_));
      }

      bool value_and_text_set(double value_, std::string text_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, efl::eolian::to_c(text_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void range_get(double* lower_limit_, double* upper_limit_, const char ** description_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
      }

      double increment_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_increment_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_value>)
{
   return (ELM_INTERFACE_ATSPI_VALUE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_VALUE_HH

