#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_WINDOW_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_WINDOW_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_window.eo.h"
}


struct elm_interface_atspi_window
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_window(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_window(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_window(elm_interface_atspi_window const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_window() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_window_created_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED );
   }

   template <typename T>
   void
   callback_window_created_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_activated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED );
   }

   template <typename T>
   void
   callback_window_activated_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_deactivated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED );
   }

   template <typename T>
   void
   callback_window_deactivated_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_WINDOW_INTERFACE);
   }

private:
};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_window >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_window >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_window>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_window >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_window, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_window>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_window() const
      {
         return ::elm_interface_atspi_window(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_window_created_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED );
   }

   template <typename T>
   void
   callback_window_created_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_CREATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_activated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED );
   }

   template <typename T>
   void
   callback_window_activated_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_ACTIVATED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_window_deactivated_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_atspi_window, function_type>,
         ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED );
   }

   template <typename T>
   void
   callback_window_deactivated_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_ATSPI_WINDOW_EVENT_WINDOW_DEACTIVATED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_window>)
{
   return (ELM_INTERFACE_ATSPI_WINDOW_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_WINDOW_HH

