#ifndef EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH
#define EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_fileselector.eo.h"
}

#include <string>

struct elm_interface_fileselector
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_fileselector(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_fileselector(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_fileselector(elm_interface_fileselector const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_fileselector() {}

   /// @brief Append custom filter into filter list
   ///
   /// @param func function
   /// @param data 
   /// @param filter_name 
   ///
   bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, std::string filter_name_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, efl::eolian::to_c(filter_name_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Clear all filters registered
   ///
   void filters_clear() const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_filters_clear());
   }

   /// @brief Append mime type based filter into filter list
   ///
   /// @param mime_types 
   /// @param filter_name 
   ///
   bool mime_types_filter_append(std::string mime_types_, std::string filter_name_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(efl::eolian::to_c(mime_types_), efl::eolian::to_c(filter_name_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param only 
   ///
   bool folder_only_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_folder_only_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param only 
   ///
   void folder_only_set(bool only_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_folder_only_set(efl::eolian::to_c(only_)));
   }

   /// @param path 
   ///
   std::string selected_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param path 
   ///
   bool selected_set(std::string path_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_set(efl::eolian::to_c(path_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w 
   /// @param h 
   ///
   void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
   }

   /// @param w 
   /// @param h 
   ///
   void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
   }

   /// @param multi 
   ///
   bool hidden_visible_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param multi 
   ///
   void hidden_visible_set(bool multi_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_hidden_visible_set(efl::eolian::to_c(multi_)));
   }

   /// @param sort 
   ///
   Elm_Fileselector_Sort sort_method_get() const
   {
      Elm_Fileselector_Sort _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_sort_method_get());
      return _tmp_ret;
   }

   /// @param sort 
   ///
   void sort_method_set(Elm_Fileselector_Sort sort_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_sort_method_set(sort_));
   }

   /// @param multi 
   ///
   bool multi_select_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_multi_select_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param multi 
   ///
   void multi_select_set(bool multi_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_multi_select_set(efl::eolian::to_c(multi_)));
   }

   /// @param expand 
   ///
   bool expandable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_expandable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param expand 
   ///
   void expandable_set(bool expand_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_expandable_set(efl::eolian::to_c(expand_)));
   }

   /// @param path 
   ///
   std::string path_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_path_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param path 
   ///
   void path_set(std::string path_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_path_set(efl::eolian::to_c(path_)));
   }

   /// @param mode 
   ///
   Elm_Fileselector_Mode mode_get() const
   {
      Elm_Fileselector_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mode_get());
      return _tmp_ret;
   }

   /// @param mode 
   ///
   void mode_set(Elm_Fileselector_Mode mode_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_mode_set(mode_));
   }

   /// @param is_save 
   ///
   bool is_save_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_is_save_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param is_save 
   ///
   void is_save_set(bool is_save_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_fileselector_is_save_set(efl::eolian::to_c(is_save_)));
   }

   /// @param ret 
   ///
   const Eina_List * selected_paths_get() const
   {
      const Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_FILESELECTOR_INTERFACE);
   }

private:
};
template <typename T>
bool _elm_interface_fileselector_custom_filter_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Filter_Func func_, void * data_, const char * filter_name_)
{
   return static_cast<T*>(self->this_)->custom_filter_append(func_, data_, efl::eolian::to_cxx<std::string>(filter_name_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_fileselector_filters_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->filters_clear();
}

template <typename T>
bool _elm_interface_fileselector_mime_types_filter_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * mime_types_, const char * filter_name_)
{
   return static_cast<T*>(self->this_)->mime_types_filter_append(efl::eolian::to_cxx<std::string>(mime_types_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(filter_name_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_interface_fileselector_folder_only_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->folder_only_get();
}

template <typename T>
void _elm_interface_fileselector_folder_only_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool only_)
{
   static_cast<T*>(self->this_)->folder_only_set(efl::eolian::to_cxx<bool>(only_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_interface_fileselector_selected_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_get();
}

template <typename T>
bool _elm_interface_fileselector_selected_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * path_)
{
   return static_cast<T*>(self->this_)->selected_set(efl::eolian::to_cxx<std::string>(path_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_fileselector_thumbnail_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->thumbnail_size_get(w_, h_);
}

template <typename T>
void _elm_interface_fileselector_thumbnail_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->thumbnail_size_set(w_, h_);
}

template <typename T>
bool _elm_interface_fileselector_hidden_visible_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->hidden_visible_get();
}

template <typename T>
void _elm_interface_fileselector_hidden_visible_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   static_cast<T*>(self->this_)->hidden_visible_set(efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Fileselector_Sort _elm_interface_fileselector_sort_method_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->sort_method_get();
}

template <typename T>
void _elm_interface_fileselector_sort_method_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Sort sort_)
{
   static_cast<T*>(self->this_)->sort_method_set(sort_);
}

template <typename T>
bool _elm_interface_fileselector_multi_select_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->multi_select_get();
}

template <typename T>
void _elm_interface_fileselector_multi_select_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool multi_)
{
   static_cast<T*>(self->this_)->multi_select_set(efl::eolian::to_cxx<bool>(multi_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_interface_fileselector_expandable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->expandable_get();
}

template <typename T>
void _elm_interface_fileselector_expandable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool expand_)
{
   static_cast<T*>(self->this_)->expandable_set(efl::eolian::to_cxx<bool>(expand_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_interface_fileselector_path_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->path_get();
}

template <typename T>
void _elm_interface_fileselector_path_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * path_)
{
   static_cast<T*>(self->this_)->path_set(efl::eolian::to_cxx<std::string>(path_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Fileselector_Mode _elm_interface_fileselector_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->mode_get();
}

template <typename T>
void _elm_interface_fileselector_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Fileselector_Mode mode_)
{
   static_cast<T*>(self->this_)->mode_set(mode_);
}

template <typename T>
bool _elm_interface_fileselector_is_save_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->is_save_get();
}

template <typename T>
void _elm_interface_fileselector_is_save_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool is_save_)
{
   static_cast<T*>(self->this_)->is_save_set(efl::eolian::to_cxx<bool>(is_save_, std::tuple<std::false_type>()));
}

template <typename T>
const Eina_List * _elm_interface_fileselector_selected_paths_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_paths_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_fileselector >
{
   template <typename T>
   struct type
   {
      virtual bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, std::string filter_name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, efl::eolian::to_c(filter_name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void filters_clear()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_filters_clear());
      }

      virtual bool mime_types_filter_append(std::string mime_types_, std::string filter_name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(efl::eolian::to_c(mime_types_), efl::eolian::to_c(filter_name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool folder_only_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_folder_only_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void folder_only_set(bool only_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_folder_only_set(efl::eolian::to_c(only_)));
      }

      virtual std::string selected_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool selected_set(std::string path_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_set(efl::eolian::to_c(path_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
      }

      virtual void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
      }

      virtual bool hidden_visible_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hidden_visible_set(bool multi_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_hidden_visible_set(efl::eolian::to_c(multi_)));
      }

      virtual Elm_Fileselector_Sort sort_method_get()
      {
         Elm_Fileselector_Sort _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_sort_method_get());
            return _tmp_ret;
      }

      virtual void sort_method_set(Elm_Fileselector_Sort sort_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_sort_method_set(sort_));
      }

      virtual bool multi_select_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_multi_select_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void multi_select_set(bool multi_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_multi_select_set(efl::eolian::to_c(multi_)));
      }

      virtual bool expandable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_expandable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void expandable_set(bool expand_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_expandable_set(efl::eolian::to_c(expand_)));
      }

      virtual std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void path_set(std::string path_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_path_set(efl::eolian::to_c(path_)));
      }

      virtual Elm_Fileselector_Mode mode_get()
      {
         Elm_Fileselector_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_mode_get());
            return _tmp_ret;
      }

      virtual void mode_set(Elm_Fileselector_Mode mode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_mode_set(mode_));
      }

      virtual bool is_save_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_is_save_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void is_save_set(bool is_save_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_fileselector_is_save_set(efl::eolian::to_c(is_save_)));
      }

      virtual const Eina_List * selected_paths_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_fileselector >
{
   static const int value = 24;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_fileselector>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_custom_filter_append_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_custom_filter_append);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_filters_clear_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_filters_clear);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mime_types_filter_append_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mime_types_filter_append);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_folder_only_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_folder_only_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_folder_only_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_folder_only_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_thumbnail_size_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_thumbnail_size_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_thumbnail_size_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_thumbnail_size_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_hidden_visible_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_hidden_visible_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_hidden_visible_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_hidden_visible_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_sort_method_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_sort_method_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_sort_method_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_sort_method_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_multi_select_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_multi_select_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_multi_select_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_multi_select_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_expandable_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_expandable_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_expandable_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_expandable_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_path_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_path_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_path_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_path_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mode_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mode_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_mode_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_mode_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_is_save_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_is_save_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_is_save_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_is_save_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_elm_interface_fileselector_selected_paths_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::elm_interface_fileselector_selected_paths_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_fileselector >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_fileselector, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_fileselector>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_fileselector() const
      {
         return ::elm_interface_fileselector(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool custom_filter_append(Elm_Fileselector_Filter_Func func_, void * data_, std::string filter_name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_custom_filter_append(func_, data_, efl::eolian::to_c(filter_name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void filters_clear()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_filters_clear());
      }

      bool mime_types_filter_append(std::string mime_types_, std::string filter_name_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mime_types_filter_append(efl::eolian::to_c(mime_types_), efl::eolian::to_c(filter_name_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool folder_only_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_folder_only_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void folder_only_set(bool only_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_folder_only_set(efl::eolian::to_c(only_)));
      }

      std::string selected_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool selected_set(std::string path_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_set(efl::eolian::to_c(path_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void thumbnail_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_get(w_, h_));
      }

      void thumbnail_size_set(Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_thumbnail_size_set(w_, h_));
      }

      bool hidden_visible_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_hidden_visible_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void hidden_visible_set(bool multi_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_hidden_visible_set(efl::eolian::to_c(multi_)));
      }

      Elm_Fileselector_Sort sort_method_get()
      {
         Elm_Fileselector_Sort _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_sort_method_get());
            return _tmp_ret;
      }

      void sort_method_set(Elm_Fileselector_Sort sort_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_sort_method_set(sort_));
      }

      bool multi_select_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_multi_select_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void multi_select_set(bool multi_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_multi_select_set(efl::eolian::to_c(multi_)));
      }

      bool expandable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_expandable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void expandable_set(bool expand_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_expandable_set(efl::eolian::to_c(expand_)));
      }

      std::string path_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void path_set(std::string path_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_path_set(efl::eolian::to_c(path_)));
      }

      Elm_Fileselector_Mode mode_get()
      {
         Elm_Fileselector_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_mode_get());
            return _tmp_ret;
      }

      void mode_set(Elm_Fileselector_Mode mode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_mode_set(mode_));
      }

      bool is_save_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_is_save_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void is_save_set(bool is_save_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_fileselector_is_save_set(efl::eolian::to_c(is_save_)));
      }

      const Eina_List * selected_paths_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_fileselector_selected_paths_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_fileselector>)
{
   return (ELM_INTERFACE_FILESELECTOR_INTERFACE);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_FILESELECTOR_HH

