#ifndef EFL_GENERATED_ELM_INTERFACE_SCROLLABLE_HH
#define EFL_GENERATED_ELM_INTERFACE_SCROLLABLE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_scrollable.eo.h"
}

#include "evas_scrollable_interface.eo.hh"
#include "evas_object_smart.eo.hh"
#include <canvas/evas_object.eo.hh>

struct elm_interface_scrollable
      : evas::scrollable_interface,
      efl::eo::detail::extension_inheritance<evas::object_smart>::template type< ::elm_interface_scrollable>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_scrollable(Eo* eo)
      : evas::scrollable_interface(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_scrollable(std::nullptr_t)
      : evas::scrollable_interface(nullptr)
   {}

   elm_interface_scrollable(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_interface_scrollable(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_scrollable(elm_interface_scrollable const& other)
      : evas::scrollable_interface(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_scrollable() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param x 
   /// @param y 
   /// @param sig 
   ///
   void content_pos_set(Evas_Coord x_, Evas_Coord y_, bool sig_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_pos_set(x_, y_, efl::eolian::to_c(sig_)));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param[out] x 
   /// @param[out] y 
   ///
   void content_pos_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_pos_get(x_, y_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param pagenumber_h 
   /// @param pagenumber_v 
   ///
   void page_show(int pagenumber_h_, int pagenumber_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_show(pagenumber_h_, pagenumber_v_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void region_bring_in(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_region_bring_in(x_, y_, w_, h_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param pagenumber_h 
   /// @param pagenumber_v 
   ///
   void page_bring_in(int pagenumber_h_, int pagenumber_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_bring_in(pagenumber_h_, pagenumber_v_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void content_region_show(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_region_show(x_, y_, w_, h_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param w 
   /// @param h 
   ///
   void content_min_limit(bool w_, bool h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_min_limit(efl::eolian::to_c(w_), efl::eolian::to_c(h_)));
   }

   /// @param x 
   /// @param y 
   ///
   void gravity_get(double* x_, double* y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_gravity_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void gravity_set(double x_, double y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_gravity_set(x_, y_));
   }

   /// @param horiz 
   /// @param vert 
   ///
   void bounce_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_bounce_allow_get(horiz_, vert_));
   }

   /// @param horiz 
   /// @param vert 
   ///
   void bounce_allow_set(bool horiz_, bool vert_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_bounce_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
   }

   /// @param disabled 
   ///
   bool wheel_disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_wheel_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled 
   ///
   void wheel_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_wheel_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param block 
   ///
   Elm_Scroller_Movement_Block movement_block_get() const
   {
      Elm_Scroller_Movement_Block _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_movement_block_get());
      return _tmp_ret;
   }

   /// @param block 
   ///
   void movement_block_set(Elm_Scroller_Movement_Block block_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_movement_block_set(block_));
   }

   /// @param disabled 
   ///
   bool momentum_animator_disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_momentum_animator_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled 
   ///
   void momentum_animator_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_momentum_animator_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param hbar 
   /// @param vbar 
   ///
   void policy_get(Elm_Scroller_Policy* hbar_, Elm_Scroller_Policy* vbar_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_policy_get(hbar_, vbar_));
   }

   /// @param hbar 
   /// @param vbar 
   ///
   void policy_set(Elm_Scroller_Policy hbar_, Elm_Scroller_Policy vbar_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_policy_set(hbar_, vbar_));
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void content_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_region_get(x_, y_, w_, h_));
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void content_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_region_set(x_, y_, w_, h_));
   }

   /// @param repeat_events 
   ///
   bool repeat_events_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_repeat_events_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param repeat_events 
   ///
   void repeat_events_set(bool repeat_events_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_repeat_events_set(efl::eolian::to_c(repeat_events_)));
   }

   /// @param x 
   /// @param y 
   ///
   void page_size_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_size_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void page_size_set(Evas_Coord x_, Evas_Coord y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_size_set(x_, y_));
   }

   /// @param disabled 
   ///
   bool bounce_animator_disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_bounce_animator_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled 
   ///
   void bounce_animator_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_bounce_animator_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param page_limit_h 
   /// @param page_limit_v 
   ///
   void page_scroll_limit_get(int* page_limit_h_, int* page_limit_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_scroll_limit_get(page_limit_h_, page_limit_v_));
   }

   /// @param page_limit_h 
   /// @param page_limit_v 
   ///
   void page_scroll_limit_set(int page_limit_h_, int page_limit_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_scroll_limit_set(page_limit_h_, page_limit_v_));
   }

   /// @param horiz 
   /// @param vert 
   ///
   void page_snap_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_snap_allow_get(horiz_, vert_));
   }

   /// @param horiz 
   /// @param vert 
   ///
   void page_snap_allow_set(bool horiz_, bool vert_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_snap_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
   }

   /// @param pagerel_h 
   /// @param pagerel_v 
   /// @param pagesize_h 
   /// @param pagesize_v 
   ///
   void paging_get(double* pagerel_h_, double* pagerel_v_, Evas_Coord* pagesize_h_, Evas_Coord* pagesize_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_paging_get(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
   }

   /// @param pagerel_h 
   /// @param pagerel_v 
   /// @param pagesize_h 
   /// @param pagesize_v 
   ///
   void paging_set(double pagerel_h_, double pagerel_v_, Evas_Coord pagesize_h_, Evas_Coord pagesize_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_paging_set(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
   }

   /// @param single_dir 
   ///
   Elm_Scroller_Single_Direction single_direction_get() const
   {
      Elm_Scroller_Single_Direction _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_single_direction_get());
      return _tmp_ret;
   }

   /// @param single_dir 
   ///
   void single_direction_set(Elm_Scroller_Single_Direction single_dir_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_single_direction_set(single_dir_));
   }

   /// @param x 
   /// @param y 
   ///
   void step_size_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_step_size_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void step_size_set(Evas_Coord x_, Evas_Coord y_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_step_size_set(x_, y_));
   }

   /// @param scroll_up_cb 
   ///
   void scroll_up_cb_set(Elm_Interface_Scrollable_Cb scroll_up_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_scroll_up_cb_set(scroll_up_cb_));
   }

   /// @param hbar_drag_cb 
   ///
   void hbar_drag_cb_set(Elm_Interface_Scrollable_Cb hbar_drag_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_hbar_drag_cb_set(hbar_drag_cb_));
   }

   /// @param drag_start_cb 
   ///
   void drag_start_cb_set(Elm_Interface_Scrollable_Cb drag_start_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_drag_start_cb_set(drag_start_cb_));
   }

   /// @param freeze 
   ///
   void freeze_set(bool freeze_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_freeze_set(efl::eolian::to_c(freeze_)));
   }

   /// @param viewport_resize_cb 
   ///
   void content_viewport_resize_cb_set(Elm_Interface_Scrollable_Resize_Cb viewport_resize_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_viewport_resize_cb_set(viewport_resize_cb_));
   }

   /// @param scroll_left_cb 
   ///
   void scroll_left_cb_set(Elm_Interface_Scrollable_Cb scroll_left_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_scroll_left_cb_set(scroll_left_cb_));
   }

   /// @param vbar_press_cb 
   ///
   void vbar_press_cb_set(Elm_Interface_Scrollable_Cb vbar_press_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_vbar_press_cb_set(vbar_press_cb_));
   }

   /// @param hbar_press_cb 
   ///
   void hbar_press_cb_set(Elm_Interface_Scrollable_Cb hbar_press_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_hbar_press_cb_set(hbar_press_cb_));
   }

   /// @param hbar_unpress_cb 
   ///
   void hbar_unpress_cb_set(Elm_Interface_Scrollable_Cb hbar_unpress_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_hbar_unpress_cb_set(hbar_unpress_cb_));
   }

   /// @param drag_stop_cb 
   ///
   void drag_stop_cb_set(Elm_Interface_Scrollable_Cb drag_stop_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_drag_stop_cb_set(drag_stop_cb_));
   }

   /// @param pan 
   ///
   void extern_pan_set(evas::object pan_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_extern_pan_set(efl::eolian::to_c(pan_)));
   }

   /// @param page_change_cb 
   ///
   void page_change_cb_set(Elm_Interface_Scrollable_Cb page_change_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_change_cb_set(page_change_cb_));
   }

   /// @param hold 
   ///
   void hold_set(bool hold_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_hold_set(efl::eolian::to_c(hold_)));
   }

   /// @param animate_start_cb 
   ///
   void animate_start_cb_set(Elm_Interface_Scrollable_Cb animate_start_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_animate_start_cb_set(animate_start_cb_));
   }

   /// @param scroll_down_cb 
   ///
   void scroll_down_cb_set(Elm_Interface_Scrollable_Cb scroll_down_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_scroll_down_cb_set(scroll_down_cb_));
   }

   /// @param h_pagerel 
   /// @param v_pagerel 
   ///
   void page_relative_set(double h_pagerel_, double v_pagerel_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_page_relative_set(h_pagerel_, v_pagerel_));
   }

   /// @param scroll_cb 
   ///
   void scroll_cb_set(Elm_Interface_Scrollable_Cb scroll_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_scroll_cb_set(scroll_cb_));
   }

   /// @param animate_stop_cb 
   ///
   void animate_stop_cb_set(Elm_Interface_Scrollable_Cb animate_stop_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_animate_stop_cb_set(animate_stop_cb_));
   }

   /// @param mirrored 
   ///
   void mirrored_set(bool mirrored_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_mirrored_set(efl::eolian::to_c(mirrored_)));
   }

   /// @param min_limit_cb 
   ///
   void content_min_limit_cb_set(Elm_Interface_Scrollable_Min_Limit_Cb min_limit_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_min_limit_cb_set(min_limit_cb_));
   }

   /// @param scroll_right_cb 
   ///
   void scroll_right_cb_set(Elm_Interface_Scrollable_Cb scroll_right_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_scroll_right_cb_set(scroll_right_cb_));
   }

   /// @param content 
   ///
   void content_set(evas::object content_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_set(efl::eolian::to_c(content_)));
   }

   /// @param edge_left_cb 
   ///
   void edge_left_cb_set(Elm_Interface_Scrollable_Cb edge_left_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_edge_left_cb_set(edge_left_cb_));
   }

   /// @param vbar_drag_cb 
   ///
   void vbar_drag_cb_set(Elm_Interface_Scrollable_Cb vbar_drag_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_vbar_drag_cb_set(vbar_drag_cb_));
   }

   /// @param vbar_unpress_cb 
   ///
   void vbar_unpress_cb_set(Elm_Interface_Scrollable_Cb vbar_unpress_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_vbar_unpress_cb_set(vbar_unpress_cb_));
   }

   /// @param edge_bottom_cb 
   ///
   void edge_bottom_cb_set(Elm_Interface_Scrollable_Cb edge_bottom_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_edge_bottom_cb_set(edge_bottom_cb_));
   }

   /// @param edge_right_cb 
   ///
   void edge_right_cb_set(Elm_Interface_Scrollable_Cb edge_right_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_edge_right_cb_set(edge_right_cb_));
   }

   /// @param edge_top_cb 
   ///
   void edge_top_cb_set(Elm_Interface_Scrollable_Cb edge_top_cb_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_edge_top_cb_set(edge_top_cb_));
   }

   /// @param edje_object 
   /// @param hit_rectangle 
   ///
   void objects_set(evas::object edje_object_, evas::object hit_rectangle_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_objects_set(efl::eolian::to_c(edje_object_), efl::eolian::to_c(hit_rectangle_)));
   }

   /// @param pagenumber_h 
   /// @param pagenumber_v 
   ///
   void last_page_get(int* pagenumber_h_, int* pagenumber_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_last_page_get(pagenumber_h_, pagenumber_v_));
   }

   /// @param pagenumber_h 
   /// @param pagenumber_v 
   ///
   void current_page_get(int* pagenumber_h_, int* pagenumber_v_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_current_page_get(pagenumber_h_, pagenumber_v_));
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void content_viewport_geometry_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_viewport_geometry_get(x_, y_, w_, h_));
   }

   /// @param w 
   /// @param h 
   ///
   void content_size_get(Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_interface_scrollable_content_size_get(w_, h_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_scrollable, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_scrollable, function_type>,
         ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_SCROLLABLE_MIXIN);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_INTERFACE_SCROLLABLE_MIXIN, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_interface_scrollable_content_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, Eina_Bool sig_)
{
   static_cast<T*>(self->this_)->content_pos_set(x_, y_, efl::eolian::to_cxx<bool>(sig_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_content_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->content_pos_get(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_page_show_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int pagenumber_h_, int pagenumber_v_)
{
   static_cast<T*>(self->this_)->page_show(pagenumber_h_, pagenumber_v_);
}

template <typename T>
void _elm_interface_scrollable_region_bring_in_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->region_bring_in(x_, y_, w_, h_);
}

template <typename T>
void _elm_interface_scrollable_page_bring_in_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int pagenumber_h_, int pagenumber_v_)
{
   static_cast<T*>(self->this_)->page_bring_in(pagenumber_h_, pagenumber_v_);
}

template <typename T>
void _elm_interface_scrollable_content_region_show_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->content_region_show(x_, y_, w_, h_);
}

template <typename T>
void _elm_interface_scrollable_content_min_limit_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool w_, Eina_Bool h_)
{
   static_cast<T*>(self->this_)->content_min_limit(efl::eolian::to_cxx<bool>(w_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(h_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_gravity_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* x_, double* y_)
{
   static_cast<T*>(self->this_)->gravity_get(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_gravity_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double x_, double y_)
{
   static_cast<T*>(self->this_)->gravity_set(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_bounce_allow_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool* horiz_, Eina_Bool* vert_)
{
   static_cast<T*>(self->this_)->bounce_allow_get(horiz_, vert_);
}

template <typename T>
void _elm_interface_scrollable_bounce_allow_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horiz_, Eina_Bool vert_)
{
   static_cast<T*>(self->this_)->bounce_allow_set(efl::eolian::to_cxx<bool>(horiz_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(vert_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_interface_scrollable_wheel_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->wheel_disabled_get();
}

template <typename T>
void _elm_interface_scrollable_wheel_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->wheel_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Scroller_Movement_Block _elm_interface_scrollable_movement_block_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->movement_block_get();
}

template <typename T>
void _elm_interface_scrollable_movement_block_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Scroller_Movement_Block block_)
{
   static_cast<T*>(self->this_)->movement_block_set(block_);
}

template <typename T>
bool _elm_interface_scrollable_momentum_animator_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->momentum_animator_disabled_get();
}

template <typename T>
void _elm_interface_scrollable_momentum_animator_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->momentum_animator_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_policy_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Scroller_Policy* hbar_, Elm_Scroller_Policy* vbar_)
{
   static_cast<T*>(self->this_)->policy_get(hbar_, vbar_);
}

template <typename T>
void _elm_interface_scrollable_policy_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Scroller_Policy hbar_, Elm_Scroller_Policy vbar_)
{
   static_cast<T*>(self->this_)->policy_set(hbar_, vbar_);
}

template <typename T>
void _elm_interface_scrollable_content_region_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->content_region_get(x_, y_, w_, h_);
}

template <typename T>
void _elm_interface_scrollable_content_region_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
{
   static_cast<T*>(self->this_)->content_region_set(x_, y_, w_, h_);
}

template <typename T>
bool _elm_interface_scrollable_repeat_events_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->repeat_events_get();
}

template <typename T>
void _elm_interface_scrollable_repeat_events_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool repeat_events_)
{
   static_cast<T*>(self->this_)->repeat_events_set(efl::eolian::to_cxx<bool>(repeat_events_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_page_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->page_size_get(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_page_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_)
{
   static_cast<T*>(self->this_)->page_size_set(x_, y_);
}

template <typename T>
bool _elm_interface_scrollable_bounce_animator_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->bounce_animator_disabled_get();
}

template <typename T>
void _elm_interface_scrollable_bounce_animator_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->bounce_animator_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_page_scroll_limit_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* page_limit_h_, int* page_limit_v_)
{
   static_cast<T*>(self->this_)->page_scroll_limit_get(page_limit_h_, page_limit_v_);
}

template <typename T>
void _elm_interface_scrollable_page_scroll_limit_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int page_limit_h_, int page_limit_v_)
{
   static_cast<T*>(self->this_)->page_scroll_limit_set(page_limit_h_, page_limit_v_);
}

template <typename T>
void _elm_interface_scrollable_page_snap_allow_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool* horiz_, Eina_Bool* vert_)
{
   static_cast<T*>(self->this_)->page_snap_allow_get(horiz_, vert_);
}

template <typename T>
void _elm_interface_scrollable_page_snap_allow_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horiz_, Eina_Bool vert_)
{
   static_cast<T*>(self->this_)->page_snap_allow_set(efl::eolian::to_cxx<bool>(horiz_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(vert_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_paging_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* pagerel_h_, double* pagerel_v_, Evas_Coord* pagesize_h_, Evas_Coord* pagesize_v_)
{
   static_cast<T*>(self->this_)->paging_get(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_);
}

template <typename T>
void _elm_interface_scrollable_paging_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double pagerel_h_, double pagerel_v_, Evas_Coord pagesize_h_, Evas_Coord pagesize_v_)
{
   static_cast<T*>(self->this_)->paging_set(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_);
}

template <typename T>
Elm_Scroller_Single_Direction _elm_interface_scrollable_single_direction_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->single_direction_get();
}

template <typename T>
void _elm_interface_scrollable_single_direction_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Scroller_Single_Direction single_dir_)
{
   static_cast<T*>(self->this_)->single_direction_set(single_dir_);
}

template <typename T>
void _elm_interface_scrollable_step_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->step_size_get(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_step_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_)
{
   static_cast<T*>(self->this_)->step_size_set(x_, y_);
}

template <typename T>
void _elm_interface_scrollable_scroll_up_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb scroll_up_cb_)
{
   static_cast<T*>(self->this_)->scroll_up_cb_set(scroll_up_cb_);
}

template <typename T>
void _elm_interface_scrollable_hbar_drag_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb hbar_drag_cb_)
{
   static_cast<T*>(self->this_)->hbar_drag_cb_set(hbar_drag_cb_);
}

template <typename T>
void _elm_interface_scrollable_drag_start_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb drag_start_cb_)
{
   static_cast<T*>(self->this_)->drag_start_cb_set(drag_start_cb_);
}

template <typename T>
void _elm_interface_scrollable_freeze_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool freeze_)
{
   static_cast<T*>(self->this_)->freeze_set(efl::eolian::to_cxx<bool>(freeze_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_content_viewport_resize_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Resize_Cb viewport_resize_cb_)
{
   static_cast<T*>(self->this_)->content_viewport_resize_cb_set(viewport_resize_cb_);
}

template <typename T>
void _elm_interface_scrollable_scroll_left_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb scroll_left_cb_)
{
   static_cast<T*>(self->this_)->scroll_left_cb_set(scroll_left_cb_);
}

template <typename T>
void _elm_interface_scrollable_vbar_press_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb vbar_press_cb_)
{
   static_cast<T*>(self->this_)->vbar_press_cb_set(vbar_press_cb_);
}

template <typename T>
void _elm_interface_scrollable_hbar_press_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb hbar_press_cb_)
{
   static_cast<T*>(self->this_)->hbar_press_cb_set(hbar_press_cb_);
}

template <typename T>
void _elm_interface_scrollable_hbar_unpress_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb hbar_unpress_cb_)
{
   static_cast<T*>(self->this_)->hbar_unpress_cb_set(hbar_unpress_cb_);
}

template <typename T>
void _elm_interface_scrollable_drag_stop_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb drag_stop_cb_)
{
   static_cast<T*>(self->this_)->drag_stop_cb_set(drag_stop_cb_);
}

template <typename T>
void _elm_interface_scrollable_extern_pan_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * pan_)
{
   static_cast<T*>(self->this_)->extern_pan_set(efl::eolian::to_cxx<evas::object>(pan_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_page_change_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb page_change_cb_)
{
   static_cast<T*>(self->this_)->page_change_cb_set(page_change_cb_);
}

template <typename T>
void _elm_interface_scrollable_hold_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool hold_)
{
   static_cast<T*>(self->this_)->hold_set(efl::eolian::to_cxx<bool>(hold_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_animate_start_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb animate_start_cb_)
{
   static_cast<T*>(self->this_)->animate_start_cb_set(animate_start_cb_);
}

template <typename T>
void _elm_interface_scrollable_scroll_down_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb scroll_down_cb_)
{
   static_cast<T*>(self->this_)->scroll_down_cb_set(scroll_down_cb_);
}

template <typename T>
void _elm_interface_scrollable_page_relative_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double h_pagerel_, double v_pagerel_)
{
   static_cast<T*>(self->this_)->page_relative_set(h_pagerel_, v_pagerel_);
}

template <typename T>
void _elm_interface_scrollable_scroll_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb scroll_cb_)
{
   static_cast<T*>(self->this_)->scroll_cb_set(scroll_cb_);
}

template <typename T>
void _elm_interface_scrollable_animate_stop_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb animate_stop_cb_)
{
   static_cast<T*>(self->this_)->animate_stop_cb_set(animate_stop_cb_);
}

template <typename T>
void _elm_interface_scrollable_mirrored_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool mirrored_)
{
   static_cast<T*>(self->this_)->mirrored_set(efl::eolian::to_cxx<bool>(mirrored_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_content_min_limit_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Min_Limit_Cb min_limit_cb_)
{
   static_cast<T*>(self->this_)->content_min_limit_cb_set(min_limit_cb_);
}

template <typename T>
void _elm_interface_scrollable_scroll_right_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb scroll_right_cb_)
{
   static_cast<T*>(self->this_)->scroll_right_cb_set(scroll_right_cb_);
}

template <typename T>
void _elm_interface_scrollable_content_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * content_)
{
   static_cast<T*>(self->this_)->content_set(efl::eolian::to_cxx<evas::object>(content_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_edge_left_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb edge_left_cb_)
{
   static_cast<T*>(self->this_)->edge_left_cb_set(edge_left_cb_);
}

template <typename T>
void _elm_interface_scrollable_vbar_drag_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb vbar_drag_cb_)
{
   static_cast<T*>(self->this_)->vbar_drag_cb_set(vbar_drag_cb_);
}

template <typename T>
void _elm_interface_scrollable_vbar_unpress_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb vbar_unpress_cb_)
{
   static_cast<T*>(self->this_)->vbar_unpress_cb_set(vbar_unpress_cb_);
}

template <typename T>
void _elm_interface_scrollable_edge_bottom_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb edge_bottom_cb_)
{
   static_cast<T*>(self->this_)->edge_bottom_cb_set(edge_bottom_cb_);
}

template <typename T>
void _elm_interface_scrollable_edge_right_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb edge_right_cb_)
{
   static_cast<T*>(self->this_)->edge_right_cb_set(edge_right_cb_);
}

template <typename T>
void _elm_interface_scrollable_edge_top_cb_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Interface_Scrollable_Cb edge_top_cb_)
{
   static_cast<T*>(self->this_)->edge_top_cb_set(edge_top_cb_);
}

template <typename T>
void _elm_interface_scrollable_objects_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * edje_object_, Evas_Object * hit_rectangle_)
{
   static_cast<T*>(self->this_)->objects_set(efl::eolian::to_cxx<evas::object>(edje_object_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(hit_rectangle_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_interface_scrollable_last_page_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* pagenumber_h_, int* pagenumber_v_)
{
   static_cast<T*>(self->this_)->last_page_get(pagenumber_h_, pagenumber_v_);
}

template <typename T>
void _elm_interface_scrollable_current_page_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* pagenumber_h_, int* pagenumber_v_)
{
   static_cast<T*>(self->this_)->current_page_get(pagenumber_h_, pagenumber_v_);
}

template <typename T>
void _elm_interface_scrollable_content_viewport_geometry_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->content_viewport_geometry_get(x_, y_, w_, h_);
}

template <typename T>
void _elm_interface_scrollable_content_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->content_size_get(w_, h_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_scrollable >
{
   template <typename T>
   struct type
   {
      virtual void content_pos_set(Evas_Coord x_, Evas_Coord y_, bool sig_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_pos_set(x_, y_, efl::eolian::to_c(sig_)));
      }

      virtual void content_pos_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_pos_get(x_, y_));
      }

      virtual void page_show(int pagenumber_h_, int pagenumber_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_show(pagenumber_h_, pagenumber_v_));
      }

      virtual void region_bring_in(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_region_bring_in(x_, y_, w_, h_));
      }

      virtual void page_bring_in(int pagenumber_h_, int pagenumber_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_bring_in(pagenumber_h_, pagenumber_v_));
      }

      virtual void content_region_show(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_region_show(x_, y_, w_, h_));
      }

      virtual void content_min_limit(bool w_, bool h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_min_limit(efl::eolian::to_c(w_), efl::eolian::to_c(h_)));
      }

      virtual void gravity_get(double* x_, double* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_gravity_get(x_, y_));
      }

      virtual void gravity_set(double x_, double y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_gravity_set(x_, y_));
      }

      virtual void bounce_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_bounce_allow_get(horiz_, vert_));
      }

      virtual void bounce_allow_set(bool horiz_, bool vert_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_bounce_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
      }

      virtual bool wheel_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_wheel_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void wheel_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_wheel_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual Elm_Scroller_Movement_Block movement_block_get()
      {
         Elm_Scroller_Movement_Block _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_movement_block_get());
            return _tmp_ret;
      }

      virtual void movement_block_set(Elm_Scroller_Movement_Block block_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_movement_block_set(block_));
      }

      virtual bool momentum_animator_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_momentum_animator_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void momentum_animator_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_momentum_animator_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual void policy_get(Elm_Scroller_Policy* hbar_, Elm_Scroller_Policy* vbar_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_policy_get(hbar_, vbar_));
      }

      virtual void policy_set(Elm_Scroller_Policy hbar_, Elm_Scroller_Policy vbar_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_policy_set(hbar_, vbar_));
      }

      virtual void content_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_region_get(x_, y_, w_, h_));
      }

      virtual void content_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_region_set(x_, y_, w_, h_));
      }

      virtual bool repeat_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_repeat_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void repeat_events_set(bool repeat_events_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_repeat_events_set(efl::eolian::to_c(repeat_events_)));
      }

      virtual void page_size_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_size_get(x_, y_));
      }

      virtual void page_size_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_size_set(x_, y_));
      }

      virtual bool bounce_animator_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_bounce_animator_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void bounce_animator_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_bounce_animator_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual void page_scroll_limit_get(int* page_limit_h_, int* page_limit_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_scroll_limit_get(page_limit_h_, page_limit_v_));
      }

      virtual void page_scroll_limit_set(int page_limit_h_, int page_limit_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_scroll_limit_set(page_limit_h_, page_limit_v_));
      }

      virtual void page_snap_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_snap_allow_get(horiz_, vert_));
      }

      virtual void page_snap_allow_set(bool horiz_, bool vert_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_snap_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
      }

      virtual void paging_get(double* pagerel_h_, double* pagerel_v_, Evas_Coord* pagesize_h_, Evas_Coord* pagesize_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_paging_get(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
      }

      virtual void paging_set(double pagerel_h_, double pagerel_v_, Evas_Coord pagesize_h_, Evas_Coord pagesize_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_paging_set(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
      }

      virtual Elm_Scroller_Single_Direction single_direction_get()
      {
         Elm_Scroller_Single_Direction _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_scrollable_single_direction_get());
            return _tmp_ret;
      }

      virtual void single_direction_set(Elm_Scroller_Single_Direction single_dir_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_single_direction_set(single_dir_));
      }

      virtual void step_size_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_step_size_get(x_, y_));
      }

      virtual void step_size_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_step_size_set(x_, y_));
      }

      virtual void scroll_up_cb_set(Elm_Interface_Scrollable_Cb scroll_up_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_scroll_up_cb_set(scroll_up_cb_));
      }

      virtual void hbar_drag_cb_set(Elm_Interface_Scrollable_Cb hbar_drag_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_hbar_drag_cb_set(hbar_drag_cb_));
      }

      virtual void drag_start_cb_set(Elm_Interface_Scrollable_Cb drag_start_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_drag_start_cb_set(drag_start_cb_));
      }

      virtual void freeze_set(bool freeze_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_freeze_set(efl::eolian::to_c(freeze_)));
      }

      virtual void content_viewport_resize_cb_set(Elm_Interface_Scrollable_Resize_Cb viewport_resize_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_viewport_resize_cb_set(viewport_resize_cb_));
      }

      virtual void scroll_left_cb_set(Elm_Interface_Scrollable_Cb scroll_left_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_scroll_left_cb_set(scroll_left_cb_));
      }

      virtual void vbar_press_cb_set(Elm_Interface_Scrollable_Cb vbar_press_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_vbar_press_cb_set(vbar_press_cb_));
      }

      virtual void hbar_press_cb_set(Elm_Interface_Scrollable_Cb hbar_press_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_hbar_press_cb_set(hbar_press_cb_));
      }

      virtual void hbar_unpress_cb_set(Elm_Interface_Scrollable_Cb hbar_unpress_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_hbar_unpress_cb_set(hbar_unpress_cb_));
      }

      virtual void drag_stop_cb_set(Elm_Interface_Scrollable_Cb drag_stop_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_drag_stop_cb_set(drag_stop_cb_));
      }

      virtual void extern_pan_set(evas::object pan_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_extern_pan_set(efl::eolian::to_c(pan_)));
      }

      virtual void page_change_cb_set(Elm_Interface_Scrollable_Cb page_change_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_change_cb_set(page_change_cb_));
      }

      virtual void hold_set(bool hold_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_hold_set(efl::eolian::to_c(hold_)));
      }

      virtual void animate_start_cb_set(Elm_Interface_Scrollable_Cb animate_start_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_animate_start_cb_set(animate_start_cb_));
      }

      virtual void scroll_down_cb_set(Elm_Interface_Scrollable_Cb scroll_down_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_scroll_down_cb_set(scroll_down_cb_));
      }

      virtual void page_relative_set(double h_pagerel_, double v_pagerel_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_page_relative_set(h_pagerel_, v_pagerel_));
      }

      virtual void scroll_cb_set(Elm_Interface_Scrollable_Cb scroll_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_scroll_cb_set(scroll_cb_));
      }

      virtual void animate_stop_cb_set(Elm_Interface_Scrollable_Cb animate_stop_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_animate_stop_cb_set(animate_stop_cb_));
      }

      virtual void mirrored_set(bool mirrored_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_mirrored_set(efl::eolian::to_c(mirrored_)));
      }

      virtual void content_min_limit_cb_set(Elm_Interface_Scrollable_Min_Limit_Cb min_limit_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_min_limit_cb_set(min_limit_cb_));
      }

      virtual void scroll_right_cb_set(Elm_Interface_Scrollable_Cb scroll_right_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_scroll_right_cb_set(scroll_right_cb_));
      }

      virtual void content_set(evas::object content_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_set(efl::eolian::to_c(content_)));
      }

      virtual void edge_left_cb_set(Elm_Interface_Scrollable_Cb edge_left_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_edge_left_cb_set(edge_left_cb_));
      }

      virtual void vbar_drag_cb_set(Elm_Interface_Scrollable_Cb vbar_drag_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_vbar_drag_cb_set(vbar_drag_cb_));
      }

      virtual void vbar_unpress_cb_set(Elm_Interface_Scrollable_Cb vbar_unpress_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_vbar_unpress_cb_set(vbar_unpress_cb_));
      }

      virtual void edge_bottom_cb_set(Elm_Interface_Scrollable_Cb edge_bottom_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_edge_bottom_cb_set(edge_bottom_cb_));
      }

      virtual void edge_right_cb_set(Elm_Interface_Scrollable_Cb edge_right_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_edge_right_cb_set(edge_right_cb_));
      }

      virtual void edge_top_cb_set(Elm_Interface_Scrollable_Cb edge_top_cb_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_edge_top_cb_set(edge_top_cb_));
      }

      virtual void objects_set(evas::object edje_object_, evas::object hit_rectangle_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_objects_set(efl::eolian::to_c(edje_object_), efl::eolian::to_c(hit_rectangle_)));
      }

      virtual void last_page_get(int* pagenumber_h_, int* pagenumber_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_last_page_get(pagenumber_h_, pagenumber_v_));
      }

      virtual void current_page_get(int* pagenumber_h_, int* pagenumber_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_current_page_get(pagenumber_h_, pagenumber_v_));
      }

      virtual void content_viewport_geometry_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_viewport_geometry_get(x_, y_, w_, h_));
      }

      virtual void content_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_interface_scrollable_content_size_get(w_, h_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_scrollable >
{
   static const int value = 70;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_scrollable>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_pos_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_pos_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_pos_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_pos_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_show_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_show);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_region_bring_in_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_region_bring_in);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_bring_in_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_bring_in);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_region_show_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_region_show);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_min_limit_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_min_limit);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_gravity_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_gravity_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_gravity_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_gravity_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_bounce_allow_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_bounce_allow_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_bounce_allow_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_bounce_allow_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_wheel_disabled_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_wheel_disabled_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_wheel_disabled_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_wheel_disabled_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_movement_block_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_movement_block_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_movement_block_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_movement_block_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_momentum_animator_disabled_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_momentum_animator_disabled_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_momentum_animator_disabled_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_momentum_animator_disabled_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_policy_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_policy_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_policy_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_policy_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_region_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_region_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_region_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_region_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_repeat_events_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_repeat_events_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_repeat_events_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_repeat_events_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_size_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_size_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_size_set_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_size_set);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_bounce_animator_disabled_get_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_bounce_animator_disabled_get);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_bounce_animator_disabled_set_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_bounce_animator_disabled_set);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_scroll_limit_get_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_scroll_limit_get);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_scroll_limit_set_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_scroll_limit_set);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_snap_allow_get_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_snap_allow_get);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_snap_allow_set_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_snap_allow_set);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_paging_get_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_paging_get);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   ops[32].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_paging_set_wrapper<T>);
   ops[32].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_paging_set);
   ops[32].op = EO_OP_OVERRIDE;
   ops[32].op_type = EO_OP_TYPE_REGULAR;
   ops[32].doc = NULL;

   ops[33].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_single_direction_get_wrapper<T>);
   ops[33].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_single_direction_get);
   ops[33].op = EO_OP_OVERRIDE;
   ops[33].op_type = EO_OP_TYPE_REGULAR;
   ops[33].doc = NULL;

   ops[34].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_single_direction_set_wrapper<T>);
   ops[34].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_single_direction_set);
   ops[34].op = EO_OP_OVERRIDE;
   ops[34].op_type = EO_OP_TYPE_REGULAR;
   ops[34].doc = NULL;

   ops[35].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_step_size_get_wrapper<T>);
   ops[35].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_step_size_get);
   ops[35].op = EO_OP_OVERRIDE;
   ops[35].op_type = EO_OP_TYPE_REGULAR;
   ops[35].doc = NULL;

   ops[36].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_step_size_set_wrapper<T>);
   ops[36].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_step_size_set);
   ops[36].op = EO_OP_OVERRIDE;
   ops[36].op_type = EO_OP_TYPE_REGULAR;
   ops[36].doc = NULL;

   ops[37].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_scroll_up_cb_set_wrapper<T>);
   ops[37].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_scroll_up_cb_set);
   ops[37].op = EO_OP_OVERRIDE;
   ops[37].op_type = EO_OP_TYPE_REGULAR;
   ops[37].doc = NULL;

   ops[38].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_hbar_drag_cb_set_wrapper<T>);
   ops[38].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_hbar_drag_cb_set);
   ops[38].op = EO_OP_OVERRIDE;
   ops[38].op_type = EO_OP_TYPE_REGULAR;
   ops[38].doc = NULL;

   ops[39].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_drag_start_cb_set_wrapper<T>);
   ops[39].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_drag_start_cb_set);
   ops[39].op = EO_OP_OVERRIDE;
   ops[39].op_type = EO_OP_TYPE_REGULAR;
   ops[39].doc = NULL;

   ops[40].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_freeze_set_wrapper<T>);
   ops[40].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_freeze_set);
   ops[40].op = EO_OP_OVERRIDE;
   ops[40].op_type = EO_OP_TYPE_REGULAR;
   ops[40].doc = NULL;

   ops[41].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_viewport_resize_cb_set_wrapper<T>);
   ops[41].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_viewport_resize_cb_set);
   ops[41].op = EO_OP_OVERRIDE;
   ops[41].op_type = EO_OP_TYPE_REGULAR;
   ops[41].doc = NULL;

   ops[42].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_scroll_left_cb_set_wrapper<T>);
   ops[42].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_scroll_left_cb_set);
   ops[42].op = EO_OP_OVERRIDE;
   ops[42].op_type = EO_OP_TYPE_REGULAR;
   ops[42].doc = NULL;

   ops[43].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_vbar_press_cb_set_wrapper<T>);
   ops[43].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_vbar_press_cb_set);
   ops[43].op = EO_OP_OVERRIDE;
   ops[43].op_type = EO_OP_TYPE_REGULAR;
   ops[43].doc = NULL;

   ops[44].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_hbar_press_cb_set_wrapper<T>);
   ops[44].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_hbar_press_cb_set);
   ops[44].op = EO_OP_OVERRIDE;
   ops[44].op_type = EO_OP_TYPE_REGULAR;
   ops[44].doc = NULL;

   ops[45].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_hbar_unpress_cb_set_wrapper<T>);
   ops[45].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_hbar_unpress_cb_set);
   ops[45].op = EO_OP_OVERRIDE;
   ops[45].op_type = EO_OP_TYPE_REGULAR;
   ops[45].doc = NULL;

   ops[46].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_drag_stop_cb_set_wrapper<T>);
   ops[46].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_drag_stop_cb_set);
   ops[46].op = EO_OP_OVERRIDE;
   ops[46].op_type = EO_OP_TYPE_REGULAR;
   ops[46].doc = NULL;

   ops[47].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_extern_pan_set_wrapper<T>);
   ops[47].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_extern_pan_set);
   ops[47].op = EO_OP_OVERRIDE;
   ops[47].op_type = EO_OP_TYPE_REGULAR;
   ops[47].doc = NULL;

   ops[48].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_change_cb_set_wrapper<T>);
   ops[48].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_change_cb_set);
   ops[48].op = EO_OP_OVERRIDE;
   ops[48].op_type = EO_OP_TYPE_REGULAR;
   ops[48].doc = NULL;

   ops[49].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_hold_set_wrapper<T>);
   ops[49].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_hold_set);
   ops[49].op = EO_OP_OVERRIDE;
   ops[49].op_type = EO_OP_TYPE_REGULAR;
   ops[49].doc = NULL;

   ops[50].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_animate_start_cb_set_wrapper<T>);
   ops[50].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_animate_start_cb_set);
   ops[50].op = EO_OP_OVERRIDE;
   ops[50].op_type = EO_OP_TYPE_REGULAR;
   ops[50].doc = NULL;

   ops[51].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_scroll_down_cb_set_wrapper<T>);
   ops[51].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_scroll_down_cb_set);
   ops[51].op = EO_OP_OVERRIDE;
   ops[51].op_type = EO_OP_TYPE_REGULAR;
   ops[51].doc = NULL;

   ops[52].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_page_relative_set_wrapper<T>);
   ops[52].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_page_relative_set);
   ops[52].op = EO_OP_OVERRIDE;
   ops[52].op_type = EO_OP_TYPE_REGULAR;
   ops[52].doc = NULL;

   ops[53].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_scroll_cb_set_wrapper<T>);
   ops[53].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_scroll_cb_set);
   ops[53].op = EO_OP_OVERRIDE;
   ops[53].op_type = EO_OP_TYPE_REGULAR;
   ops[53].doc = NULL;

   ops[54].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_animate_stop_cb_set_wrapper<T>);
   ops[54].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_animate_stop_cb_set);
   ops[54].op = EO_OP_OVERRIDE;
   ops[54].op_type = EO_OP_TYPE_REGULAR;
   ops[54].doc = NULL;

   ops[55].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_mirrored_set_wrapper<T>);
   ops[55].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_mirrored_set);
   ops[55].op = EO_OP_OVERRIDE;
   ops[55].op_type = EO_OP_TYPE_REGULAR;
   ops[55].doc = NULL;

   ops[56].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_min_limit_cb_set_wrapper<T>);
   ops[56].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_min_limit_cb_set);
   ops[56].op = EO_OP_OVERRIDE;
   ops[56].op_type = EO_OP_TYPE_REGULAR;
   ops[56].doc = NULL;

   ops[57].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_scroll_right_cb_set_wrapper<T>);
   ops[57].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_scroll_right_cb_set);
   ops[57].op = EO_OP_OVERRIDE;
   ops[57].op_type = EO_OP_TYPE_REGULAR;
   ops[57].doc = NULL;

   ops[58].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_set_wrapper<T>);
   ops[58].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_set);
   ops[58].op = EO_OP_OVERRIDE;
   ops[58].op_type = EO_OP_TYPE_REGULAR;
   ops[58].doc = NULL;

   ops[59].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_edge_left_cb_set_wrapper<T>);
   ops[59].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_edge_left_cb_set);
   ops[59].op = EO_OP_OVERRIDE;
   ops[59].op_type = EO_OP_TYPE_REGULAR;
   ops[59].doc = NULL;

   ops[60].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_vbar_drag_cb_set_wrapper<T>);
   ops[60].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_vbar_drag_cb_set);
   ops[60].op = EO_OP_OVERRIDE;
   ops[60].op_type = EO_OP_TYPE_REGULAR;
   ops[60].doc = NULL;

   ops[61].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_vbar_unpress_cb_set_wrapper<T>);
   ops[61].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_vbar_unpress_cb_set);
   ops[61].op = EO_OP_OVERRIDE;
   ops[61].op_type = EO_OP_TYPE_REGULAR;
   ops[61].doc = NULL;

   ops[62].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_edge_bottom_cb_set_wrapper<T>);
   ops[62].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_edge_bottom_cb_set);
   ops[62].op = EO_OP_OVERRIDE;
   ops[62].op_type = EO_OP_TYPE_REGULAR;
   ops[62].doc = NULL;

   ops[63].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_edge_right_cb_set_wrapper<T>);
   ops[63].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_edge_right_cb_set);
   ops[63].op = EO_OP_OVERRIDE;
   ops[63].op_type = EO_OP_TYPE_REGULAR;
   ops[63].doc = NULL;

   ops[64].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_edge_top_cb_set_wrapper<T>);
   ops[64].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_edge_top_cb_set);
   ops[64].op = EO_OP_OVERRIDE;
   ops[64].op_type = EO_OP_TYPE_REGULAR;
   ops[64].doc = NULL;

   ops[65].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_objects_set_wrapper<T>);
   ops[65].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_objects_set);
   ops[65].op = EO_OP_OVERRIDE;
   ops[65].op_type = EO_OP_TYPE_REGULAR;
   ops[65].doc = NULL;

   ops[66].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_last_page_get_wrapper<T>);
   ops[66].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_last_page_get);
   ops[66].op = EO_OP_OVERRIDE;
   ops[66].op_type = EO_OP_TYPE_REGULAR;
   ops[66].doc = NULL;

   ops[67].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_current_page_get_wrapper<T>);
   ops[67].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_current_page_get);
   ops[67].op = EO_OP_OVERRIDE;
   ops[67].op_type = EO_OP_TYPE_REGULAR;
   ops[67].doc = NULL;

   ops[68].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_viewport_geometry_get_wrapper<T>);
   ops[68].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_viewport_geometry_get);
   ops[68].op = EO_OP_OVERRIDE;
   ops[68].op_type = EO_OP_TYPE_REGULAR;
   ops[68].doc = NULL;

   ops[69].func = reinterpret_cast<void*>(& ::_elm_interface_scrollable_content_size_get_wrapper<T>);
   ops[69].api_func = reinterpret_cast<void*>(& ::elm_interface_scrollable_content_size_get);
   ops[69].op = EO_OP_OVERRIDE;
   ops[69].op_type = EO_OP_TYPE_REGULAR;
   ops[69].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_scrollable >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_scrollable, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_interface_scrollable >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_scrollable, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_scrollable>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_scrollable() const
      {
         return ::elm_interface_scrollable(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void content_pos_set(Evas_Coord x_, Evas_Coord y_, bool sig_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_pos_set(x_, y_, efl::eolian::to_c(sig_)));
      }

      void content_pos_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_pos_get(x_, y_));
      }

      void page_show(int pagenumber_h_, int pagenumber_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_show(pagenumber_h_, pagenumber_v_));
      }

      void region_bring_in(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_region_bring_in(x_, y_, w_, h_));
      }

      void page_bring_in(int pagenumber_h_, int pagenumber_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_bring_in(pagenumber_h_, pagenumber_v_));
      }

      void content_region_show(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_region_show(x_, y_, w_, h_));
      }

      void content_min_limit(bool w_, bool h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_min_limit(efl::eolian::to_c(w_), efl::eolian::to_c(h_)));
      }

      void gravity_get(double* x_, double* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_gravity_get(x_, y_));
      }

      void gravity_set(double x_, double y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_gravity_set(x_, y_));
      }

      void bounce_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_bounce_allow_get(horiz_, vert_));
      }

      void bounce_allow_set(bool horiz_, bool vert_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_bounce_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
      }

      bool wheel_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_wheel_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void wheel_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_wheel_disabled_set(efl::eolian::to_c(disabled_)));
      }

      Elm_Scroller_Movement_Block movement_block_get()
      {
         Elm_Scroller_Movement_Block _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_movement_block_get());
            return _tmp_ret;
      }

      void movement_block_set(Elm_Scroller_Movement_Block block_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_movement_block_set(block_));
      }

      bool momentum_animator_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_momentum_animator_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void momentum_animator_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_momentum_animator_disabled_set(efl::eolian::to_c(disabled_)));
      }

      void policy_get(Elm_Scroller_Policy* hbar_, Elm_Scroller_Policy* vbar_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_policy_get(hbar_, vbar_));
      }

      void policy_set(Elm_Scroller_Policy hbar_, Elm_Scroller_Policy vbar_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_policy_set(hbar_, vbar_));
      }

      void content_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_region_get(x_, y_, w_, h_));
      }

      void content_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_region_set(x_, y_, w_, h_));
      }

      bool repeat_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_repeat_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void repeat_events_set(bool repeat_events_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_repeat_events_set(efl::eolian::to_c(repeat_events_)));
      }

      void page_size_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_size_get(x_, y_));
      }

      void page_size_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_size_set(x_, y_));
      }

      bool bounce_animator_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_bounce_animator_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void bounce_animator_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_bounce_animator_disabled_set(efl::eolian::to_c(disabled_)));
      }

      void page_scroll_limit_get(int* page_limit_h_, int* page_limit_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_scroll_limit_get(page_limit_h_, page_limit_v_));
      }

      void page_scroll_limit_set(int page_limit_h_, int page_limit_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_scroll_limit_set(page_limit_h_, page_limit_v_));
      }

      void page_snap_allow_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_snap_allow_get(horiz_, vert_));
      }

      void page_snap_allow_set(bool horiz_, bool vert_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_snap_allow_set(efl::eolian::to_c(horiz_), efl::eolian::to_c(vert_)));
      }

      void paging_get(double* pagerel_h_, double* pagerel_v_, Evas_Coord* pagesize_h_, Evas_Coord* pagesize_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_paging_get(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
      }

      void paging_set(double pagerel_h_, double pagerel_v_, Evas_Coord pagesize_h_, Evas_Coord pagesize_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_paging_set(pagerel_h_, pagerel_v_, pagesize_h_, pagesize_v_));
      }

      Elm_Scroller_Single_Direction single_direction_get()
      {
         Elm_Scroller_Single_Direction _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_scrollable_single_direction_get());
            return _tmp_ret;
      }

      void single_direction_set(Elm_Scroller_Single_Direction single_dir_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_single_direction_set(single_dir_));
      }

      void step_size_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_step_size_get(x_, y_));
      }

      void step_size_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_step_size_set(x_, y_));
      }

      void scroll_up_cb_set(Elm_Interface_Scrollable_Cb scroll_up_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_scroll_up_cb_set(scroll_up_cb_));
      }

      void hbar_drag_cb_set(Elm_Interface_Scrollable_Cb hbar_drag_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_hbar_drag_cb_set(hbar_drag_cb_));
      }

      void drag_start_cb_set(Elm_Interface_Scrollable_Cb drag_start_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_drag_start_cb_set(drag_start_cb_));
      }

      void freeze_set(bool freeze_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_freeze_set(efl::eolian::to_c(freeze_)));
      }

      void content_viewport_resize_cb_set(Elm_Interface_Scrollable_Resize_Cb viewport_resize_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_viewport_resize_cb_set(viewport_resize_cb_));
      }

      void scroll_left_cb_set(Elm_Interface_Scrollable_Cb scroll_left_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_scroll_left_cb_set(scroll_left_cb_));
      }

      void vbar_press_cb_set(Elm_Interface_Scrollable_Cb vbar_press_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_vbar_press_cb_set(vbar_press_cb_));
      }

      void hbar_press_cb_set(Elm_Interface_Scrollable_Cb hbar_press_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_hbar_press_cb_set(hbar_press_cb_));
      }

      void hbar_unpress_cb_set(Elm_Interface_Scrollable_Cb hbar_unpress_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_hbar_unpress_cb_set(hbar_unpress_cb_));
      }

      void drag_stop_cb_set(Elm_Interface_Scrollable_Cb drag_stop_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_drag_stop_cb_set(drag_stop_cb_));
      }

      void extern_pan_set(evas::object pan_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_extern_pan_set(efl::eolian::to_c(pan_)));
      }

      void page_change_cb_set(Elm_Interface_Scrollable_Cb page_change_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_change_cb_set(page_change_cb_));
      }

      void hold_set(bool hold_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_hold_set(efl::eolian::to_c(hold_)));
      }

      void animate_start_cb_set(Elm_Interface_Scrollable_Cb animate_start_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_animate_start_cb_set(animate_start_cb_));
      }

      void scroll_down_cb_set(Elm_Interface_Scrollable_Cb scroll_down_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_scroll_down_cb_set(scroll_down_cb_));
      }

      void page_relative_set(double h_pagerel_, double v_pagerel_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_page_relative_set(h_pagerel_, v_pagerel_));
      }

      void scroll_cb_set(Elm_Interface_Scrollable_Cb scroll_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_scroll_cb_set(scroll_cb_));
      }

      void animate_stop_cb_set(Elm_Interface_Scrollable_Cb animate_stop_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_animate_stop_cb_set(animate_stop_cb_));
      }

      void mirrored_set(bool mirrored_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_mirrored_set(efl::eolian::to_c(mirrored_)));
      }

      void content_min_limit_cb_set(Elm_Interface_Scrollable_Min_Limit_Cb min_limit_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_min_limit_cb_set(min_limit_cb_));
      }

      void scroll_right_cb_set(Elm_Interface_Scrollable_Cb scroll_right_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_scroll_right_cb_set(scroll_right_cb_));
      }

      void content_set(evas::object content_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_set(efl::eolian::to_c(content_)));
      }

      void edge_left_cb_set(Elm_Interface_Scrollable_Cb edge_left_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_edge_left_cb_set(edge_left_cb_));
      }

      void vbar_drag_cb_set(Elm_Interface_Scrollable_Cb vbar_drag_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_vbar_drag_cb_set(vbar_drag_cb_));
      }

      void vbar_unpress_cb_set(Elm_Interface_Scrollable_Cb vbar_unpress_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_vbar_unpress_cb_set(vbar_unpress_cb_));
      }

      void edge_bottom_cb_set(Elm_Interface_Scrollable_Cb edge_bottom_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_edge_bottom_cb_set(edge_bottom_cb_));
      }

      void edge_right_cb_set(Elm_Interface_Scrollable_Cb edge_right_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_edge_right_cb_set(edge_right_cb_));
      }

      void edge_top_cb_set(Elm_Interface_Scrollable_Cb edge_top_cb_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_edge_top_cb_set(edge_top_cb_));
      }

      void objects_set(evas::object edje_object_, evas::object hit_rectangle_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_objects_set(efl::eolian::to_c(edje_object_), efl::eolian::to_c(hit_rectangle_)));
      }

      void last_page_get(int* pagenumber_h_, int* pagenumber_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_last_page_get(pagenumber_h_, pagenumber_v_));
      }

      void current_page_get(int* pagenumber_h_, int* pagenumber_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_current_page_get(pagenumber_h_, pagenumber_v_));
      }

      void content_viewport_geometry_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_viewport_geometry_get(x_, y_, w_, h_));
      }

      void content_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_interface_scrollable_content_size_get(w_, h_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_interface_scrollable, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_interface_scrollable, function_type>,
         ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_INTERFACE_SCROLLABLE_EVENT_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_scrollable>)
{
   return (ELM_INTERFACE_SCROLLABLE_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_SCROLLABLE_HH

