#ifndef EFL_GENERATED_ELM_INWIN_HH
#define EFL_GENERATED_ELM_INWIN_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_inwin.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_inwin
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_inwin(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_inwin(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_inwin(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_inwin(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_inwin(elm_inwin const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_inwin() {}

   /// @brief Activates an inwin object, ensuring its visibility
   ///
   /// This function will make sure that the inwin @p obj is completely visible
   /// by calling evas_object_show() and evas_object_raise() on it, to bring it
   /// to the front. It also sets the keyboard focus to it, which will be passed
   /// onto its content.
   ///
   /// The object's theme will also receive the signal "elm,action,show" with
   /// source "elm".
   ///
   /// @ingroup Inwin
   ///
   void activate() const
   {
      eo_do(_eo_ptr(), ::elm_obj_win_inwin_activate());
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INWIN_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_INWIN_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_inwin_activate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->activate();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_inwin >
{
   template <typename T>
   struct type
   {
      virtual void activate()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_win_inwin_activate());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_inwin >
{
   static const int value = 1;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_inwin>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_inwin_activate_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_win_inwin_activate);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_inwin >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_inwin, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_inwin >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_inwin, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_inwin>
{
   template <typename U>
   struct type
   {
      operator ::elm_inwin() const
      {
         return ::elm_inwin(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void activate()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_win_inwin_activate());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_inwin>)
{
   return (ELM_INWIN_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_INWIN_HH

