#ifndef EFL_GENERATED_ELM_LABEL_HH
#define EFL_GENERATED_ELM_LABEL_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_label.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_label
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_label(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_label(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_label(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_label(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_label(elm_label const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_label() {}

   /// @brief @brief Start slide effect.
   ///
   /// @see elm_label_slide_mode_set()
   /// @since 1.8
   ///
   /// @ingroup Label
   ///
   void slide_go() const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_slide_go());
   }

   /// @param w The wrap width in pixels at a minimum where words need to wrap
   ///
   Evas_Coord wrap_width_get() const
   {
      Evas_Coord _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_wrap_width_get());
      return _tmp_ret;
   }

   /// @param w The wrap width in pixels at a minimum where words need to wrap
   ///
   void wrap_width_set(Evas_Coord w_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_wrap_width_set(w_));
   }

   /// @param speed The speed of the slide animation in px per seconds
   ///
   double slide_speed_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_speed_get());
      return _tmp_ret;
   }

   /// @param speed The speed of the slide animation in px per seconds
   ///
   void slide_speed_set(double speed_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_slide_speed_set(speed_));
   }

   /// @param mode The slide mode
   ///
   Elm_Label_Slide_Mode slide_mode_get() const
   {
      Elm_Label_Slide_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_mode_get());
      return _tmp_ret;
   }

   /// @param mode The slide mode
   ///
   void slide_mode_set(Elm_Label_Slide_Mode mode_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_slide_mode_set(mode_));
   }

   /// @param duration The duration in seconds in moving text from slide begin position
   /// to slide end position
   ///
   double slide_duration_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_duration_get());
      return _tmp_ret;
   }

   /// @param duration The duration in seconds in moving text from slide begin position
   /// to slide end position
   ///
   void slide_duration_set(double duration_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_slide_duration_set(duration_));
   }

   /// @param wrap To wrap text or not
   ///
   Elm_Wrap_Type line_wrap_get() const
   {
      Elm_Wrap_Type _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_line_wrap_get());
      return _tmp_ret;
   }

   /// @param wrap To wrap text or not
   ///
   void line_wrap_set(Elm_Wrap_Type wrap_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_line_wrap_set(wrap_));
   }

   /// @param ellipsis To ellipsis text or not
   ///
   bool ellipsis_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_label_ellipsis_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param ellipsis To ellipsis text or not
   ///
   void ellipsis_set(bool ellipsis_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_label_ellipsis_set(efl::eolian::to_c(ellipsis_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slide_end_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_SLIDE_END, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_SLIDE_END );
   }

   template <typename T>
   void
   callback_slide_end_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_SLIDE_END, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_LABEL_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_LABEL_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_label_slide_go_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->slide_go();
}

template <typename T>
Evas_Coord _elm_label_wrap_width_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->wrap_width_get();
}

template <typename T>
void _elm_label_wrap_width_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_)
{
   static_cast<T*>(self->this_)->wrap_width_set(w_);
}

template <typename T>
double _elm_label_slide_speed_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->slide_speed_get();
}

template <typename T>
void _elm_label_slide_speed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double speed_)
{
   static_cast<T*>(self->this_)->slide_speed_set(speed_);
}

template <typename T>
Elm_Label_Slide_Mode _elm_label_slide_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->slide_mode_get();
}

template <typename T>
void _elm_label_slide_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Label_Slide_Mode mode_)
{
   static_cast<T*>(self->this_)->slide_mode_set(mode_);
}

template <typename T>
double _elm_label_slide_duration_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->slide_duration_get();
}

template <typename T>
void _elm_label_slide_duration_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double duration_)
{
   static_cast<T*>(self->this_)->slide_duration_set(duration_);
}

template <typename T>
Elm_Wrap_Type _elm_label_line_wrap_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->line_wrap_get();
}

template <typename T>
void _elm_label_line_wrap_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Wrap_Type wrap_)
{
   static_cast<T*>(self->this_)->line_wrap_set(wrap_);
}

template <typename T>
bool _elm_label_ellipsis_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->ellipsis_get();
}

template <typename T>
void _elm_label_ellipsis_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool ellipsis_)
{
   static_cast<T*>(self->this_)->ellipsis_set(efl::eolian::to_cxx<bool>(ellipsis_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_label >
{
   template <typename T>
   struct type
   {
      virtual void slide_go()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_slide_go());
      }

      virtual Evas_Coord wrap_width_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_wrap_width_get());
            return _tmp_ret;
      }

      virtual void wrap_width_set(Evas_Coord w_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_wrap_width_set(w_));
      }

      virtual double slide_speed_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_slide_speed_get());
            return _tmp_ret;
      }

      virtual void slide_speed_set(double speed_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_slide_speed_set(speed_));
      }

      virtual Elm_Label_Slide_Mode slide_mode_get()
      {
         Elm_Label_Slide_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_slide_mode_get());
            return _tmp_ret;
      }

      virtual void slide_mode_set(Elm_Label_Slide_Mode mode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_slide_mode_set(mode_));
      }

      virtual double slide_duration_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_slide_duration_get());
            return _tmp_ret;
      }

      virtual void slide_duration_set(double duration_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_slide_duration_set(duration_));
      }

      virtual Elm_Wrap_Type line_wrap_get()
      {
         Elm_Wrap_Type _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_line_wrap_get());
            return _tmp_ret;
      }

      virtual void line_wrap_set(Elm_Wrap_Type wrap_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_line_wrap_set(wrap_));
      }

      virtual bool ellipsis_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_label_ellipsis_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void ellipsis_set(bool ellipsis_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_label_ellipsis_set(efl::eolian::to_c(ellipsis_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_label >
{
   static const int value = 13;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_label>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_label_slide_go_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_go);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_label_wrap_width_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_label_wrap_width_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_label_wrap_width_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_label_wrap_width_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_label_slide_speed_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_speed_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_label_slide_speed_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_speed_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_label_slide_mode_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_mode_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_label_slide_mode_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_mode_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_label_slide_duration_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_duration_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_label_slide_duration_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_label_slide_duration_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_label_line_wrap_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_label_line_wrap_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_label_line_wrap_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_label_line_wrap_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_label_ellipsis_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_label_ellipsis_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_label_ellipsis_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_label_ellipsis_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_label >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_label, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_label >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_label, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_label>
{
   template <typename U>
   struct type
   {
      operator ::elm_label() const
      {
         return ::elm_label(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void slide_go()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_slide_go());
      }

      Evas_Coord wrap_width_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_wrap_width_get());
            return _tmp_ret;
      }

      void wrap_width_set(Evas_Coord w_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_wrap_width_set(w_));
      }

      double slide_speed_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_speed_get());
            return _tmp_ret;
      }

      void slide_speed_set(double speed_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_slide_speed_set(speed_));
      }

      Elm_Label_Slide_Mode slide_mode_get()
      {
         Elm_Label_Slide_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_mode_get());
            return _tmp_ret;
      }

      void slide_mode_set(Elm_Label_Slide_Mode mode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_slide_mode_set(mode_));
      }

      double slide_duration_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_slide_duration_get());
            return _tmp_ret;
      }

      void slide_duration_set(double duration_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_slide_duration_set(duration_));
      }

      Elm_Wrap_Type line_wrap_get()
      {
         Elm_Wrap_Type _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_line_wrap_get());
            return _tmp_ret;
      }

      void line_wrap_set(Elm_Wrap_Type wrap_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_line_wrap_set(wrap_));
      }

      bool ellipsis_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_label_ellipsis_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void ellipsis_set(bool ellipsis_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_label_ellipsis_set(efl::eolian::to_c(ellipsis_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slide_end_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_LABEL_EVENT_SLIDE_END, priority_,
            &efl::eo::_detail::event_callback<::elm_label, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_label, function_type>,
         ELM_LABEL_EVENT_SLIDE_END );
   }

   template <typename T>
   void
   callback_slide_end_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_LABEL_EVENT_SLIDE_END, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_label>)
{
   return (ELM_LABEL_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_LABEL_HH

