#ifndef EFL_GENERATED_ELM_NOTIFY_HH
#define EFL_GENERATED_ELM_NOTIFY_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_notify.eo.h"
}

#include "elm_container.eo.hh"

struct elm_notify
      : elm_container
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_notify(Eo* eo)
      : elm_container(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_notify(std::nullptr_t)
      : elm_container(nullptr)
   {}

   elm_notify(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_notify(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_notify(elm_notify const& other)
      : elm_container(eo_ref(other._eo_ptr()))
   {}

   ~elm_notify() {}

   /// @param horizontal The horizontal alignment of the notification
   /// @param vertical The vertical alignment of the notification
   ///
   void align_get(double* horizontal_, double* vertical_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_notify_align_get(horizontal_, vertical_));
   }

   /// @param horizontal The horizontal alignment of the notification
   /// @param vertical The vertical alignment of the notification
   ///
   void align_set(double horizontal_, double vertical_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_notify_align_set(horizontal_, vertical_));
   }

   /// @param allow EINA_TRUE If events are allowed, otherwise not
   ///
   bool allow_events_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_notify_allow_events_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param allow EINA_TRUE If events are allowed, otherwise not
   ///
   void allow_events_set(bool allow_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_notify_allow_events_set(efl::eolian::to_c(allow_)));
   }

   /// @param timeout The timeout in seconds
   ///
   double timeout_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_notify_timeout_get());
      return _tmp_ret;
   }

   /// @param timeout The timeout in seconds
   ///
   void timeout_set(double timeout_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_notify_timeout_set(timeout_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_block_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NOTIFY_EVENT_BLOCK_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_notify, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_notify, function_type>,
         ELM_NOTIFY_EVENT_BLOCK_CLICKED );
   }

   template <typename T>
   void
   callback_block_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NOTIFY_EVENT_BLOCK_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_timeout_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NOTIFY_EVENT_TIMEOUT, priority_,
            &efl::eo::_detail::event_callback<::elm_notify, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_notify, function_type>,
         ELM_NOTIFY_EVENT_TIMEOUT );
   }

   template <typename T>
   void
   callback_timeout_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_NOTIFY_EVENT_TIMEOUT, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_NOTIFY_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_NOTIFY_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_notify_align_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* horizontal_, double* vertical_)
{
   static_cast<T*>(self->this_)->align_get(horizontal_, vertical_);
}

template <typename T>
void _elm_notify_align_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double horizontal_, double vertical_)
{
   static_cast<T*>(self->this_)->align_set(horizontal_, vertical_);
}

template <typename T>
bool _elm_notify_allow_events_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->allow_events_get();
}

template <typename T>
void _elm_notify_allow_events_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool allow_)
{
   static_cast<T*>(self->this_)->allow_events_set(efl::eolian::to_cxx<bool>(allow_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_notify_timeout_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->timeout_get();
}

template <typename T>
void _elm_notify_timeout_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double timeout_)
{
   static_cast<T*>(self->this_)->timeout_set(timeout_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_notify >
{
   template <typename T>
   struct type
   {
      virtual void align_get(double* horizontal_, double* vertical_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_align_get(horizontal_, vertical_));
      }

      virtual void align_set(double horizontal_, double vertical_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_align_set(horizontal_, vertical_));
      }

      virtual bool allow_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_notify_allow_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void allow_events_set(bool allow_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_allow_events_set(efl::eolian::to_c(allow_)));
      }

      virtual double timeout_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_notify_timeout_get());
            return _tmp_ret;
      }

      virtual void timeout_set(double timeout_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_notify_timeout_set(timeout_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_notify >
{
   static const int value = 6;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_notify>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_notify_align_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_align_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_notify_align_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_align_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_notify_allow_events_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_allow_events_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_notify_allow_events_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_allow_events_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_notify_timeout_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_timeout_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_notify_timeout_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_notify_timeout_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_notify >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_notify, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_notify >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_notify, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_notify>
{
   template <typename U>
   struct type
   {
      operator ::elm_notify() const
      {
         return ::elm_notify(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void align_get(double* horizontal_, double* vertical_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_notify_align_get(horizontal_, vertical_));
      }

      void align_set(double horizontal_, double vertical_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_notify_align_set(horizontal_, vertical_));
      }

      bool allow_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_notify_allow_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void allow_events_set(bool allow_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_notify_allow_events_set(efl::eolian::to_c(allow_)));
      }

      double timeout_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_notify_timeout_get());
            return _tmp_ret;
      }

      void timeout_set(double timeout_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_notify_timeout_set(timeout_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_block_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NOTIFY_EVENT_BLOCK_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_notify, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_notify, function_type>,
         ELM_NOTIFY_EVENT_BLOCK_CLICKED );
   }

   template <typename T>
   void
   callback_block_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NOTIFY_EVENT_BLOCK_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_timeout_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_NOTIFY_EVENT_TIMEOUT, priority_,
            &efl::eo::_detail::event_callback<::elm_notify, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_notify, function_type>,
         ELM_NOTIFY_EVENT_TIMEOUT );
   }

   template <typename T>
   void
   callback_timeout_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_NOTIFY_EVENT_TIMEOUT, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_notify>)
{
   return (ELM_NOTIFY_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_NOTIFY_HH

