#ifndef EFL_GENERATED_ELM_PAN_HH
#define EFL_GENERATED_ELM_PAN_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_pan.eo.h"
}

#include "evas_smart_clipped.eo.hh"

struct elm_pan
      : evas::smart_clipped
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_pan(Eo* eo)
      : evas::smart_clipped(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_pan(std::nullptr_t)
      : evas::smart_clipped(nullptr)
   {}

   elm_pan(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_pan(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_pan(elm_pan const& other)
      : evas::smart_clipped(eo_ref(other._eo_ptr()))
   {}

   ~elm_pan() {}

   /// @param x 
   /// @param y 
   ///
   void gravity_get(double* x_, double* y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_gravity_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void gravity_set(double x_, double y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_gravity_set(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void pos_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_pos_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void pos_set(Evas_Coord x_, Evas_Coord y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_pos_set(x_, y_));
   }

   /// @param w 
   /// @param h 
   ///
   void content_size_get(Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_content_size_get(w_, h_));
   }

   /// @param x 
   /// @param y 
   ///
   void pos_min_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_pos_min_get(x_, y_));
   }

   /// @param x 
   /// @param y 
   ///
   void pos_max_get(Evas_Coord* x_, Evas_Coord* y_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_pan_pos_max_get(x_, y_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PAN_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_pan, function_type>,
         ELM_PAN_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PAN_EVENT_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PAN_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_PAN_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_pan_gravity_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* x_, double* y_)
{
   static_cast<T*>(self->this_)->gravity_get(x_, y_);
}

template <typename T>
void _elm_pan_gravity_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double x_, double y_)
{
   static_cast<T*>(self->this_)->gravity_set(x_, y_);
}

template <typename T>
void _elm_pan_pos_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->pos_get(x_, y_);
}

template <typename T>
void _elm_pan_pos_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_)
{
   static_cast<T*>(self->this_)->pos_set(x_, y_);
}

template <typename T>
void _elm_pan_content_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->content_size_get(w_, h_);
}

template <typename T>
void _elm_pan_pos_min_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->pos_min_get(x_, y_);
}

template <typename T>
void _elm_pan_pos_max_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_)
{
   static_cast<T*>(self->this_)->pos_max_get(x_, y_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_pan >
{
   template <typename T>
   struct type
   {
      virtual void gravity_get(double* x_, double* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_gravity_get(x_, y_));
      }

      virtual void gravity_set(double x_, double y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_gravity_set(x_, y_));
      }

      virtual void pos_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_get(x_, y_));
      }

      virtual void pos_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_set(x_, y_));
      }

      virtual void content_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_content_size_get(w_, h_));
      }

      virtual void pos_min_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_min_get(x_, y_));
      }

      virtual void pos_max_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_pan_pos_max_get(x_, y_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_pan >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_pan>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_pan_gravity_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_gravity_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_pan_gravity_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_gravity_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_pan_pos_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_pan_pos_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_pan_content_size_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_content_size_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_pan_pos_min_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_min_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_pan_pos_max_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_pan_pos_max_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_pan >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_pan, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_pan >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_pan, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_pan>
{
   template <typename U>
   struct type
   {
      operator ::elm_pan() const
      {
         return ::elm_pan(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void gravity_get(double* x_, double* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_gravity_get(x_, y_));
      }

      void gravity_set(double x_, double y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_gravity_set(x_, y_));
      }

      void pos_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_pos_get(x_, y_));
      }

      void pos_set(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_pos_set(x_, y_));
      }

      void content_size_get(Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_content_size_get(w_, h_));
      }

      void pos_min_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_pos_min_get(x_, y_));
      }

      void pos_max_get(Evas_Coord* x_, Evas_Coord* y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_pan_pos_max_get(x_, y_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PAN_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_pan, function_type>,
         ELM_PAN_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PAN_EVENT_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_pan>)
{
   return (ELM_PAN_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PAN_HH

