#ifndef EFL_GENERATED_ELM_PANEL_HH
#define EFL_GENERATED_ELM_PANEL_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_panel.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_scrollable.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"

struct elm_panel
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_scrollable>::template type< ::elm_panel>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_panel>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_panel(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_panel(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_panel(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_panel(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_panel(elm_panel const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_panel() {}

   /// @brief @brief Toggle the hidden state of the panel from code
   ///
   /// @ingroup Panel
   ///
   void toggle() const
   {
      eo_do(_eo_ptr(), ::elm_obj_panel_toggle());
   }

   /// @param orient The panel orientation. Can be one of the following:
   /// @li ELM_PANEL_ORIENT_TOP
   /// @li ELM_PANEL_ORIENT_LEFT
   /// @li ELM_PANEL_ORIENT_RIGHT
   ///
   Elm_Panel_Orient orient_get() const
   {
      Elm_Panel_Orient _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panel_orient_get());
      return _tmp_ret;
   }

   /// @param orient The panel orientation. Can be one of the following:
   /// @li ELM_PANEL_ORIENT_TOP
   /// @li ELM_PANEL_ORIENT_LEFT
   /// @li ELM_PANEL_ORIENT_RIGHT
   ///
   void orient_set(Elm_Panel_Orient orient_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panel_orient_set(orient_));
   }

   /// @param hidden If true, the panel will run the animation to disappear.
   ///
   bool hidden_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panel_hidden_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param hidden If true, the panel will run the animation to disappear.
   ///
   void hidden_set(bool hidden_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panel_hidden_set(efl::eolian::to_c(hidden_)));
   }

   /// @param scrollable 
   ///
   void scrollable_set(bool scrollable_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panel_scrollable_set(efl::eolian::to_c(scrollable_)));
   }

   /// @param ratio 
   ///
   void scrollable_content_size_set(double ratio_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panel_scrollable_content_size_set(ratio_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANEL_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_panel, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panel, function_type>,
         ELM_PANEL_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANEL_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANEL_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_panel, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panel, function_type>,
         ELM_PANEL_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANEL_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PANEL_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_PANEL_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_panel_toggle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->toggle();
}

template <typename T>
Elm_Panel_Orient _elm_panel_orient_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->orient_get();
}

template <typename T>
void _elm_panel_orient_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Panel_Orient orient_)
{
   static_cast<T*>(self->this_)->orient_set(orient_);
}

template <typename T>
bool _elm_panel_hidden_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->hidden_get();
}

template <typename T>
void _elm_panel_hidden_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool hidden_)
{
   static_cast<T*>(self->this_)->hidden_set(efl::eolian::to_cxx<bool>(hidden_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_panel_scrollable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool scrollable_)
{
   static_cast<T*>(self->this_)->scrollable_set(efl::eolian::to_cxx<bool>(scrollable_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_panel_scrollable_content_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double ratio_)
{
   static_cast<T*>(self->this_)->scrollable_content_size_set(ratio_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_panel >
{
   template <typename T>
   struct type
   {
      virtual void toggle()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_toggle());
      }

      virtual Elm_Panel_Orient orient_get()
      {
         Elm_Panel_Orient _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panel_orient_get());
            return _tmp_ret;
      }

      virtual void orient_set(Elm_Panel_Orient orient_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_orient_set(orient_));
      }

      virtual bool hidden_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panel_hidden_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hidden_set(bool hidden_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_hidden_set(efl::eolian::to_c(hidden_)));
      }

      virtual void scrollable_set(bool scrollable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_scrollable_set(efl::eolian::to_c(scrollable_)));
      }

      virtual void scrollable_content_size_set(double ratio_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_scrollable_content_size_set(ratio_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_panel >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_panel>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_panel_toggle_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_toggle);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_panel_orient_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_orient_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_panel_orient_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_orient_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_panel_hidden_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_hidden_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_panel_hidden_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_hidden_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_panel_scrollable_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_scrollable_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_panel_scrollable_content_size_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_scrollable_content_size_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_panel >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_panel, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_panel >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_panel, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_panel>
{
   template <typename U>
   struct type
   {
      operator ::elm_panel() const
      {
         return ::elm_panel(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void toggle()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panel_toggle());
      }

      Elm_Panel_Orient orient_get()
      {
         Elm_Panel_Orient _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panel_orient_get());
            return _tmp_ret;
      }

      void orient_set(Elm_Panel_Orient orient_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panel_orient_set(orient_));
      }

      bool hidden_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panel_hidden_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void hidden_set(bool hidden_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panel_hidden_set(efl::eolian::to_c(hidden_)));
      }

      void scrollable_set(bool scrollable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panel_scrollable_set(efl::eolian::to_c(scrollable_)));
      }

      void scrollable_content_size_set(double ratio_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panel_scrollable_content_size_set(ratio_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANEL_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_panel, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panel, function_type>,
         ELM_PANEL_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANEL_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANEL_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_panel, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panel, function_type>,
         ELM_PANEL_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANEL_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_panel>)
{
   return (ELM_PANEL_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PANEL_HH

