#ifndef EFL_GENERATED_ELM_PANES_HH
#define EFL_GENERATED_ELM_PANES_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_panes.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_panes
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_panes(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_panes(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_panes(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_panes(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_panes(elm_panes const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_panes() {}

   /// @param size Value between 0.0 and 1.0 representing size proportion
   /// of left side.
   ///
   double content_left_size_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_size_get());
      return _tmp_ret;
   }

   /// @param size Value between 0.0 and 1.0 representing size proportion
   /// of left side.
   ///
   void content_left_size_set(double size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_left_size_set(size_));
   }

   /// @param horizontal Use @c EINA_TRUE to make @p obj to split panes
   /// horizontally ("top" and "bottom" contents). @c EINA_FALSE to make it
   /// vertically ("left" and "right" contents)
   ///
   bool horizontal_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_horizontal_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param horizontal Use @c EINA_TRUE to make @p obj to split panes
   /// horizontally ("top" and "bottom" contents). @c EINA_FALSE to make it
   /// vertically ("left" and "right" contents)
   ///
   void horizontal_set(bool horizontal_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_horizontal_set(efl::eolian::to_c(horizontal_)));
   }

   /// @param fixed Use @c EINA_TRUE to fix the left and right panes sizes and make
   /// them not to be resized by user interaction. Use @c EINA_FALSE to make them
   /// resizable.
   ///
   bool fixed_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_fixed_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param fixed Use @c EINA_TRUE to fix the left and right panes sizes and make
   /// them not to be resized by user interaction. Use @c EINA_FALSE to make them
   /// resizable.
   ///
   void fixed_set(bool fixed_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_fixed_set(efl::eolian::to_c(fixed_)));
   }

   /// @param size Value between 0.0 and 1.0 representing size proportion
   /// of right side.
   ///
   double content_right_size_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_size_get());
      return _tmp_ret;
   }

   /// @param size Value between 0.0 and 1.0 representing size proportion
   /// of right side.
   ///
   void content_right_size_set(double size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_right_size_set(size_));
   }

   /// @param size value between 0.0 and 1.0 representing size proportion
   /// of minimum size of left side.
   ///
   double content_left_min_relative_size_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_min_relative_size_get());
      return _tmp_ret;
   }

   /// @param size value between 0.0 and 1.0 representing size proportion
   /// of minimum size of left side.
   ///
   void content_left_min_relative_size_set(double size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_left_min_relative_size_set(size_));
   }

   /// @param size value between 0.0 and 1.0 representing size proportion
   /// of minimum size of right side.
   ///
   double content_right_min_relative_size_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_min_relative_size_get());
      return _tmp_ret;
   }

   /// @param size value between 0.0 and 1.0 representing size proportion
   /// of minimum size of right side.
   ///
   void content_right_min_relative_size_set(double size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_right_min_relative_size_set(size_));
   }

   /// @param size value representing minimum size of left side
   /// in pixels.
   ///
   Evas_Coord content_left_min_size_get() const
   {
      Evas_Coord _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_min_size_get());
      return _tmp_ret;
   }

   /// @param size value representing minimum size of left side
   /// in pixels.
   ///
   void content_left_min_size_set(Evas_Coord size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_left_min_size_set(size_));
   }

   /// @param size value representing minimum size of right side
   /// in pixels.
   ///
   Evas_Coord content_right_min_size_get() const
   {
      Evas_Coord _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_min_size_get());
      return _tmp_ret;
   }

   /// @param size value representing minimum size of right side
   /// in pixels.
   ///
   void content_right_min_size_set(Evas_Coord size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_panes_content_right_min_size_set(size_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unpress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_UNPRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_UNPRESS );
   }

   template <typename T>
   void
   callback_unpress_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_UNPRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_CLICKED_DOUBLE, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PANES_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_PANES_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
double _elm_panes_content_left_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_left_size_get();
}

template <typename T>
void _elm_panes_content_left_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double size_)
{
   static_cast<T*>(self->this_)->content_left_size_set(size_);
}

template <typename T>
bool _elm_panes_horizontal_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->horizontal_get();
}

template <typename T>
void _elm_panes_horizontal_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   static_cast<T*>(self->this_)->horizontal_set(efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_panes_fixed_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->fixed_get();
}

template <typename T>
void _elm_panes_fixed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fixed_)
{
   static_cast<T*>(self->this_)->fixed_set(efl::eolian::to_cxx<bool>(fixed_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_panes_content_right_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_right_size_get();
}

template <typename T>
void _elm_panes_content_right_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double size_)
{
   static_cast<T*>(self->this_)->content_right_size_set(size_);
}

template <typename T>
double _elm_panes_content_left_min_relative_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_left_min_relative_size_get();
}

template <typename T>
void _elm_panes_content_left_min_relative_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double size_)
{
   static_cast<T*>(self->this_)->content_left_min_relative_size_set(size_);
}

template <typename T>
double _elm_panes_content_right_min_relative_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_right_min_relative_size_get();
}

template <typename T>
void _elm_panes_content_right_min_relative_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double size_)
{
   static_cast<T*>(self->this_)->content_right_min_relative_size_set(size_);
}

template <typename T>
Evas_Coord _elm_panes_content_left_min_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_left_min_size_get();
}

template <typename T>
void _elm_panes_content_left_min_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord size_)
{
   static_cast<T*>(self->this_)->content_left_min_size_set(size_);
}

template <typename T>
Evas_Coord _elm_panes_content_right_min_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->content_right_min_size_get();
}

template <typename T>
void _elm_panes_content_right_min_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord size_)
{
   static_cast<T*>(self->this_)->content_right_min_size_set(size_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_panes >
{
   template <typename T>
   struct type
   {
      virtual double content_left_size_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_left_size_get());
            return _tmp_ret;
      }

      virtual void content_left_size_set(double size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_left_size_set(size_));
      }

      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      virtual bool fixed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_fixed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void fixed_set(bool fixed_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_fixed_set(efl::eolian::to_c(fixed_)));
      }

      virtual double content_right_size_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_right_size_get());
            return _tmp_ret;
      }

      virtual void content_right_size_set(double size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_right_size_set(size_));
      }

      virtual double content_left_min_relative_size_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_left_min_relative_size_get());
            return _tmp_ret;
      }

      virtual void content_left_min_relative_size_set(double size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_left_min_relative_size_set(size_));
      }

      virtual double content_right_min_relative_size_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_right_min_relative_size_get());
            return _tmp_ret;
      }

      virtual void content_right_min_relative_size_set(double size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_right_min_relative_size_set(size_));
      }

      virtual Evas_Coord content_left_min_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_left_min_size_get());
            return _tmp_ret;
      }

      virtual void content_left_min_size_set(Evas_Coord size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_left_min_size_set(size_));
      }

      virtual Evas_Coord content_right_min_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panes_content_right_min_size_get());
            return _tmp_ret;
      }

      virtual void content_right_min_size_set(Evas_Coord size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_panes_content_right_min_size_set(size_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_panes >
{
   static const int value = 16;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_panes>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_size_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_size_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_size_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_size_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_panes_horizontal_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_horizontal_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_panes_horizontal_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_horizontal_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_panes_fixed_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_fixed_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_panes_fixed_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_fixed_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_size_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_size_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_size_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_size_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_min_relative_size_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_min_relative_size_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_min_relative_size_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_min_relative_size_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_min_relative_size_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_min_relative_size_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_min_relative_size_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_min_relative_size_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_min_size_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_min_size_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_panes_content_left_min_size_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_left_min_size_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_min_size_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_min_size_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_panes_content_right_min_size_set_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_panes_content_right_min_size_set);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_panes >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_panes, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_panes >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_panes, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_panes>
{
   template <typename U>
   struct type
   {
      operator ::elm_panes() const
      {
         return ::elm_panes(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      double content_left_size_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_size_get());
            return _tmp_ret;
      }

      void content_left_size_set(double size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_left_size_set(size_));
      }

      bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void horizontal_set(bool horizontal_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      bool fixed_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_fixed_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void fixed_set(bool fixed_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_fixed_set(efl::eolian::to_c(fixed_)));
      }

      double content_right_size_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_size_get());
            return _tmp_ret;
      }

      void content_right_size_set(double size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_right_size_set(size_));
      }

      double content_left_min_relative_size_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_min_relative_size_get());
            return _tmp_ret;
      }

      void content_left_min_relative_size_set(double size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_left_min_relative_size_set(size_));
      }

      double content_right_min_relative_size_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_min_relative_size_get());
            return _tmp_ret;
      }

      void content_right_min_relative_size_set(double size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_right_min_relative_size_set(size_));
      }

      Evas_Coord content_left_min_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_left_min_size_get());
            return _tmp_ret;
      }

      void content_left_min_size_set(Evas_Coord size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_left_min_size_set(size_));
      }

      Evas_Coord content_right_min_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_panes_content_right_min_size_get());
            return _tmp_ret;
      }

      void content_right_min_size_set(Evas_Coord size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_panes_content_right_min_size_set(size_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unpress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_UNPRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_UNPRESS );
   }

   template <typename T>
   void
   callback_unpress_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_UNPRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PANES_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_panes, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_panes, function_type>,
         ELM_PANES_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PANES_EVENT_CLICKED_DOUBLE, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_panes>)
{
   return (ELM_PANES_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PANES_HH

