#ifndef EFL_GENERATED_ELM_PHOTOCAM_HH
#define EFL_GENERATED_ELM_PHOTOCAM_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_photocam.eo.h"
}

#include "elm_widget.eo.hh"
#include "elm_interface_scrollable.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <string>

struct elm_photocam
      : elm_widget,
      efl::eo::detail::extension_inheritance<elm_interface_scrollable>::template type< ::elm_photocam>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_photocam>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_photocam(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_photocam(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   elm_photocam(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_photocam(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_photocam(elm_photocam const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_photocam() {}

   /// @brief @brief Set the viewed region of the image
   ///
   /// This shows the region of the image without using animation.
   ///
   /// @ingroup Photocam
   ///
   /// @param x X-coordinate of region in image original pixels
   /// @param y Y-coordinate of region in image original pixels
   /// @param w Width of region in image original pixels
   /// @param h Height of region in image original pixels
   ///
   void image_region_show(int x_, int y_, int w_, int h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_image_region_show(x_, y_, w_, h_));
   }

   /// @param paused The pause state to set
   ///
   bool paused_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_paused_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param paused The pause state to set
   ///
   void paused_set(bool paused_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_paused_set(efl::eolian::to_c(paused_)));
   }

   /// @param file The photo file
   ///
   std::string file_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_file_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param file The photo file
   ///
   Evas_Load_Error file_set(std::string file_) const
   {
      Evas_Load_Error _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_file_set(efl::eolian::to_c(file_)));
      return _tmp_ret;
   }

   /// @param gesture The gesture state to set
   ///
   bool gesture_enabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_gesture_enabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param gesture The gesture state to set
   ///
   void gesture_enabled_set(bool gesture_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_gesture_enabled_set(efl::eolian::to_c(gesture_)));
   }

   /// @param zoom The zoom level to set
   ///
   double zoom_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_zoom_get());
      return _tmp_ret;
   }

   /// @param zoom The zoom level to set
   ///
   void zoom_set(double zoom_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_zoom_set(zoom_));
   }

   /// @param mode The desired mode
   ///
   Elm_Photocam_Zoom_Mode zoom_mode_get() const
   {
      Elm_Photocam_Zoom_Mode _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_zoom_mode_get());
      return _tmp_ret;
   }

   /// @param mode The desired mode
   ///
   void zoom_mode_set(Elm_Photocam_Zoom_Mode mode_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_zoom_mode_set(mode_));
   }

   /// @param x A pointer to the X-coordinate of region
   /// @param y A pointer to the Y-coordinate of region
   /// @param w A pointer to the width
   /// @param h A pointer to the height
   ///
   void image_region_get(int* x_, int* y_, int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_image_region_get(x_, y_, w_, h_));
   }

   evas::object internal_image_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_photocam_internal_image_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param w A pointer to the width return
   /// @param h A pointer to the height return
   ///
   void image_size_get(int* w_, int* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_photocam_image_size_get(w_, h_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LONGPRESSED );
   }

   template <typename T>
   void
   callback_longpressed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOAD, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOAD );
   }

   template <typename T>
   void
   callback_load_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOAD, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOADED );
   }

   template <typename T>
   void
   callback_loaded_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOAD_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOAD_DETAIL );
   }

   template <typename T>
   void
   callback_load_detail_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOAD_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOADED_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOADED_DETAIL );
   }

   template <typename T>
   void
   callback_loaded_detail_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOADED_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_change_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_CHANGE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_CHANGE );
   }

   template <typename T>
   void
   callback_zoom_change_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_CHANGE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL );
   }

   template <typename T>
   void
   callback_scroll_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START );
   }

   template <typename T>
   void
   callback_scroll_anim_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP );
   }

   template <typename T>
   void
   callback_scroll_anim_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START );
   }

   template <typename T>
   void
   callback_scroll_drag_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP );
   }

   template <typename T>
   void
   callback_scroll_drag_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PHOTOCAM_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_PHOTOCAM_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_photocam_image_region_show_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int x_, int y_, int w_, int h_)
{
   static_cast<T*>(self->this_)->image_region_show(x_, y_, w_, h_);
}

template <typename T>
bool _elm_photocam_paused_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->paused_get();
}

template <typename T>
void _elm_photocam_paused_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool paused_)
{
   static_cast<T*>(self->this_)->paused_set(efl::eolian::to_cxx<bool>(paused_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_photocam_file_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->file_get();
}

template <typename T>
Evas_Load_Error _elm_photocam_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_)
{
   return static_cast<T*>(self->this_)->file_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_photocam_gesture_enabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->gesture_enabled_get();
}

template <typename T>
void _elm_photocam_gesture_enabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool gesture_)
{
   static_cast<T*>(self->this_)->gesture_enabled_set(efl::eolian::to_cxx<bool>(gesture_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_photocam_zoom_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->zoom_get();
}

template <typename T>
void _elm_photocam_zoom_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double zoom_)
{
   static_cast<T*>(self->this_)->zoom_set(zoom_);
}

template <typename T>
Elm_Photocam_Zoom_Mode _elm_photocam_zoom_mode_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->zoom_mode_get();
}

template <typename T>
void _elm_photocam_zoom_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Photocam_Zoom_Mode mode_)
{
   static_cast<T*>(self->this_)->zoom_mode_set(mode_);
}

template <typename T>
void _elm_photocam_image_region_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* x_, int* y_, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->image_region_get(x_, y_, w_, h_);
}

template <typename T>
evas::object _elm_photocam_internal_image_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->internal_image_get();
}

template <typename T>
void _elm_photocam_image_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* w_, int* h_)
{
   static_cast<T*>(self->this_)->image_size_get(w_, h_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_photocam >
{
   template <typename T>
   struct type
   {
      virtual void image_region_show(int x_, int y_, int w_, int h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_image_region_show(x_, y_, w_, h_));
      }

      virtual bool paused_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_paused_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void paused_set(bool paused_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_paused_set(efl::eolian::to_c(paused_)));
      }

      virtual std::string file_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_file_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Evas_Load_Error file_set(std::string file_)
      {
         Evas_Load_Error _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_file_set(efl::eolian::to_c(file_)));
            return _tmp_ret;
      }

      virtual bool gesture_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_gesture_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void gesture_enabled_set(bool gesture_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_gesture_enabled_set(efl::eolian::to_c(gesture_)));
      }

      virtual double zoom_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_zoom_get());
            return _tmp_ret;
      }

      virtual void zoom_set(double zoom_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_zoom_set(zoom_));
      }

      virtual Elm_Photocam_Zoom_Mode zoom_mode_get()
      {
         Elm_Photocam_Zoom_Mode _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_zoom_mode_get());
            return _tmp_ret;
      }

      virtual void zoom_mode_set(Elm_Photocam_Zoom_Mode mode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_zoom_mode_set(mode_));
      }

      virtual void image_region_get(int* x_, int* y_, int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_image_region_get(x_, y_, w_, h_));
      }

      virtual evas::object internal_image_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photocam_internal_image_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void image_size_get(int* w_, int* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_photocam_image_size_get(w_, h_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_photocam >
{
   static const int value = 14;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_photocam>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_photocam_image_region_show_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_image_region_show);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_photocam_paused_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_paused_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_photocam_paused_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_paused_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_photocam_file_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_file_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_photocam_file_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_file_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_photocam_gesture_enabled_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_gesture_enabled_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_photocam_gesture_enabled_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_gesture_enabled_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_photocam_zoom_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_zoom_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_photocam_zoom_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_zoom_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_photocam_zoom_mode_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_zoom_mode_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_photocam_zoom_mode_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_zoom_mode_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_photocam_image_region_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_image_region_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_photocam_internal_image_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_internal_image_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_photocam_image_size_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_photocam_image_size_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_photocam >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_photocam, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_photocam >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_photocam, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_photocam>
{
   template <typename U>
   struct type
   {
      operator ::elm_photocam() const
      {
         return ::elm_photocam(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void image_region_show(int x_, int y_, int w_, int h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_image_region_show(x_, y_, w_, h_));
      }

      bool paused_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_paused_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void paused_set(bool paused_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_paused_set(efl::eolian::to_c(paused_)));
      }

      std::string file_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_file_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      Evas_Load_Error file_set(std::string file_)
      {
         Evas_Load_Error _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_file_set(efl::eolian::to_c(file_)));
            return _tmp_ret;
      }

      bool gesture_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_gesture_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void gesture_enabled_set(bool gesture_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_gesture_enabled_set(efl::eolian::to_c(gesture_)));
      }

      double zoom_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_zoom_get());
            return _tmp_ret;
      }

      void zoom_set(double zoom_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_zoom_set(zoom_));
      }

      Elm_Photocam_Zoom_Mode zoom_mode_get()
      {
         Elm_Photocam_Zoom_Mode _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_zoom_mode_get());
            return _tmp_ret;
      }

      void zoom_mode_set(Elm_Photocam_Zoom_Mode mode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_zoom_mode_set(mode_));
      }

      void image_region_get(int* x_, int* y_, int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_image_region_get(x_, y_, w_, h_));
      }

      evas::object internal_image_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_photocam_internal_image_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void image_size_get(int* w_, int* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_photocam_image_size_get(w_, h_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LONGPRESSED );
   }

   template <typename T>
   void
   callback_longpressed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOAD, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOAD );
   }

   template <typename T>
   void
   callback_load_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOAD, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOADED );
   }

   template <typename T>
   void
   callback_loaded_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOAD_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOAD_DETAIL );
   }

   template <typename T>
   void
   callback_load_detail_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOAD_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_LOADED_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_LOADED_DETAIL );
   }

   template <typename T>
   void
   callback_loaded_detail_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_LOADED_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_change_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_ZOOM_CHANGE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_ZOOM_CHANGE );
   }

   template <typename T>
   void
   callback_zoom_change_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_ZOOM_CHANGE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL );
   }

   template <typename T>
   void
   callback_scroll_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START );
   }

   template <typename T>
   void
   callback_scroll_anim_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP );
   }

   template <typename T>
   void
   callback_scroll_anim_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_ANIM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START );
   }

   template <typename T>
   void
   callback_scroll_drag_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP );
   }

   template <typename T>
   void
   callback_scroll_drag_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_SCROLL_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_DOWNLOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam, function_type>,
         ELM_PHOTOCAM_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_photocam>)
{
   return (ELM_PHOTOCAM_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PHOTOCAM_HH

