#ifndef EFL_GENERATED_ELM_PHOTOCAM_PAN_HH
#define EFL_GENERATED_ELM_PHOTOCAM_PAN_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_photocam_pan.eo.h"
}

#include "elm_pan.eo.hh"

struct elm_photocam_pan
      : elm_pan
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_photocam_pan(Eo* eo)
      : elm_pan(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_photocam_pan(std::nullptr_t)
      : elm_pan(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_photocam_pan(elm_photocam_pan const& other)
      : elm_pan(eo_ref(other._eo_ptr()))
   {}

   ~elm_photocam_pan() {}

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED );
   }

   template <typename T>
   void
   callback_longpressed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOAD, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOAD );
   }

   template <typename T>
   void
   callback_load_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOAD, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOADED );
   }

   template <typename T>
   void
   callback_loaded_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL );
   }

   template <typename T>
   void
   callback_load_detail_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL );
   }

   template <typename T>
   void
   callback_loaded_detail_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_change_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE );
   }

   template <typename T>
   void
   callback_zoom_change_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL );
   }

   template <typename T>
   void
   callback_scroll_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START );
   }

   template <typename T>
   void
   callback_scroll_anim_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP );
   }

   template <typename T>
   void
   callback_scroll_anim_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START );
   }

   template <typename T>
   void
   callback_scroll_drag_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP );
   }

   template <typename T>
   void
   callback_scroll_drag_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_PHOTOCAM_PAN_CLASS);
   }

private:
};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_photocam_pan >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_photocam_pan >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_photocam_pan>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_photocam_pan >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_photocam_pan, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_photocam_pan>
{
   template <typename U>
   struct type
   {
      operator ::elm_photocam_pan() const
      {
         return ::elm_photocam_pan(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_PRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_longpressed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED );
   }

   template <typename T>
   void
   callback_longpressed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LONGPRESSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOAD, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOAD );
   }

   template <typename T>
   void
   callback_load_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOAD, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOADED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOADED );
   }

   template <typename T>
   void
   callback_loaded_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOADED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL );
   }

   template <typename T>
   void
   callback_load_detail_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOAD_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_loaded_detail_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL );
   }

   template <typename T>
   void
   callback_loaded_detail_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_LOADED_DETAIL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_START );
   }

   template <typename T>
   void
   callback_zoom_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP );
   }

   template <typename T>
   void
   callback_zoom_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_zoom_change_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE );
   }

   template <typename T>
   void
   callback_zoom_change_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_ZOOM_CHANGE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL );
   }

   template <typename T>
   void
   callback_scroll_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START );
   }

   template <typename T>
   void
   callback_scroll_anim_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_anim_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP );
   }

   template <typename T>
   void
   callback_scroll_anim_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_ANIM_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START );
   }

   template <typename T>
   void
   callback_scroll_drag_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_scroll_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP );
   }

   template <typename T>
   void
   callback_scroll_drag_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_SCROLL_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START );
   }

   template <typename T>
   void
   callback_download_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_progress_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS );
   }

   template <typename T>
   void
   callback_download_progress_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_PROGRESS, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_done_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE );
   }

   template <typename T>
   void
   callback_download_done_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_DONE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_download_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR );
   }

   template <typename T>
   void
   callback_download_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_DOWNLOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_photocam_pan, function_type>,
         ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_PHOTOCAM_PAN_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_photocam_pan>)
{
   return (ELM_PHOTOCAM_PAN_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_PHOTOCAM_PAN_HH

