#ifndef EFL_GENERATED_ELM_RADIO_HH
#define EFL_GENERATED_ELM_RADIO_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_radio.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <canvas/evas_object.eo.hh>

struct elm_radio
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_radio>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_radio(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_radio(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_radio(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_radio(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_radio(elm_radio const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_radio() {}

   /// @brief @brief Add this radio to a group of other radio objects
   ///
   /// Radio objects work in groups. Each member should have a different integer
   /// value assigned. In order to have them work as a group, they need to know
   /// about each other. This adds the given radio object to the group of which
   /// the group object indicated is a member.
   ///
   /// @ingroup Radio
   ///
   /// @param group Any object whose group the @p obj is to join.
   ///
   void group_add(evas::object group_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_radio_group_add(efl::eolian::to_c(group_)));
   }

   /// @param value The value to use if this radio object is selected
   ///
   int state_value_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_radio_state_value_get());
      return _tmp_ret;
   }

   /// @param value The value to use if this radio object is selected
   ///
   void state_value_set(int value_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_radio_state_value_set(value_));
   }

   /// @param value The value to use for the group
   ///
   int value_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_radio_value_get());
      return _tmp_ret;
   }

   /// @param value The value to use for the group
   ///
   void value_set(int value_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_radio_value_set(value_));
   }

   /// @param valuep Pointer to the integer to modify
   ///
   void value_pointer_set(int * valuep_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_radio_value_pointer_set(valuep_));
   }

   evas::object selected_object_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_radio_selected_object_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_RADIO_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_RADIO_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_radio_group_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * group_)
{
   static_cast<T*>(self->this_)->group_add(efl::eolian::to_cxx<evas::object>(group_, std::tuple<std::false_type>()));
}

template <typename T>
int _elm_radio_state_value_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->state_value_get();
}

template <typename T>
void _elm_radio_state_value_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int value_)
{
   static_cast<T*>(self->this_)->state_value_set(value_);
}

template <typename T>
int _elm_radio_value_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->value_get();
}

template <typename T>
void _elm_radio_value_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int value_)
{
   static_cast<T*>(self->this_)->value_set(value_);
}

template <typename T>
void _elm_radio_value_pointer_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int * valuep_)
{
   static_cast<T*>(self->this_)->value_pointer_set(valuep_);
}

template <typename T>
evas::object _elm_radio_selected_object_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->selected_object_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_radio >
{
   template <typename T>
   struct type
   {
      virtual void group_add(evas::object group_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_group_add(efl::eolian::to_c(group_)));
      }

      virtual int state_value_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_state_value_get());
            return _tmp_ret;
      }

      virtual void state_value_set(int value_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_state_value_set(value_));
      }

      virtual int value_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_value_get());
            return _tmp_ret;
      }

      virtual void value_set(int value_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_value_set(value_));
      }

      virtual void value_pointer_set(int * valuep_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_radio_value_pointer_set(valuep_));
      }

      virtual evas::object selected_object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_radio_selected_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm_radio >
{
   static const int value = 7;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_radio>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_radio_group_add_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_group_add);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_radio_state_value_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_state_value_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_radio_state_value_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_state_value_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_radio_value_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_radio_value_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_radio_value_pointer_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_value_pointer_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_radio_selected_object_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_radio_selected_object_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_radio >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_radio, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_radio >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_radio, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_radio>
{
   template <typename U>
   struct type
   {
      operator ::elm_radio() const
      {
         return ::elm_radio(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void group_add(evas::object group_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_radio_group_add(efl::eolian::to_c(group_)));
      }

      int state_value_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_radio_state_value_get());
            return _tmp_ret;
      }

      void state_value_set(int value_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_radio_state_value_set(value_));
      }

      int value_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_radio_value_get());
            return _tmp_ret;
      }

      void value_set(int value_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_radio_value_set(value_));
      }

      void value_pointer_set(int * valuep_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_radio_value_pointer_set(valuep_));
      }

      evas::object selected_object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_radio_selected_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_RADIO_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_radio, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_radio, function_type>,
         ELM_RADIO_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_RADIO_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_radio>)
{
   return (ELM_RADIO_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_RADIO_HH

