#ifndef EFL_GENERATED_ELM_ROUTE_HH
#define EFL_GENERATED_ELM_ROUTE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_route.eo.h"
}

#include "elm_widget.eo.hh"

struct elm_route
      : elm_widget
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_route(Eo* eo)
      : elm_widget(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_route(std::nullptr_t)
      : elm_widget(nullptr)
   {}

   elm_route(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_route(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_route(elm_route const& other)
      : elm_widget(eo_ref(other._eo_ptr()))
   {}

   ~elm_route() {}

   /// @param emap 
   ///
   void emap_set(void * emap_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_route_emap_set(emap_));
   }

   /// @param min Pointer to store the minimum value.
   /// @param max Pointer to store the maximum value.
   ///
   void longitude_min_max_get(double* min_, double* max_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_route_longitude_min_max_get(min_, max_));
   }

   /// @param min Pointer to store the minimum value.
   /// @param max Pointer to store the maximum value.
   ///
   void latitude_min_max_get(double* min_, double* max_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_route_latitude_min_max_get(min_, max_));
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_ROUTE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_ROUTE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_route_emap_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, void * emap_)
{
   static_cast<T*>(self->this_)->emap_set(emap_);
}

template <typename T>
void _elm_route_longitude_min_max_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   static_cast<T*>(self->this_)->longitude_min_max_get(min_, max_);
}

template <typename T>
void _elm_route_latitude_min_max_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   static_cast<T*>(self->this_)->latitude_min_max_get(min_, max_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_route >
{
   template <typename T>
   struct type
   {
      virtual void emap_set(void * emap_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_emap_set(emap_));
      }

      virtual void longitude_min_max_get(double* min_, double* max_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_longitude_min_max_get(min_, max_));
      }

      virtual void latitude_min_max_get(double* min_, double* max_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_route_latitude_min_max_get(min_, max_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_route >
{
   static const int value = 3;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_route>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_route_emap_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_route_emap_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_route_longitude_min_max_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_route_longitude_min_max_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_route_latitude_min_max_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_route_latitude_min_max_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_route >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_route, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_route >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_route, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_route>
{
   template <typename U>
   struct type
   {
      operator ::elm_route() const
      {
         return ::elm_route(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void emap_set(void * emap_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_route_emap_set(emap_));
      }

      void longitude_min_max_get(double* min_, double* max_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_route_longitude_min_max_get(min_, max_));
      }

      void latitude_min_max_get(double* min_, double* max_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_route_latitude_min_max_get(min_, max_));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_route>)
{
   return (ELM_ROUTE_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_ROUTE_HH

