#ifndef EFL_GENERATED_ELM_SCROLLER_HH
#define EFL_GENERATED_ELM_SCROLLER_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_scroller.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_scrollable.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <string>

struct elm_scroller
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_scrollable>::template type< ::elm_scroller>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_scroller>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_scroller(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_scroller(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_scroller(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_scroller(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_scroller(elm_scroller const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_scroller() {}

   /// @brief @brief Set the maximum of the movable page at a flicking.
   ///
   /// The value of maximum movable page should be more than 1.
   ///
   /// @see elm_scroller_page_scroll_limit_get()
   ///
   /// @since 1.8
   ///
   /// @ingroup Scroller
   ///
   /// @param page_limit_h The maximum of the movable horizontal page
   /// @param page_limit_v The maximum of the movable vertical page
   ///
   void page_scroll_limit_set(int page_limit_h_, int page_limit_v_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
   }

   /// @brief @brief Get the maximum of the movable page at a flicking.
   ///
   /// @see elm_scroller_page_scroll_limit_set()
   ///
   /// @since 1.8
   ///
   /// @ingroup Scroller
   ///
   /// @param page_limit_h The maximum of the movable horizontal page
   /// @param page_limit_v The maximum of the movable vertical page
   ///
   void page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
   }

   /// @param propagation If propagation is enabled or not
   ///
   bool propagate_events_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_scroller_propagate_events_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param propagation If propagation is enabled or not
   ///
   void propagate_events_set(bool propagation_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_scroller_propagate_events_set(efl::eolian::to_c(propagation_)));
   }

   /// @param klass 
   /// @param group 
   ///
   void custom_widget_base_theme_set(std::string klass_, std::string group_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_scroller_custom_widget_base_theme_set(efl::eolian::to_c(klass_), efl::eolian::to_c(group_)));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SCROLLER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_scroller, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_scroller, function_type>,
         ELM_SCROLLER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SCROLLER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SCROLLER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_scroller, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_scroller, function_type>,
         ELM_SCROLLER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SCROLLER_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_SCROLLER_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_SCROLLER_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_scroller_page_scroll_limit_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int page_limit_h_, int page_limit_v_)
{
   static_cast<T*>(self->this_)->page_scroll_limit_set(page_limit_h_, page_limit_v_);
}

template <typename T>
void _elm_scroller_page_scroll_limit_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int * page_limit_h_, int * page_limit_v_)
{
   static_cast<T*>(self->this_)->page_scroll_limit_get(page_limit_h_, page_limit_v_);
}

template <typename T>
bool _elm_scroller_propagate_events_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->propagate_events_get();
}

template <typename T>
void _elm_scroller_propagate_events_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool propagation_)
{
   static_cast<T*>(self->this_)->propagate_events_set(efl::eolian::to_cxx<bool>(propagation_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_scroller_custom_widget_base_theme_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * klass_, const char * group_)
{
   static_cast<T*>(self->this_)->custom_widget_base_theme_set(efl::eolian::to_cxx<std::string>(klass_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(group_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_scroller >
{
   template <typename T>
   struct type
   {
      virtual void page_scroll_limit_set(int page_limit_h_, int page_limit_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
      }

      virtual void page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
      }

      virtual bool propagate_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_scroller_propagate_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void propagate_events_set(bool propagation_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_propagate_events_set(efl::eolian::to_c(propagation_)));
      }

      virtual void custom_widget_base_theme_set(std::string klass_, std::string group_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_custom_widget_base_theme_set(efl::eolian::to_c(klass_), efl::eolian::to_c(group_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_scroller >
{
   static const int value = 5;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_scroller>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_scroller_page_scroll_limit_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_page_scroll_limit_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_scroller_page_scroll_limit_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_page_scroll_limit_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_scroller_propagate_events_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_propagate_events_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_scroller_propagate_events_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_propagate_events_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_scroller_custom_widget_base_theme_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_custom_widget_base_theme_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_scroller >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_scroller, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_scroller >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_scroller, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_scroller>
{
   template <typename U>
   struct type
   {
      operator ::elm_scroller() const
      {
         return ::elm_scroller(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void page_scroll_limit_set(int page_limit_h_, int page_limit_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
      }

      void page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
      }

      bool propagate_events_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_scroller_propagate_events_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void propagate_events_set(bool propagation_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_scroller_propagate_events_set(efl::eolian::to_c(propagation_)));
      }

      void custom_widget_base_theme_set(std::string klass_, std::string group_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_scroller_custom_widget_base_theme_set(efl::eolian::to_c(klass_), efl::eolian::to_c(group_)));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SCROLLER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_scroller, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_scroller, function_type>,
         ELM_SCROLLER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SCROLLER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SCROLLER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_scroller, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_scroller, function_type>,
         ELM_SCROLLER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SCROLLER_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_scroller>)
{
   return (ELM_SCROLLER_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_SCROLLER_HH

