#ifndef EFL_GENERATED_ELM_SEPARATOR_HH
#define EFL_GENERATED_ELM_SEPARATOR_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_separator.eo.h"
}

#include "elm_layout.eo.hh"

struct elm_separator
      : elm_layout
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_separator(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_separator(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_separator(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_separator(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_separator(elm_separator const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_separator() {}

   /// @param horizontal If true, the separator is horizontal
   ///
   bool horizontal_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_separator_horizontal_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param horizontal If true, the separator is horizontal
   ///
   void horizontal_set(bool horizontal_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_separator_horizontal_set(efl::eolian::to_c(horizontal_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_SEPARATOR_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_SEPARATOR_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _elm_separator_horizontal_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->horizontal_get();
}

template <typename T>
void _elm_separator_horizontal_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   static_cast<T*>(self->this_)->horizontal_set(efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_separator >
{
   template <typename T>
   struct type
   {
      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_separator_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_separator_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_separator >
{
   static const int value = 2;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_separator>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_separator_horizontal_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_separator_horizontal_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_separator_horizontal_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_separator_horizontal_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_separator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_separator, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_separator >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_separator, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_separator>
{
   template <typename U>
   struct type
   {
      operator ::elm_separator() const
      {
         return ::elm_separator(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_separator_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void horizontal_set(bool horizontal_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_separator_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_separator>)
{
   return (ELM_SEPARATOR_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_SEPARATOR_HH

