#ifndef EFL_GENERATED_ELM_SLIDER_HH
#define EFL_GENERATED_ELM_SLIDER_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_slider.eo.h"
}

#include "elm_layout.eo.hh"
#include "elm_interface_atspi_value.eo.hh"
#include "elm_interface_atspi_widget_action.eo.hh"
#include <string>

struct elm_slider
      : elm_layout,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_value>::template type< ::elm_slider>,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget_action>::template type< ::elm_slider>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_slider(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_slider(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_slider(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_slider(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_slider(elm_slider const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_slider() {}

   /// @param horizontal Use @c EINA_TRUE to make @p obj to be
   /// @b horizontal, @c EINA_FALSE to make it @b vertical.
   ///
   bool horizontal_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_horizontal_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param horizontal Use @c EINA_TRUE to make @p obj to be
   /// @b horizontal, @c EINA_FALSE to make it @b vertical.
   ///
   void horizontal_set(bool horizontal_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_horizontal_set(efl::eolian::to_c(horizontal_)));
   }

   /// @param val The value to be displayed.
   ///
   double value_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_value_get());
      return _tmp_ret;
   }

   /// @param val The value to be displayed.
   ///
   void value_set(double val_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_value_set(val_));
   }

   /// @param indicator The format string for the indicator display.
   ///
   std::string indicator_format_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_format_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param indicator The format string for the indicator display.
   ///
   void indicator_format_set(std::string indicator_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_indicator_format_set(efl::eolian::to_c(indicator_)));
   }

   /// @param inverted Use @c EINA_TRUE to make @p obj inverted,
   /// @c EINA_FALSE to bring it back to default, non-inverted values.
   ///
   bool inverted_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_inverted_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param inverted Use @c EINA_TRUE to make @p obj inverted,
   /// @c EINA_FALSE to bring it back to default, non-inverted values.
   ///
   void inverted_set(bool inverted_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_inverted_set(efl::eolian::to_c(inverted_)));
   }

   /// @param show @c EINA_TRUE will make it enlarge, @c EINA_FALSE will
   /// let the knob always at default size.
   ///
   bool indicator_show_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param show @c EINA_TRUE will make it enlarge, @c EINA_FALSE will
   /// let the knob always at default size.
   ///
   void indicator_show_set(bool show_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_indicator_show_set(efl::eolian::to_c(show_)));
   }

   /// @param min The minimum value.
   /// @param max The maximum value.
   ///
   void min_max_get(double* min_, double* max_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_min_max_get(min_, max_));
   }

   /// @param min The minimum value.
   /// @param max The maximum value.
   ///
   void min_max_set(double min_, double max_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_min_max_set(min_, max_));
   }

   /// @param units The format string for the unit display.
   ///
   std::string unit_format_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_unit_format_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param units The format string for the unit display.
   ///
   void unit_format_set(std::string units_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_unit_format_set(efl::eolian::to_c(units_)));
   }

   /// @param flag @ EINA_TRUE sets the indicator visible
   ///
   bool indicator_show_on_focus_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param flag @ EINA_TRUE sets the indicator visible
   ///
   void indicator_show_on_focus_set(bool flag_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_indicator_show_on_focus_set(efl::eolian::to_c(flag_)));
   }

   /// @param size The length of the slider's bar region.
   ///
   Evas_Coord span_size_get() const
   {
      Evas_Coord _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_span_size_get());
      return _tmp_ret;
   }

   /// @param size The length of the slider's bar region.
   ///
   void span_size_set(Evas_Coord size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_span_size_set(size_));
   }

   /// @param step The step value.
   ///
   double step_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_slider_step_get());
      return _tmp_ret;
   }

   /// @param step The step value.
   ///
   void step_set(double step_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_step_set(step_));
   }

   /// @param func The indicator format function.
   /// @param free_func The freeing function for the format string.
   ///
   void indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
   }

   /// @param func The units format function.
   /// @param free_func The freeing function for the format string.
   ///
   void units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_slider_units_format_function_set(func_, free_func_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_delay_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_DELAY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_DELAY_CHANGED );
   }

   template <typename T>
   void
   callback_delay_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_DELAY_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slider_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_SLIDER_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_SLIDER_DRAG_START );
   }

   template <typename T>
   void
   callback_slider_drag_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_SLIDER_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slider_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_SLIDER_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_SLIDER_DRAG_STOP );
   }

   template <typename T>
   void
   callback_slider_drag_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_SLIDER_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_UNFOCUSED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_SLIDER_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_SLIDER_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
bool _elm_slider_horizontal_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->horizontal_get();
}

template <typename T>
void _elm_slider_horizontal_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool horizontal_)
{
   static_cast<T*>(self->this_)->horizontal_set(efl::eolian::to_cxx<bool>(horizontal_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_slider_value_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->value_get();
}

template <typename T>
void _elm_slider_value_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double val_)
{
   static_cast<T*>(self->this_)->value_set(val_);
}

template <typename T>
std::string _elm_slider_indicator_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->indicator_format_get();
}

template <typename T>
void _elm_slider_indicator_format_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * indicator_)
{
   static_cast<T*>(self->this_)->indicator_format_set(efl::eolian::to_cxx<std::string>(indicator_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_slider_inverted_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->inverted_get();
}

template <typename T>
void _elm_slider_inverted_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool inverted_)
{
   static_cast<T*>(self->this_)->inverted_set(efl::eolian::to_cxx<bool>(inverted_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_slider_indicator_show_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->indicator_show_get();
}

template <typename T>
void _elm_slider_indicator_show_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool show_)
{
   static_cast<T*>(self->this_)->indicator_show_set(efl::eolian::to_cxx<bool>(show_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_slider_min_max_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* min_, double* max_)
{
   static_cast<T*>(self->this_)->min_max_get(min_, max_);
}

template <typename T>
void _elm_slider_min_max_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double min_, double max_)
{
   static_cast<T*>(self->this_)->min_max_set(min_, max_);
}

template <typename T>
std::string _elm_slider_unit_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->unit_format_get();
}

template <typename T>
void _elm_slider_unit_format_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * units_)
{
   static_cast<T*>(self->this_)->unit_format_set(efl::eolian::to_cxx<std::string>(units_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_slider_indicator_show_on_focus_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->indicator_show_on_focus_get();
}

template <typename T>
void _elm_slider_indicator_show_on_focus_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool flag_)
{
   static_cast<T*>(self->this_)->indicator_show_on_focus_set(efl::eolian::to_cxx<bool>(flag_, std::tuple<std::false_type>()));
}

template <typename T>
Evas_Coord _elm_slider_span_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->span_size_get();
}

template <typename T>
void _elm_slider_span_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord size_)
{
   static_cast<T*>(self->this_)->span_size_set(size_);
}

template <typename T>
double _elm_slider_step_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->step_get();
}

template <typename T>
void _elm_slider_step_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double step_)
{
   static_cast<T*>(self->this_)->step_set(step_);
}

template <typename T>
void _elm_slider_indicator_format_function_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, slider_func_type func_, slider_freefunc_type free_func_)
{
   static_cast<T*>(self->this_)->indicator_format_function_set(func_, free_func_);
}

template <typename T>
void _elm_slider_units_format_function_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, slider_func_type func_, slider_freefunc_type free_func_)
{
   static_cast<T*>(self->this_)->units_format_function_set(func_, free_func_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_slider >
{
   template <typename T>
   struct type
   {
      virtual bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void horizontal_set(bool horizontal_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      virtual double value_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_value_get());
            return _tmp_ret;
      }

      virtual void value_set(double val_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_value_set(val_));
      }

      virtual std::string indicator_format_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_format_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_format_set(std::string indicator_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_format_set(efl::eolian::to_c(indicator_)));
      }

      virtual bool inverted_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_inverted_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void inverted_set(bool inverted_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_inverted_set(efl::eolian::to_c(inverted_)));
      }

      virtual bool indicator_show_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_show_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_show_set(bool show_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_show_set(efl::eolian::to_c(show_)));
      }

      virtual void min_max_get(double* min_, double* max_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_min_max_get(min_, max_));
      }

      virtual void min_max_set(double min_, double max_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_min_max_set(min_, max_));
      }

      virtual std::string unit_format_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_unit_format_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void unit_format_set(std::string units_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_unit_format_set(efl::eolian::to_c(units_)));
      }

      virtual bool indicator_show_on_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void indicator_show_on_focus_set(bool flag_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_show_on_focus_set(efl::eolian::to_c(flag_)));
      }

      virtual Evas_Coord span_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_span_size_get());
            return _tmp_ret;
      }

      virtual void span_size_set(Evas_Coord size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_span_size_set(size_));
      }

      virtual double step_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_slider_step_get());
            return _tmp_ret;
      }

      virtual void step_set(double step_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_step_set(step_));
      }

      virtual void indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
      }

      virtual void units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_slider_units_format_function_set(func_, free_func_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_slider >
{
   static const int value = 22;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_slider>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_slider_horizontal_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_horizontal_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_slider_horizontal_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_horizontal_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_slider_value_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_value_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_slider_value_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_value_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_format_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_format_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_slider_inverted_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_inverted_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_slider_inverted_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_inverted_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_show_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_show_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_slider_min_max_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_min_max_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_slider_min_max_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_min_max_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_slider_unit_format_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_unit_format_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_slider_unit_format_set_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_unit_format_set);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_show_on_focus_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_on_focus_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_show_on_focus_set_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_show_on_focus_set);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_slider_span_size_get_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_span_size_get);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_slider_span_size_set_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_span_size_set);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_slider_step_get_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_step_get);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_slider_step_set_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_step_set);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_slider_indicator_format_function_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_indicator_format_function_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_slider_units_format_function_set_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_obj_slider_units_format_function_set);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_slider >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_slider, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_slider >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_slider, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_slider>
{
   template <typename U>
   struct type
   {
      operator ::elm_slider() const
      {
         return ::elm_slider(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool horizontal_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_horizontal_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void horizontal_set(bool horizontal_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_horizontal_set(efl::eolian::to_c(horizontal_)));
      }

      double value_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_value_get());
            return _tmp_ret;
      }

      void value_set(double val_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_value_set(val_));
      }

      std::string indicator_format_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_format_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void indicator_format_set(std::string indicator_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_indicator_format_set(efl::eolian::to_c(indicator_)));
      }

      bool inverted_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_inverted_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void inverted_set(bool inverted_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_inverted_set(efl::eolian::to_c(inverted_)));
      }

      bool indicator_show_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void indicator_show_set(bool show_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_indicator_show_set(efl::eolian::to_c(show_)));
      }

      void min_max_get(double* min_, double* max_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_min_max_get(min_, max_));
      }

      void min_max_set(double min_, double max_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_min_max_set(min_, max_));
      }

      std::string unit_format_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_unit_format_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void unit_format_set(std::string units_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_unit_format_set(efl::eolian::to_c(units_)));
      }

      bool indicator_show_on_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_indicator_show_on_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void indicator_show_on_focus_set(bool flag_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_indicator_show_on_focus_set(efl::eolian::to_c(flag_)));
      }

      Evas_Coord span_size_get()
      {
         Evas_Coord _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_span_size_get());
            return _tmp_ret;
      }

      void span_size_set(Evas_Coord size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_span_size_set(size_));
      }

      double step_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_slider_step_get());
            return _tmp_ret;
      }

      void step_set(double step_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_step_set(step_));
      }

      void indicator_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_indicator_format_function_set(func_, free_func_));
      }

      void units_format_function_set(slider_func_type func_, slider_freefunc_type free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_slider_units_format_function_set(func_, free_func_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_CHANGED );
   }

   template <typename T>
   void
   callback_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_delay_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_DELAY_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_DELAY_CHANGED );
   }

   template <typename T>
   void
   callback_delay_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_DELAY_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slider_drag_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_SLIDER_DRAG_START, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_SLIDER_DRAG_START );
   }

   template <typename T>
   void
   callback_slider_drag_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_SLIDER_DRAG_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_slider_drag_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_SLIDER_DRAG_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_SLIDER_DRAG_STOP );
   }

   template <typename T>
   void
   callback_slider_drag_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_SLIDER_DRAG_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_language_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_LANGUAGE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_LANGUAGE_CHANGED );
   }

   template <typename T>
   void
   callback_language_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_LANGUAGE_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_access_changed_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_ACCESS_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_ACCESS_CHANGED );
   }

   template <typename T>
   void
   callback_access_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_ACCESS_CHANGED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_focused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_FOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_FOCUSED );
   }

   template <typename T>
   void
   callback_focused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_FOCUSED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_unfocused_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_SLIDER_EVENT_UNFOCUSED, priority_,
            &efl::eo::_detail::event_callback<::elm_slider, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_slider, function_type>,
         ELM_SLIDER_EVENT_UNFOCUSED );
   }

   template <typename T>
   void
   callback_unfocused_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_SLIDER_EVENT_UNFOCUSED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_slider>)
{
   return (ELM_SLIDER_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_SLIDER_HH

