#ifndef EFL_GENERATED_ELM_SYSTRAY_HH
#define EFL_GENERATED_ELM_SYSTRAY_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_systray.eo.h"
}

#include <string>

struct elm_systray
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_systray(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_systray(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_systray(elm_systray const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_systray() {}

   /// @brief Register this Status Notifier Item in the System Tray Watcher. This function should only be called after the event ELM_EVENT_SYSTRAY_READY is emitted.
   ///
   bool register_() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_register());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param id 
   ///
   std::string id_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_id_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param id 
   ///
   void id_set(std::string id_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_id_set(efl::eolian::to_c(id_)));
   }

   /// @param cat Category
   ///
   Elm_Systray_Category category_get() const
   {
      Elm_Systray_Category _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_category_get());
      return _tmp_ret;
   }

   /// @param cat Category
   ///
   void category_set(Elm_Systray_Category cat_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_category_set(cat_));
   }

   /// @param icon_theme_path 
   ///
   std::string icon_theme_path_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param icon_theme_path 
   ///
   void icon_theme_path_set(std::string icon_theme_path_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_icon_theme_path_set(efl::eolian::to_c(icon_theme_path_)));
   }

   /// @param menu 
   ///
   const Eo * menu_get() const
   {
      const Eo * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_menu_get());
      return _tmp_ret;
   }

   /// @param menu 
   ///
   void menu_set(const Eo * menu_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_menu_set(menu_));
   }

   /// @param att_icon_name 
   ///
   std::string att_icon_name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_att_icon_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param att_icon_name 
   ///
   void att_icon_name_set(std::string att_icon_name_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_att_icon_name_set(efl::eolian::to_c(att_icon_name_)));
   }

   /// @param st Status
   ///
   Elm_Systray_Status status_get() const
   {
      Elm_Systray_Status _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_status_get());
      return _tmp_ret;
   }

   /// @param st Status
   ///
   void status_set(Elm_Systray_Status st_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_status_set(st_));
   }

   /// @param icon_name 
   ///
   std::string icon_name_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_name_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param icon_name 
   ///
   void icon_name_set(std::string icon_name_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_icon_name_set(efl::eolian::to_c(icon_name_)));
   }

   /// @param title 
   ///
   std::string title_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_systray_title_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param title 
   ///
   void title_set(std::string title_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_systray_title_set(efl::eolian::to_c(title_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_SYSTRAY_CLASS);
   }

private:
};
template <typename T>
bool _elm_systray_register__wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->register_();
}

template <typename T>
std::string _elm_systray_id_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->id_get();
}

template <typename T>
void _elm_systray_id_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * id_)
{
   static_cast<T*>(self->this_)->id_set(efl::eolian::to_cxx<std::string>(id_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Systray_Category _elm_systray_category_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->category_get();
}

template <typename T>
void _elm_systray_category_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Systray_Category cat_)
{
   static_cast<T*>(self->this_)->category_set(cat_);
}

template <typename T>
std::string _elm_systray_icon_theme_path_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->icon_theme_path_get();
}

template <typename T>
void _elm_systray_icon_theme_path_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * icon_theme_path_)
{
   static_cast<T*>(self->this_)->icon_theme_path_set(efl::eolian::to_cxx<std::string>(icon_theme_path_, std::tuple<std::false_type>()));
}

template <typename T>
const Eo * _elm_systray_menu_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->menu_get();
}

template <typename T>
void _elm_systray_menu_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Eo * menu_)
{
   static_cast<T*>(self->this_)->menu_set(menu_);
}

template <typename T>
std::string _elm_systray_att_icon_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->att_icon_name_get();
}

template <typename T>
void _elm_systray_att_icon_name_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * att_icon_name_)
{
   static_cast<T*>(self->this_)->att_icon_name_set(efl::eolian::to_cxx<std::string>(att_icon_name_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Systray_Status _elm_systray_status_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->status_get();
}

template <typename T>
void _elm_systray_status_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Systray_Status st_)
{
   static_cast<T*>(self->this_)->status_set(st_);
}

template <typename T>
std::string _elm_systray_icon_name_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->icon_name_get();
}

template <typename T>
void _elm_systray_icon_name_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * icon_name_)
{
   static_cast<T*>(self->this_)->icon_name_set(efl::eolian::to_cxx<std::string>(icon_name_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_systray_title_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->title_get();
}

template <typename T>
void _elm_systray_title_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   static_cast<T*>(self->this_)->title_set(efl::eolian::to_cxx<std::string>(title_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_systray >
{
   template <typename T>
   struct type
   {
      virtual bool register_()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_register());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string id_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_id_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void id_set(std::string id_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_id_set(efl::eolian::to_c(id_)));
      }

      virtual Elm_Systray_Category category_get()
      {
         Elm_Systray_Category _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_category_get());
            return _tmp_ret;
      }

      virtual void category_set(Elm_Systray_Category cat_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_category_set(cat_));
      }

      virtual std::string icon_theme_path_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_theme_path_set(std::string icon_theme_path_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_icon_theme_path_set(efl::eolian::to_c(icon_theme_path_)));
      }

      virtual const Eo * menu_get()
      {
         const Eo * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_menu_get());
            return _tmp_ret;
      }

      virtual void menu_set(const Eo * menu_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_menu_set(menu_));
      }

      virtual std::string att_icon_name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_att_icon_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void att_icon_name_set(std::string att_icon_name_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_att_icon_name_set(efl::eolian::to_c(att_icon_name_)));
      }

      virtual Elm_Systray_Status status_get()
      {
         Elm_Systray_Status _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_status_get());
            return _tmp_ret;
      }

      virtual void status_set(Elm_Systray_Status st_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_status_set(st_));
      }

      virtual std::string icon_name_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_icon_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_name_set(std::string icon_name_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_icon_name_set(efl::eolian::to_c(icon_name_)));
      }

      virtual std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void title_set(std::string title_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_title_set(efl::eolian::to_c(title_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_systray >
{
   static const int value = 17;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_systray>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_systray_register__wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_register);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_systray_id_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_id_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_systray_id_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_id_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_systray_category_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_category_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_systray_category_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_category_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_systray_icon_theme_path_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_theme_path_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_systray_icon_theme_path_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_theme_path_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_systray_menu_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_menu_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_systray_menu_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_menu_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_systray_att_icon_name_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_att_icon_name_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_systray_att_icon_name_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_att_icon_name_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_systray_status_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_status_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_systray_status_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_status_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_systray_icon_name_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_name_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_systray_icon_name_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_name_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_systray_title_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_title_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_systray_title_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_title_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_systray >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_systray, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_systray>
{
   template <typename U>
   struct type
   {
      operator ::elm_systray() const
      {
         return ::elm_systray(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      bool register_()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_register());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string id_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_id_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void id_set(std::string id_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_id_set(efl::eolian::to_c(id_)));
      }

      Elm_Systray_Category category_get()
      {
         Elm_Systray_Category _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_category_get());
            return _tmp_ret;
      }

      void category_set(Elm_Systray_Category cat_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_category_set(cat_));
      }

      std::string icon_theme_path_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void icon_theme_path_set(std::string icon_theme_path_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_icon_theme_path_set(efl::eolian::to_c(icon_theme_path_)));
      }

      const Eo * menu_get()
      {
         const Eo * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_menu_get());
            return _tmp_ret;
      }

      void menu_set(const Eo * menu_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_menu_set(menu_));
      }

      std::string att_icon_name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_att_icon_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void att_icon_name_set(std::string att_icon_name_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_att_icon_name_set(efl::eolian::to_c(att_icon_name_)));
      }

      Elm_Systray_Status status_get()
      {
         Elm_Systray_Status _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_status_get());
            return _tmp_ret;
      }

      void status_set(Elm_Systray_Status st_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_status_set(st_));
      }

      std::string icon_name_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_name_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void icon_name_set(std::string icon_name_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_icon_name_set(efl::eolian::to_c(icon_name_)));
      }

      std::string title_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_systray_title_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void title_set(std::string title_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_systray_title_set(efl::eolian::to_c(title_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_systray>)
{
   return (ELM_SYSTRAY_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_SYSTRAY_HH

