#ifndef EFL_GENERATED_ELM_THUMB_HH
#define EFL_GENERATED_ELM_THUMB_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_thumb.eo.h"
}

#include "elm_layout.eo.hh"
#include "evas_clickable_interface.eo.hh"
#include <string>

struct elm_thumb
      : elm_layout,
      efl::eo::detail::extension_inheritance<evas::clickable_interface>::template type< ::elm_thumb>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_thumb(Eo* eo)
      : elm_layout(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_thumb(std::nullptr_t)
      : elm_layout(nullptr)
   {}

   elm_thumb(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_thumb(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_thumb(elm_thumb const& other)
      : elm_layout(eo_ref(other._eo_ptr()))
   {}

   ~elm_thumb() {}

   /// @brief Reload thumbnail if it was generated before.
   ///
   /// This is useful if the ethumb client configuration changed, like its
   /// size, aspect or any other property one set in the handle returned
   /// by elm_thumb_ethumb_client_get().
   ///
   /// If the options didn't change, the thumbnail won't be generated again, but
   /// the old one will still be used.
   ///
   /// @see elm_thumb_file_set()
   ///
   /// @ingroup Thumb
   ///
   void reload() const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_reload());
   }

   /// @param compress The compression of the thumb.
   ///
   void compress_get(int* compress_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_compress_get(compress_));
   }

   /// @param compress The compression of the thumb.
   ///
   void compress_set(int compress_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_compress_set(compress_));
   }

   /// @param format The format setting.
   ///
   Ethumb_Thumb_Format format_get() const
   {
      Ethumb_Thumb_Format _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_format_get());
      return _tmp_ret;
   }

   /// @param format The format setting.
   ///
   void format_set(Ethumb_Thumb_Format format_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_format_set(format_));
   }

   /// @param setting The animation setting.
   ///
   Elm_Thumb_Animation_Setting animate_get() const
   {
      Elm_Thumb_Animation_Setting _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_animate_get());
      return _tmp_ret;
   }

   /// @param setting The animation setting.
   ///
   void animate_set(Elm_Thumb_Animation_Setting setting_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_animate_set(setting_));
   }

   /// @param size The FDO size setting.
   ///
   Ethumb_Thumb_FDO_Size fdo_size_get() const
   {
      Ethumb_Thumb_FDO_Size _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_fdo_size_get());
      return _tmp_ret;
   }

   /// @param size The FDO size setting.
   ///
   void fdo_size_set(Ethumb_Thumb_FDO_Size size_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_fdo_size_set(size_));
   }

   /// @param file The path to file that will be used as thumbnail source.
   /// @param key The key used in case of an EET file.
   ///
   void file_get(const char ** file_, const char ** key_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_file_get(file_, key_));
   }

   /// @param file The path to file that will be used as thumbnail source.
   /// @param key The key used in case of an EET file.
   ///
   void file_set(std::string file_, std::string key_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
   }

   /// @param orient The orientation setting.
   ///
   Ethumb_Thumb_Orientation orientation_get() const
   {
      Ethumb_Thumb_Orientation _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_orientation_get());
      return _tmp_ret;
   }

   /// @param orient The orientation setting.
   ///
   void orientation_set(Ethumb_Thumb_Orientation orient_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_orientation_set(orient_));
   }

   /// @param edit Turn on or off editability. Default is @c EINA_FALSE.
   ///
   bool editable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param edit Turn on or off editability. Default is @c EINA_FALSE.
   ///
   bool editable_set(bool edit_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_set(efl::eolian::to_c(edit_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param aspect The aspect setting.
   ///
   Ethumb_Thumb_Aspect aspect_get() const
   {
      Ethumb_Thumb_Aspect _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_thumb_aspect_get());
      return _tmp_ret;
   }

   /// @param aspect The aspect setting.
   ///
   void aspect_set(Ethumb_Thumb_Aspect aspect_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_aspect_set(aspect_));
   }

   /// @param quality The quality of the thumb.
   ///
   void quality_get(int* quality_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_quality_get(quality_));
   }

   /// @param quality The quality of the thumb.
   ///
   void quality_set(int quality_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_quality_set(quality_));
   }

   /// @param tw The width of the thumb.
   /// @param th The height of the thumb.
   ///
   void size_get(int* tw_, int* th_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_size_get(tw_, th_));
   }

   /// @param tw The width of the thumb.
   /// @param th The height of the thumb.
   ///
   void size_set(int tw_, int th_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_size_set(tw_, th_));
   }

   /// @param cropx The x coordinate of the crop.
   /// @param cropy The y coordinate of the crop.
   ///
   void crop_align_get(double* cropx_, double* cropy_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
   }

   /// @param cropx The x coordinate of the crop.
   /// @param cropy The y coordinate of the crop.
   ///
   void crop_align_set(double cropx_, double cropy_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
   }

   /// @param file Pointer to thumb path.
   /// @param key Pointer to thumb key.
   ///
   void path_get(const char ** file_, const char ** key_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_thumb_path_get(file_, key_));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_ERROR );
   }

   template <typename T>
   void
   callback_generate_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_START, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_START );
   }

   template <typename T>
   void
   callback_generate_start_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_STOP );
   }

   template <typename T>
   void
   callback_generate_stop_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_LOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_LOAD_ERROR );
   }

   template <typename T>
   void
   callback_load_error_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_LOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_PRESS, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ELM_THUMB_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_THUMB_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _elm_thumb_reload_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->reload();
}

template <typename T>
void _elm_thumb_compress_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* compress_)
{
   static_cast<T*>(self->this_)->compress_get(compress_);
}

template <typename T>
void _elm_thumb_compress_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int compress_)
{
   static_cast<T*>(self->this_)->compress_set(compress_);
}

template <typename T>
Ethumb_Thumb_Format _elm_thumb_format_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->format_get();
}

template <typename T>
void _elm_thumb_format_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Format format_)
{
   static_cast<T*>(self->this_)->format_set(format_);
}

template <typename T>
Elm_Thumb_Animation_Setting _elm_thumb_animate_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->animate_get();
}

template <typename T>
void _elm_thumb_animate_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Thumb_Animation_Setting setting_)
{
   static_cast<T*>(self->this_)->animate_set(setting_);
}

template <typename T>
Ethumb_Thumb_FDO_Size _elm_thumb_fdo_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->fdo_size_get();
}

template <typename T>
void _elm_thumb_fdo_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_FDO_Size size_)
{
   static_cast<T*>(self->this_)->fdo_size_set(size_);
}

template <typename T>
void _elm_thumb_file_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char ** file_, const char ** key_)
{
   static_cast<T*>(self->this_)->file_get(file_, key_);
}

template <typename T>
void _elm_thumb_file_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * key_)
{
   static_cast<T*>(self->this_)->file_set(efl::eolian::to_cxx<std::string>(file_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
Ethumb_Thumb_Orientation _elm_thumb_orientation_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->orientation_get();
}

template <typename T>
void _elm_thumb_orientation_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Orientation orient_)
{
   static_cast<T*>(self->this_)->orientation_set(orient_);
}

template <typename T>
bool _elm_thumb_editable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->editable_get();
}

template <typename T>
bool _elm_thumb_editable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool edit_)
{
   return static_cast<T*>(self->this_)->editable_set(efl::eolian::to_cxx<bool>(edit_, std::tuple<std::false_type>()));
}

template <typename T>
Ethumb_Thumb_Aspect _elm_thumb_aspect_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->aspect_get();
}

template <typename T>
void _elm_thumb_aspect_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ethumb_Thumb_Aspect aspect_)
{
   static_cast<T*>(self->this_)->aspect_set(aspect_);
}

template <typename T>
void _elm_thumb_quality_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* quality_)
{
   static_cast<T*>(self->this_)->quality_get(quality_);
}

template <typename T>
void _elm_thumb_quality_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int quality_)
{
   static_cast<T*>(self->this_)->quality_set(quality_);
}

template <typename T>
void _elm_thumb_size_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int* tw_, int* th_)
{
   static_cast<T*>(self->this_)->size_get(tw_, th_);
}

template <typename T>
void _elm_thumb_size_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int tw_, int th_)
{
   static_cast<T*>(self->this_)->size_set(tw_, th_);
}

template <typename T>
void _elm_thumb_crop_align_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double* cropx_, double* cropy_)
{
   static_cast<T*>(self->this_)->crop_align_get(cropx_, cropy_);
}

template <typename T>
void _elm_thumb_crop_align_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double cropx_, double cropy_)
{
   static_cast<T*>(self->this_)->crop_align_set(cropx_, cropy_);
}

template <typename T>
void _elm_thumb_path_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char ** file_, const char ** key_)
{
   static_cast<T*>(self->this_)->path_get(file_, key_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_thumb >
{
   template <typename T>
   struct type
   {
      virtual void reload()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_reload());
      }

      virtual void compress_get(int* compress_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_compress_get(compress_));
      }

      virtual void compress_set(int compress_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_compress_set(compress_));
      }

      virtual Ethumb_Thumb_Format format_get()
      {
         Ethumb_Thumb_Format _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_format_get());
            return _tmp_ret;
      }

      virtual void format_set(Ethumb_Thumb_Format format_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_format_set(format_));
      }

      virtual Elm_Thumb_Animation_Setting animate_get()
      {
         Elm_Thumb_Animation_Setting _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_animate_get());
            return _tmp_ret;
      }

      virtual void animate_set(Elm_Thumb_Animation_Setting setting_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_animate_set(setting_));
      }

      virtual Ethumb_Thumb_FDO_Size fdo_size_get()
      {
         Ethumb_Thumb_FDO_Size _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_fdo_size_get());
            return _tmp_ret;
      }

      virtual void fdo_size_set(Ethumb_Thumb_FDO_Size size_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_fdo_size_set(size_));
      }

      virtual void file_get(const char ** file_, const char ** key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_file_get(file_, key_));
      }

      virtual void file_set(std::string file_, std::string key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      virtual Ethumb_Thumb_Orientation orientation_get()
      {
         Ethumb_Thumb_Orientation _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_orientation_get());
            return _tmp_ret;
      }

      virtual void orientation_set(Ethumb_Thumb_Orientation orient_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_orientation_set(orient_));
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool editable_set(bool edit_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_editable_set(efl::eolian::to_c(edit_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Ethumb_Thumb_Aspect aspect_get()
      {
         Ethumb_Thumb_Aspect _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_thumb_aspect_get());
            return _tmp_ret;
      }

      virtual void aspect_set(Ethumb_Thumb_Aspect aspect_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_aspect_set(aspect_));
      }

      virtual void quality_get(int* quality_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_quality_get(quality_));
      }

      virtual void quality_set(int quality_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_quality_set(quality_));
      }

      virtual void size_get(int* tw_, int* th_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_size_get(tw_, th_));
      }

      virtual void size_set(int tw_, int th_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_size_set(tw_, th_));
      }

      virtual void crop_align_get(double* cropx_, double* cropy_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
      }

      virtual void crop_align_set(double cropx_, double cropy_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
      }

      virtual void path_get(const char ** file_, const char ** key_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_thumb_path_get(file_, key_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_thumb >
{
   static const int value = 24;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_thumb>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_thumb_reload_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_reload);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_thumb_compress_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_compress_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_thumb_compress_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_compress_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_thumb_format_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_format_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_thumb_format_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_format_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_thumb_animate_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_animate_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_thumb_animate_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_animate_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_thumb_fdo_size_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_fdo_size_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_thumb_fdo_size_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_fdo_size_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_thumb_file_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_file_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_thumb_file_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_file_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_thumb_orientation_get_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_orientation_get);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_thumb_orientation_set_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_orientation_set);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_thumb_editable_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_editable_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_thumb_editable_set_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_editable_set);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_thumb_aspect_get_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_aspect_get);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_thumb_aspect_set_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_aspect_set);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_thumb_quality_get_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_quality_get);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_thumb_quality_set_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_quality_set);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_thumb_size_get_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_size_get);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_thumb_size_set_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_size_set);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_thumb_crop_align_get_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_crop_align_get);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_elm_thumb_crop_align_set_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_crop_align_set);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_elm_thumb_path_get_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::elm_obj_thumb_path_get);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_thumb >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_thumb, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_thumb >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_thumb, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_thumb>
{
   template <typename U>
   struct type
   {
      operator ::elm_thumb() const
      {
         return ::elm_thumb(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void reload()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_reload());
      }

      void compress_get(int* compress_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_compress_get(compress_));
      }

      void compress_set(int compress_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_compress_set(compress_));
      }

      Ethumb_Thumb_Format format_get()
      {
         Ethumb_Thumb_Format _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_format_get());
            return _tmp_ret;
      }

      void format_set(Ethumb_Thumb_Format format_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_format_set(format_));
      }

      Elm_Thumb_Animation_Setting animate_get()
      {
         Elm_Thumb_Animation_Setting _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_animate_get());
            return _tmp_ret;
      }

      void animate_set(Elm_Thumb_Animation_Setting setting_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_animate_set(setting_));
      }

      Ethumb_Thumb_FDO_Size fdo_size_get()
      {
         Ethumb_Thumb_FDO_Size _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_fdo_size_get());
            return _tmp_ret;
      }

      void fdo_size_set(Ethumb_Thumb_FDO_Size size_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_fdo_size_set(size_));
      }

      void file_get(const char ** file_, const char ** key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_file_get(file_, key_));
      }

      void file_set(std::string file_, std::string key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_file_set(efl::eolian::to_c(file_), efl::eolian::to_c(key_)));
      }

      Ethumb_Thumb_Orientation orientation_get()
      {
         Ethumb_Thumb_Orientation _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_orientation_get());
            return _tmp_ret;
      }

      void orientation_set(Ethumb_Thumb_Orientation orient_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_orientation_set(orient_));
      }

      bool editable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool editable_set(bool edit_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_editable_set(efl::eolian::to_c(edit_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      Ethumb_Thumb_Aspect aspect_get()
      {
         Ethumb_Thumb_Aspect _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_thumb_aspect_get());
            return _tmp_ret;
      }

      void aspect_set(Ethumb_Thumb_Aspect aspect_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_aspect_set(aspect_));
      }

      void quality_get(int* quality_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_quality_get(quality_));
      }

      void quality_set(int quality_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_quality_set(quality_));
      }

      void size_get(int* tw_, int* th_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_size_get(tw_, th_));
      }

      void size_set(int tw_, int th_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_size_set(tw_, th_));
      }

      void crop_align_get(double* cropx_, double* cropy_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_crop_align_get(cropx_, cropy_));
      }

      void crop_align_set(double cropx_, double cropy_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_crop_align_set(cropx_, cropy_));
      }

      void path_get(const char ** file_, const char ** key_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_thumb_path_get(file_, key_));
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_CLICKED, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_CLICKED );
   }

   template <typename T>
   void
   callback_clicked_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_CLICKED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_clicked_double_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_CLICKED_DOUBLE, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_CLICKED_DOUBLE );
   }

   template <typename T>
   void
   callback_clicked_double_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_CLICKED_DOUBLE, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_ERROR );
   }

   template <typename T>
   void
   callback_generate_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_start_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_START, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_START );
   }

   template <typename T>
   void
   callback_generate_start_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_START, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_generate_stop_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_GENERATE_STOP, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_GENERATE_STOP );
   }

   template <typename T>
   void
   callback_generate_stop_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_GENERATE_STOP, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_load_error_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_LOAD_ERROR, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_LOAD_ERROR );
   }

   template <typename T>
   void
   callback_load_error_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_LOAD_ERROR, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_press_add(F && callback_,
                                 ::efl::eo::callback_priority priority_ =
                                 ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_THUMB_EVENT_PRESS, priority_,
            &efl::eo::_detail::event_callback<::elm_thumb, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::elm_thumb, function_type>,
         ELM_THUMB_EVENT_PRESS );
   }

   template <typename T>
   void
   callback_press_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ELM_THUMB_EVENT_PRESS, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::elm_thumb>)
{
   return (ELM_THUMB_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_THUMB_HH

