#ifndef EFL_GENERATED_ELM_WIDGET_HH
#define EFL_GENERATED_ELM_WIDGET_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_widget.eo.h"
}

#include "evas_object_smart.eo.hh"
#include "elm_interface_atspi_widget.eo.hh"
#include <canvas/evas_object.eo.hh>
#include <eina-cxx/eina_list.hh>
#include <eina-cxx/eina_ptrlist.hh>
#include <string>

struct elm_widget
      : evas::object_smart,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_widget>::template type< ::elm_widget>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_widget(Eo* eo)
      : evas::object_smart(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_widget(std::nullptr_t)
      : evas::object_smart(nullptr)
   {}

   elm_widget(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_widget(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_widget(elm_widget const& other)
      : evas::object_smart(eo_ref(other._eo_ptr()))
   {}

   ~elm_widget() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param[out] newest_focus_order 
   /// @param can_focus_only 
   ///
   evas::object newest_focus_order_get(unsigned int* newest_focus_order_, bool can_focus_only_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_newest_focus_order_get(newest_focus_order_, efl::eolian::to_c(can_focus_only_)));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void scroll_hold_push() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_scroll_hold_push());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param cur 
   ///
   void cursor_add(Elm_Cursor * cur_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_cursor_add(cur_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param next 
   /// @param dir 
   ///
   void focus_next_object_set(evas::object next_, Elm_Focus_Direction dir_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_next_object_set(efl::eolian::to_c(next_), dir_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param dir 
   ///
   evas::object focus_next_object_get(Elm_Focus_Direction dir_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_object_get(dir_));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_tree_unfocusable_handle() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_tree_unfocusable_handle());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param child 
   /// @param relative_child 
   ///
   void focus_custom_chain_prepend(evas::object child_, evas::object relative_child_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_custom_chain_prepend(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param part 
   /// @param text 
   ///
   std::string part_text_translate(std::string part_, std::string text_) const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_part_text_translate(efl::eolian::to_c(part_), efl::eolian::to_c(text_)));
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Get the focus highlight geometry of widget.
   ///
   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   void focus_highlight_geometry_get(Evas_Coord * x_, Evas_Coord * y_, Evas_Coord * w_, Evas_Coord * h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_highlight_geometry_get(x_, y_, w_, h_));
   }

   /// @brief 'Virtual' function to activate widget.
   ///
   /// @param act 
   ///
   bool activate(Elm_Activate act_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_activate(act_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief 'Virtual' function handling sub objects being added.
   ///
   /// @param sobj 
   ///
   bool sub_object_add(evas::object sobj_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_sub_object_add(efl::eolian::to_c(sobj_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief 'Virtual' function which checks if handling of passing focus to sub-objects in given direction is supported by widget.
   ///
   bool focus_direction_manager_is() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_manager_is());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief 'Virtual' function handling input events on the widget.
   ///
   /// @param source 
   /// @param type 
   /// @param event_info 
   ///
   bool event(evas::object source_, Evas_Callback_Type type_, void * event_info_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_event(efl::eolian::to_c(source_), type_, event_info_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param func 
   /// @param data 
   ///
   void event_callback_add(Elm_Event_Cb func_, const void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_event_callback_add(func_, data_));
   }

   /// @brief 'Virtual' function on the widget being set access.
   ///
   /// @param acs 
   ///
   void access(bool acs_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_access(efl::eolian::to_c(acs_)));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param cur 
   ///
   void cursor_del(Elm_Cursor * cur_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_cursor_del(cur_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param func 
   /// @param data 
   ///
   void * event_callback_del(Elm_Event_Cb func_, const void * data_) const
   {
      void * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_event_callback_del(func_, data_));
      return _tmp_ret;
   }

   /// @brief 'Virtual' function handling focus in/out events on the widget.
   /// return EINA_TRUE if this widget can handle focus, EINA_FALSE otherwise
   ///
   bool on_focus() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_on_focus());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief 'Virtual' function returning an inner area of a widget that should be brought into the visible area of a broader viewport, may this context arise.
   ///
   /// @param[out] x 
   /// @param[out] y 
   /// @param[out] w 
   /// @param[out] h 
   ///
   bool on_focus_region(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_on_focus_region(x_, y_, w_, h_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param dir 
   ///
   void focus_cycle(Elm_Focus_Direction dir_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_cycle(dir_));
   }

   /// @brief 'Virtual' function handling passing focus to sub-objects given a direction, in degrees.
   ///
   /// @param base 
   /// @param degree 
   /// @param[out] direction 
   /// @param[out] weight 
   ///
   bool focus_direction(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction(base_, degree_, direction_, weight_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param type 
   /// @param event_info 
   /// @param event_flags 
   ///
   bool event_propagate(Evas_Callback_Type type_, void * event_info_, Evas_Event_Flags * event_flags_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_event_propagate(type_, event_info_, event_flags_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param emission 
   /// @param source 
   /// @param func 
   /// @param data 
   ///
   void signal_callback_add(std::string emission_, std::string source_, Edje_Signal_Cb func_, void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_signal_callback_add(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_, data_));
   }

   /// @brief 'Virtual' function which checks if handling of passing focus to sub-objects is supported by widget.
   ///
   bool focus_next_manager_is() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_manager_is());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param name 
   /// @param recurse 
   ///
   evas::object name_find(std::string name_, int recurse_) const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_name_find(efl::eolian::to_c(name_), recurse_));
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param base 
   /// @param items 
   /// @param list_data_get 
   /// @param degree 
   /// @param[out] direction 
   /// @param[out] weight 
   ///
   bool focus_list_direction_get(const Evas_Object * base_, const Eina_List * items_, list_data_get_func_type list_data_get_, double degree_, Evas_Object ** direction_, double* weight_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_list_direction_get(base_, items_, list_data_get_, degree_, direction_, weight_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focused_object_clear() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focused_object_clear());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param degree 
   ///
   bool focus_direction_go(double degree_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_go(degree_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   /// @param forceshow 
   ///
   void show_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_, bool forceshow_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_show_region_set(x_, y_, w_, h_, efl::eolian::to_c(forceshow_)));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param[out] x 
   /// @param[out] y 
   /// @param[out] w 
   /// @param[out] h 
   ///
   void show_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_show_region_get(x_, y_, w_, h_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   void scroll_freeze_pop() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_scroll_freeze_pop());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param tt 
   ///
   void tooltip_del(Elm_Tooltip * tt_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_tooltip_del(tt_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param dir 
   /// @param[out] next 
   ///
   bool focus_next_get(Elm_Focus_Direction dir_, Evas_Object ** next_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_get(dir_, next_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param part 
   ///
   std::string translatable_part_text_get(std::string part_) const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_translatable_part_text_get(efl::eolian::to_c(part_)));
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief @internal
   ///
   /// Restore the focus state of the sub-tree.
   ///
   /// This API will restore the focus state of the sub-tree to the latest
   /// state. If a sub-tree is unfocused and wants to get back to the latest
   /// focus state, this API will be helpful.
   ///
   /// @ingroup Widget
   ///
   void focus_restore() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_restore());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void scroll_hold_pop() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_scroll_hold_pop());
   }

   /// @brief 'Virtual' function handling language changes on Elementary.
   ///
   bool translate() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_translate());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void scroll_freeze_push() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_scroll_freeze_push());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_custom_chain_unset() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_custom_chain_unset());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_steal() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_steal());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_hide_handle() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_hide_handle());
   }

   /// @brief 'Virtual' function handling passing focus to sub-objects.
   ///
   /// @param dir 
   /// @param[out] next 
   ///
   bool focus_next(Elm_Focus_Direction dir_, Evas_Object ** next_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next(dir_, next_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param items 
   /// @param list_data_get 
   /// @param dir 
   /// @param[out] next 
   ///
   bool focus_list_next_get(const Eina_List * items_, list_data_get_func_type list_data_get_, Elm_Focus_Direction dir_, Evas_Object ** next_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_list_next_get(items_, list_data_get_, dir_, next_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_mouse_up_handle() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_mouse_up_handle());
   }

   /// @brief 'Virtual' function on the widget being re-themed.
   ///
   bool theme_apply() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_apply());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param base 
   /// @param degree 
   /// @param[out] direction 
   /// @param[out] weight 
   ///
   bool focus_direction_get(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_get(base_, degree_, direction_, weight_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param emission 
   /// @param source 
   /// @param func 
   ///
   void * signal_callback_del(std::string emission_, std::string source_, Edje_Signal_Cb func_) const
   {
      void * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_signal_callback_del(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_));
      return _tmp_ret;
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param emission 
   /// @param source 
   ///
   void signal_emit(std::string emission_, std::string source_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_signal_emit(efl::eolian::to_c(emission_), efl::eolian::to_c(source_)));
   }

   /// @brief 'Virtual' function on the widget being disabled.
   ///
   bool disable() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_disable());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief 'Virtual' function handling sub objects being removed.
   ///
   /// @param sobj 
   ///
   bool sub_object_del(evas::object sobj_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_sub_object_del(efl::eolian::to_c(sobj_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param tt 
   ///
   void tooltip_add(Elm_Tooltip * tt_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_tooltip_add(tt_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_region_show() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_region_show());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void focus_disabled_handle() const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_disabled_handle());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param child 
   /// @param relative_child 
   ///
   void focus_custom_chain_append(evas::object child_, evas::object relative_child_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_custom_chain_append(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
   }

   /// @param focus 
   ///
   bool focus_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param focus 
   ///
   void focus_set(bool focus_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_set(efl::eolian::to_c(focus_)));
   }

   /// @param lock 
   ///
   bool drag_lock_y_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_lock_y_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param lock 
   ///
   void drag_lock_y_set(bool lock_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_drag_lock_y_set(efl::eolian::to_c(lock_)));
   }

   /// @param style 
   ///
   std::string focus_highlight_style_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_highlight_style_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param style 
   ///
   bool focus_highlight_style_set(std::string style_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_highlight_style_set(efl::eolian::to_c(style_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param tree_unfocusable 
   ///
   bool tree_unfocusable_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_tree_unfocusable_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param tree_unfocusable 
   ///
   void tree_unfocusable_set(bool tree_unfocusable_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_tree_unfocusable_set(efl::eolian::to_c(tree_unfocusable_)));
   }

   /// @param mirrored 
   ///
   bool mirrored_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_mirrored_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param mirrored 
   ///
   void mirrored_set(bool mirrored_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_mirrored_set(efl::eolian::to_c(mirrored_)));
   }

   /// @param th 
   ///
   Elm_Theme * theme_get() const
   {
      Elm_Theme * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_get());
      return _tmp_ret;
   }

   /// @param th 
   ///
   void theme_set(Elm_Theme * th_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_theme_set(th_));
   }

   /// @param disabled 
   ///
   bool disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled 
   ///
   void disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param ignore 
   ///
   bool highlight_ignore_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_ignore_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param ignore 
   ///
   void highlight_ignore_set(bool ignore_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_highlight_ignore_set(efl::eolian::to_c(ignore_)));
   }

   /// @param automatic 
   ///
   bool mirrored_automatic_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_mirrored_automatic_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param automatic 
   ///
   void mirrored_automatic_set(bool automatic_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_mirrored_automatic_set(efl::eolian::to_c(automatic_)));
   }

   /// @param disabled 
   ///
   bool orientation_mode_disabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_orientation_mode_disabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param disabled 
   ///
   void orientation_mode_disabled_set(bool disabled_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_orientation_mode_disabled_set(efl::eolian::to_c(disabled_)));
   }

   /// @param style 
   ///
   std::string style_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_style_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param style 
   ///
   bool style_set(std::string style_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_style_set(efl::eolian::to_c(style_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param scale 
   ///
   double scale_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_scale_get());
      return _tmp_ret;
   }

   /// @param scale 
   ///
   void scale_set(double scale_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_scale_set(scale_));
   }

   /// @param objs 
   ///
   const Eina_List * focus_custom_chain_get() const
   {
      const Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_custom_chain_get());
      return _tmp_ret;
   }

   /// @param objs 
   ///
   void focus_custom_chain_set(Eina_List * objs_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_focus_custom_chain_set(objs_));
   }

   /// @param can_focus 
   ///
   bool can_focus_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_can_focus_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param can_focus 
   ///
   void can_focus_set(bool can_focus_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_can_focus_set(efl::eolian::to_c(can_focus_)));
   }

   /// @param highlight 
   ///
   bool highlight_in_theme_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_in_theme_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param highlight 
   ///
   void highlight_in_theme_set(bool highlight_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
   }

   /// @param parent 
   ///
   evas::object parent_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param parent 
   ///
   void parent_set(evas::object parent_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_parent_set(efl::eolian::to_c(parent_)));
   }

   /// @param txt 
   ///
   std::string access_info_get() const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_access_info_get());
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param txt 
   ///
   void access_info_set(std::string txt_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_access_info_set(efl::eolian::to_c(txt_)));
   }

   /// @param lock 
   ///
   bool drag_lock_x_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_lock_x_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param lock 
   ///
   void drag_lock_x_set(bool lock_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_drag_lock_x_set(efl::eolian::to_c(lock_)));
   }

   /// @param highlight highlight
   ///
   bool access_highlight_in_theme_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_access_highlight_in_theme_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param highlight highlight
   ///
   void access_highlight_in_theme_set(bool highlight_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_access_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
   }

   /// @param highlighted 
   ///
   void parent_highlight_set(bool highlighted_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_parent_highlight_set(efl::eolian::to_c(highlighted_)));
   }

   /// @param edj 
   /// @param wname 
   /// @param welement 
   /// @param wstyle 
   ///
   bool theme_object_set(evas::object edj_, std::string wname_, std::string welement_, std::string wstyle_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_object_set(efl::eolian::to_c(edj_), efl::eolian::to_c(wname_), efl::eolian::to_c(welement_), efl::eolian::to_c(wstyle_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param sobj 
   ///
   void hover_object_set(evas::object sobj_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_hover_object_set(efl::eolian::to_c(sobj_)));
   }

   /// @param dispmode 
   ///
   void display_mode_set(Evas_Display_Mode dispmode_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_display_mode_set(dispmode_));
   }

   /// @param func 
   /// @param data 
   ///
   void on_show_region_hook_set(region_hook_func_type func_, void * data_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_on_show_region_hook_set(func_, data_));
   }

   /// @param part 
   /// @param domain 
   /// @param translatable 
   ///
   void domain_part_text_translatable_set(std::string part_, std::string domain_, bool translatable_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_domain_part_text_translatable_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(translatable_)));
   }

   /// @param rotation 
   ///
   void orientation_set(int rotation_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_orientation_set(rotation_));
   }

   /// @param sobj 
   /// @param sub_obj 
   ///
   void resize_object_set(evas::object sobj_, bool sub_obj_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_resize_object_set(efl::eolian::to_c(sobj_), efl::eolian::to_c(sub_obj_)));
   }

   /// @param part 
   /// @param domain 
   /// @param label 
   ///
   void domain_translatable_part_text_set(std::string part_, std::string domain_, std::string label_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_domain_translatable_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(label_)));
   }

   Eina_List * scrollable_children_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_scrollable_children_get());
      return _tmp_ret;
   }

   int scroll_hold_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_scroll_hold_get());
      return _tmp_ret;
   }

   int drag_child_locked_y_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_child_locked_y_get());
      return _tmp_ret;
   }

   /// @param enable 
   ///
   bool item_loop_enabled_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_item_loop_enabled_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param enable 
   ///
   void item_loop_enabled_set(bool enable_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_item_loop_enabled_set(efl::eolian::to_c(enable_)));
   }

   bool child_can_focus_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_child_can_focus_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   int scroll_freeze_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_scroll_freeze_get());
      return _tmp_ret;
   }

   /// @param x 
   /// @param y 
   /// @param w 
   /// @param h 
   ///
   bool focus_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_region_get(x_, y_, w_, h_));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   evas::object top_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_top_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   unsigned int focus_order_get() const
   {
      unsigned int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_order_get());
      return _tmp_ret;
   }

   int drag_child_locked_x_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_child_locked_x_get());
      return _tmp_ret;
   }

   Eina_List * can_focus_child_list_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_can_focus_child_list_get());
      return _tmp_ret;
   }

   Elm_Object_Item * focused_item_get() const
   {
      Elm_Object_Item * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focused_item_get());
      return _tmp_ret;
   }

   /// @param horiz 
   /// @param vert 
   ///
   void parents_bounce_get(Eina_Bool* horiz_, Eina_Bool* vert_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_parents_bounce_get(horiz_, vert_));
   }

   evas::object parent_widget_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent_widget_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   bool highlight_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   evas::object focused_object_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_focused_object_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param parent 
   ///
   evas::object parent2_get() const
   {
      Evas_Object * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent2_get());
      return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param parent 
   ///
   void parent2_set(evas::object parent_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_parent2_set(efl::eolian::to_c(parent_)));
   }

   /// @param label 
   ///
   std::string part_text_get(std::string part_) const
   {
      const char * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_obj_widget_part_text_get(efl::eolian::to_c(part_)));
      return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @param label 
   ///
   void part_text_set(std::string part_, std::string label_) const
   {
      eo_do(_eo_ptr(), ::elm_obj_widget_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(label_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_WIDGET_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_WIDGET_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
evas::object _elm_widget_newest_focus_order_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, unsigned int* newest_focus_order_, Eina_Bool can_focus_only_)
{
   return static_cast<T*>(self->this_)->newest_focus_order_get(newest_focus_order_, efl::eolian::to_cxx<bool>(can_focus_only_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_scroll_hold_push_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->scroll_hold_push();
}

template <typename T>
void _elm_widget_cursor_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Cursor * cur_)
{
   static_cast<T*>(self->this_)->cursor_add(cur_);
}

template <typename T>
void _elm_widget_focus_next_object_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * next_, Elm_Focus_Direction dir_)
{
   static_cast<T*>(self->this_)->focus_next_object_set(efl::eolian::to_cxx<evas::object>(next_, std::tuple<std::false_type>()), dir_);
}

template <typename T>
evas::object _elm_widget_focus_next_object_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Focus_Direction dir_)
{
   return static_cast<T*>(self->this_)->focus_next_object_get(dir_);
}

template <typename T>
void _elm_widget_focus_tree_unfocusable_handle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_tree_unfocusable_handle();
}

template <typename T>
void _elm_widget_focus_custom_chain_prepend_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * child_, Evas_Object * relative_child_)
{
   static_cast<T*>(self->this_)->focus_custom_chain_prepend(efl::eolian::to_cxx<evas::object>(child_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(relative_child_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_widget_part_text_translate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_, const char * text_)
{
   return static_cast<T*>(self->this_)->part_text_translate(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(text_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_focus_highlight_geometry_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord * x_, Evas_Coord * y_, Evas_Coord * w_, Evas_Coord * h_)
{
   static_cast<T*>(self->this_)->focus_highlight_geometry_get(x_, y_, w_, h_);
}

template <typename T>
bool _elm_widget_activate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Activate act_)
{
   return static_cast<T*>(self->this_)->activate(act_);
}

template <typename T>
bool _elm_widget_sub_object_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sobj_)
{
   return static_cast<T*>(self->this_)->sub_object_add(efl::eolian::to_cxx<evas::object>(sobj_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_focus_direction_manager_is_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_direction_manager_is();
}

template <typename T>
bool _elm_widget_event_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * source_, Evas_Callback_Type type_, void * event_info_)
{
   return static_cast<T*>(self->this_)->event(efl::eolian::to_cxx<evas::object>(source_, std::tuple<std::false_type>()), type_, event_info_);
}

template <typename T>
void _elm_widget_event_callback_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Event_Cb func_, const void * data_)
{
   static_cast<T*>(self->this_)->event_callback_add(func_, data_);
}

template <typename T>
void _elm_widget_access_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool acs_)
{
   static_cast<T*>(self->this_)->access(efl::eolian::to_cxx<bool>(acs_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_cursor_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Cursor * cur_)
{
   static_cast<T*>(self->this_)->cursor_del(cur_);
}

template <typename T>
void * _elm_widget_event_callback_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Event_Cb func_, const void * data_)
{
   return static_cast<T*>(self->this_)->event_callback_del(func_, data_);
}

template <typename T>
bool _elm_widget_on_focus_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->on_focus();
}

template <typename T>
bool _elm_widget_on_focus_region_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
{
   return static_cast<T*>(self->this_)->on_focus_region(x_, y_, w_, h_);
}

template <typename T>
void _elm_widget_focus_cycle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Focus_Direction dir_)
{
   static_cast<T*>(self->this_)->focus_cycle(dir_);
}

template <typename T>
bool _elm_widget_focus_direction_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
{
   return static_cast<T*>(self->this_)->focus_direction(base_, degree_, direction_, weight_);
}

template <typename T>
bool _elm_widget_event_propagate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Callback_Type type_, void * event_info_, Evas_Event_Flags * event_flags_)
{
   return static_cast<T*>(self->this_)->event_propagate(type_, event_info_, event_flags_);
}

template <typename T>
void _elm_widget_signal_callback_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * emission_, const char * source_, Edje_Signal_Cb func_, void * data_)
{
   static_cast<T*>(self->this_)->signal_callback_add(efl::eolian::to_cxx<std::string>(emission_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(source_, std::tuple<std::false_type>()), func_, data_);
}

template <typename T>
bool _elm_widget_focus_next_manager_is_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_next_manager_is();
}

template <typename T>
evas::object _elm_widget_name_find_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * name_, int recurse_)
{
   return static_cast<T*>(self->this_)->name_find(efl::eolian::to_cxx<std::string>(name_, std::tuple<std::false_type>()), recurse_);
}

template <typename T>
bool _elm_widget_focus_list_direction_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Evas_Object * base_, const Eina_List * items_, list_data_get_func_type list_data_get_, double degree_, Evas_Object ** direction_, double* weight_)
{
   return static_cast<T*>(self->this_)->focus_list_direction_get(base_, items_, list_data_get_, degree_, direction_, weight_);
}

template <typename T>
void _elm_widget_focused_object_clear_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focused_object_clear();
}

template <typename T>
bool _elm_widget_focus_direction_go_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double degree_)
{
   return static_cast<T*>(self->this_)->focus_direction_go(degree_);
}

template <typename T>
void _elm_widget_show_region_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_, Eina_Bool forceshow_)
{
   static_cast<T*>(self->this_)->show_region_set(x_, y_, w_, h_, efl::eolian::to_cxx<bool>(forceshow_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_show_region_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
{
   static_cast<T*>(self->this_)->show_region_get(x_, y_, w_, h_);
}

template <typename T>
void _elm_widget_scroll_freeze_pop_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->scroll_freeze_pop();
}

template <typename T>
void _elm_widget_tooltip_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Tooltip * tt_)
{
   static_cast<T*>(self->this_)->tooltip_del(tt_);
}

template <typename T>
bool _elm_widget_focus_next_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Focus_Direction dir_, Evas_Object ** next_)
{
   return static_cast<T*>(self->this_)->focus_next_get(dir_, next_);
}

template <typename T>
std::string _elm_widget_translatable_part_text_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_)
{
   return static_cast<T*>(self->this_)->translatable_part_text_get(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_focus_restore_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_restore();
}

template <typename T>
void _elm_widget_scroll_hold_pop_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->scroll_hold_pop();
}

template <typename T>
bool _elm_widget_translate_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->translate();
}

template <typename T>
void _elm_widget_scroll_freeze_push_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->scroll_freeze_push();
}

template <typename T>
void _elm_widget_focus_custom_chain_unset_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_custom_chain_unset();
}

template <typename T>
void _elm_widget_focus_steal_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_steal();
}

template <typename T>
void _elm_widget_focus_hide_handle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_hide_handle();
}

template <typename T>
bool _elm_widget_focus_next_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Focus_Direction dir_, Evas_Object ** next_)
{
   return static_cast<T*>(self->this_)->focus_next(dir_, next_);
}

template <typename T>
bool _elm_widget_focus_list_next_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Eina_List * items_, list_data_get_func_type list_data_get_, Elm_Focus_Direction dir_, Evas_Object ** next_)
{
   return static_cast<T*>(self->this_)->focus_list_next_get(items_, list_data_get_, dir_, next_);
}

template <typename T>
void _elm_widget_focus_mouse_up_handle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_mouse_up_handle();
}

template <typename T>
bool _elm_widget_theme_apply_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->theme_apply();
}

template <typename T>
bool _elm_widget_focus_direction_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
{
   return static_cast<T*>(self->this_)->focus_direction_get(base_, degree_, direction_, weight_);
}

template <typename T>
void * _elm_widget_signal_callback_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * emission_, const char * source_, Edje_Signal_Cb func_)
{
   return static_cast<T*>(self->this_)->signal_callback_del(efl::eolian::to_cxx<std::string>(emission_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(source_, std::tuple<std::false_type>()), func_);
}

template <typename T>
void _elm_widget_signal_emit_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * emission_, const char * source_)
{
   static_cast<T*>(self->this_)->signal_emit(efl::eolian::to_cxx<std::string>(emission_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(source_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_disable_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->disable();
}

template <typename T>
bool _elm_widget_sub_object_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sobj_)
{
   return static_cast<T*>(self->this_)->sub_object_del(efl::eolian::to_cxx<evas::object>(sobj_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_tooltip_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Tooltip * tt_)
{
   static_cast<T*>(self->this_)->tooltip_add(tt_);
}

template <typename T>
void _elm_widget_focus_region_show_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_region_show();
}

template <typename T>
void _elm_widget_focus_disabled_handle_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->focus_disabled_handle();
}

template <typename T>
void _elm_widget_focus_custom_chain_append_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * child_, Evas_Object * relative_child_)
{
   static_cast<T*>(self->this_)->focus_custom_chain_append(efl::eolian::to_cxx<evas::object>(child_, std::tuple<std::false_type>()), efl::eolian::to_cxx<evas::object>(relative_child_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_focus_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_get();
}

template <typename T>
void _elm_widget_focus_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool focus_)
{
   static_cast<T*>(self->this_)->focus_set(efl::eolian::to_cxx<bool>(focus_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_drag_lock_y_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->drag_lock_y_get();
}

template <typename T>
void _elm_widget_drag_lock_y_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool lock_)
{
   static_cast<T*>(self->this_)->drag_lock_y_set(efl::eolian::to_cxx<bool>(lock_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_widget_focus_highlight_style_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_highlight_style_get();
}

template <typename T>
bool _elm_widget_focus_highlight_style_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * style_)
{
   return static_cast<T*>(self->this_)->focus_highlight_style_set(efl::eolian::to_cxx<std::string>(style_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_tree_unfocusable_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->tree_unfocusable_get();
}

template <typename T>
void _elm_widget_tree_unfocusable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool tree_unfocusable_)
{
   static_cast<T*>(self->this_)->tree_unfocusable_set(efl::eolian::to_cxx<bool>(tree_unfocusable_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_mirrored_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->mirrored_get();
}

template <typename T>
void _elm_widget_mirrored_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool mirrored_)
{
   static_cast<T*>(self->this_)->mirrored_set(efl::eolian::to_cxx<bool>(mirrored_, std::tuple<std::false_type>()));
}

template <typename T>
Elm_Theme * _elm_widget_theme_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->theme_get();
}

template <typename T>
void _elm_widget_theme_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Elm_Theme * th_)
{
   static_cast<T*>(self->this_)->theme_set(th_);
}

template <typename T>
bool _elm_widget_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->disabled_get();
}

template <typename T>
void _elm_widget_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_highlight_ignore_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->highlight_ignore_get();
}

template <typename T>
void _elm_widget_highlight_ignore_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool ignore_)
{
   static_cast<T*>(self->this_)->highlight_ignore_set(efl::eolian::to_cxx<bool>(ignore_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_mirrored_automatic_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->mirrored_automatic_get();
}

template <typename T>
void _elm_widget_mirrored_automatic_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool automatic_)
{
   static_cast<T*>(self->this_)->mirrored_automatic_set(efl::eolian::to_cxx<bool>(automatic_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_orientation_mode_disabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->orientation_mode_disabled_get();
}

template <typename T>
void _elm_widget_orientation_mode_disabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool disabled_)
{
   static_cast<T*>(self->this_)->orientation_mode_disabled_set(efl::eolian::to_cxx<bool>(disabled_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_widget_style_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->style_get();
}

template <typename T>
bool _elm_widget_style_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * style_)
{
   return static_cast<T*>(self->this_)->style_set(efl::eolian::to_cxx<std::string>(style_, std::tuple<std::false_type>()));
}

template <typename T>
double _elm_widget_scale_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->scale_get();
}

template <typename T>
void _elm_widget_scale_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double scale_)
{
   static_cast<T*>(self->this_)->scale_set(scale_);
}

template <typename T>
const Eina_List * _elm_widget_focus_custom_chain_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_custom_chain_get();
}

template <typename T>
void _elm_widget_focus_custom_chain_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_List * objs_)
{
   static_cast<T*>(self->this_)->focus_custom_chain_set(objs_);
}

template <typename T>
bool _elm_widget_can_focus_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->can_focus_get();
}

template <typename T>
void _elm_widget_can_focus_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool can_focus_)
{
   static_cast<T*>(self->this_)->can_focus_set(efl::eolian::to_cxx<bool>(can_focus_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_highlight_in_theme_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->highlight_in_theme_get();
}

template <typename T>
void _elm_widget_highlight_in_theme_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool highlight_)
{
   static_cast<T*>(self->this_)->highlight_in_theme_set(efl::eolian::to_cxx<bool>(highlight_, std::tuple<std::false_type>()));
}

template <typename T>
evas::object _elm_widget_parent_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->parent_get();
}

template <typename T>
void _elm_widget_parent_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * parent_)
{
   static_cast<T*>(self->this_)->parent_set(efl::eolian::to_cxx<evas::object>(parent_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_widget_access_info_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->access_info_get();
}

template <typename T>
void _elm_widget_access_info_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * txt_)
{
   static_cast<T*>(self->this_)->access_info_set(efl::eolian::to_cxx<std::string>(txt_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_drag_lock_x_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->drag_lock_x_get();
}

template <typename T>
void _elm_widget_drag_lock_x_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool lock_)
{
   static_cast<T*>(self->this_)->drag_lock_x_set(efl::eolian::to_cxx<bool>(lock_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_access_highlight_in_theme_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->access_highlight_in_theme_get();
}

template <typename T>
void _elm_widget_access_highlight_in_theme_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool highlight_)
{
   static_cast<T*>(self->this_)->access_highlight_in_theme_set(efl::eolian::to_cxx<bool>(highlight_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_parent_highlight_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool highlighted_)
{
   static_cast<T*>(self->this_)->parent_highlight_set(efl::eolian::to_cxx<bool>(highlighted_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_theme_object_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * edj_, const char * wname_, const char * welement_, const char * wstyle_)
{
   return static_cast<T*>(self->this_)->theme_object_set(efl::eolian::to_cxx<evas::object>(edj_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(wname_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(welement_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(wstyle_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_hover_object_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sobj_)
{
   static_cast<T*>(self->this_)->hover_object_set(efl::eolian::to_cxx<evas::object>(sobj_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_display_mode_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Display_Mode dispmode_)
{
   static_cast<T*>(self->this_)->display_mode_set(dispmode_);
}

template <typename T>
void _elm_widget_on_show_region_hook_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, region_hook_func_type func_, void * data_)
{
   static_cast<T*>(self->this_)->on_show_region_hook_set(func_, data_);
}

template <typename T>
void _elm_widget_domain_part_text_translatable_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_, const char * domain_, Eina_Bool translatable_)
{
   static_cast<T*>(self->this_)->domain_part_text_translatable_set(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(domain_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(translatable_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_orientation_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int rotation_)
{
   static_cast<T*>(self->this_)->orientation_set(rotation_);
}

template <typename T>
void _elm_widget_resize_object_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sobj_, Eina_Bool sub_obj_)
{
   static_cast<T*>(self->this_)->resize_object_set(efl::eolian::to_cxx<evas::object>(sobj_, std::tuple<std::false_type>()), efl::eolian::to_cxx<bool>(sub_obj_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_domain_translatable_part_text_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_, const char * domain_, const char * label_)
{
   static_cast<T*>(self->this_)->domain_translatable_part_text_set(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(domain_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()));
}

template <typename T>
Eina_List * _elm_widget_scrollable_children_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->scrollable_children_get();
}

template <typename T>
int _elm_widget_scroll_hold_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->scroll_hold_get();
}

template <typename T>
int _elm_widget_drag_child_locked_y_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->drag_child_locked_y_get();
}

template <typename T>
bool _elm_widget_item_loop_enabled_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->item_loop_enabled_get();
}

template <typename T>
void _elm_widget_item_loop_enabled_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool enable_)
{
   static_cast<T*>(self->this_)->item_loop_enabled_set(efl::eolian::to_cxx<bool>(enable_, std::tuple<std::false_type>()));
}

template <typename T>
bool _elm_widget_child_can_focus_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->child_can_focus_get();
}

template <typename T>
int _elm_widget_scroll_freeze_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->scroll_freeze_get();
}

template <typename T>
bool _elm_widget_focus_region_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
{
   return static_cast<T*>(self->this_)->focus_region_get(x_, y_, w_, h_);
}

template <typename T>
evas::object _elm_widget_top_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->top_get();
}

template <typename T>
unsigned int _elm_widget_focus_order_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focus_order_get();
}

template <typename T>
int _elm_widget_drag_child_locked_x_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->drag_child_locked_x_get();
}

template <typename T>
Eina_List * _elm_widget_can_focus_child_list_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->can_focus_child_list_get();
}

template <typename T>
Elm_Object_Item * _elm_widget_focused_item_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focused_item_get();
}

template <typename T>
void _elm_widget_parents_bounce_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool* horiz_, Eina_Bool* vert_)
{
   static_cast<T*>(self->this_)->parents_bounce_get(horiz_, vert_);
}

template <typename T>
evas::object _elm_widget_parent_widget_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->parent_widget_get();
}

template <typename T>
bool _elm_widget_highlight_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->highlight_get();
}

template <typename T>
evas::object _elm_widget_focused_object_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->focused_object_get();
}

template <typename T>
evas::object _elm_widget_parent2_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->parent2_get();
}

template <typename T>
void _elm_widget_parent2_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * parent_)
{
   static_cast<T*>(self->this_)->parent2_set(efl::eolian::to_cxx<evas::object>(parent_, std::tuple<std::false_type>()));
}

template <typename T>
std::string _elm_widget_part_text_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_)
{
   return static_cast<T*>(self->this_)->part_text_get(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()));
}

template <typename T>
void _elm_widget_part_text_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * part_, const char * label_)
{
   static_cast<T*>(self->this_)->part_text_set(efl::eolian::to_cxx<std::string>(part_, std::tuple<std::false_type>()), efl::eolian::to_cxx<std::string>(label_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_widget >
{
   template <typename T>
   struct type
   {
      virtual evas::object newest_focus_order_get(unsigned int* newest_focus_order_, bool can_focus_only_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_newest_focus_order_get(newest_focus_order_, efl::eolian::to_c(can_focus_only_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void scroll_hold_push()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_scroll_hold_push());
      }

      virtual void cursor_add(Elm_Cursor * cur_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_cursor_add(cur_));
      }

      virtual void focus_next_object_set(evas::object next_, Elm_Focus_Direction dir_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_next_object_set(efl::eolian::to_c(next_), dir_));
      }

      virtual evas::object focus_next_object_get(Elm_Focus_Direction dir_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_next_object_get(dir_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_tree_unfocusable_handle()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_tree_unfocusable_handle());
      }

      virtual void focus_custom_chain_prepend(evas::object child_, evas::object relative_child_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_custom_chain_prepend(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
      }

      virtual std::string part_text_translate(std::string part_, std::string text_)
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_part_text_translate(efl::eolian::to_c(part_), efl::eolian::to_c(text_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_highlight_geometry_get(Evas_Coord * x_, Evas_Coord * y_, Evas_Coord * w_, Evas_Coord * h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_highlight_geometry_get(x_, y_, w_, h_));
      }

      virtual bool activate(Elm_Activate act_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_activate(act_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool sub_object_add(evas::object sobj_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_sub_object_add(efl::eolian::to_c(sobj_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_direction_manager_is()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_direction_manager_is());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool event(evas::object source_, Evas_Callback_Type type_, void * event_info_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_event(efl::eolian::to_c(source_), type_, event_info_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void event_callback_add(Elm_Event_Cb func_, const void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_event_callback_add(func_, data_));
      }

      virtual void access(bool acs_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_access(efl::eolian::to_c(acs_)));
      }

      virtual void cursor_del(Elm_Cursor * cur_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_cursor_del(cur_));
      }

      virtual void * event_callback_del(Elm_Event_Cb func_, const void * data_)
      {
         void * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_event_callback_del(func_, data_));
            return _tmp_ret;
      }

      virtual bool on_focus()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_on_focus());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool on_focus_region(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_on_focus_region(x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_cycle(Elm_Focus_Direction dir_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_cycle(dir_));
      }

      virtual bool focus_direction(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_direction(base_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool event_propagate(Evas_Callback_Type type_, void * event_info_, Evas_Event_Flags * event_flags_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_event_propagate(type_, event_info_, event_flags_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void signal_callback_add(std::string emission_, std::string source_, Edje_Signal_Cb func_, void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_signal_callback_add(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_, data_));
      }

      virtual bool focus_next_manager_is()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_next_manager_is());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object name_find(std::string name_, int recurse_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_name_find(efl::eolian::to_c(name_), recurse_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_list_direction_get(const Evas_Object * base_, const Eina_List * items_, list_data_get_func_type list_data_get_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_list_direction_get(base_, items_, list_data_get_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focused_object_clear()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focused_object_clear());
      }

      virtual bool focus_direction_go(double degree_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_direction_go(degree_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void show_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_, bool forceshow_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_show_region_set(x_, y_, w_, h_, efl::eolian::to_c(forceshow_)));
      }

      virtual void show_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_show_region_get(x_, y_, w_, h_));
      }

      virtual void scroll_freeze_pop()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_scroll_freeze_pop());
      }

      virtual void tooltip_del(Elm_Tooltip * tt_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_tooltip_del(tt_));
      }

      virtual bool focus_next_get(Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_next_get(dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual std::string translatable_part_text_get(std::string part_)
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_translatable_part_text_get(efl::eolian::to_c(part_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_restore()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_restore());
      }

      virtual void scroll_hold_pop()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_scroll_hold_pop());
      }

      virtual bool translate()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_translate());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void scroll_freeze_push()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_scroll_freeze_push());
      }

      virtual void focus_custom_chain_unset()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_custom_chain_unset());
      }

      virtual void focus_steal()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_steal());
      }

      virtual void focus_hide_handle()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_hide_handle());
      }

      virtual bool focus_next(Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_next(dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_list_next_get(const Eina_List * items_, list_data_get_func_type list_data_get_, Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_list_next_get(items_, list_data_get_, dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_mouse_up_handle()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_mouse_up_handle());
      }

      virtual bool theme_apply()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_theme_apply());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_direction_get(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_direction_get(base_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void * signal_callback_del(std::string emission_, std::string source_, Edje_Signal_Cb func_)
      {
         void * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_signal_callback_del(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_));
            return _tmp_ret;
      }

      virtual void signal_emit(std::string emission_, std::string source_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_signal_emit(efl::eolian::to_c(emission_), efl::eolian::to_c(source_)));
      }

      virtual bool disable()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_disable());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool sub_object_del(evas::object sobj_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_sub_object_del(efl::eolian::to_c(sobj_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void tooltip_add(Elm_Tooltip * tt_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_tooltip_add(tt_));
      }

      virtual void focus_region_show()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_region_show());
      }

      virtual void focus_disabled_handle()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_disabled_handle());
      }

      virtual void focus_custom_chain_append(evas::object child_, evas::object relative_child_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_custom_chain_append(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
      }

      virtual bool focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void focus_set(bool focus_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_set(efl::eolian::to_c(focus_)));
      }

      virtual bool drag_lock_y_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_drag_lock_y_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void drag_lock_y_set(bool lock_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_drag_lock_y_set(efl::eolian::to_c(lock_)));
      }

      virtual std::string focus_highlight_style_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_highlight_style_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool focus_highlight_style_set(std::string style_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_highlight_style_set(efl::eolian::to_c(style_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool tree_unfocusable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_tree_unfocusable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void tree_unfocusable_set(bool tree_unfocusable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_tree_unfocusable_set(efl::eolian::to_c(tree_unfocusable_)));
      }

      virtual bool mirrored_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_mirrored_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void mirrored_set(bool mirrored_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_mirrored_set(efl::eolian::to_c(mirrored_)));
      }

      virtual Elm_Theme * theme_get()
      {
         Elm_Theme * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_theme_get());
            return _tmp_ret;
      }

      virtual void theme_set(Elm_Theme * th_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_theme_set(th_));
      }

      virtual bool disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual bool highlight_ignore_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_highlight_ignore_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void highlight_ignore_set(bool ignore_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_highlight_ignore_set(efl::eolian::to_c(ignore_)));
      }

      virtual bool mirrored_automatic_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_mirrored_automatic_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void mirrored_automatic_set(bool automatic_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_mirrored_automatic_set(efl::eolian::to_c(automatic_)));
      }

      virtual bool orientation_mode_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_orientation_mode_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void orientation_mode_disabled_set(bool disabled_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_orientation_mode_disabled_set(efl::eolian::to_c(disabled_)));
      }

      virtual std::string style_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_style_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool style_set(std::string style_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_style_set(efl::eolian::to_c(style_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual double scale_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_scale_get());
            return _tmp_ret;
      }

      virtual void scale_set(double scale_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_scale_set(scale_));
      }

      virtual const Eina_List * focus_custom_chain_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_custom_chain_get());
            return _tmp_ret;
      }

      virtual void focus_custom_chain_set(Eina_List * objs_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_focus_custom_chain_set(objs_));
      }

      virtual bool can_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_can_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void can_focus_set(bool can_focus_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_can_focus_set(efl::eolian::to_c(can_focus_)));
      }

      virtual bool highlight_in_theme_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_highlight_in_theme_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void highlight_in_theme_set(bool highlight_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
      }

      virtual evas::object parent_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_parent_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void parent_set(evas::object parent_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_parent_set(efl::eolian::to_c(parent_)));
      }

      virtual std::string access_info_get()
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_access_info_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void access_info_set(std::string txt_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_access_info_set(efl::eolian::to_c(txt_)));
      }

      virtual bool drag_lock_x_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_drag_lock_x_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void drag_lock_x_set(bool lock_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_drag_lock_x_set(efl::eolian::to_c(lock_)));
      }

      virtual bool access_highlight_in_theme_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_access_highlight_in_theme_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void access_highlight_in_theme_set(bool highlight_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_access_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
      }

      virtual void parent_highlight_set(bool highlighted_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_parent_highlight_set(efl::eolian::to_c(highlighted_)));
      }

      virtual bool theme_object_set(evas::object edj_, std::string wname_, std::string welement_, std::string wstyle_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_theme_object_set(efl::eolian::to_c(edj_), efl::eolian::to_c(wname_), efl::eolian::to_c(welement_), efl::eolian::to_c(wstyle_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hover_object_set(evas::object sobj_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_hover_object_set(efl::eolian::to_c(sobj_)));
      }

      virtual void display_mode_set(Evas_Display_Mode dispmode_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_display_mode_set(dispmode_));
      }

      virtual void on_show_region_hook_set(region_hook_func_type func_, void * data_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_on_show_region_hook_set(func_, data_));
      }

      virtual void domain_part_text_translatable_set(std::string part_, std::string domain_, bool translatable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_domain_part_text_translatable_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(translatable_)));
      }

      virtual void orientation_set(int rotation_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_orientation_set(rotation_));
      }

      virtual void resize_object_set(evas::object sobj_, bool sub_obj_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_resize_object_set(efl::eolian::to_c(sobj_), efl::eolian::to_c(sub_obj_)));
      }

      virtual void domain_translatable_part_text_set(std::string part_, std::string domain_, std::string label_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_domain_translatable_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(label_)));
      }

      virtual Eina_List * scrollable_children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_scrollable_children_get());
            return _tmp_ret;
      }

      virtual int scroll_hold_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_scroll_hold_get());
            return _tmp_ret;
      }

      virtual int drag_child_locked_y_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_drag_child_locked_y_get());
            return _tmp_ret;
      }

      virtual bool item_loop_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_item_loop_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void item_loop_enabled_set(bool enable_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_item_loop_enabled_set(efl::eolian::to_c(enable_)));
      }

      virtual bool child_can_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_child_can_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual int scroll_freeze_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_scroll_freeze_get());
            return _tmp_ret;
      }

      virtual bool focus_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_region_get(x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object top_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_top_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual unsigned int focus_order_get()
      {
         unsigned int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focus_order_get());
            return _tmp_ret;
      }

      virtual int drag_child_locked_x_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_drag_child_locked_x_get());
            return _tmp_ret;
      }

      virtual Eina_List * can_focus_child_list_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_can_focus_child_list_get());
            return _tmp_ret;
      }

      virtual Elm_Object_Item * focused_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focused_item_get());
            return _tmp_ret;
      }

      virtual void parents_bounce_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_parents_bounce_get(horiz_, vert_));
      }

      virtual evas::object parent_widget_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_parent_widget_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool highlight_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_highlight_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object focused_object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_focused_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual evas::object parent2_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_parent2_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void parent2_set(evas::object parent_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_parent2_set(efl::eolian::to_c(parent_)));
      }

      virtual std::string part_text_get(std::string part_)
      {
         const char * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_widget_part_text_get(efl::eolian::to_c(part_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void part_text_set(std::string part_, std::string label_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::elm_obj_widget_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(label_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm_widget >
{
   static const int value = 122;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_widget>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_widget_newest_focus_order_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_newest_focus_order_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_hold_push_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_hold_push);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_elm_widget_cursor_add_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_cursor_add);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_elm_widget_focus_next_object_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_next_object_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_elm_widget_focus_next_object_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_next_object_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_elm_widget_focus_tree_unfocusable_handle_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_tree_unfocusable_handle);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_elm_widget_focus_custom_chain_prepend_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_custom_chain_prepend);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_elm_widget_part_text_translate_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_part_text_translate);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_elm_widget_focus_highlight_geometry_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_highlight_geometry_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_elm_widget_activate_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_activate);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_elm_widget_sub_object_add_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_sub_object_add);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_elm_widget_focus_direction_manager_is_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_direction_manager_is);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_elm_widget_event_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_event);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_elm_widget_event_callback_add_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_event_callback_add);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_elm_widget_access_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_access);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_elm_widget_cursor_del_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_cursor_del);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_elm_widget_event_callback_del_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_event_callback_del);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   ops[17].func = reinterpret_cast<void*>(& ::_elm_widget_on_focus_wrapper<T>);
   ops[17].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_on_focus);
   ops[17].op = EO_OP_OVERRIDE;
   ops[17].op_type = EO_OP_TYPE_REGULAR;
   ops[17].doc = NULL;

   ops[18].func = reinterpret_cast<void*>(& ::_elm_widget_on_focus_region_wrapper<T>);
   ops[18].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_on_focus_region);
   ops[18].op = EO_OP_OVERRIDE;
   ops[18].op_type = EO_OP_TYPE_REGULAR;
   ops[18].doc = NULL;

   ops[19].func = reinterpret_cast<void*>(& ::_elm_widget_focus_cycle_wrapper<T>);
   ops[19].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_cycle);
   ops[19].op = EO_OP_OVERRIDE;
   ops[19].op_type = EO_OP_TYPE_REGULAR;
   ops[19].doc = NULL;

   ops[20].func = reinterpret_cast<void*>(& ::_elm_widget_focus_direction_wrapper<T>);
   ops[20].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_direction);
   ops[20].op = EO_OP_OVERRIDE;
   ops[20].op_type = EO_OP_TYPE_REGULAR;
   ops[20].doc = NULL;

   ops[21].func = reinterpret_cast<void*>(& ::_elm_widget_event_propagate_wrapper<T>);
   ops[21].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_event_propagate);
   ops[21].op = EO_OP_OVERRIDE;
   ops[21].op_type = EO_OP_TYPE_REGULAR;
   ops[21].doc = NULL;

   ops[22].func = reinterpret_cast<void*>(& ::_elm_widget_signal_callback_add_wrapper<T>);
   ops[22].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_signal_callback_add);
   ops[22].op = EO_OP_OVERRIDE;
   ops[22].op_type = EO_OP_TYPE_REGULAR;
   ops[22].doc = NULL;

   ops[23].func = reinterpret_cast<void*>(& ::_elm_widget_focus_next_manager_is_wrapper<T>);
   ops[23].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_next_manager_is);
   ops[23].op = EO_OP_OVERRIDE;
   ops[23].op_type = EO_OP_TYPE_REGULAR;
   ops[23].doc = NULL;

   ops[24].func = reinterpret_cast<void*>(& ::_elm_widget_name_find_wrapper<T>);
   ops[24].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_name_find);
   ops[24].op = EO_OP_OVERRIDE;
   ops[24].op_type = EO_OP_TYPE_REGULAR;
   ops[24].doc = NULL;

   ops[25].func = reinterpret_cast<void*>(& ::_elm_widget_focus_list_direction_get_wrapper<T>);
   ops[25].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_list_direction_get);
   ops[25].op = EO_OP_OVERRIDE;
   ops[25].op_type = EO_OP_TYPE_REGULAR;
   ops[25].doc = NULL;

   ops[26].func = reinterpret_cast<void*>(& ::_elm_widget_focused_object_clear_wrapper<T>);
   ops[26].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focused_object_clear);
   ops[26].op = EO_OP_OVERRIDE;
   ops[26].op_type = EO_OP_TYPE_REGULAR;
   ops[26].doc = NULL;

   ops[27].func = reinterpret_cast<void*>(& ::_elm_widget_focus_direction_go_wrapper<T>);
   ops[27].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_direction_go);
   ops[27].op = EO_OP_OVERRIDE;
   ops[27].op_type = EO_OP_TYPE_REGULAR;
   ops[27].doc = NULL;

   ops[28].func = reinterpret_cast<void*>(& ::_elm_widget_show_region_set_wrapper<T>);
   ops[28].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_show_region_set);
   ops[28].op = EO_OP_OVERRIDE;
   ops[28].op_type = EO_OP_TYPE_REGULAR;
   ops[28].doc = NULL;

   ops[29].func = reinterpret_cast<void*>(& ::_elm_widget_show_region_get_wrapper<T>);
   ops[29].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_show_region_get);
   ops[29].op = EO_OP_OVERRIDE;
   ops[29].op_type = EO_OP_TYPE_REGULAR;
   ops[29].doc = NULL;

   ops[30].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_freeze_pop_wrapper<T>);
   ops[30].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_freeze_pop);
   ops[30].op = EO_OP_OVERRIDE;
   ops[30].op_type = EO_OP_TYPE_REGULAR;
   ops[30].doc = NULL;

   ops[31].func = reinterpret_cast<void*>(& ::_elm_widget_tooltip_del_wrapper<T>);
   ops[31].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_tooltip_del);
   ops[31].op = EO_OP_OVERRIDE;
   ops[31].op_type = EO_OP_TYPE_REGULAR;
   ops[31].doc = NULL;

   ops[32].func = reinterpret_cast<void*>(& ::_elm_widget_focus_next_get_wrapper<T>);
   ops[32].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_next_get);
   ops[32].op = EO_OP_OVERRIDE;
   ops[32].op_type = EO_OP_TYPE_REGULAR;
   ops[32].doc = NULL;

   ops[33].func = reinterpret_cast<void*>(& ::_elm_widget_translatable_part_text_get_wrapper<T>);
   ops[33].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_translatable_part_text_get);
   ops[33].op = EO_OP_OVERRIDE;
   ops[33].op_type = EO_OP_TYPE_REGULAR;
   ops[33].doc = NULL;

   ops[34].func = reinterpret_cast<void*>(& ::_elm_widget_focus_restore_wrapper<T>);
   ops[34].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_restore);
   ops[34].op = EO_OP_OVERRIDE;
   ops[34].op_type = EO_OP_TYPE_REGULAR;
   ops[34].doc = NULL;

   ops[35].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_hold_pop_wrapper<T>);
   ops[35].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_hold_pop);
   ops[35].op = EO_OP_OVERRIDE;
   ops[35].op_type = EO_OP_TYPE_REGULAR;
   ops[35].doc = NULL;

   ops[36].func = reinterpret_cast<void*>(& ::_elm_widget_translate_wrapper<T>);
   ops[36].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_translate);
   ops[36].op = EO_OP_OVERRIDE;
   ops[36].op_type = EO_OP_TYPE_REGULAR;
   ops[36].doc = NULL;

   ops[37].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_freeze_push_wrapper<T>);
   ops[37].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_freeze_push);
   ops[37].op = EO_OP_OVERRIDE;
   ops[37].op_type = EO_OP_TYPE_REGULAR;
   ops[37].doc = NULL;

   ops[38].func = reinterpret_cast<void*>(& ::_elm_widget_focus_custom_chain_unset_wrapper<T>);
   ops[38].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_custom_chain_unset);
   ops[38].op = EO_OP_OVERRIDE;
   ops[38].op_type = EO_OP_TYPE_REGULAR;
   ops[38].doc = NULL;

   ops[39].func = reinterpret_cast<void*>(& ::_elm_widget_focus_steal_wrapper<T>);
   ops[39].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_steal);
   ops[39].op = EO_OP_OVERRIDE;
   ops[39].op_type = EO_OP_TYPE_REGULAR;
   ops[39].doc = NULL;

   ops[40].func = reinterpret_cast<void*>(& ::_elm_widget_focus_hide_handle_wrapper<T>);
   ops[40].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_hide_handle);
   ops[40].op = EO_OP_OVERRIDE;
   ops[40].op_type = EO_OP_TYPE_REGULAR;
   ops[40].doc = NULL;

   ops[41].func = reinterpret_cast<void*>(& ::_elm_widget_focus_next_wrapper<T>);
   ops[41].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_next);
   ops[41].op = EO_OP_OVERRIDE;
   ops[41].op_type = EO_OP_TYPE_REGULAR;
   ops[41].doc = NULL;

   ops[42].func = reinterpret_cast<void*>(& ::_elm_widget_focus_list_next_get_wrapper<T>);
   ops[42].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_list_next_get);
   ops[42].op = EO_OP_OVERRIDE;
   ops[42].op_type = EO_OP_TYPE_REGULAR;
   ops[42].doc = NULL;

   ops[43].func = reinterpret_cast<void*>(& ::_elm_widget_focus_mouse_up_handle_wrapper<T>);
   ops[43].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_mouse_up_handle);
   ops[43].op = EO_OP_OVERRIDE;
   ops[43].op_type = EO_OP_TYPE_REGULAR;
   ops[43].doc = NULL;

   ops[44].func = reinterpret_cast<void*>(& ::_elm_widget_theme_apply_wrapper<T>);
   ops[44].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_theme_apply);
   ops[44].op = EO_OP_OVERRIDE;
   ops[44].op_type = EO_OP_TYPE_REGULAR;
   ops[44].doc = NULL;

   ops[45].func = reinterpret_cast<void*>(& ::_elm_widget_focus_direction_get_wrapper<T>);
   ops[45].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_direction_get);
   ops[45].op = EO_OP_OVERRIDE;
   ops[45].op_type = EO_OP_TYPE_REGULAR;
   ops[45].doc = NULL;

   ops[46].func = reinterpret_cast<void*>(& ::_elm_widget_signal_callback_del_wrapper<T>);
   ops[46].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_signal_callback_del);
   ops[46].op = EO_OP_OVERRIDE;
   ops[46].op_type = EO_OP_TYPE_REGULAR;
   ops[46].doc = NULL;

   ops[47].func = reinterpret_cast<void*>(& ::_elm_widget_signal_emit_wrapper<T>);
   ops[47].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_signal_emit);
   ops[47].op = EO_OP_OVERRIDE;
   ops[47].op_type = EO_OP_TYPE_REGULAR;
   ops[47].doc = NULL;

   ops[48].func = reinterpret_cast<void*>(& ::_elm_widget_disable_wrapper<T>);
   ops[48].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_disable);
   ops[48].op = EO_OP_OVERRIDE;
   ops[48].op_type = EO_OP_TYPE_REGULAR;
   ops[48].doc = NULL;

   ops[49].func = reinterpret_cast<void*>(& ::_elm_widget_sub_object_del_wrapper<T>);
   ops[49].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_sub_object_del);
   ops[49].op = EO_OP_OVERRIDE;
   ops[49].op_type = EO_OP_TYPE_REGULAR;
   ops[49].doc = NULL;

   ops[50].func = reinterpret_cast<void*>(& ::_elm_widget_tooltip_add_wrapper<T>);
   ops[50].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_tooltip_add);
   ops[50].op = EO_OP_OVERRIDE;
   ops[50].op_type = EO_OP_TYPE_REGULAR;
   ops[50].doc = NULL;

   ops[51].func = reinterpret_cast<void*>(& ::_elm_widget_focus_region_show_wrapper<T>);
   ops[51].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_region_show);
   ops[51].op = EO_OP_OVERRIDE;
   ops[51].op_type = EO_OP_TYPE_REGULAR;
   ops[51].doc = NULL;

   ops[52].func = reinterpret_cast<void*>(& ::_elm_widget_focus_disabled_handle_wrapper<T>);
   ops[52].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_disabled_handle);
   ops[52].op = EO_OP_OVERRIDE;
   ops[52].op_type = EO_OP_TYPE_REGULAR;
   ops[52].doc = NULL;

   ops[53].func = reinterpret_cast<void*>(& ::_elm_widget_focus_custom_chain_append_wrapper<T>);
   ops[53].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_custom_chain_append);
   ops[53].op = EO_OP_OVERRIDE;
   ops[53].op_type = EO_OP_TYPE_REGULAR;
   ops[53].doc = NULL;

   ops[54].func = reinterpret_cast<void*>(& ::_elm_widget_focus_get_wrapper<T>);
   ops[54].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_get);
   ops[54].op = EO_OP_OVERRIDE;
   ops[54].op_type = EO_OP_TYPE_REGULAR;
   ops[54].doc = NULL;

   ops[55].func = reinterpret_cast<void*>(& ::_elm_widget_focus_set_wrapper<T>);
   ops[55].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_set);
   ops[55].op = EO_OP_OVERRIDE;
   ops[55].op_type = EO_OP_TYPE_REGULAR;
   ops[55].doc = NULL;

   ops[56].func = reinterpret_cast<void*>(& ::_elm_widget_drag_lock_y_get_wrapper<T>);
   ops[56].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_lock_y_get);
   ops[56].op = EO_OP_OVERRIDE;
   ops[56].op_type = EO_OP_TYPE_REGULAR;
   ops[56].doc = NULL;

   ops[57].func = reinterpret_cast<void*>(& ::_elm_widget_drag_lock_y_set_wrapper<T>);
   ops[57].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_lock_y_set);
   ops[57].op = EO_OP_OVERRIDE;
   ops[57].op_type = EO_OP_TYPE_REGULAR;
   ops[57].doc = NULL;

   ops[58].func = reinterpret_cast<void*>(& ::_elm_widget_focus_highlight_style_get_wrapper<T>);
   ops[58].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_highlight_style_get);
   ops[58].op = EO_OP_OVERRIDE;
   ops[58].op_type = EO_OP_TYPE_REGULAR;
   ops[58].doc = NULL;

   ops[59].func = reinterpret_cast<void*>(& ::_elm_widget_focus_highlight_style_set_wrapper<T>);
   ops[59].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_highlight_style_set);
   ops[59].op = EO_OP_OVERRIDE;
   ops[59].op_type = EO_OP_TYPE_REGULAR;
   ops[59].doc = NULL;

   ops[60].func = reinterpret_cast<void*>(& ::_elm_widget_tree_unfocusable_get_wrapper<T>);
   ops[60].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_tree_unfocusable_get);
   ops[60].op = EO_OP_OVERRIDE;
   ops[60].op_type = EO_OP_TYPE_REGULAR;
   ops[60].doc = NULL;

   ops[61].func = reinterpret_cast<void*>(& ::_elm_widget_tree_unfocusable_set_wrapper<T>);
   ops[61].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_tree_unfocusable_set);
   ops[61].op = EO_OP_OVERRIDE;
   ops[61].op_type = EO_OP_TYPE_REGULAR;
   ops[61].doc = NULL;

   ops[62].func = reinterpret_cast<void*>(& ::_elm_widget_mirrored_get_wrapper<T>);
   ops[62].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_mirrored_get);
   ops[62].op = EO_OP_OVERRIDE;
   ops[62].op_type = EO_OP_TYPE_REGULAR;
   ops[62].doc = NULL;

   ops[63].func = reinterpret_cast<void*>(& ::_elm_widget_mirrored_set_wrapper<T>);
   ops[63].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_mirrored_set);
   ops[63].op = EO_OP_OVERRIDE;
   ops[63].op_type = EO_OP_TYPE_REGULAR;
   ops[63].doc = NULL;

   ops[64].func = reinterpret_cast<void*>(& ::_elm_widget_theme_get_wrapper<T>);
   ops[64].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_theme_get);
   ops[64].op = EO_OP_OVERRIDE;
   ops[64].op_type = EO_OP_TYPE_REGULAR;
   ops[64].doc = NULL;

   ops[65].func = reinterpret_cast<void*>(& ::_elm_widget_theme_set_wrapper<T>);
   ops[65].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_theme_set);
   ops[65].op = EO_OP_OVERRIDE;
   ops[65].op_type = EO_OP_TYPE_REGULAR;
   ops[65].doc = NULL;

   ops[66].func = reinterpret_cast<void*>(& ::_elm_widget_disabled_get_wrapper<T>);
   ops[66].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_disabled_get);
   ops[66].op = EO_OP_OVERRIDE;
   ops[66].op_type = EO_OP_TYPE_REGULAR;
   ops[66].doc = NULL;

   ops[67].func = reinterpret_cast<void*>(& ::_elm_widget_disabled_set_wrapper<T>);
   ops[67].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_disabled_set);
   ops[67].op = EO_OP_OVERRIDE;
   ops[67].op_type = EO_OP_TYPE_REGULAR;
   ops[67].doc = NULL;

   ops[68].func = reinterpret_cast<void*>(& ::_elm_widget_highlight_ignore_get_wrapper<T>);
   ops[68].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_highlight_ignore_get);
   ops[68].op = EO_OP_OVERRIDE;
   ops[68].op_type = EO_OP_TYPE_REGULAR;
   ops[68].doc = NULL;

   ops[69].func = reinterpret_cast<void*>(& ::_elm_widget_highlight_ignore_set_wrapper<T>);
   ops[69].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_highlight_ignore_set);
   ops[69].op = EO_OP_OVERRIDE;
   ops[69].op_type = EO_OP_TYPE_REGULAR;
   ops[69].doc = NULL;

   ops[70].func = reinterpret_cast<void*>(& ::_elm_widget_mirrored_automatic_get_wrapper<T>);
   ops[70].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_mirrored_automatic_get);
   ops[70].op = EO_OP_OVERRIDE;
   ops[70].op_type = EO_OP_TYPE_REGULAR;
   ops[70].doc = NULL;

   ops[71].func = reinterpret_cast<void*>(& ::_elm_widget_mirrored_automatic_set_wrapper<T>);
   ops[71].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_mirrored_automatic_set);
   ops[71].op = EO_OP_OVERRIDE;
   ops[71].op_type = EO_OP_TYPE_REGULAR;
   ops[71].doc = NULL;

   ops[72].func = reinterpret_cast<void*>(& ::_elm_widget_orientation_mode_disabled_get_wrapper<T>);
   ops[72].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_orientation_mode_disabled_get);
   ops[72].op = EO_OP_OVERRIDE;
   ops[72].op_type = EO_OP_TYPE_REGULAR;
   ops[72].doc = NULL;

   ops[73].func = reinterpret_cast<void*>(& ::_elm_widget_orientation_mode_disabled_set_wrapper<T>);
   ops[73].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_orientation_mode_disabled_set);
   ops[73].op = EO_OP_OVERRIDE;
   ops[73].op_type = EO_OP_TYPE_REGULAR;
   ops[73].doc = NULL;

   ops[74].func = reinterpret_cast<void*>(& ::_elm_widget_style_get_wrapper<T>);
   ops[74].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_style_get);
   ops[74].op = EO_OP_OVERRIDE;
   ops[74].op_type = EO_OP_TYPE_REGULAR;
   ops[74].doc = NULL;

   ops[75].func = reinterpret_cast<void*>(& ::_elm_widget_style_set_wrapper<T>);
   ops[75].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_style_set);
   ops[75].op = EO_OP_OVERRIDE;
   ops[75].op_type = EO_OP_TYPE_REGULAR;
   ops[75].doc = NULL;

   ops[76].func = reinterpret_cast<void*>(& ::_elm_widget_scale_get_wrapper<T>);
   ops[76].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scale_get);
   ops[76].op = EO_OP_OVERRIDE;
   ops[76].op_type = EO_OP_TYPE_REGULAR;
   ops[76].doc = NULL;

   ops[77].func = reinterpret_cast<void*>(& ::_elm_widget_scale_set_wrapper<T>);
   ops[77].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scale_set);
   ops[77].op = EO_OP_OVERRIDE;
   ops[77].op_type = EO_OP_TYPE_REGULAR;
   ops[77].doc = NULL;

   ops[78].func = reinterpret_cast<void*>(& ::_elm_widget_focus_custom_chain_get_wrapper<T>);
   ops[78].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_custom_chain_get);
   ops[78].op = EO_OP_OVERRIDE;
   ops[78].op_type = EO_OP_TYPE_REGULAR;
   ops[78].doc = NULL;

   ops[79].func = reinterpret_cast<void*>(& ::_elm_widget_focus_custom_chain_set_wrapper<T>);
   ops[79].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_custom_chain_set);
   ops[79].op = EO_OP_OVERRIDE;
   ops[79].op_type = EO_OP_TYPE_REGULAR;
   ops[79].doc = NULL;

   ops[80].func = reinterpret_cast<void*>(& ::_elm_widget_can_focus_get_wrapper<T>);
   ops[80].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_can_focus_get);
   ops[80].op = EO_OP_OVERRIDE;
   ops[80].op_type = EO_OP_TYPE_REGULAR;
   ops[80].doc = NULL;

   ops[81].func = reinterpret_cast<void*>(& ::_elm_widget_can_focus_set_wrapper<T>);
   ops[81].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_can_focus_set);
   ops[81].op = EO_OP_OVERRIDE;
   ops[81].op_type = EO_OP_TYPE_REGULAR;
   ops[81].doc = NULL;

   ops[82].func = reinterpret_cast<void*>(& ::_elm_widget_highlight_in_theme_get_wrapper<T>);
   ops[82].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_highlight_in_theme_get);
   ops[82].op = EO_OP_OVERRIDE;
   ops[82].op_type = EO_OP_TYPE_REGULAR;
   ops[82].doc = NULL;

   ops[83].func = reinterpret_cast<void*>(& ::_elm_widget_highlight_in_theme_set_wrapper<T>);
   ops[83].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_highlight_in_theme_set);
   ops[83].op = EO_OP_OVERRIDE;
   ops[83].op_type = EO_OP_TYPE_REGULAR;
   ops[83].doc = NULL;

   ops[84].func = reinterpret_cast<void*>(& ::_elm_widget_parent_get_wrapper<T>);
   ops[84].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent_get);
   ops[84].op = EO_OP_OVERRIDE;
   ops[84].op_type = EO_OP_TYPE_REGULAR;
   ops[84].doc = NULL;

   ops[85].func = reinterpret_cast<void*>(& ::_elm_widget_parent_set_wrapper<T>);
   ops[85].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent_set);
   ops[85].op = EO_OP_OVERRIDE;
   ops[85].op_type = EO_OP_TYPE_REGULAR;
   ops[85].doc = NULL;

   ops[86].func = reinterpret_cast<void*>(& ::_elm_widget_access_info_get_wrapper<T>);
   ops[86].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_access_info_get);
   ops[86].op = EO_OP_OVERRIDE;
   ops[86].op_type = EO_OP_TYPE_REGULAR;
   ops[86].doc = NULL;

   ops[87].func = reinterpret_cast<void*>(& ::_elm_widget_access_info_set_wrapper<T>);
   ops[87].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_access_info_set);
   ops[87].op = EO_OP_OVERRIDE;
   ops[87].op_type = EO_OP_TYPE_REGULAR;
   ops[87].doc = NULL;

   ops[88].func = reinterpret_cast<void*>(& ::_elm_widget_drag_lock_x_get_wrapper<T>);
   ops[88].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_lock_x_get);
   ops[88].op = EO_OP_OVERRIDE;
   ops[88].op_type = EO_OP_TYPE_REGULAR;
   ops[88].doc = NULL;

   ops[89].func = reinterpret_cast<void*>(& ::_elm_widget_drag_lock_x_set_wrapper<T>);
   ops[89].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_lock_x_set);
   ops[89].op = EO_OP_OVERRIDE;
   ops[89].op_type = EO_OP_TYPE_REGULAR;
   ops[89].doc = NULL;

   ops[90].func = reinterpret_cast<void*>(& ::_elm_widget_access_highlight_in_theme_get_wrapper<T>);
   ops[90].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_access_highlight_in_theme_get);
   ops[90].op = EO_OP_OVERRIDE;
   ops[90].op_type = EO_OP_TYPE_REGULAR;
   ops[90].doc = NULL;

   ops[91].func = reinterpret_cast<void*>(& ::_elm_widget_access_highlight_in_theme_set_wrapper<T>);
   ops[91].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_access_highlight_in_theme_set);
   ops[91].op = EO_OP_OVERRIDE;
   ops[91].op_type = EO_OP_TYPE_REGULAR;
   ops[91].doc = NULL;

   ops[92].func = reinterpret_cast<void*>(& ::_elm_widget_parent_highlight_set_wrapper<T>);
   ops[92].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent_highlight_set);
   ops[92].op = EO_OP_OVERRIDE;
   ops[92].op_type = EO_OP_TYPE_REGULAR;
   ops[92].doc = NULL;

   ops[93].func = reinterpret_cast<void*>(& ::_elm_widget_theme_object_set_wrapper<T>);
   ops[93].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_theme_object_set);
   ops[93].op = EO_OP_OVERRIDE;
   ops[93].op_type = EO_OP_TYPE_REGULAR;
   ops[93].doc = NULL;

   ops[94].func = reinterpret_cast<void*>(& ::_elm_widget_hover_object_set_wrapper<T>);
   ops[94].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_hover_object_set);
   ops[94].op = EO_OP_OVERRIDE;
   ops[94].op_type = EO_OP_TYPE_REGULAR;
   ops[94].doc = NULL;

   ops[95].func = reinterpret_cast<void*>(& ::_elm_widget_display_mode_set_wrapper<T>);
   ops[95].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_display_mode_set);
   ops[95].op = EO_OP_OVERRIDE;
   ops[95].op_type = EO_OP_TYPE_REGULAR;
   ops[95].doc = NULL;

   ops[96].func = reinterpret_cast<void*>(& ::_elm_widget_on_show_region_hook_set_wrapper<T>);
   ops[96].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_on_show_region_hook_set);
   ops[96].op = EO_OP_OVERRIDE;
   ops[96].op_type = EO_OP_TYPE_REGULAR;
   ops[96].doc = NULL;

   ops[97].func = reinterpret_cast<void*>(& ::_elm_widget_domain_part_text_translatable_set_wrapper<T>);
   ops[97].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_domain_part_text_translatable_set);
   ops[97].op = EO_OP_OVERRIDE;
   ops[97].op_type = EO_OP_TYPE_REGULAR;
   ops[97].doc = NULL;

   ops[98].func = reinterpret_cast<void*>(& ::_elm_widget_orientation_set_wrapper<T>);
   ops[98].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_orientation_set);
   ops[98].op = EO_OP_OVERRIDE;
   ops[98].op_type = EO_OP_TYPE_REGULAR;
   ops[98].doc = NULL;

   ops[99].func = reinterpret_cast<void*>(& ::_elm_widget_resize_object_set_wrapper<T>);
   ops[99].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_resize_object_set);
   ops[99].op = EO_OP_OVERRIDE;
   ops[99].op_type = EO_OP_TYPE_REGULAR;
   ops[99].doc = NULL;

   ops[100].func = reinterpret_cast<void*>(& ::_elm_widget_domain_translatable_part_text_set_wrapper<T>);
   ops[100].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_domain_translatable_part_text_set);
   ops[100].op = EO_OP_OVERRIDE;
   ops[100].op_type = EO_OP_TYPE_REGULAR;
   ops[100].doc = NULL;

   ops[101].func = reinterpret_cast<void*>(& ::_elm_widget_scrollable_children_get_wrapper<T>);
   ops[101].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scrollable_children_get);
   ops[101].op = EO_OP_OVERRIDE;
   ops[101].op_type = EO_OP_TYPE_REGULAR;
   ops[101].doc = NULL;

   ops[102].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_hold_get_wrapper<T>);
   ops[102].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_hold_get);
   ops[102].op = EO_OP_OVERRIDE;
   ops[102].op_type = EO_OP_TYPE_REGULAR;
   ops[102].doc = NULL;

   ops[103].func = reinterpret_cast<void*>(& ::_elm_widget_drag_child_locked_y_get_wrapper<T>);
   ops[103].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_child_locked_y_get);
   ops[103].op = EO_OP_OVERRIDE;
   ops[103].op_type = EO_OP_TYPE_REGULAR;
   ops[103].doc = NULL;

   ops[104].func = reinterpret_cast<void*>(& ::_elm_widget_item_loop_enabled_get_wrapper<T>);
   ops[104].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_item_loop_enabled_get);
   ops[104].op = EO_OP_OVERRIDE;
   ops[104].op_type = EO_OP_TYPE_REGULAR;
   ops[104].doc = NULL;

   ops[105].func = reinterpret_cast<void*>(& ::_elm_widget_item_loop_enabled_set_wrapper<T>);
   ops[105].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_item_loop_enabled_set);
   ops[105].op = EO_OP_OVERRIDE;
   ops[105].op_type = EO_OP_TYPE_REGULAR;
   ops[105].doc = NULL;

   ops[106].func = reinterpret_cast<void*>(& ::_elm_widget_child_can_focus_get_wrapper<T>);
   ops[106].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_child_can_focus_get);
   ops[106].op = EO_OP_OVERRIDE;
   ops[106].op_type = EO_OP_TYPE_REGULAR;
   ops[106].doc = NULL;

   ops[107].func = reinterpret_cast<void*>(& ::_elm_widget_scroll_freeze_get_wrapper<T>);
   ops[107].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_scroll_freeze_get);
   ops[107].op = EO_OP_OVERRIDE;
   ops[107].op_type = EO_OP_TYPE_REGULAR;
   ops[107].doc = NULL;

   ops[108].func = reinterpret_cast<void*>(& ::_elm_widget_focus_region_get_wrapper<T>);
   ops[108].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_region_get);
   ops[108].op = EO_OP_OVERRIDE;
   ops[108].op_type = EO_OP_TYPE_REGULAR;
   ops[108].doc = NULL;

   ops[109].func = reinterpret_cast<void*>(& ::_elm_widget_top_get_wrapper<T>);
   ops[109].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_top_get);
   ops[109].op = EO_OP_OVERRIDE;
   ops[109].op_type = EO_OP_TYPE_REGULAR;
   ops[109].doc = NULL;

   ops[110].func = reinterpret_cast<void*>(& ::_elm_widget_focus_order_get_wrapper<T>);
   ops[110].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focus_order_get);
   ops[110].op = EO_OP_OVERRIDE;
   ops[110].op_type = EO_OP_TYPE_REGULAR;
   ops[110].doc = NULL;

   ops[111].func = reinterpret_cast<void*>(& ::_elm_widget_drag_child_locked_x_get_wrapper<T>);
   ops[111].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_drag_child_locked_x_get);
   ops[111].op = EO_OP_OVERRIDE;
   ops[111].op_type = EO_OP_TYPE_REGULAR;
   ops[111].doc = NULL;

   ops[112].func = reinterpret_cast<void*>(& ::_elm_widget_can_focus_child_list_get_wrapper<T>);
   ops[112].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_can_focus_child_list_get);
   ops[112].op = EO_OP_OVERRIDE;
   ops[112].op_type = EO_OP_TYPE_REGULAR;
   ops[112].doc = NULL;

   ops[113].func = reinterpret_cast<void*>(& ::_elm_widget_focused_item_get_wrapper<T>);
   ops[113].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focused_item_get);
   ops[113].op = EO_OP_OVERRIDE;
   ops[113].op_type = EO_OP_TYPE_REGULAR;
   ops[113].doc = NULL;

   ops[114].func = reinterpret_cast<void*>(& ::_elm_widget_parents_bounce_get_wrapper<T>);
   ops[114].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parents_bounce_get);
   ops[114].op = EO_OP_OVERRIDE;
   ops[114].op_type = EO_OP_TYPE_REGULAR;
   ops[114].doc = NULL;

   ops[115].func = reinterpret_cast<void*>(& ::_elm_widget_parent_widget_get_wrapper<T>);
   ops[115].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent_widget_get);
   ops[115].op = EO_OP_OVERRIDE;
   ops[115].op_type = EO_OP_TYPE_REGULAR;
   ops[115].doc = NULL;

   ops[116].func = reinterpret_cast<void*>(& ::_elm_widget_highlight_get_wrapper<T>);
   ops[116].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_highlight_get);
   ops[116].op = EO_OP_OVERRIDE;
   ops[116].op_type = EO_OP_TYPE_REGULAR;
   ops[116].doc = NULL;

   ops[117].func = reinterpret_cast<void*>(& ::_elm_widget_focused_object_get_wrapper<T>);
   ops[117].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_focused_object_get);
   ops[117].op = EO_OP_OVERRIDE;
   ops[117].op_type = EO_OP_TYPE_REGULAR;
   ops[117].doc = NULL;

   ops[118].func = reinterpret_cast<void*>(& ::_elm_widget_parent2_get_wrapper<T>);
   ops[118].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent2_get);
   ops[118].op = EO_OP_OVERRIDE;
   ops[118].op_type = EO_OP_TYPE_REGULAR;
   ops[118].doc = NULL;

   ops[119].func = reinterpret_cast<void*>(& ::_elm_widget_parent2_set_wrapper<T>);
   ops[119].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_parent2_set);
   ops[119].op = EO_OP_OVERRIDE;
   ops[119].op_type = EO_OP_TYPE_REGULAR;
   ops[119].doc = NULL;

   ops[120].func = reinterpret_cast<void*>(& ::_elm_widget_part_text_get_wrapper<T>);
   ops[120].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_part_text_get);
   ops[120].op = EO_OP_OVERRIDE;
   ops[120].op_type = EO_OP_TYPE_REGULAR;
   ops[120].doc = NULL;

   ops[121].func = reinterpret_cast<void*>(& ::_elm_widget_part_text_set_wrapper<T>);
   ops[121].api_func = reinterpret_cast<void*>(& ::elm_obj_widget_part_text_set);
   ops[121].op = EO_OP_OVERRIDE;
   ops[121].op_type = EO_OP_TYPE_REGULAR;
   ops[121].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_widget >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_widget, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_widget >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_widget, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_widget>
{
   template <typename U>
   struct type
   {
      operator ::elm_widget() const
      {
         return ::elm_widget(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      evas::object newest_focus_order_get(unsigned int* newest_focus_order_, bool can_focus_only_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_newest_focus_order_get(newest_focus_order_, efl::eolian::to_c(can_focus_only_)));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void scroll_hold_push()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_scroll_hold_push());
      }

      void cursor_add(Elm_Cursor * cur_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_cursor_add(cur_));
      }

      void focus_next_object_set(evas::object next_, Elm_Focus_Direction dir_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_next_object_set(efl::eolian::to_c(next_), dir_));
      }

      evas::object focus_next_object_get(Elm_Focus_Direction dir_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_object_get(dir_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_tree_unfocusable_handle()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_tree_unfocusable_handle());
      }

      void focus_custom_chain_prepend(evas::object child_, evas::object relative_child_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_custom_chain_prepend(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
      }

      std::string part_text_translate(std::string part_, std::string text_)
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_part_text_translate(efl::eolian::to_c(part_), efl::eolian::to_c(text_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_highlight_geometry_get(Evas_Coord * x_, Evas_Coord * y_, Evas_Coord * w_, Evas_Coord * h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_highlight_geometry_get(x_, y_, w_, h_));
      }

      bool activate(Elm_Activate act_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_activate(act_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool sub_object_add(evas::object sobj_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_sub_object_add(efl::eolian::to_c(sobj_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_direction_manager_is()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_manager_is());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool event(evas::object source_, Evas_Callback_Type type_, void * event_info_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_event(efl::eolian::to_c(source_), type_, event_info_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void event_callback_add(Elm_Event_Cb func_, const void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_event_callback_add(func_, data_));
      }

      void access(bool acs_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_access(efl::eolian::to_c(acs_)));
      }

      void cursor_del(Elm_Cursor * cur_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_cursor_del(cur_));
      }

      void * event_callback_del(Elm_Event_Cb func_, const void * data_)
      {
         void * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_event_callback_del(func_, data_));
            return _tmp_ret;
      }

      bool on_focus()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_on_focus());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool on_focus_region(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_on_focus_region(x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_cycle(Elm_Focus_Direction dir_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_cycle(dir_));
      }

      bool focus_direction(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction(base_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool event_propagate(Evas_Callback_Type type_, void * event_info_, Evas_Event_Flags * event_flags_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_event_propagate(type_, event_info_, event_flags_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void signal_callback_add(std::string emission_, std::string source_, Edje_Signal_Cb func_, void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_signal_callback_add(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_, data_));
      }

      bool focus_next_manager_is()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_manager_is());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object name_find(std::string name_, int recurse_)
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_name_find(efl::eolian::to_c(name_), recurse_));
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_list_direction_get(const Evas_Object * base_, const Eina_List * items_, list_data_get_func_type list_data_get_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_list_direction_get(base_, items_, list_data_get_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focused_object_clear()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focused_object_clear());
      }

      bool focus_direction_go(double degree_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_go(degree_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void show_region_set(Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_, bool forceshow_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_show_region_set(x_, y_, w_, h_, efl::eolian::to_c(forceshow_)));
      }

      void show_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_show_region_get(x_, y_, w_, h_));
      }

      void scroll_freeze_pop()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_scroll_freeze_pop());
      }

      void tooltip_del(Elm_Tooltip * tt_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_tooltip_del(tt_));
      }

      bool focus_next_get(Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next_get(dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      std::string translatable_part_text_get(std::string part_)
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_translatable_part_text_get(efl::eolian::to_c(part_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_restore()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_restore());
      }

      void scroll_hold_pop()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_scroll_hold_pop());
      }

      bool translate()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_translate());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void scroll_freeze_push()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_scroll_freeze_push());
      }

      void focus_custom_chain_unset()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_custom_chain_unset());
      }

      void focus_steal()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_steal());
      }

      void focus_hide_handle()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_hide_handle());
      }

      bool focus_next(Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_next(dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_list_next_get(const Eina_List * items_, list_data_get_func_type list_data_get_, Elm_Focus_Direction dir_, Evas_Object ** next_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_list_next_get(items_, list_data_get_, dir_, next_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_mouse_up_handle()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_mouse_up_handle());
      }

      bool theme_apply()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_apply());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_direction_get(const Evas_Object * base_, double degree_, Evas_Object ** direction_, double* weight_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_direction_get(base_, degree_, direction_, weight_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void * signal_callback_del(std::string emission_, std::string source_, Edje_Signal_Cb func_)
      {
         void * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_signal_callback_del(efl::eolian::to_c(emission_), efl::eolian::to_c(source_), func_));
            return _tmp_ret;
      }

      void signal_emit(std::string emission_, std::string source_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_signal_emit(efl::eolian::to_c(emission_), efl::eolian::to_c(source_)));
      }

      bool disable()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_disable());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool sub_object_del(evas::object sobj_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_sub_object_del(efl::eolian::to_c(sobj_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void tooltip_add(Elm_Tooltip * tt_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_tooltip_add(tt_));
      }

      void focus_region_show()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_region_show());
      }

      void focus_disabled_handle()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_disabled_handle());
      }

      void focus_custom_chain_append(evas::object child_, evas::object relative_child_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_custom_chain_append(efl::eolian::to_c(child_), efl::eolian::to_c(relative_child_)));
      }

      bool focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void focus_set(bool focus_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_set(efl::eolian::to_c(focus_)));
      }

      bool drag_lock_y_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_lock_y_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void drag_lock_y_set(bool lock_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_drag_lock_y_set(efl::eolian::to_c(lock_)));
      }

      std::string focus_highlight_style_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_highlight_style_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool focus_highlight_style_set(std::string style_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_highlight_style_set(efl::eolian::to_c(style_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool tree_unfocusable_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_tree_unfocusable_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void tree_unfocusable_set(bool tree_unfocusable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_tree_unfocusable_set(efl::eolian::to_c(tree_unfocusable_)));
      }

      bool mirrored_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_mirrored_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void mirrored_set(bool mirrored_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_mirrored_set(efl::eolian::to_c(mirrored_)));
      }

      Elm_Theme * theme_get()
      {
         Elm_Theme * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_get());
            return _tmp_ret;
      }

      void theme_set(Elm_Theme * th_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_theme_set(th_));
      }

      bool disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_disabled_set(efl::eolian::to_c(disabled_)));
      }

      bool highlight_ignore_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_ignore_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void highlight_ignore_set(bool ignore_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_highlight_ignore_set(efl::eolian::to_c(ignore_)));
      }

      bool mirrored_automatic_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_mirrored_automatic_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void mirrored_automatic_set(bool automatic_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_mirrored_automatic_set(efl::eolian::to_c(automatic_)));
      }

      bool orientation_mode_disabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_orientation_mode_disabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void orientation_mode_disabled_set(bool disabled_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_orientation_mode_disabled_set(efl::eolian::to_c(disabled_)));
      }

      std::string style_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_style_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool style_set(std::string style_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_style_set(efl::eolian::to_c(style_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      double scale_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_scale_get());
            return _tmp_ret;
      }

      void scale_set(double scale_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_scale_set(scale_));
      }

      const Eina_List * focus_custom_chain_get()
      {
         const Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_custom_chain_get());
            return _tmp_ret;
      }

      void focus_custom_chain_set(Eina_List * objs_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_focus_custom_chain_set(objs_));
      }

      bool can_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_can_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void can_focus_set(bool can_focus_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_can_focus_set(efl::eolian::to_c(can_focus_)));
      }

      bool highlight_in_theme_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_in_theme_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void highlight_in_theme_set(bool highlight_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
      }

      evas::object parent_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void parent_set(evas::object parent_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_parent_set(efl::eolian::to_c(parent_)));
      }

      std::string access_info_get()
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_access_info_get());
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void access_info_set(std::string txt_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_access_info_set(efl::eolian::to_c(txt_)));
      }

      bool drag_lock_x_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_lock_x_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void drag_lock_x_set(bool lock_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_drag_lock_x_set(efl::eolian::to_c(lock_)));
      }

      bool access_highlight_in_theme_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_access_highlight_in_theme_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void access_highlight_in_theme_set(bool highlight_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_access_highlight_in_theme_set(efl::eolian::to_c(highlight_)));
      }

      void parent_highlight_set(bool highlighted_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_parent_highlight_set(efl::eolian::to_c(highlighted_)));
      }

      bool theme_object_set(evas::object edj_, std::string wname_, std::string welement_, std::string wstyle_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_theme_object_set(efl::eolian::to_c(edj_), efl::eolian::to_c(wname_), efl::eolian::to_c(welement_), efl::eolian::to_c(wstyle_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void hover_object_set(evas::object sobj_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_hover_object_set(efl::eolian::to_c(sobj_)));
      }

      void display_mode_set(Evas_Display_Mode dispmode_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_display_mode_set(dispmode_));
      }

      void on_show_region_hook_set(region_hook_func_type func_, void * data_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_on_show_region_hook_set(func_, data_));
      }

      void domain_part_text_translatable_set(std::string part_, std::string domain_, bool translatable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_domain_part_text_translatable_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(translatable_)));
      }

      void orientation_set(int rotation_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_orientation_set(rotation_));
      }

      void resize_object_set(evas::object sobj_, bool sub_obj_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_resize_object_set(efl::eolian::to_c(sobj_), efl::eolian::to_c(sub_obj_)));
      }

      void domain_translatable_part_text_set(std::string part_, std::string domain_, std::string label_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_domain_translatable_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(domain_), efl::eolian::to_c(label_)));
      }

      Eina_List * scrollable_children_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_scrollable_children_get());
            return _tmp_ret;
      }

      int scroll_hold_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_scroll_hold_get());
            return _tmp_ret;
      }

      int drag_child_locked_y_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_child_locked_y_get());
            return _tmp_ret;
      }

      bool item_loop_enabled_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_item_loop_enabled_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void item_loop_enabled_set(bool enable_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_item_loop_enabled_set(efl::eolian::to_c(enable_)));
      }

      bool child_can_focus_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_child_can_focus_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      int scroll_freeze_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_scroll_freeze_get());
            return _tmp_ret;
      }

      bool focus_region_get(Evas_Coord* x_, Evas_Coord* y_, Evas_Coord* w_, Evas_Coord* h_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_region_get(x_, y_, w_, h_));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object top_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_top_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      unsigned int focus_order_get()
      {
         unsigned int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focus_order_get());
            return _tmp_ret;
      }

      int drag_child_locked_x_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_drag_child_locked_x_get());
            return _tmp_ret;
      }

      Eina_List * can_focus_child_list_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_can_focus_child_list_get());
            return _tmp_ret;
      }

      Elm_Object_Item * focused_item_get()
      {
         Elm_Object_Item * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focused_item_get());
            return _tmp_ret;
      }

      void parents_bounce_get(Eina_Bool* horiz_, Eina_Bool* vert_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_parents_bounce_get(horiz_, vert_));
      }

      evas::object parent_widget_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent_widget_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool highlight_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_highlight_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object focused_object_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_focused_object_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      evas::object parent2_get()
      {
         Evas_Object * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_parent2_get());
            return efl::eolian::to_cxx<evas::object>(_tmp_ret, std::tuple<std::false_type>());
      }

      void parent2_set(evas::object parent_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_parent2_set(efl::eolian::to_c(parent_)));
      }

      std::string part_text_get(std::string part_)
      {
         const char * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_obj_widget_part_text_get(efl::eolian::to_c(part_)));
            return efl::eolian::to_cxx<std::string>(_tmp_ret, std::tuple<std::false_type>());
      }

      void part_text_set(std::string part_, std::string label_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::elm_obj_widget_part_text_set(efl::eolian::to_c(part_), efl::eolian::to_c(label_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_widget>)
{
   return (ELM_WIDGET_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_WIDGET_HH

